<?php
	/**
	 * this file contains all actions for the backup-folder
	 * @package time-o-meter
	 * @subpackage backup
	 */

	// zugriffsrechte pruefen
	if (defined('USER_GROUP_ID') and $access->check_group(USER_GROUP_ID, 'admin_backup'))
	{
		//Loescht ein Backup (Datei + DB-Eintrag)
		if ($_POST['job_string'] == 'del_backup')
		{
			//Reloadpruefung
			if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
			{
				//Fehlerhafte POST Variablen
				if ($chk_var->error_count_int == 0 or !is_numeric($_POST['backupid_int']))
				{
					$sql = $cdb->select('SELECT filename FROM hdb_backup WHERE file_id='.$_POST['backupid_int']);
					$result = $cdb->fetch_array($sql);

					if (file_exists(TOM_ABS_PFAD.'files/backup/'.$result['filename']))
					{
						@unlink(TOM_ABS_PFAD.'files/backup/'.$result['filename']);
					}

					if ($cdb->delete("DELETE FROM hdb_backup WHERE file_id=".$_POST['backupid_int']." LIMIT 1"))
					{
						$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'del_ok'); /*Der Datensatz wurde geloescht.*/
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
			}
			$GLOBALS['TOM_VAR']['fileinc'] = 'main';
		}
		// Loescht alle selektierten Backups (Datei + DB-Eintrag)
		elseif ($_POST['job_string'] == 'del_all_backups')
		{
			//Reloadsperre
			if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
			{
				//POST Daten pruefen
				if ($chk_var->error_count_int == 0 and is_array($_POST['backup_array']))
				{
					$error_count = 0;
					foreach ($_POST['backup_array'] as $f_id)
					{
						if (is_numeric($f_id))
						{
							$sql = $cdb->select('SELECT filename FROM hdb_backup WHERE file_id='.$f_id);
							$result = $cdb->fetch_array($sql);

							if (isset($result['filename']) and !empty($result['filename']))
							{
								if ($cdb->select("DELETE FROM hdb_backup WHERE file_id=$f_id LIMIT 1"))
								{
									//Backupdate loeschen
									if (is_file(TOM_ABS_PFAD.'files/backup/'.$result['filename']))
									{
										@unlink(TOM_ABS_PFAD.'files/backup/'.$result['filename']);
									}
								}
								else
								{
									$error_count++;
								}
							}
						}
					}

					if ($error_count == 0)
					{
						$meldung_array['ok'][] = get_text('757', 'return'); /*Die Datensaetze wurden geloescht.*/
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/.' '.get_text('758', 'return', 'decode_on') /*Es konnten nicht alle Daten geloescht werden.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
			}
			$GLOBALS['TOM_VAR']['fileinc'] = 'backup_del_all';
		}
		//Erstellt ein manuelles Backup (Datei + DB-Eintrag)
		elseif ($_POST['job_string'] == 'add_backup')
		{
			//Reloadsperre
			if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
			{
				//POST Daten pruefen
				if ($chk_var->error_count_int == 0)
				{
					$pflichtfeld = 0;
					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfeld++;}
					//Pflichtfelder
					if ($pflichtfeld == 0)
					{
						//Backupklasse
						$backup = new MySqlBackup;
						//Backup erstellen
						if ($backup->create_dump('manu', $_POST['bezeichnung']) === true)
						{
							$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'backup_ok'); /*Das Datenbank-Backup wurde erfolgreich erstellt.*/
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
			}
			$GLOBALS['TOM_VAR']['fileinc'] = 'main';
		}
		//Backup wiederherstellen
		elseif ($_POST['job_string'] == 'restore_backup')
		{
			//Reloadsperre
			if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
			{
				//POST Daten pruefen
				if ($chk_sum->Chk($_POST['VCS']) === true and $chk_var->error_count_int == 0)
				{
					$sql = $cdb->select('SELECT filename FROM hdb_backup WHERE file_id='.$_POST['fileid_int']);
					$result = $cdb->fetch_array($sql);

					if (isset($result['filename']) and !empty($result['filename']))
					{
						$msb = new MySqlBackup;
						if ($msb->restore_dump($result['filename']))
						{
							$meldung_array['ok'][] = get_text(947, 'return', 'decode_on'); //Das Backup wurde erfolgreich wiederhergestellt.
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
			}
			$GLOBALS['TOM_VAR']['fileinc'] = 'main';
		}
	}
	else
	{
		$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_zugriffsrechte') /*Sie besitzen nicht die notwendigen Zugriffsrechte fuer diesen Bereich.*/, WARNING, __LINE__);
	}
?>