<?php
	/**
	 * cronjob
	 * this file should be executed periodically by a cronjob
	 * @package time-o-meter
	 * @subpackage cj
	 */

	/**
	 * Ausgabe des HTML-Headers unterbinden
	 */
	define('PAGE_AREA','CJ');

	require_once('../inc/include.php');

	//Wochentag
	$current_day_int = date('w');
	//Aktuelle Stunde
	$current_hour_string = date('H');
	//Tageskurzbezeichnungen
	$day_name_short_array = array('So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa');

	//alte Checksummen loeschen
	$chk_sum->DelOldChecksum();
	//alte Reloadeintraege loeschen
	$reload->del_reload_id();

	/*
	//nur bei Demo installation
	if (file_exists('_demo_cj.php'))
	{
		require_once('_demo_cj.php');
	}
	*/

	//MySQL Backup erstellen
	if (isset($setup_array['auto_backup_aktiv']) and $setup_array['auto_backup_aktiv'] == 'j')
	{
		//pruefen ob fuer den Heutiges Tag ein Backupauftrag vorliegt
		if (isset($setup_array['auto_backup'][$day_name_short_array[$current_day_int]]) or isset($setup_array['auto_backup']['daily']))
		{
			//Variable fuer das erstellen eines Backups
			$backup_create = false;

			//Alle drei moeglichen zeiten pruefen
			for ($i = 1; $i <= 3; $i++)
			{
				if (isset($setup_array['auto_backup'][$day_name_short_array[$current_day_int]]['uhrzeit'.$i]) and $setup_array['auto_backup'][$day_name_short_array[$current_day_int]]['uhrzeit'.$i] == $current_hour_string)
				{
					$backup_create = true;
					break;
				}
				elseif (isset($setup_array['auto_backup']['daily']['uhrzeit'.$i]) and $setup_array['auto_backup']['daily']['uhrzeit'.$i] == $current_hour_string)
				{
					$backup_create = true;
					break;
				}
			}

			//Backup erstellen
			if ($backup_create === true)
			{
				$backup = new MySqlBackup;
				$result = $backup->create_dump();
				$empfaenger_array = array();

				//Backup erfolgreich erstellt
				if ($result === true)
				{
					//BackupMail
					if (isset($setup_array['backup_mail_senden']) and $setup_array['backup_mail_senden'] == 'j')
					{
						$mail = new Mailer;
						$dump_info = $backup->get_dump_info();

						//Mehrere E-Mailempfaenger
						if (substr_count($setup_array['backup_mail_recipients'], ',') > 0)
						{
							//String am Komma teilen
							$empfaenger_array = explode(',', $setup_array['backup_mail_recipients']);

							//Sollte eigendlich immer ein array rauskommen
							if (is_array($empfaenger_array))
							{
								//Emailadressen pruefen
								foreach ($empfaenger_array as &$adress)
								{
									//keine gueltige E-Mailadresse
									if (!$mail->is_mail($adress))
									{
										$adress = '';
									}
									else
									{
										$adress = trim($adress);
									}
								}
							}
						}
						else
						{
							if ($mail->is_mail($setup_array['backup_mail_recipients']))
							{
								$empfaenger_array[] = trim($setup_array['backup_mail_recipients']);
							}
						}
					}

					//E-Mailempfaenger vorhanden
					if (count($empfaenger_array) > 0)
					{
						$subject = get_text(672, 'return');//Datenbank-Backup
						$body = get_text(671, 'return')."\n\n";//Unter nachfolgendem Link koennen Sie sich das Backup herunterladen.

						//Downloadlink
						if (file_exists(TOM_ABS_PFAD.'config/cryptpw_salt.php'))
						{
							require_once(TOM_ABS_PFAD.'config/cryptpw_salt.php');

							if (isset($cryptpw_salt_array['sz']))
							{
								$body .= ' <a href="'.TOM_ABS_URL.'cj/download.php?backup_int='.$dump_info['dump_id'].'&backup_string='.md5(md5($cryptpw_salt_array['sz'][0].$dump_info['file_name']).md5($cryptpw_salt_array['sz'][1].$dump_info['dump_typ']).md5($cryptpw_salt_array['sz'][2].$dump_info['file_size']).md5($cryptpw_salt_array['sz'][3].$dump_info['dump_id'])).'>Download</a>';
							}
						}
						foreach ($empfaenger_array as $mail_adress)
						{
							if (!empty($mail_adress))
							{
								$mail->send_html_mail($subject, $body, $mail_adress);
							}
						}
					}

					//Tabellen mit ueberhang Optimieren
					$sql = $cdb->query("SHOW TABLE STATUS");
					while ($result = $cdb->fetch_array($sql))
					{
						//ueberhang vorhanden
						if (isset($result['Data_free']) and $result['Data_free'] > 0)
						{
							$cdb->query("OPTIMIZE TABLE ".$result['Name']);
						}
					}
				}
			}
		}
	}

	//0 Uhr Jobs
	if (date('G') == '0')
	{
		$kal = new Kalender;

		//Feiertage ins Archive uebernehmen
		$kal->holiday_to_archiv();

		//Stundenzettel abschliessen
		if (isset($setup_array['stz_editierbar_bis']))
		{
			$next_day = intval($setup_array['stz_editierbar_bis']) + 1;
			if (date('j') == $next_day)
			{
				$ts = new TimeSheet;
				$tss = new TimeSheetSave();
				//minus 1 monat
				$last_month = $kal->date_calculator('', 0, -1, 0);
				$last_month = substr($last_month[0], 0, -2).'01';

				$sql = $cdb->select("SELECT user_id, datum FROM hdb_stz_monat WHERE datum<='$last_month' AND abgeschlossen='n' ORDER BY datum ASC");
				while($result = $cdb->fetch_array($sql))
				{
					$month = substr($result['datum'], 5, 2);
					$year = substr($result['datum'], 0, 4);

					if ($tss->recalculation_month_data($result['user_id'], $year, $month))
					{
						$ts->close_time_sheet($result['user_id'], $month, $year);
					}
				}
			}
		}
	}
	//1 Uhr wird alles ausgefuehrt was irgendwie etwas mit loeschen zu tun hat
	elseif (date('G') == '1')
	{
		$kal = new Kalender;
		$log = new Logbook;

		/*
		* Projekte entfernen die ein Loeschdatum besitzen. Nur 0 Uhr ausfuehren
		* anfang
		*/
		$sql = $cdb->select("SELECT projekt_id FROM hdb_projekte WHERE anzeigen='j' AND del_time='".date('Ymd')."000000'");
		while ($result = $cdb->fetch_array($sql))
		{
			$cdb->update("UPDATE hdb_projekte SET anzeigen='n' WHERE projekt_id=".$result['projekt_id'].' LIMIT 1');
		}
		/*
		* Projekte entfernen die ein Loeschdatum besitzen. Nur 0 Uhr ausfuehren
		* ende
		*/

		/*
		 * User mit einem Loeschdatum ausblenden
		 * anfang
		 */
		$sql = $cdb->select("SELECT user_id FROM hdb_user WHERE anzeigen='j' AND del_time='".date('Ymd')."000000'");
		while ($result = $cdb->fetch_array($sql))
		{
			$cdb->update("UPDATE hdb_user SET login_aktiv='n', anzeigen='n' WHERE user_id=".$result['user_id']);
		}
		/*
		 * User mit einem Loeschdatum ausblenden
		 * ende
		 */

		/*
		 * Abwesenheitsantraege loeschen
		 * anfang
		 */
		$six_months_ago = $kal->date_calculator('', 0, -6, 0);
		//Alle Abwesenheitsantraege loeschen die aelter als 6 Monate sind
		$cdb->query("DELETE FROM hdb_absence_list WHERE date_to<'".$six_months_ago[0]."'");
		/*
		 * Abwesenheitsantraege loeschen
		 * ende
		 */

		/*
		 * Temporaere Dateien loeschen
		 * anfang
		 */
		if (file_exists(TOM_ABS_PFAD.'files/tmp/'))
		{
			$dir = opendir(TOM_ABS_PFAD.'files/tmp/');
			while (false !== ($file = readdir($dir)))
			{
				if (is_file(TOM_ABS_PFAD.'files/tmp/'.$file) and $file != '.' and $file != '..')
				{
					//nur dateien die schon mehr als 24h nicht mehr geaendert wurden loeschen
					if (fileatime(TOM_ABS_PFAD.'files/tmp/'.$file) < $kal->setup_array['current_timestamp'] - 86400)
					{
						@unlink(TOM_ABS_PFAD.'files/tmp/'.$file);
					}
				}
			}
		}
		/*
		 * Temporaere Dateien loeschen
		 * ende
		 */

		/*
		 * Alte Logbuchdaten entfernen
		 * anfang
		 */
		//Enterfernt den sessionhash aus der Logbuchtabelle
		$log->clear_login_session();

		//Logbuchdateien immer am 1 eines jeden monat packen
		if (date('j') == 1)
		{
			$log->pack_all_log_files();
		}
		/*
		 * Alte Logbuchdaten entfernen
		 * ende
		 */

		/*
		* Mitteilungen entfernen die vom Admin und User ausgeblendet sind
		* anfang
		*/
		//alle mitteilungen die der admin ausgeblendet hat
		$sql = $cdb->select("SELECT message_id FROM hdb_mitteilungen WHERE anzeigen_admin='n'");
		while ($result = $cdb->fetch_array($sql))
		{
			//alle mitteilungen die an User gesendet wurden zaehlen
			$all_sql = $cdb->select('SELECT COUNT(user_id) AS count_id FROM hdb_mitteilungen_recipients WHERE message_id='.$result['message_id']);
			$all_result = $cdb->fetch_array($all_sql);
			//alle mitteilungen die an user gesendet und ausgeblendet wurden zaehlen
			$hidden_sql = $cdb->select('SELECT COUNT(user_id) AS count_id FROM hdb_mitteilungen_recipients WHERE message_id='.$result['message_id']." AND anzeigen_user='n'");
			$hidden_result = $cdb->fetch_array($hidden_sql);

			//alle user haben die mitteilung ausgeblendet
			if ($all_result['count_id'] == $hidden_result['count_id'])
			{
				$cdb->delete('DELETE FROM hdb_mitteilungen WHERE message_id='.$result['message_id']);
				$cdb->delete('DELETE FROM hdb_mitteilungen_recipients WHERE message_id='.$result['message_id']);
			}
		}
		/*
		* Mitteilungen entfernen die vom Admin und User ausgeblendet sind
		* ende
		*/

		//Alle Passwortanforderungen entfernen die aelter als 24h sind
		$cdb->delete("DELETE FROM hdb_user_lostpw WHERE create_time<'".date('YmdHis', time() - 86400)."'");
		//Webservice Cache Leeren
		$cdb->delete("DELETE FROM hdb_webservice_cache WHERE expire_time < '".date('YmdHis')."'");
		//alte Webservice Logins löschen
		$cdb->delete("DELETE FROM hdb_webservice_access WHERE expire<'".date("YmdHis")."'");
	}
	//5 Uhr aufgaben
	elseif (date('G') == '5')
	{
		//Mailklasse
		$mail = new Mailer;

		//empfaengeradressen aus dem setuparray auslesen
		$mail_to = @unserialize($setup_array['email_recipients_project_report']);

		//empfaengeradressen auslesen
		$to_array = array();
		for($i = 0; $i < count($mail_to); $i++)
		{
			if ($mail_to[$i]['type'] == 'from_userlist')
			{
				$to_array[] = $mail_to[$i]['email'];
			}
			elseif ($mail_to[$i]['type'] == 'free_input')
			{
				//komma als trennzeichen fuer mehrere mailadressen vorhanden
				if (strpos($mail_to[$i]['email'], ',') !== false)
				{
					$tmp_to_array = explode(',', $mail_to[$i]['email']);

					for ($j = 0; $j < count($tmp_to_array); $j++)
					{
						$to_array[] = trim($tmp_to_array[$j]);
					}
				}
				//semikolon als trennzeichen
				elseif (strpos($mail_to[$i]['email'], ';') !== false)
				{
					$tmp_to_array = explode(';', $mail_to[$i]['email']);

					for ($j = 0; $j < count($tmp_to_array); $j++)
					{
						$to_array[] = trim($tmp_to_array[$j]);
					}
				}
				//kein trennzeichen
				else
				{
					$to_array[] = trim($mail_to[$i]['email']);
				}
			}
		}
		//Doppelte werte entfernen
		$tmp_to_array = array_unique($to_array);
		$to_array = array();
		//pruefen ob die mailadressen korrekt sind
		foreach($tmp_to_array as $mailadress)
		{
			if ($mail->is_mail($mailadress))
			{
				$to_array[] = $mailadress;
			}
		}

		/*
		* Projektbenachrichtigungen versenden
		* anfang
		*/
		$tsr = new TimeSheetReport;
		$ps_result = $tsr->cj_projectinformation();
		$ps_result_count = count($ps_result);

		if ($ps_result_count > 0 and isset($setup_array['email_recipients_project_report']))
		{
			if (count($to_array) > 0)
			{
				$subject = htmlentities(get_text(675, 'return', 'decode_on'), ENT_QUOTES, 'UTF-8', false);//Projektstunden-Report

				$body = html_entity_decode($setup_array['application_name']).'&nbsp;'.get_text(675, 'return');//Projektstunden-Report
				$body .= '<br /><br />';

				if ($ps_result_count > 1)
				{
					$body .= get_text(677, 'return');//Nachfolgende Projekte haben die voreingestellten Projektbenachrichtigungsgrenzen erreicht bzw. ueberschritten.
				}
				else
				{
					$body .= get_text(676, 'return');//Nachfolgendes Projekt hat die voreingestellte Projektbenachrichtigungsgrenze erreicht bzw. &uuml;berschritten.
				}

				$body .= '<br />';

				for ($i = 0; $i < $ps_result_count; $i++)
				{

					$body .= '<br />';
					$body .= get_text(291, 'return').':';//Projektname
					$body .= '&nbsp;'.$ps_result[$i]['name'];
					$body .= '<br />';
					$body .= get_text(292, 'return').':';//Projektkuerzel
					$body .= '&nbsp;'.$ps_result[$i]['kurzname'];
					$body .= '<br />';
					$body .= get_text(678, 'return').':';//Projektbenachrichtigung senden bei
					$body .= '&nbsp;'.$ps_result[$i]['soll'].' %';
					$body .= '<br />';
					$body .= get_text(679, 'return').':';//Aktueller Projektstand
					$body .= '&nbsp;'.$ps_result[$i]['ist'].' %';
					$body .= '<br /><hr />';
				}

				$body .= '<br /><br />'.get_text(829,'return','decode_on')/*Mit freundlichen gruessen*/."<br />".get_text(830,'return','decode_on')/*Ihr <application_name> Team*/;

				// Platzhalter suchen und ersetzen, falls vorhanden
				// <application_name> = Name der Anwendung (aus Grundeinstellungen holen und Entities decodieren wenn noetig)
				$body = str_replace('<application_name>', html_entity_decode($setup_array['application_name']), $body);
				$body = str_replace('<br>', '<br />', $body);


				//Mails versenden
				for ($i = 0; $i < count($to_array); $i++)
				{
					$mail->send_html_mail($subject, $body, $to_array[$i]);
				}
			}
		}
		/*
		* Projektbenachrichtigungen versenden
		* ende
		*/

		/**
		 * Stundenzettelplausibilitaet
		 * anfang
		 */

		$stzp = new TimeSheetPlausibility;
		$result = $stzp->chk_timesheet();

		if (count($result) > 0)
		{
			$body = $stzp->get_html_mail($result);

			$subject = htmlentities(get_text(315, 'return', 'decode_on'), ENT_QUOTES, 'UTF-8', false);


			//Mails versenden
			for ($i = 0; $i < count($to_array); $i++)
			{
				// Plausibilitaetspruefung der Stundenzettel
				$mail->send_html_mail($subject, $body, $to_array[$i]);
			}



		}
		/**
		 * Stundenzettelplausibilitaet
		 * ende
		 */

	}
?>