<?php
	/**
	 * annual holiday overview / jahresurlaubsplan
	 * @package time-o-meter
	 * @subpackage holiday
	 */

	//Urlaubsklasse
	$holiday = new Holiday;
	$quali = new Qualification();
	$pro = new Project();

	if (!isset($_POST['filter_date_string']))
	{
		$_POST['filter_date_string'] = date('Y');
	}

	if (!isset($_POST['filter_user_int']))
	{
		$_POST['filter_user_int'] = 0;
	}

	if (!isset($_POST['filter_caltype_string']))
	{
		$_POST['filter_caltype_string'] = 'holiday';
	}

	if (!isset($_POST['show_open_status']))
	{
		$_POST['show_open_status'] = 0;
	}

	//Projekte des aktuellen Users auslesen
	$my_project_ids_array = array();

	if (strlen($_POST['filter_date_string']) == 4)
	{
		$where = " WHERE (t1.anzeigen='j' OR LEFT(t1.del_time, 4)>='".$_POST['filter_date_string']."') AND LEFT(t1.start_datum, 4)<='".$_POST['filter_date_string']."' AND LEFT(t1.end_datum, 4)>='".$_POST['filter_date_string']."' AND t2.user_id=".USER_ID." AND (t2.anzeigen='j' OR LEFT(t2.del_time, 4)>='".$_POST['filter_date_string']."')";
	}
	elseif (strlen($_POST['filter_date_string']) == 7)
	{
		$where = " WHERE (t1.anzeigen='j' OR LEFT(t1.del_time, 7)>='".$_POST['filter_date_string']."') AND LEFT(t1.start_datum, 7)<='".$_POST['filter_date_string']."' AND LEFT(t1.end_datum, 7)>='".$_POST['filter_date_string']."' AND t2.user_id=".USER_ID." AND (t2.anzeigen='j' OR LEFT(t2.del_time, 7)>='".$_POST['filter_date_string']."')";
	}
	else
	{
		$where = " WHERE t1.anzeigen='j' AND t2.user_id=".USER_ID." AND t2.anzeigen='j'";
	}

	$sql = $cdb->select('SELECT t1.projekt_id FROM hdb_projekte t1
						LEFT JOIN hdb_user_projekt t2 ON t1.projekt_id=t2.projekt_id
						'.$where);
	while ($result = $cdb->fetch_array($sql))
	{
		$my_project_ids_array[] = $result['projekt_id'];
	}

	if (strlen($_POST['filter_date_string']) == 4)
	{
		$result = $pro->get_project(0, $_POST['filter_date_string']);
	}
	elseif (strlen($_POST['filter_date_string']) == 7)
	{
		$result = $pro->get_project(0, substr($_POST['filter_date_string'], 0, 4), substr($_POST['filter_date_string'], 5, 2));
	}
	else
	{
		$result = $pro->get_project();
	}

	$my_project_array = array();
	$other_project_array = array();
	$my_project_id_string = '';

	if ($result !== false)
	{
		foreach ($result as $pro_data)
		{
			if (in_array($pro_data['projekt_id'], $my_project_ids_array))
			{
				$my_project_array[] = $pro_data;

				if (empty($my_project_id_string))
				{
					$my_project_id_string = $pro_data['projekt_id'];
				}
				else
				{
					$my_project_id_string .= ','.$pro_data['projekt_id'];
				}
			}
			else
			{
				$other_project_array[] = $pro_data;
			}
		}
	}

	if (!isset($_POST['project_id_string']))
	{
		//Wenn kein admin die eigenden Qualifikationen per default auswaehlen
		if ($access->check_group(USER_GROUP_ID, 'admin_antrag_read') or $access->check_group(USER_GROUP_ID, 'admin_antrag_write'))
		{
			$_POST['project_id_string'] = 0;
		}
		else
		{
			$_POST['project_id_string'] = $my_project_id_string;
		}
	}

	//Qualifikatinen des aktuellen users auslesen
	$my_quali_ids_array = array();
	$sql = $cdb->select('SELECT quali_id FROM hdb_user_qualifikation WHERE user_id='.USER_ID);
	while ($result = $cdb->fetch_array($sql))
	{
		$my_quali_ids_array[] = $result['quali_id'];
	}

	$result = $quali->get_qualification();

	$my_quali_array = array();
	$other_quali_array = array();
	$my_quali_id_string = '';

	if ($result !== false)
	{
		foreach ($result as $quali_data)
		{
			if (in_array($quali_data['quali_id'], $my_quali_ids_array))
			{
				$my_quali_array[] = $quali_data;
				if (empty($my_quali_id_string))
				{
					$my_quali_id_string = $quali_data['quali_id'];
				}
				else
				{
					$my_quali_id_string .= ','.$quali_data['quali_id'];
				}
			}
			else
			{
				$other_quali_array[] = $quali_data;
			}
		}
	}

	if (!isset($_POST['quali_id_string']))
	{
		//Wenn kein admin die eigenden Qualifikationen per default auswaehlen
		if ($access->check_group(USER_GROUP_ID, 'admin_antrag_read') or $access->check_group(USER_GROUP_ID, 'admin_antrag_write'))
		{
			$_POST['quali_id_string'] = 0;
		}
		else
		{
			$_POST['quali_id_string'] = $my_quali_id_string;
		}
	}
?>
<script type="text/javascript">
	<!--
		function select_cal()
		{
			if (document.filter_form.filter_caltype_string.value == 'holiday')
			{
				document.getElementById('quali_txt').style.display = 'none';
				document.getElementById('quali_data').style.display = 'none';
				document.getElementById('quali_id_string').value = 0;

				document.getElementById('project_txt').style.display = 'none';
				document.getElementById('project_data').style.display = 'none';
				document.getElementById('project_id_string').value = 0;

				document.getElementById('user_txt').style.display = '';
				document.getElementById('user_data').style.display = '';
			}
			else if (document.filter_form.filter_caltype_string.value == 'qualification')
			{
				document.getElementById('quali_txt').style.display = '';
				document.getElementById('quali_data').style.display = '';

				document.getElementById('filter_user_int').value = '';
				document.getElementById('user_txt').style.display = 'none';
				document.getElementById('user_data').style.display = 'none';

				document.getElementById('project_txt').style.display = 'none';
				document.getElementById('project_data').style.display = 'none';
				document.getElementById('project_id_string').value = 0;
			}
			else if (document.filter_form.filter_caltype_string.value == 'project')
			{
				document.getElementById('quali_txt').style.display = 'none';
				document.getElementById('quali_data').style.display = 'none';
				document.getElementById('user_txt').style.display = 'none';
				document.getElementById('user_data').style.display = 'none';
				document.getElementById('filter_user_int').value = '';
				document.getElementById('quali_id_string').value = 0;

				document.getElementById('project_txt').style.display = '';
				document.getElementById('project_data').style.display = '';
			}
		}
	// -->
</script>
<table cellpadding="0" cellspacing="0" border="0" width="100%">
	<tr valign="middle">
		<td class="main_table_header" width="100%"><?php get_text('119'); /*Jahresurlaubsplan*/?></td>
	</tr>
	<tr><td><img src="<?php echo TOM_ABS_URL.'template/'.$setup_array['template'].'/image/_spacer.gif'; ?>" width="1" height="4" border="0" alt="" /></td></tr>
	<tr>
		<td class="main_table_content">
			<form action="index.php<?php echo $gv->create_get_string(); ?>" method="post" name="filter_form" accept-charset="UTF-8">
				<div id="filter_block_min" style="display:none;">
					<table cellpadding="2" cellspacing="0" border="0" width="100%" class="border">
						<tr>
							<td class="table_header_left" width="66%"><?php get_text(77);//Filteroptionen ?></td>
							<td class="table_header" align="right" width="34%"><img src="<?php echo TOM_ABS_URL.'template/'.$setup_array['template'].'/image/_max.gif'; ?>" alt="" width="16" height="14" border="0" style="vertical-align:middle; cursor:pointer;" onclick="set_filter('filter_block');" /></td>
						</tr>
					</table>
				</div>
				<div id="filter_block_max">
					<table cellpadding="2" cellspacing="0" border="0" width="100%" class="border">
						<colgroup>
							<col width="20%" />
							<col width="30%" />
							<col width="20%" />
							<col width="30%" />
						</colgroup>
						<tr class="table_tr_bg_2">
							<td class="table_header_left" colspan="3"><?php get_text('77'); /*Filteroptionen*/?></td>
							<td class="table_header" align="right"><img src="<?php echo TOM_ABS_URL.'template/'.$setup_array['template'].'/image/_min.gif'; ?>" alt="" width="16" height="14" border="0" style="vertical-align:middle; cursor:pointer;" onclick="set_filter('filter_block');" /></td>
						</tr>
						<tr>
							<td class="filter_td_2"><?php get_text(1009); //Kalendertyp?>:</td>
							<td class="filter_td_1">
								<select name="filter_caltype_string" class="ipt_200" onchange="select_cal();">
									<option value="holiday"<?php if ($_POST['filter_caltype_string'] == 'holiday'){echo ' selected="selected"';} ?>><?php get_text(1010); //Uebersicht nach Mitarbeiter ?></option>
									<?php
										if ($quali->exist_with_minheadcount() and isset($setup_array['holiday']['overview_qualification']) and $setup_array['holiday']['overview_qualification'] == true)
										{
									?>
											<option value="qualification"<?php if ($_POST['filter_caltype_string'] == 'qualification'){echo ' selected="selected"';} ?>><?php get_text(1011); //Uebersicht nach Qualifikation ?></option>
									<?php
										}
										if ($pro->exist_with_assignment($_POST['filter_date_string']) and isset($setup_array['holiday']['overview_project']) and $setup_array['holiday']['overview_project'] == true)
										{
									?>
											<option value="project"<?php if ($_POST['filter_caltype_string'] == 'project'){echo ' selected="selected"';} ?>><?php get_text(1032); //Uebersicht nach Projekt ?></option>
									<?php
										}
									?>
								</select>
							</td>
							<td class="filter_td_2">
								<span id="project_txt"<?php if ($_POST['filter_caltype_string'] != 'project'){echo ' style="display: none;"';} ?>><?php get_text(333); //Projekte ?>:</span>
								<span id="quali_txt"<?php if ($_POST['filter_caltype_string'] != 'qualification'){echo ' style="display: none;"';} ?>><?php get_text(240); //Qualifikationen ?>:</span>
								<span id="user_txt" <?php if ($_POST['filter_caltype_string'] != 'holiday'){echo ' style="display: none;"';} ?>><?php get_text('', 'echo', 'decode_on', 'mitarbeiter'); /*Mitarbeiter*/?>:</span>
							</td>
							<td class="filter_td_2">
								<span id="project_data"<?php if ($_POST['filter_caltype_string'] != 'project'){echo ' style="display: none;"';} ?>>
									<select name="project_id_string" id="project_id_string" class="ipt_200">
										<option value="0"><?php get_text(1012); //keine Auswahl ?></option>
										<?php
											if (!empty($my_project_array))
											{
												echo '<optgroup label="'.get_text(1033, 'return')/*Meine Projekte*/.'">';

												if ($_POST['project_id_string'] == $my_project_id_string)
												{
													$selected = ' selected="selected"';
												}
												else
												{
													$selected = '';
												}
												echo '<option value="'.$my_project_id_string.'"'.$selected.'>'.get_text(1034, 'return')/*Alle meine Projekte*/.'</option>';

												foreach ($my_project_array as $pro_data)
												{
													if ($_POST['project_id_string'] == $pro_data['projekt_id'])
													{
														$selected = ' selected="selected"';
													}
													else
													{
														$selected = '';
													}

													echo '<option value="'.$pro_data['projekt_id'].'"'.$selected.'>'.$pro_data['kurzname'].' - '.$pro_data['name'].'</option>';
												}
												echo '</optgroup>';
											}
											if (!empty($other_project_array))
											{
												echo '<optgroup label="'.get_text(1035, 'return')/*Andere Projekte*/.'">';
												foreach ($other_project_array as $pro_data)
												{
													if ($_POST['project_id_string'] == $pro_data['projekt_id'])
													{
														$selected = ' selected="selected"';
													}
													else
													{
														$selected = '';
													}

													echo '<option value="'.$pro_data['projekt_id'].'"'.$selected.'>'.$pro_data['kurzname'].' - '.$pro_data['name'].'</option>';
												}
												echo '</optgroup>';
											}
										?>
									</select>
								</span>
								<span id="quali_data"<?php if ($_POST['filter_caltype_string'] != 'qualification'){echo ' style="display: none;"';} ?>>
									<select name="quali_id_string" id="quali_id_string" class="ipt_200">
										<option value="0"><?php get_text(1012); //keine Auswahl ?></option>
										<?php
											if (!empty($my_quali_array))
											{
												echo '<optgroup label="'.get_text(1013, 'return')/*Meine Qualifikationen*/.'">';

												if ($_POST['quali_id_string'] == $my_quali_id_string)
												{
													$selected = ' selected="selected"';
												}
												else
												{
													$selected = '';
												}
												echo '<option value="'.$my_quali_id_string.'"'.$selected.'>'.get_text(1014, 'return')/*Alle meine Qualifikationen*/.'</option>';

												foreach ($my_quali_array as $quali_data)
												{
													if ($_POST['quali_id_string'] == $quali_data['quali_id'])
													{
														$selected = ' selected="selected"';
													}
													else
													{
														$selected = '';
													}

													echo '<option value="'.$quali_data['quali_id'].'"'.$selected.'>'.$quali_data['qualifikation'].'</option>';
												}
												echo '</optgroup>';
											}
											if (!empty($other_quali_array))
											{
												echo '<optgroup label="'.get_text(1015, 'return')/*Andere Qualifikationen*/.'">';
												foreach ($other_quali_array as $quali_data)
												{
													if ($_POST['quali_id_string'] == $quali_data['quali_id'])
													{
														$selected = ' selected="selected"';
													}
													else
													{
														$selected = '';
													}

													echo '<option value="'.$quali_data['quali_id'].'"'.$selected.'>'.$quali_data['qualifikation'].'</option>';
												}
												echo '</optgroup>';
											}
										?>
									</select>
								</span>
								<span id="user_data" <?php if ($_POST['filter_caltype_string'] != 'holiday'){echo ' style="display: none;"';} ?>>
									<select name="filter_user_int" id="filter_user_int" class="ipt_200">
										<option value=""><?php get_text('', 'echo', 'decode_on', 'please_select'); /*Bitte waehlen*/?></option>
										<?php
											$sql = $cdb->select("SELECT user_id, vorname, nachname FROM hdb_user WHERE anzeigen='j' ORDER BY sort_name ASC");
											while ($result = $cdb->fetch_array($sql))
											{
												if ($_POST['filter_user_int'] == $result['user_id'])
												{
													$selected = ' selected="selected"';
												}
												else
												{
													$selected = '';
												}
												echo '<option value="'.$result['user_id'].'"'.$selected.'>'.$result['nachname'].', '.$result['vorname'].'</option>';
											}
										?>
									</select>
								</span>
							</td>
						</tr>
						<tr>
							<td class="filter_td_2">
								<?php
									if ($access->check_group(USER_GROUP_ID, 'admin_antrag_read') or $access->check_group(USER_GROUP_ID, 'admin_antrag_write'))
									{
										get_text(1039);/*Noch nicht genehmigte Antraege anzeigen*/
									}
									else
									{
										echo '&nbsp;';
									}
								?>
							</td>
							<td class="filter_td_1">
								<?php
									if ($access->check_group(USER_GROUP_ID, 'admin_antrag_read') or $access->check_group(USER_GROUP_ID, 'admin_antrag_write'))
									{
										if ($_POST['show_open_status'] == 1)
										{
											echo '<input type="checkbox" name="show_open_status" value="1" checked="checked" />';
										}
										else
										{
											echo '<input type="checkbox" name="show_open_status" value="1" />';
										}
									}
									else
									{
										echo '&nbsp;';
									}
								?>
							</td>
							<td class="filter_td_2"><?php get_text('', 'echo', 'decode_on', 'jahr'); /*Jahr*/?>/<?php get_text('', 'echo', 'decode_on', 'monat'); /*Monat*/?>:</td>
							<td class="filter_td_2">
								<select name="filter_date_string" class="ipt_200">
									<option value=""><?php get_text('', 'echo', 'decode_on', 'please_select'); /*Bitte waehlen*/?></option>
									<?php
										$year_monat_array = array();
										$sql = $cdb->select("SELECT LEFT(t1.datum, 7) AS date FROM hdb_stz t1
															LEFT JOIN hdb_absence_type t2 ON t1.absence_id=t2.absence_type_id
															WHERE t1.absence_id>0 AND t2.application=1 GROUP BY LEFT(t1.datum, 7)");
										while ($result = $cdb->fetch_array($sql))
										{
											$year_monat_array[] = str_replace('-', '', $result['date']);
										}

										//Alle beantragungspflichtigen abwesenheitsgruende
										$sql = $cdb->select("SELECT LEFT(t1.date_from, 7) AS date_start, LEFT(t1.date_to, 7) AS date_end FROM hdb_absence_list t1
															LEFT JOIN hdb_absence_type t2 ON t1.absence_type_id=t2.absence_type_id
															WHERE LEFT(t1.date_from, 7)>='".date('Y-m')."' AND t2.application=1");
										while ($result = $cdb->fetch_array($sql))
										{
											$year_monat_array[] = str_replace('-', '', $result['date_start']);
											$year_monat_array[] = str_replace('-', '', $result['date_end']);
										}

										$year_monat_array = array_unique($year_monat_array);
										rsort($year_monat_array);
										$year_array = array();

										for ($i = 0; $i < count($year_monat_array); $i++)
										{
											$tmp_year_string = substr($year_monat_array[$i], 0, 4);
											$tmp_month_string = substr($year_monat_array[$i], 4, 2);

											if (!in_array($tmp_year_string, $year_array))
											{
												$year_array[] = $tmp_year_string;
												if ($_POST['filter_date_string'] == $tmp_year_string)
												{
													$selected = ' selected="selected"';
												}
												else
												{
													$selected = '';
												}
												echo '<option value="'.$tmp_year_string.'"'.$selected.'>'.$tmp_year_string.'</option>';
											}

											if ($_POST['filter_date_string'] == $tmp_year_string.'-'.$tmp_month_string)
											{
												$selected = ' selected="selected"';
											}
											else
											{
												$selected = '';
											}
											echo '<option value="'.$tmp_year_string.'-'.$tmp_month_string.'"'.$selected.'>'.$tmp_year_string.'/'.$tmp_month_string.'</option>';
										}
									?>
								</select>
							</td>
						</tr>
						<tr class="filter_tr_end">
							<td colspan="3"><?php echo get_button(get_text('', 'return', 'decode_on', 'reset') /*zuruecksetzen*/, 'cancel.png', 'onclick="document.filter_form.reset();"'); ?></td>
							<td colspan="2" align="right"><?php echo get_button(get_text('', 'return', 'decode_on', 'show') /*Anzeigen*/, 'tick.png', 'onclick="document.filter_form.submit();"', 'submit'); ?></td>
						</tr>
					</table>
				</div>
			</form>
			<br />
			<table cellpadding="0" cellspacing="2" border="0" width="100%">
				<colgroup>
					<col width="3%" />
					<col width="22%" />
					<col width="3%" />
					<col width="22%" />
					<col width="3%" />
					<col width="22%" />
					<col width="3%" />
					<col width="22%" />
				</colgroup>
				<?php
					$caption_array = array();
					$sql = $cdb->select('SELECT absence_name, color FROM hdb_absence_type WHERE display=1 AND application=1');
					while ($result = $cdb->fetch_array($sql))
					{
						$caption_array[] = array('name'	=> $result['absence_name'],
												'color'	=> $result['color']);
					}

					if ($_POST['filter_caltype_string'] == 'qualification')
					{
						$caption_array[] = array('name'	=> get_text(1016, 'return')/*kein Kritischer Wert erreicht*/,
												'class'	=> 'quali_ok');

						$caption_array[] = array('name'	=> get_text(1017, 'return')/*min. Wert erreicht*/,
												'class'	=> 'quali_error');

						$caption_array[] = array('name'	=> get_text(1018, 'return')/*Kritischer Wert erreicht*/,
												'class'	=> 'quali_critical');
					}
					if ($_POST['show_open_status'] == 1)
					{
						$caption_array[] = array('name'	=> '&times; = '.get_text(1038, 'return')/*Noch nicht genehmigt*/);
					}

					$line_count = ceil(count($caption_array) / 4);

					$array_count = 0;
					for ($l = 1; $l <= $line_count; $l++)
					{
						echo '<tr>';

						for ($td = 1; $td <= 4; $td++)
						{
							if (isset($caption_array[$array_count]))
							{
								if (isset($caption_array[$array_count]['color']) and !empty($caption_array[$array_count]['color']))
								{
									echo '<td style="background-color:#'.$caption_array[$array_count]['color'].';">&nbsp;</td>';
								}
								elseif (isset($caption_array[$array_count]['class']) and !empty($caption_array[$array_count]['class']))
								{
									echo '<td class="'.$caption_array[$array_count]['class'].'">&nbsp;</td>';
								}
								else
								{
									echo '<td>&nbsp;</td>';
								}

								echo '<td>'.$caption_array[$array_count]['name'].'</td>';
							}
							else
							{
								echo '<td colspan="2">&nbsp;</td>';
							}
							$array_count++;
						}

						echo '</tr>';
					}
				?>
			</table>
			<?php
				if (strlen($_POST['filter_date_string']) == 4)
				{
					$for_min = 1;
					$for_max = 12;
					$year_int = $_POST['filter_date_string'];
				}
				else
				{
					$for_min = intval(substr($_POST['filter_date_string'], 5, 2));
					$for_max = $for_min;
					$year_int = substr($_POST['filter_date_string'], 0, 4);
				}

				if (isset($_POST['quali_id_string']))
				{
					$holiday->set_options(array('quali_id' => $_POST['quali_id_string']));
				}

				if (isset($_POST['project_id_string']))
				{
					$holiday->set_options(array('project_id' => $_POST['project_id_string']));
				}

				if (isset($_POST['filter_user_int']) and $_POST['filter_user_int'] > 0)
				{
					$holiday->set_options(array('user_id' => $_POST['filter_user_int']));
				}

				if ($access->check_group(USER_GROUP_ID, 'admin_antrag_read') or $access->check_group(USER_GROUP_ID, 'admin_antrag_write'))
				{
					if ($_POST['show_open_status'] == 1)
					{
						$holiday->set_options(array('show_open_status' => 1));
					}
				}

				//$holiday->set_request_data(32, '2010-01-25', '2010-02-05', 2);

				//Monate Ausgeben
				for ($j = $for_min; $j <= $for_max; $j++)
				{
					echo $holiday->get_vacation_schedule($year_int, $j, $_POST['filter_caltype_string']);
				}

				//FIXME
				if ($_POST['filter_caltype_string'] == 'holiday')
				{
			?>
					<table width="100%">
						<tr>
							<td align="center">
								<form name="pdf_form" method="post" action="<?php echo TOM_ABS_URL.'report/pdf_holiday_year.php'; echo $gv->create_get_string(); ?>" target="_blank" accept-charset="UTF-8">
									<input type="hidden" name="filter_user_int" value="<?php echo $_POST['filter_user_int']; ?>" />
									<?php
										if (strlen($_POST['filter_date_string']) == 4)
										{
											echo '<input type="hidden" name="year_int" value="'.$_POST['filter_date_string'].'" />';
										}
										else
										{
											echo '<input type="hidden" name="year_int" value="'.substr($_POST['filter_date_string'], 0, 4).'" />';
											echo '<input type="hidden" name="month_int" value="'.intval(substr($_POST['filter_date_string'], 5, 2)).'" />';
										}

										echo get_button(get_text(588, 'return'), 'page_white_acrobat.png', 'onclick="document.pdf_form.submit();"', 'submit');//PDF Erstellen
									?>
								</form>
							</td>
						</tr>
					</table>
			<?php
				}
			?>
		</td>
	</tr>
</table>