<?php
	/**
	 * xml output of date-values for flextime and holidays
	 * @package time-o-meter
	 * @subpackage holiday
	 */

	/**
	 * include-sammlung einbinden
	 */
	require_once('../inc/include.php');

	//XML Header
	header('Content-type: application/xml');
	header("Cache-Control: no-cache, must-revalidate");
	header("Expires: ".date('r', time() - 86400));
	$return = '<?xml version="1.0" encoding="utf-8"?>'."\n";
	$return .= "<root>\n";
	$return .= "<data>\n";

	//pruefen ob alle GET Variablen vorhanden sind
	if (isset($_GET['absence_id_int']) and !empty($_GET['absence_id_int']) and isset($_GET['status']) and !empty($_GET['status']))
	{
		$where_array = array();
		$count = 0;

		$where_array[] = 'absence_type_id='.$_GET['absence_id_int'];

		if ($access->check_group(USER_GROUP_ID, 'admin_antrag_read') or $access->check_group(USER_GROUP_ID, 'admin_antrag_write'))
		{
			if (isset($_GET['user_id_int']) and $_GET['user_id_int'] > 0)
			{
				$where_array[] = 'user_id='.$_GET['user_id_int'];
			}
		}
		else
		{
			$where_array[] = 'user_id='.USER_ID;
		}

		$sql = $cdb->select('SELECT approval FROM hdb_absence_type WHERE absence_type_id='.$_GET['absence_id_int']);
		$result = $cdb->fetch_array($sql);

		//nur bei genehmigungspflichtigen abwesenheitsgruenden verwenden
		if ($result['approval'] == 1)
		{
			//genehmigte
			if ($_GET['status'] == 'open')
			{
				$where_array[] = "status='open'";
			}
			//abgelehnte
			elseif ($_GET['status'] == 'approved')
			{
				$where_array[] = "status='approved'";
			}
			//in bearbeitung
			elseif ($_GET['status'] == 'rejected')
			{
				$where_array[] = "status='rejected'";
			}
		}

		$where = '';
		for ($i = 0; $i < count($where_array); $i++)
		{
			if (empty($where))
			{
				$where = 'WHERE '.$where_array[$i];
			}
			else
			{
				$where .= ' AND '.$where_array[$i];
			}
		}
		$sql = $cdb->select('SELECT date_from FROM hdb_absence_list '.$where.' GROUP BY LEFT(date_from, 7) ORDER BY date_from ASC');
		while ($result = $cdb->fetch_array($sql))
		{
			$return .= '<date>'.str_replace('-', ' / ', substr($result['date_from'], 0, 7))."</date>\n";
			$count++;
		}

		if ($count == 0)
		{
			$return .= "<date>0000-00-00</date>\n";
		}
	}
	else
	{
		$return .= "<date>0000-00-00</date>\n";
	}

	$return .= "</data>\n";
	$return .= "</root>";

	echo utf8_encode($return);
?>