<?php
	/**
	 * xml output for the period between two dates
	 * @package time-o-meter
	 * @subpackage holiday
	 */

	/**
	 * include-sammlung einbinden
	 */
	require_once('../inc/include.php');

	//XML Header
	header('Content-type: application/xml');
	header("Cache-Control: no-cache, must-revalidate");
	header("Expires: ".date('r', time() - 86400));
	$return = '<?xml version="1.0" encoding="utf-8"?>'."\n";
	$return .= "<root>\n";
	$return .= "<holiday>\n";
	//pruefen ob alle GET Variablen vorhanden sind
	if (isset($_GET['start_date']) and !empty($_GET['start_date']) and isset($_GET['end_date']) and !empty($_GET['end_date']))
	{
		//Datumsangaben in ISO wandeln und pruefen
		$start_date_iso = $kal->is_iso_date($kal->free_to_iso($_GET['start_date']));
		$end_date_iso = $kal->is_iso_date($kal->free_to_iso($_GET['end_date']));

		//Keine Fehler
		if ($start_date_iso !== false and $end_date_iso !== false)
		{
			$holiday_count_float = 0;
			$chk_date = $start_date_iso;

			//Je Tag ein durchlauf
			while ($chk_date <= $end_date_iso)
			{

				//Wochenden keine Aktion
				if ($kal->is_weekend($chk_date))
				{
					//$holiday_count_float += 0;
				}
				//Feiertag keine Aktion
				elseif ($kal->is_holiday($chk_date))
				{
					//$holiday_count_float += 0;
				}
				//Halber Arbeitstag
				elseif ($kal->is_half_holiday($chk_date))
				{
					$holiday_count_float += 0.5;
				}
				//normaler Werktag
				else
				{
					$holiday_count_float += 1;
				}

				$chk_date_array = $kal->date_calculator($chk_date, '', '', 1);
				$chk_date = $chk_date_array[0];
			}
			$return .= "<days>$holiday_count_float</days>\n";
			$return .= "<startdate>$start_date_iso</startdate>\n";
			$return .= "<enddate>$end_date_iso</enddate>\n";
		}
		else
		{
			$return .= "<days>0</days>\n";
			$return .= "<startdate>0000-00-00</startdate>\n";
			$return .= "<enddate>0000-00-00</enddate>\n";
		}
	}
	else
	{
		$return .= "<days>0</days>\n";
		$return .= "<startdate>0000-00-00</startdate>\n";
		$return .= "<enddate>0000-00-00</enddate>\n";
	}
	$return .= "</holiday>\n";
	$return .= "</root>";
	echo utf8_encode($return);
?>