<?php
	/**
	 * xml output for the calendar
	 * @package time-o-meter
	 * @subpackage holiday
	 */

	/**
	 * include-sammlung einbinden
	 */
	require_once('../inc/include.php');

	//XML Header
	header('Content-type: application/xml');
	header("Cache-Control: no-cache, must-revalidate");
	header("Expires: ".date('r', time() - 86400));
	$return = '<?xml version="1.0" encoding="utf-8"?>'."\n";
	$return .= "<root>\n";
	$return .= "<holiday>\n";
	//pruefen ob alle GET Variablen vorhanden sind

	$get_error = false;
	//startdatum
	if (isset($_GET['start_date_string']) and !empty($_GET['start_date_string']))
	{
		$start_date_string = $kal->is_iso_date($kal->free_to_iso($_GET['start_date_string']));

		if ($start_date_string === false)
		{
			$get_error = true;
		}
	}
	else
	{
		$get_error = true;
	}

	//enddatum
	if (isset($_GET['end_date_string']) and !empty($_GET['end_date_string']))
	{
		$end_date_string = $kal->is_iso_date($kal->free_to_iso($_GET['end_date_string']));

		if ($end_date_string === false)
		{
			$get_error = true;
		}
	}
	else
	{
		$get_error = true;
	}

	if (!isset($_GET['caltype_string']) or ($_GET['caltype_string'] != 'holiday' and $_GET['caltype_string'] != 'qualification' and $_GET['caltype_string'] != 'project'))
	{
		$get_error = true;
	}

	if (!isset($_GET['absence_type_id_int']))
	{
		$get_error = true;
	}

	if (!isset($_GET['user_id_int']))
	{
		$get_error = true;
	}

	if ($get_error == false)
	{
		$holiday = new Holiday();

		if ($_GET['caltype_string'] == 'qualification')
		{
			if (isset($_GET['quali_id_string']) and !empty($_GET['quali_id_string']))
			{
				$holiday->set_options(array('quali_id' => $_GET['quali_id_string']));
			}
			else
			{
				$holiday->set_options(array('quali_id' => 0));
			}
		}
		elseif ($_GET['caltype_string'] == 'project')
		{
			if (isset($_GET['project_id_string']) and !empty($_GET['project_id_string']))
			{
				$holiday->set_options(array('project_id' => $_GET['project_id_string']));
			}
			else
			{
				$holiday->set_options(array('project_id' => 0));
			}
		}

		if (isset($_GET['show_open_status_int']) and $_GET['show_open_status_int'] == 1)
		{
			if ($access->check_group(USER_GROUP_ID, 'admin_antrag_read') or $access->check_group(USER_GROUP_ID, 'admin_antrag_write'))
			{
				$holiday->set_options(array('show_open_status' => 1));
			}
		}

		$holiday->set_request_data($_GET['user_id_int'], $start_date_string, $end_date_string, $_GET['absence_type_id_int']);

		$start_year_int = substr($start_date_string, 0, 4);
		$start_month_int = intval(substr($start_date_string, 5, 2));

		$end_year_int = substr($end_date_string, 0, 4);
		$end_month_int = intval(substr($end_date_string, 5, 2));

		$read_year_int = $start_year_int;
		$read_month_int = $start_month_int;

		$read_month_data = true;
		$month_data_string = '';
		while ($read_month_data === true)
		{
			$month_data_string .= $holiday->get_vacation_schedule($read_year_int, $read_month_int, $_GET['caltype_string']);
			$month_data_string .= "<br />";

			if ("$read_year_int-$read_month_int" == "$end_year_int-$end_month_int")
			{
				$read_month_data = false;
			}
			else
			{
				if ($read_month_int == 12)
				{
					$read_month_int = 1;
					$read_year_int++;
				}
				else
				{
					$read_month_int++;
				}
			}
		}

		$return .= "<month_data><![CDATA[$month_data_string]]></month_data>\n";
	}
	else
	{
		$return .= "<month_data><![CDATA[&nbsp;]]></month_data>\n";
	}
	$return .= "</holiday>\n";
	$return .= "</root>";
	echo utf8_encode($return);
?>