function TS_pdf_submit(project_count)
{
	//Tagesbezogener Stundenzettel
	if (document.PDFTimeSheet.pdf_type[0].checked == true)
	{
		document.PDFTimeSheet.submit();
	}
	//Projektbezogener Stundenzettel
	else
	{
		var project_checked = false;
		
		//Pruefen ob min. ein Projekt ausgewählt ist
		for (var i = 0; i < project_count; i++)
		{
			//Checkbox ist aktiviert
			if (document.getElementById("pdf_projekt_" + i).checked == true)
			{
				project_checked = true;
				break;
			}			
		}
		
		if (project_checked == true)
		{
			document.PDFTimeSheet.submit();
		}
		else
		{
			alert(txt_TS_pdf_submit);
		}
	}
}

/**
* waehlt den Stundenzettelreporttyp aus
* @return void
*/
function TS_pdf_set_type(project_count)
{
	//Tagesbezogener Stundenzettel
	if (document.PDFTimeSheet.pdf_type[0].checked == true)
	{
		//Ziel anpassen
		document.PDFTimeSheet.action = "../report/pdf_stz.php?" + JS_GV_INDEX + '=' + JS_GV_KEY;
		
		//Disabled
		document.PDFTimeSheet.elements["pdf[zeit]"].disabled = false;
		document.PDFTimeSheet.elements["pdf[kommentar]"].disabled = false;
		
		if (project_count > 0)
		{
			//NZS Spalte ist nur bei Projekten vorhanden
			document.PDFTimeSheet.elements["pdf[nzs]"].disabled = false;
		}
	}
	//Projektbezogener Stundenzettel
	else
	{
		//Ziel anpassen
		document.PDFTimeSheet.action = "../report/pdf_stz_project.php?" + JS_GV_INDEX + '=' + JS_GV_KEY;
		
		//Disabled
		document.PDFTimeSheet.elements["pdf[zeit]"].checked = false;
		document.PDFTimeSheet.elements["pdf[zeit]"].disabled = true;
		document.PDFTimeSheet.elements["pdf[kommentar]"].checked = false;
		document.PDFTimeSheet.elements["pdf[kommentar]"].disabled = true;
		
		if (project_count > 0)
		{
			//NZS Spalte ist nur bei Projekten vorhanden
			document.PDFTimeSheet.elements["pdf[nzs]"].checked = false;
			document.PDFTimeSheet.elements["pdf[nzs]"].disabled = true;
		}
		
		var project_checked = false;
		//Anzahl der Projekte
		for (var i = 0; i < project_count; i++)
		{
			if (project_checked == false)
			{			
				//Checkbox ist aktiviert
				if (document.getElementById("pdf_projekt_" + i).checked == true)
				{
					project_checked = true;
					document.getElementById("pdf_projektkommentar_" + i).disabled = false;
				}
			}
			else
			{
				document.getElementById("pdf_projekt_" + i).checked = false;
				document.getElementById("pdf_projektkommentar_" + i).disabled = true;
			}
		}			
	}
	
	TS_pdf_width(project_count, 'NULL');
}
function TS_pdf_check_project_checkbox(project_count, project)
{
	//Anzahl der Projekte
	for (var i = 0; i < project_count; i++)
	{
		if (project != i)
		{
			document.getElementById("pdf_projekt_" + i).checked = false;
			document.getElementById("pdf_projektkommentar_" + i).disabled = true;
		}
	}
}
/**
* Berechnet die Breite der aktuellen PDF Seitenausgabe
* @return void
*/
function TS_pdf_width(project_count, project)
{
	var pdf_width = 0;
	var pdf_tmp_width = 0;
	var pdf_max_width = 277;
	
	//Nur bei Projektbezogenen stundenzettel und nur wenn eine aenderung an den Projektckeckboxen erfolgt
	if (project != 'NULL' && document.PDFTimeSheet.pdf_type[1].checked == true)
	{
		TS_pdf_check_project_checkbox(project_count, project);
	}
	
	if (document.PDFTimeSheet.elements["pdf[datum]"].checked == true)
	{
		pdf_width += 15;
	}
	if (document.PDFTimeSheet.elements["pdf[kommen]"].checked == true)
	{
		pdf_width += 15;
	}
	if (document.PDFTimeSheet.elements["pdf[pause]"].checked == true)
	{
		pdf_width += 15;
	}
	if (document.PDFTimeSheet.elements["pdf[gehen]"].checked == true)
	{
		pdf_width += 15;
	}
	if (document.PDFTimeSheet.elements["pdf[istzeit]"].checked == true)
	{
		pdf_width += 15;
	}
	if (document.PDFTimeSheet.elements["pdf[abwesenheit]"].checked == true)
	{
		pdf_width += 20;
	}
	if (document.PDFTimeSheet.elements["pdf[zeit]"].checked == true)
	{
		pdf_width += 15;
	}
	if (document.PDFTimeSheet.elements["pdf[kommentar]"].checked == true)
	{
		pdf_width += 25;
	}
	
	//Projekte vorhanden
	if (project_count > 0)
	{
		//NZS Spalte ist nur bei Projekten vorhanden
		if (document.PDFTimeSheet.elements["pdf[nzs]"].checked == true)
		{
			pdf_width += 15;
		}
		
		//Anzahl der Projekte
		for (var i = 0; i < project_count; i++)
		{
			//Aktuelle breite
			pdf_tmp_width = pdf_width;
			
			//pruefen ob die naechste Spalte nicht die max. breite ueberschreitet
			if (pdf_max_width >= pdf_tmp_width + 15)
			{
			 	//Checkbox ist aktiviert
			 	if (document.getElementById("pdf_projekt_" + i).checked == true)
				{
					//Seitenbreite hochzaehlen
					pdf_width += 15;
					
					document.getElementById("pdf_projektkommentar_" + i).disabled = false;
					//Projektkommentar ist aktiviert
					if (document.getElementById("pdf_projektkommentar_" + i).checked == true)
					{
						pdf_tmp_width = pdf_width;
						//pruefen ob die naechste Spalte nicht die max. breite ueberschreitet
						if (pdf_max_width >= pdf_tmp_width + 25)
						{
							pdf_width += 25;
						}
						else
						{
							document.getElementById("pdf_projektkommentar_" + i).checked = false;
						}
					}
				}
				//Projektkommentarcheckbox deaktivieren
				else
				{
					document.getElementById("pdf_projektkommentar_" + i).checked = false;
					document.getElementById("pdf_projektkommentar_" + i).disabled = true;
				}
			}
			//Alle nachfolgenden Checkboxen leeren und gegebenenfalls auf disabled setzten
			else
			{
				document.getElementById("pdf_projekt_" + i).checked = false;
				document.getElementById("pdf_projektkommentar_" + i).checked = false;
				document.getElementById("pdf_projektkommentar_" + i).disabled = true;
			}
		}
	}
	
	document.getElementById("pdf_page_width").innerHTML = pdf_width + " mm";
	//TS_pdf_set_type(project_count);
}
/**
* oeffnet die Projektzeiteingabe und laed eventuell vorhandene Zeiten aus der DB bzw. Hiddenfelder
* @return void
*/
function TS_open_projekt_time(day, project)
{
	//pruefen ob ein bezahlter Abwesenheitsgrund ausgewaehlt ist
	if (!TS_chk_absence(day))
	{
		TS_open_time_pro[0] = day;
		TS_open_time_pro[1] = project;
		
		if (day < 10)
		{
			var day_string = "0" + day;
		}
		else
		{
			var day_string = day;
		}
		
		//Box einblenden und Sanduhr
		document.getElementById("dyn_area_pro_time").style.display = "";
		document.getElementById("dyn_area_pro_time").style.cursor = "wait";
		
		//Headerzeile schreiben
		document.getElementById("dyn_area_pro_time_header").innerHTML = TS_open_pro_time_header + " (" + TS_pro_name[project] + ") " + TS_year + "-" + TS_month + "-" + day_string;
		
		var value_kommen_string = "";
		var value_pause_string = "";
		var value_gehen_string = "";
		
		//pruefen ob bereits hiddenfelder vorhanden sind
		if (TS_pro_Te[day][project] == 1)
		{
			//Sonderzeichen wandeln
			value_kommen_string = TS_timeval(document.getElementById("pro_time_kommen_"+day+"_"+project).value);
			value_pause_string = TS_floatval(document.getElementById("pro_time_pause_"+day+"_"+project).value);
			value_gehen_string = TS_timeval(document.getElementById("pro_time_gehen_"+day+"_"+project).value);
			
			document.TimeSheet.pro_time_kommen.value = value_kommen_string;
			document.TimeSheet.pro_time_pause.value = value_pause_string;
			document.TimeSheet.pro_time_gehen.value = value_gehen_string;
			
			//Projektzeitenberechnung
			TS_calculate_project_time(value_kommen_string, value_pause_string, value_gehen_string);
		}
		else //keine hiddenfeld da daten in db suchen
		{
			//Inhalt aus DB Laden
			var xmlHttp = GetXmlHttpRequest();
			var time_string = "";
			if (xmlHttp)
			{
				xmlHttp.open('GET', JS_ABS_URL + "inc/TimeSheet_XML.php?type=pro_time&date=" + TS_year + "-" + TS_month + "-" + day_string + "&user=" + TS_user + "&project=" + project + '&' + JS_GV_INDEX + '=' + JS_GV_KEY, true);
				xmlHttp.onreadystatechange = function()
				{
					if (xmlHttp.readyState == 4)
					{
						var FILEDATA = xmlHttp.responseXML;
						//kommen
						var data = FILEDATA.getElementsByTagName('kommen');
						time_string = data[0].childNodes[0].nodeValue;
						if (time_string != "NULL")
						{
							value_kommen_string = TS_timeval(time_string);
						}
						//pause
						data = FILEDATA.getElementsByTagName('pause');
						time_string = data[0].childNodes[0].nodeValue;
						if (time_string != "NULL")
						{
							value_pause_string = TS_floatval(time_string);
						}
						//gehen
						data = FILEDATA.getElementsByTagName('gehen');
						time_string = data[0].childNodes[0].nodeValue;
						if (time_string != "NULL")
						{
							value_gehen_string = TS_timeval(time_string);
						}
						document.TimeSheet.pro_time_kommen.value = value_kommen_string;
						document.TimeSheet.pro_time_pause.value = value_pause_string;
						document.TimeSheet.pro_time_gehen.value = value_gehen_string;
						//projektberechnung aufrufen
						TS_calculate_project_time(value_kommen_string, value_pause_string, value_gehen_string);
					}
				}
				xmlHttp.send(null);
			}
		}
	}
}
/**
* Wird bei der Eingabe von Projektzeiten aktiviert
* @param string typ
* @return void
*/
function TS_start_pro_time(typ)
{
	//pruefen ob ein bezahlter Abwesenheitsgrund ausgewaehlt ist
	if (!TS_chk_absence(TS_open_time_pro[0]))
	{
		var kommen_string = "";
		var pause_float = 0;
		var gehen_string = "";
		
		//kommenzeit pruefen
		if (typ == "kommen")
		{
			kommen_string = TS_timeval(document.TimeSheet.pro_time_kommen.value);
			pause_float = document.TimeSheet.pro_time_pause.value;
			gehen_string = document.TimeSheet.pro_time_gehen.value;
			
			document.TimeSheet.pro_time_kommen.value = kommen_string;
		}
		//pausenzeit pruefen
		else if (typ == "pause")
		{
			kommen_string = document.TimeSheet.pro_time_kommen.value;
			pause_float = TS_floatval(document.TimeSheet.pro_time_pause.value);
			gehen_string = document.TimeSheet.pro_time_gehen.value;
			
			document.TimeSheet.pro_time_pause.value = pause_float;
		}
		//gehen zeit pruefen
		else if (typ == "gehen")
		{
			kommen_string = document.TimeSheet.pro_time_kommen.value;
			pause_float = document.TimeSheet.pro_time_pause.value;
			gehen_string = TS_timeval(document.TimeSheet.pro_time_gehen.value);
			
			document.TimeSheet.pro_time_gehen.value = gehen_string;
		}
		//Projektzeitberechnung aufrufen
		TS_calculate_project_time(kommen_string, pause_float, gehen_string);
	}
}
/**
* Brechnet die Projektzeiten
* @param string kommen
* @param float pause
* @param string gehen
* @return void
*/
function TS_calculate_project_time(kommen, pause, gehen)
{
	//kommen und gehen muss daten enthalten
	if (kommen != "" && gehen != "")
	{
		//zeitberechnung
		var pro_time_float = TS_calculate_time(kommen, pause, gehen);
		
		if (pro_time_float > 0)
		{
			//Zeitangabe ausgeben
			document.getElementById("pro_time_result").innerHTML = pro_time_float + " h";
			//temporaer zwischenspeichern
			TS_tmp_pro_time[0] = pro_time_float;
			TS_tmp_pro_time[1] = kommen;
			TS_tmp_pro_time[2] = pause;
			TS_tmp_pro_time[3] = gehen; 
		}
		else
		{
			//Zeitangabe ausgeben
			document.getElementById("pro_time_result").innerHTML = "&nbsp;";
			//temporaer zwischenspeichern
			TS_tmp_pro_time[0] = 0;
			TS_tmp_pro_time[1] = "";
			TS_tmp_pro_time[2] = "";
			TS_tmp_pro_time[3] = "";
		}
	}
	else
	{
		//Zeitangabe ausgeben
		document.getElementById("pro_time_result").innerHTML = "&nbsp;";
		//temporaer zwischenspeichern
		TS_tmp_pro_time[0] = 0;
		TS_tmp_pro_time[1] = "";
		TS_tmp_pro_time[2] = "";
		TS_tmp_pro_time[3] = "";
	}
	//Sanduhr entfernen
	document.getElementById("dyn_area_pro_time").style.cursor = "auto";
}
/**
* Schliesst das fenster zur eingabe der Projektzeiten und aktualisiert bzw. erstellt die hidden felder
* @return void
*/
function TS_close_pro_time()
{
	//ausblenden
	document.getElementById("dyn_area_pro_time").style.display = "none";
	
	//projektzeit fuer die gesamtzeitberechnung speichern
	TS_pro_T[TS_open_time_pro[0]][TS_open_time_pro[1]] = TS_tmp_pro_time[0];
	
	//ipt feld aktualisieren
	document.TimeSheet.elements["projektzeit["+TS_open_time_pro[0]+"]["+TS_open_time_pro[1]+"][stunden]"].value = TS_tmp_pro_time[0];
	
	//Projektzeiteingabefelder leeren
	document.getElementById("pro_time_result").innerHTML = "&nbsp;";
	document.TimeSheet.pro_time_kommen.value = "";
	document.TimeSheet.pro_time_pause.value = "";
	document.TimeSheet.pro_time_gehen.value = "";
	
	//hiddenfelder erstellen
	if (TS_pro_Te[TS_open_time_pro[0]][TS_open_time_pro[1]] == 0)
	{
		var kommen_element = document.createElement("input");
		kommen_element.setAttribute("type", "hidden", 1);
		kommen_element.setAttribute("name", "projektzeit["+TS_open_time_pro[0]+"]["+TS_open_time_pro[1]+"][kommen]", 1);
		kommen_element.setAttribute("id", "pro_time_kommen_"+TS_open_time_pro[0]+"_"+TS_open_time_pro[1], 1);
		kommen_element.setAttribute("value", TS_tmp_pro_time[1], 1);
		document.getElementById("TimeSheet").appendChild(kommen_element);
		
		var pause_element = document.createElement("input");
		pause_element.setAttribute("type", "hidden", 1);
		pause_element.setAttribute("name", "projektzeit["+TS_open_time_pro[0]+"]["+TS_open_time_pro[1]+"][pause]", 1);
		pause_element.setAttribute("id", "pro_time_pause_"+TS_open_time_pro[0]+"_"+TS_open_time_pro[1], 1);
		pause_element.setAttribute("value", TS_tmp_pro_time[2], 1);
		document.getElementById("TimeSheet").appendChild(pause_element);
		
		var gehen_element = document.createElement("input");
		gehen_element.setAttribute("type", "hidden", 1);
		gehen_element.setAttribute("name", "projektzeit["+TS_open_time_pro[0]+"]["+TS_open_time_pro[1]+"][gehen]", 1);
		gehen_element.setAttribute("id", "pro_time_gehen_"+TS_open_time_pro[0]+"_"+TS_open_time_pro[1], 1);
		gehen_element.setAttribute("value", TS_tmp_pro_time[3], 1);
		document.getElementById("TimeSheet").appendChild(gehen_element);
		
		//Markieren das hiddenfelder existieren
		TS_pro_Te[TS_open_time_pro[0]][TS_open_time_pro[1]] = 1;
	}
	else
	{
		//hiddenfelder aktualisieren
		document.getElementById("pro_time_kommen_"+TS_open_time_pro[0]+"_"+TS_open_time_pro[1]).value = TS_tmp_pro_time[1];
		document.getElementById("pro_time_pause_"+TS_open_time_pro[0]+"_"+TS_open_time_pro[1]).value = TS_tmp_pro_time[2];
		document.getElementById("pro_time_gehen_"+TS_open_time_pro[0]+"_"+TS_open_time_pro[1]).value = TS_tmp_pro_time[3];
	}
	
	//Bild aendern
	if (TS_tmp_pro_time[0] > 0 && TS_tmp_pro_time[1] != "" && TS_tmp_pro_time[3] != "")
	{
		document.getElementById("tpi_"+TS_open_time_pro[0]+"_"+TS_open_time_pro[1]).src = TS_img_pfad + "/time.png";
	}
	else
	{
		document.getElementById("tpi_"+TS_open_time_pro[0]+"_"+TS_open_time_pro[1]).src = TS_img_pfad + "/time_add.png";
	}
	
	//nzs Stunden neu berechnen
	TS_calculate_nzs(TS_open_time_pro[0]);
	TS_calculate_total_value("nzs");
	//Projektgesamtwerte
	TS_calculate_total_project_value(TS_open_time_pro[1]);
}
/**
* Schliesst das Fenster zur Eingabe der Projektzeiten
* @return void
*/
function TS_exit_pro_time()
{
	//ausblenden
	document.getElementById("dyn_area_pro_time").style.display = "none";
	
	//Projektzeiteingabefelder leeren
	document.getElementById("pro_time_result").innerHTML = "&nbsp;";
	document.TimeSheet.pro_time_kommen.value = "";
	document.TimeSheet.pro_time_pause.value = "";
	document.TimeSheet.pro_time_gehen.value = "";
}
/**
* oeffnet die Tagesprojektkommentareingabe und laed eventuell vorhandene Kommentare aus der DB bzw. hiddenfelder
* @return void
*/
function TS_open_pro_comment(day, project)
{
	//pruefen ob ein bezahlter Abwesenheitsgrund ausgewaehlt ist
	if (!TS_chk_absence(day))
	{
		TS_open_comment_pro[0] = day;
		TS_open_comment_pro[1] = project;
		
		if (day < 10)
		{
			var day_string = "0" + day;
		}
		else
		{
			var day_string = day;
		}
		//Box einblenden und Sanduhr
		document.getElementById("dyn_area_pro_comment").style.display = "";
		document.getElementById("dyn_area_pro_comment").style.cursor = "wait";
		
		//Headerzeile schreiben
		document.getElementById("dyn_area_pro_comment_header").innerHTML = TS_open_pro_comment_header + " (" + TS_pro_name[project] + ") " + TS_year + "-" + TS_month + "-" + day_string;
		
		//pruefen ob bereits ein hiddenfeld vorhanden
		if (TS_note[day][project] == 1)
		{
			//Sonderzeichen wandeln
			var value_string = document.getElementById("pro_kommentar_"+day+"_"+project).value;
			value_string = value_string.replace(/&quot;/g, "\"");
			value_string = value_string.replace(/&#039;/g, "\'");
			value_string = value_string.replace(/\[br\]/g, "\n");
			document.TimeSheet.dyn_pro_comment.value = value_string;
			//Sanduhr entfernen
			document.getElementById("dyn_area_pro_comment").style.cursor = "auto";
		}
		else
		{
			//Inhalt aus DB Laden
			var xmlHttp = GetXmlHttpRequest();
			var textarea_string = "";
			if (xmlHttp)
			{
				xmlHttp.open('GET', JS_ABS_URL + "inc/TimeSheet_XML.php?type=pro_comment&date=" + TS_year + "-" + TS_month + "-" + day_string + "&user=" + TS_user + "&project=" + project + '&' + JS_GV_INDEX + '=' + JS_GV_KEY, true);
				xmlHttp.onreadystatechange = function()
				{
					if (xmlHttp.readyState == 4)
					{
						var FILEDATA = xmlHttp.responseXML;
						var data = FILEDATA.getElementsByTagName('value');
						textarea_string = data[0].childNodes[0].nodeValue;
						if (textarea_string != "NULL")
						{
							document.TimeSheet.dyn_pro_comment.value = textarea_string
						}
						else
						{
							document.TimeSheet.dyn_pro_comment.value = "";
						}
						//Sanduhr entfernen
						document.getElementById("dyn_area_pro_comment").style.cursor = "auto";
					}
				}
				xmlHttp.send(null);
			}
		}
	}
}
/*
* Schliesst die Tagesprojektkommentareingabe ohne die uebernamhe der Werte in ein hidden feld
* @return void
*/
function TS_exit_pro_comment()
{
	//Box ausblenden
	document.getElementById("dyn_area_pro_comment").style.display = "none";
	document.TimeSheet.dyn_pro_comment.value = "";
}
/**
* Schliesst die Tagesprojektkommentareingabe und uebernimmt die Werte in ein hiddenfeld
* @return void
*/
function TS_close_pro_comment()
{
	//Box ausblenden
	document.getElementById("dyn_area_pro_comment").style.display = "none";
	
	if (document.TimeSheet.dyn_pro_comment.value != "")
	{
		var value_string = document.TimeSheet.dyn_pro_comment.value;
		//Sonderzeichen wandeln
		value_string = value_string.replace(/\"/g, "&quot;");
		value_string = value_string.replace(/\'/g, "&#039;");
		value_string = value_string.replace(/\r\n/g, "\n");
		value_string = value_string.replace(/\n/g, "[br]");
		//Bild aendern
		document.getElementById("cpi_"+TS_open_comment_pro[0]+"_"+TS_open_comment_pro[1]).src = TS_img_pfad + "/table.png";
	}
	else
	{
		var value_string = document.TimeSheet.dyn_day_comment.value;
		//Bild aendern
		document.getElementById("cpi_"+TS_open_comment_pro[0]+"_"+TS_open_comment_pro[1]).src = TS_img_pfad + "/table_add.png";
	}
	
	//Hiddenfeld existiert nicht
	if (TS_note[TS_open_comment_pro[0]][TS_open_comment_pro[1]] == 0)
	{
		var myelement = document.createElement("input");
		myelement.setAttribute("type", "hidden", 1);
		myelement.setAttribute("name", "projektkommentar["+TS_open_comment_pro[0]+"]["+TS_open_comment_pro[1]+"]", 1);
		myelement.setAttribute("id", "pro_kommentar_"+TS_open_comment_pro[0]+"_"+TS_open_comment_pro[1], 1);
		myelement.setAttribute("value", value_string, 1);
		document.getElementById("TimeSheet").appendChild(myelement);
		//Markieren das hiddenfeld erstellt wurde
		TS_note[TS_open_comment_pro[0]][TS_open_comment_pro[1]] = 1;
	}
	else
	{
		document.getElementById("pro_kommentar_"+TS_open_comment_pro[0]+"_"+TS_open_comment_pro[1]).value = value_string;
	}
	document.TimeSheet.dyn_pro_comment.value = "";
}
/**
* oeffnet die Tageskommentareingabe und laed eventuell vorhandene Kommentare aus der DB bzw. hiddenfelder
* @return void
*/
function TS_open_day_comment(day)
{
	TS_open_comment_day = day;
	
	if (day < 10)
	{
		var day_string = "0" + day;
	}
	else
	{
		var day_string = day;
	}
	//Box einblenden und Sanduhr
	document.getElementById("dyn_area_day_comment").style.display = "";
	document.getElementById("dyn_area_day_comment").style.cursor = "wait";
	
	//Headerzeile schreiben
	document.getElementById("dyn_area_day_comment_header").innerHTML = TS_open_day_comment_header + " " + TS_year + "-" + TS_month + "-" + day_string;
	
	//pruefen ob bereits ein hiddenfeld vorhanden
	if (TS_note[day][0] == 1)
	{
		//Sonderzeichen wandeln
		var value_string = document.getElementById("kommentar_"+day).value;
		value_string = value_string.replace(/&quot;/g, "\"");
		value_string = value_string.replace(/&#039;/g, "\'");
		value_string = value_string.replace(/\[br\]/g, "\n");
		document.TimeSheet.dyn_day_comment.value = value_string;
		//Sanduhr entfernen
		document.getElementById("dyn_area_day_comment").style.cursor = "auto";
	}
	else
	{
		//Inhalt aus DB Laden
		var xmlHttp = GetXmlHttpRequest();
		var textarea_string = "";
		if (xmlHttp)
		{
			xmlHttp.open('GET', JS_ABS_URL + "inc/TimeSheet_XML.php?type=day_comment&date=" + TS_year + "-" + TS_month + "-" + day_string + "&user=" + TS_user + '&' + JS_GV_INDEX + '=' + JS_GV_KEY, true);
			xmlHttp.onreadystatechange = function()
			{
				if (xmlHttp.readyState == 4)
				{
					var FILEDATA = xmlHttp.responseXML;
					var data = FILEDATA.getElementsByTagName('value');
					textarea_string = data[0].childNodes[0].nodeValue;
					if (textarea_string != "NULL")
					{
						document.TimeSheet.dyn_day_comment.value = textarea_string
					}
					else
					{
						document.TimeSheet.dyn_day_comment.value = "";
					}
					//Sanduhr entfernen
					document.getElementById("dyn_area_day_comment").style.cursor = "auto";
				}
			}
			xmlHttp.send(null);
		}
	}
}
/*
* Schliesst die Tageskommentareingabe ohne die uebernamhe der Werte in ein hidden feld
* @return void
*/
function TS_exit_day_comment()
{
	//Box ausblenden
	document.getElementById("dyn_area_day_comment").style.display = "none";
	document.TimeSheet.dyn_day_comment.value = "";
}
/**
* Schliesst die Tageskommentareingabe und uebernimmt die Werte in ein hiddenfeld
* @return void
*/
function TS_close_day_comment()
{
	//Box ausblenden
	document.getElementById("dyn_area_day_comment").style.display = "none";
	
	if (document.TimeSheet.dyn_day_comment.value != "")
	{
		var value_string = document.TimeSheet.dyn_day_comment.value;
		//Sonderzeichen wandeln
		value_string = value_string.replace(/\"/g, "&quot;");
		value_string = value_string.replace(/\'/g, "&#039;");
		value_string = value_string.replace(/\r\n/g, "\n");
		value_string = value_string.replace(/\n/g, "[br]");
		//Bild aendern
		document.getElementById("cdi_"+TS_open_comment_day).src = TS_img_pfad + "/table.png";
	}
	else
	{
		var value_string = document.TimeSheet.dyn_day_comment.value;
		//Bild aendern
		document.getElementById("cdi_"+TS_open_comment_day).src = TS_img_pfad + "/table_add.png";
	}
	
	//Hiddenfeld existiert nicht
	if (TS_note[TS_open_comment_day][0] == 0)
	{
		var myelement = document.createElement("input");
		myelement.setAttribute("type", "hidden", 1);
		myelement.setAttribute("name", "kommentar["+TS_open_comment_day+"]", 1);
		myelement.setAttribute("id", "kommentar_"+TS_open_comment_day, 1);
		myelement.setAttribute("value", value_string, 1);
		document.getElementById("TimeSheet").appendChild(myelement);
		//Markieren das hiddenfeld erstellt wurde
		TS_note[TS_open_comment_day][0] = 1;
	}
	else
	{
		document.getElementById("kommentar_"+TS_open_comment_day).value = value_string;
	}
	document.TimeSheet.dyn_day_comment.value = "";
}
/**
* Wenn keine Pausenzeit vorhanden wird die Standardpausenzeit eingetragen
* @param int day
* @return void
*/
function TS_pausenzeit(day)
{
	if (!TS_chk_absence(day))
	{
		if (isNaN(parseInt(document.TimeSheet.elements["pause["+day+"]"].value)))
		{
			var pause_int = TS_pausen_zeit;
			TS_write_element(pause_int, "pause", day);
		}
	}	
}
/**
* Startet die einzelnen Funktionen die fuer eine Arbeitszeitberechnung benoetigt werden.
* public
* @param string ipt, Inputfeld welche die funktion gestartet hat
* @param int day, 1-31
* @return void
*/
function TS_start_time(ipt, day)
{
	//pruefen ob ein bezahlter Abwesenheitsgrund ausgewaehlt ist
	if (!TS_chk_absence(day))
	{
		var kommen_string	= "";
		var pause_int		= 0;
		var gehen_string	= "";
		
		if (ipt == "kommen")
		{
			//Kommen Zeit pruefen und eintragen
			kommen_string	= TS_timeval(document.TimeSheet.elements["kommen["+day+"]"].value);
			pause_int		= document.TimeSheet.elements["pause["+day+"]"].value;
			gehen_string	= document.TimeSheet.elements["gehen["+day+"]"].value;
			
			TS_write_element(kommen_string, "kommen", day);
		}
		else if (ipt == "pause")
		{
			//Pause Zeit pruefen und eintragen
			kommen_string	= document.TimeSheet.elements["kommen["+day+"]"].value;
			pause_int = TS_intval(document.TimeSheet.elements["pause["+day+"]"].value);
			gehen_string	= document.TimeSheet.elements["gehen["+day+"]"].value;
			
			TS_write_element(pause_int, "pause", day);
		}
		else if (ipt == "gehen")
		{
			//Gehen Zeit pruefen und eintragen
			kommen_string	= document.TimeSheet.elements["kommen["+day+"]"].value;
			pause_int		= document.TimeSheet.elements["pause["+day+"]"].value;
			gehen_string	= TS_timeval(document.TimeSheet.elements["gehen["+day+"]"].value);
			
			TS_write_element(gehen_string, "gehen", day);
		}
		
		//Berechnung der Arbeitszeit starten
		if (kommen_string != "" && gehen_string != "")
		{
			var absence_full_day = true;
			var absence_id_int = 0;
			if (typeof document.TimeSheet.elements["abwesenheit["+day+"]"] != "undefined")
			{
				absence_id_int = TS_intval(document.TimeSheet.elements["abwesenheit["+day+"]"].value);
				if (absence_id_int > 0)
				{
					absence_full_day = TS_absence[absence_id_int];
				}
			}
			
			//Arbeitszeit berechnen
			var worktime_float = TS_calculate_time(kommen_string, pause_int, gehen_string);
			//ueberstunden
			var worktime_overtime = 0;
			
			if (worktime_float > 0)
			{
				//Arbeitszeit eintragen
				TS_write_element(worktime_float, "istzeit", day);
				//Istzeit aktualisieren
				TS_istzeit[day] = worktime_float;
				
				if (absence_id_int == 0)
				{
					//ueberstunden
					if (worktime_float < TS_day_setup[day]["min_sollstunden"])
					{
						worktime_overtime = worktime_float - TS_day_setup[day]["min_sollstunden"]; 
					}
					else if (worktime_float > TS_day_setup[day]["max_sollstunden"])
					{
						worktime_overtime = worktime_float - TS_day_setup[day]["max_sollstunden"];
					}
				}
				
				//ueberstunden aktualisieren
				TS_zeit[day] = worktime_overtime;
				
				if (worktime_overtime != 0)
				{
					TS_write_element(TS_round(worktime_overtime), "zeit", day);
				}
				else
				{
					TS_write_element("&nbsp;", "zeit", day);
				}
				TS_calculate_total_value("istzeit");
				TS_calculate_total_value("zeit");
				//NZS aktualisieren
				if (TS_project_exists == true)
				{
					TS_calculate_nzs(day);
					TS_calculate_total_value("nzs");
				}
			}
			else
			{
				//Istzeit aktualisieren
				TS_istzeit[day] = 0;
				//ueberstunden aktualisieren
				TS_zeit[day] = 0 - TS_day_setup[day]["min_sollstunden"];
				
				TS_calculate_total_value("istzeit");
				TS_calculate_total_value("zeit");
				//NZS aktualisieren
				if (TS_project_exists == true)
				{
					TS_calculate_nzs(day);
					TS_calculate_total_value("nzs");
				}
				
				//irgend ein fehler alle leeren
				TS_write_element("", "kommen", day);
				TS_write_element("", "pause", day);
				TS_write_element("", "gehen", day);
				TS_write_element("&nbsp", "istzeit", day);	
			}
		}
		else //kommen und gehen sind leer istzeit, zeit und nzs aktualisieren
		{
			//Istzeit aktualisieren
			TS_istzeit[day] = 0;
			//ueberstunden aktualisieren
			TS_zeit[day] = 0 - TS_day_setup[day]["min_sollstunden"];
			
			TS_write_element("&nbsp", "istzeit", day);
			
			if (TS_zeit[day] == 0)
			{
				TS_write_element("&nbsp;", "zeit", day);
			}
			else
			{
				TS_write_element(TS_zeit[day], "zeit", day);
			}
			TS_calculate_total_value("istzeit");
			TS_calculate_total_value("zeit");
			//NZS aktualisieren
			if (TS_project_exists == true)
			{
				TS_calculate_nzs(day);
				TS_calculate_total_value("nzs");
			}
		}
	}
}
/**
* Wandelt den Wert in einen Floatwert und aktualisiert die NZS zeiten
* public
* @param int project
* @param int day
* @return
*/
function TS_project_time(project, day)
{
	//pruefen ob ein bezahlter Abwesenheitsgrund ausgewaehlt ist
	if (!TS_chk_absence(day))
	{
		var project_time_float = 0;
		project_time_float = TS_floatval(document.TimeSheet.elements["projektzeit["+day+"]["+project+"][stunden]"].value);
		
		document.TimeSheet.elements["projektzeit["+day+"]["+project+"][stunden]"].value = project_time_float;
		TS_pro_T[day][project] = project_time_float;
		
		//NZS aktualisieren
		if (TS_project_exists == true)
		{
			TS_calculate_nzs(day);
			TS_calculate_total_value("nzs");
		}
		
		//Bild aendern
		if (project_time_float > 0)
		{
			document.getElementById("tpi_"+day+"_"+project).src = TS_img_pfad + "/time.png";
		}
		else
		{
			document.getElementById("tpi_"+day+"_"+project).src = TS_img_pfad + "/time_add.png";
		}
		
		//Projektgesamtwerte
		TS_calculate_total_project_value(project);
	}
	else
	{
		document.TimeSheet.elements["projektzeit["+day+"]["+project+"][stunden]"].value = "";
	}
}
/**
* prueft fuer den Tag den Abwesenheitsgrund. Ist dies ein Bezahlter Abwesenheitsgrund wird true zurueck gegeben ansonsten false
* @param int day
* @return boole
*/
function TS_chk_absence(day)
{
	if (typeof document.TimeSheet.elements["abwesenheit["+day+"]"] != "undefined")
	{
		var absence_id_int = TS_intval(document.TimeSheet.elements["abwesenheit["+day+"]"].value);
		if (TS_absence[absence_id_int] == true)
		{
			if (TS_absence_full_day[absence_id_int] == true)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			return false;
		}
	}
	else
	{
		return false;
	}
}
/**
* Startet die entsprechenden Aktionen beim auswaehlen eines Abwesenheitsgrundes
* public
* @param int day
* @return void
*/
function TS_set_absence(day)
{
	var absence_id_int = TS_intval(document.TimeSheet.elements["abwesenheit["+day+"]"].value);
	
	//es wurde ein abwesenheitsgrund ausgewaehlt
	if (absence_id_int > 0)
	{
		//Abwesenheitsdrund fuer den gesamten Tag verwenden?
		var absence_full_day = TS_absence_full_day[absence_id_int];
		
		//Abwesenheitsgrund fuer den gesamten tag.
		//Alle zeiten werden zurueckgesetzt
		if (absence_full_day == true)
		{
			//Urlaubstage
			if (absence_id_int == 2)
			{
				TS_urlaub[day] = TS_day_setup[day]["urlaubstag"];
			}
			else
			{
				TS_urlaub[day] = 0;
			}
			
			//Bezahlter abwesenheitsgrund
			if (TS_absence[absence_id_int] == true)
			{
				TS_zeit[day] = 0;
				//TS_istzeit[day] = TS_day_setup[day]["min_sollstunden"];
				TS_istzeit[day] = 0;
				TS_nzs[day] = 0;
				
				TS_write_element("", "kommen", day);
				TS_write_element("", "pause", day);
				TS_write_element("", "gehen", day);
				TS_write_element(TS_istzeit[day], "istzeit", day);
				TS_write_element("&nbsp;", "zeit", day);
				TS_write_element("&nbsp;", "nzs", day);
				
				TS_clear_project(day);
				TS_ipt_status(day, false);
			}
			else//minusstunden
			{
				TS_zeit[day] = 0 - TS_day_setup[day]["min_sollstunden"];
				TS_istzeit[day] = 0;
				TS_nzs[day] = 0;
				
				TS_write_element("", "kommen", day);
				TS_write_element("", "pause", day);
				TS_write_element("", "gehen", day);
				TS_write_element("&nbsp;", "istzeit", day);
				TS_write_element(TS_zeit[day], "zeit", day);
				TS_write_element("&nbsp;", "nzs", day);
				
				TS_clear_project(day);
				TS_ipt_status(day, false);
			}
		}
		//Abwesenheitsgrund zuzueglich zur arbeitszeit
		else
		{
			//Urlaubstage
			if (absence_id_int == 2)
			{
				//keine arbeitszeit eingetragen
				if (TS_istzeit[day] == 0)
				{
					TS_urlaub[day] = TS_day_setup[day]["urlaubstag"];
				}
				//arbeitszeit vorhanden
				else
				{
					//die bereits geleisteten stunden sind mehr als erforderlich. keinen urlaub abzeihen
					if (TS_istzeit[day] >= TS_day_setup[day]["min_sollstunden"])
					{
						TS_urlaub[day] = 0;
					}
					else
					{
						//Urlaubstage mit kommastelle
						TS_urlaub[day] = TS_round((TS_day_setup[day]["min_sollstunden"] - TS_istzeit[day]) / TS_day_setup[day]["min_sollstunden"] * TS_day_setup[day]["urlaubstag"]);
					}
				}
			}
			else
			{
				TS_urlaub[day] = 0;
			}
			
			//Bezahlter abwesenheitsgrund
			if (TS_absence[absence_id_int] == true)
			{
				TS_zeit[day] = 0;
				//TS_istzeit[day] = TS_day_setup[day]["min_sollstunden"];
				//TS_istzeit[day] = 0;
				//TS_nzs[day] = 0;
				
				/*
				TS_write_element("", "kommen", day);
				TS_write_element("", "pause", day);
				TS_write_element("", "gehen", day);
				TS_write_element(TS_istzeit[day], "istzeit", day);
				TS_write_element("&nbsp;", "zeit", day);
				TS_write_element("&nbsp;", "nzs", day);
				
				TS_clear_project(day);
				TS_ipt_status(day, false);
				*/
			}
			else//minusstunden
			{
				TS_zeit[day] = 0 - TS_day_setup[day]["min_sollstunden"];
				TS_istzeit[day] = 0;
				TS_nzs[day] = 0;
				
				/*
				TS_write_element("", "kommen", day);
				TS_write_element("", "pause", day);
				TS_write_element("", "gehen", day);
				TS_write_element("&nbsp;", "istzeit", day);
				TS_write_element(TS_zeit[day], "zeit", day);
				TS_write_element("&nbsp;", "nzs", day);
				
				TS_clear_project(day);
				TS_ipt_status(day, false);
				*/
			}
		}
	}
	else //gegebenenfalls disabled entfernen
	{
		TS_zeit[day] = 0 - TS_day_setup[day]["min_sollstunden"];
		TS_istzeit[day] = 0;
		TS_nzs[day] = 0;
		TS_urlaub[day] = 0;
		
		/*
		TS_write_element("", "kommen", day);
		TS_write_element("", "pause", day);
		TS_write_element("", "gehen", day);
		*/
		TS_write_element("&nbsp;", "istzeit", day);
		TS_write_element(TS_zeit[day], "zeit", day);
		TS_write_element("&nbsp;", "nzs", day);
		
		TS_clear_project(day);
		TS_ipt_status(day, true);
		
		TS_start_time("kommen", day);
	}
	TS_calculate_total_value("istzeit");
	TS_calculate_total_value("zeit");
	TS_calculate_total_value("urlaub");
	//NZS aktualisieren
	if (TS_project_exists == true)
	{
		TS_calculate_total_value("nzs");
		//Projektgesamtwerte
		for (var i = 0; i < TS_pro_id.length; i++)
		{
			TS_calculate_total_project_value(TS_pro_id[i]);
		}
	}
}
function TS_calculate_total_project_value(project)
{
	var count = 0;
	for (var i in TS_pro_T)
	{
		count += TS_pro_T[i][project];
	}
	document.getElementById("pro_time_all_"+project).innerHTML = count+" h";
}
/**
* Berechnet die Gesamtwerte
* @param string typ
* @return void
*/
function TS_calculate_total_value(typ)
{
	var count = 0;

	if (typ == "istzeit")
	{
		for (var i in TS_istzeit)
		{
			count+= TS_istzeit[i];
		}
		
		//TS_write_element(TS_round(count + TS_get_absence_hours()) + " h", "istzeit_all", "");
		TS_write_element(TS_round(count) + " h", "istzeit_all", "");
	}
	else if (typ == "zeit")
	{
		/*
		for (var i in TS_zeit)
		{
			count+= TS_zeit[i];
		}
		
		TS_write_element(TS_round(count) + " h", "zeit_all", "");
		
		count = TS_stunden_start + count;
		
		TS_write_element(TS_round(count) + " h", "uebertrag_all", "");
		*/
		
		for (var i in TS_istzeit)
		{
			count+= TS_istzeit[i];
		}
		
		if (count < TS_sollstunden_month)
		{
			count = count - TS_sollstunden_month;
		}
		else if (count > TS_sollstunden_month)
		{
			count = TS_sollstunden_month - count;
		}
		else
		{
			count = 0;
		}
		
		count = count + TS_get_absence_hours();
		
		TS_write_element(TS_round(count) + " h", "zeit_all", "");
		
		count = TS_stunden_start + count;
		
		TS_write_element(TS_round(count) + " h", "uebertrag_all", "");
	}
	else if (typ == "nzs")
	{
		for (var i in TS_nzs)
		{
			count+= TS_nzs[i];
		}
		
		TS_write_element(TS_round(count) + " h", "nzs_all", "");
	}
	else if (typ == "urlaub")
	{
		for (var i in TS_urlaub)
		{
			count+= TS_urlaub[i];
		}
		
		count = TS_urlaub_start - count;
		
		TS_write_element(TS_round(count), "urlaub_all", "");
	}
}

function TS_get_absence_hours()
{
	var absence_id_int = 0;
	var absence_hour_count = 0;
	
	for (var day = 1; day <= TS_month_day_count; day++)
	{
		if (typeof document.TimeSheet.elements["abwesenheit["+day+"]"] != "undefined")
		{
			absence_id_int = TS_intval(document.TimeSheet.elements["abwesenheit["+day+"]"].value);
			if (absence_id_int > 0)
			{
				absence_full_day = TS_absence[absence_id_int];
				//Bezahlter abwesenheitsgrund
				if (TS_absence[absence_id_int] == true)
				{
					//volle arbeitszeit rechnen
					if (TS_absence_full_day[absence_id_int] == true)
					{
						absence_hour_count += TS_day_setup[day]["min_sollstunden"];
					}
					//nur die restzeit rechnen
					else
					{
						if (TS_istzeit[day] >= TS_day_setup[day]["min_sollstunden"])
						{
							absence_hour_count += TS_day_setup[day]["min_sollstunden"];
						}
						else
						{
							absence_hour_count += TS_day_setup[day]["min_sollstunden"] - TS_istzeit[day];
						}
					}
				}				
			}
		}
	}
	return absence_hour_count;
}
/**
* Setzt die ipt felder auf read only oder gibt sie wieder frei
* @param int day
* @param activ boole
* @return
*/
function TS_ipt_status(day, activ)
{
	//aktivieren
	if (activ == true)
	{
		document.TimeSheet.elements["kommen["+day+"]"].readOnly = false;
		document.TimeSheet.elements["pause["+day+"]"].readOnly = false;
		document.TimeSheet.elements["gehen["+day+"]"].readOnly = false;
		
		//FIXME: Projektzeiten muessen noch mit rein
		for (var i = 0; i < TS_pro_id.length; i++)
		{
			document.TimeSheet.elements["projektzeit["+day+"]["+TS_pro_id[i]+"][stunden]"].readOnly = false;
		}
	}
	else//deaktivieren
	{
		document.TimeSheet.elements["kommen["+day+"]"].readOnly = true;
		document.TimeSheet.elements["pause["+day+"]"].readOnly = true;
		document.TimeSheet.elements["gehen["+day+"]"].readOnly = true;
		
		//FIXME: Projektzeiten muessen noch mit rein
		for(var i = 0; i < TS_pro_id.length; i++)
		{
			document.TimeSheet.elements["projektzeit["+day+"]["+TS_pro_id[i]+"][stunden]"].readOnly = true;
		}
	}
}
/**
* Leer alle eingaben eines tages
* @param int day
* @param boole zeit, true = zeit auf 0, false = zeit als fehlstunden
* @return void
*/
function TS_clear_project(day)
{
	//Projekte leeren
	//FIXME: Projektzeiten muessen noch raus
	for (var i = 0; i < TS_pro_id.length; i++)
	{
		//pruefen ob das ipt existiert
		if (typeof document.TimeSheet.elements["projektzeit["+day+"]["+TS_pro_id[i]+"][stunden]"].value != "undefined")
		{
			document.TimeSheet.elements["projektzeit["+day+"]["+TS_pro_id[i]+"][stunden]"].value = "";
		}
		//Projektzeiten loeschen
		TS_pro_T[day][TS_pro_id[i]] = 0;
		//Bild aendern
		document.getElementById("tpi_"+day+"_"+TS_pro_id[i]).src = TS_img_pfad + "/time_add.png";
	}
}
/**
* Berechnet die NZS Zeit
* @param int day
* @return void
*/
function TS_calculate_nzs(day)
{
	var nzs_time_float = 0;
	var project_time_float = 0;
	
	
	//Projekteingabefelder abarbeiten
	for (var i = 0; i < TS_pro_id.length; i++)
	{//alert(typeof TS_pro_id[i] + "#####" + day + "_" + TS_pro_id[i] + "__" + TS_pro_id.length + " i:" +i );
	
		//pruefen ob das ipt existiert
		if (typeof TS_pro_id[i] != "undefined" && typeof document.TimeSheet.elements["projektzeit["+day+"]["+TS_pro_id[i]+"][stunden]"].value != "undefined")
		{
			project_time_float += TS_floatval(document.TimeSheet.elements["projektzeit["+day+"]["+TS_pro_id[i]+"][stunden]"].value);
		}
	}
	
	if (TS_istzeit[day] != project_time_float)
	{
		nzs_time_float = TS_istzeit[day] - project_time_float;
	}
	else
	{
		nzs_time_float = 0;
	}
	
	//NZS Speichern
	TS_nzs[day] = nzs_time_float;
	
	if (nzs_time_float != 0)
	{
		TS_write_element(TS_round(nzs_time_float), "nzs", day);
	}
	else
	{
		TS_write_element("&nbsp;", "nzs", day);
	}
}
/**
* Berechnet die Arbeitszeit zwischen kommen pause und gehen
* @param string kommen, HH:MM
* @param int pause
* @param string gehen, HH:MM
* @return float
*/
function TS_calculate_time(kommen, pause, gehen)
{
	var kommen_array		= kommen.split(":");
	var gehen_array			= gehen.split(":");
	
	var kommen_stunde_int	= TS_intval(kommen_array[0]);
	var kommen_minute_int	= TS_intval(kommen_array[1]);
	var gehen_stunde_int	= TS_intval(gehen_array[0]);
	var gehen_minute_int	= TS_intval(gehen_array[1]);
	
	var kommen_time_int		= 0;
	var gehen_time_int		= 0;
	
	var total_time_float	= 0;
	
	//kommenzeit in minuten bis 00 Uhr
	if (kommen_minute_int != 0)
	{
		kommen_time_int = 60 - kommen_minute_int;
		kommen_stunde_int++; 
	}
	kommen_time_int += (24 - kommen_stunde_int) * 60;
	
	//gehenzeit in minuten bis 00 Uhr
	if (gehen_minute_int != 0)
	{
		gehen_time_int = 60 - gehen_minute_int;
		gehen_stunde_int++;
	}
	gehen_time_int += (24 - gehen_stunde_int) * 60;
	
	//Arbeitszeit berechnen wenn diese am selben tag ist
	if (gehen_stunde_int >= kommen_stunde_int)
	{
		total_time_float = kommen_time_int - gehen_time_int;
			
		if (total_time_float > pause)
		{
			total_time_float -= pause;
			total_time_float = TS_round(total_time_float / 60);
			return total_time_float; 
		}
		else
		{
			return 0;
		}
	}
	else//Arbeitszeit berechnen wenn diese ueber zwei tage geht
	{
		total_time_float = kommen_time_int + 1440 - gehen_time_int;
			
		if (total_time_float > pause)
		{
			total_time_float -= pause;
			total_time_float = TS_round(total_time_float / 60);
			return total_time_float; 
		}
		else
		{
			return 0;
		}
	}
}

function TS_set_time(ipt, day)
{
	//pruefen ob ein bezahlter Abwesenheitsgrund ausgewaehlt ist
	if (!TS_chk_absence(day))
	{
		var time_now = new Date();
		var h = time_now.getHours();
		var m = time_now.getMinutes();
		
		if (h < 10)
		{
			h = '0' + h;
		}
		
		if (m < 10)
		{
			m = '0' + m;
		}
		
		//Kommen Zeit
		if (ipt == "kommen")
		{
			var kommen_string = TS_timeval(h + ':' + m);
			TS_write_element(kommen_string, "kommen", day);
		}
		else if(ipt == "gehen")
		{
			var gehen_string = TS_timeval(h + ':' + m);
			TS_write_element(gehen_string, "gehen", day);
		}
	}
}
/**
* Schreibt einen wert in ein Inputfeld oder einen HTML tag
* @param string value, Zu schreibender Wert.
* @param string typ, Typ des zu beschreibenden elements
* @param int day. Tagesnummer 1-31
* @return void
*/
function TS_write_element(value, typ, day)
{
	if (typ == "istzeit")
	{
		document.getElementById("istzeit_"+day).innerHTML = value;
	}
	else if (typ == "zeit")
	{
		document.getElementById("zeit_"+day).innerHTML = value;
	}
	else if (typ == "nzs")
	{
		if (TS_project_exists == true)
		{
			document.getElementById("nzs_"+day).innerHTML = value;
		}
	}
	else if (typ == "istzeit_all")
	{
		document.getElementById("istzeit_all").innerHTML = value;
	}
	else if (typ == "zeit_all")
	{
		document.getElementById("zeit_all").innerHTML = value;
	}
	else if (typ == "uebertrag_all")
	{
		document.getElementById("uebertrag_all").innerHTML = value;
	}
	else if (typ == "nzs_all")
	{
		if (TS_project_exists == true)
		{
			document.getElementById("nzs_all").innerHTML = value;
		}
	}
	else if (typ == "urlaub_all")
	{
		document.getElementById("urlaub_all").innerHTML = value;
	}
	//ab hier werden nurnoch inputfelder beschrieben
	else if (typ == "kommen")
	{
		document.TimeSheet.elements["kommen["+day+"]"].value = value;
	}
	else if (typ == "pause")
	{
		document.TimeSheet.elements["pause["+day+"]"].value = value;
	}
	else if (typ == "gehen")
	{
		document.TimeSheet.elements["gehen["+day+"]"].value = value;
	}
}
/**
* Wandelt den uebergebenen Wert in einen Zeitstring HH:MM
* @param string time
* @return string
*/
function TS_timeval(time)
{
	//ersetzt alle Zeichen die keine zahl sind durch :
	var tmp_time_string = time.replace(/\D+/, ":");
	//anzahl der nichtzahlen
	var sign_count_int = 0;
	//anzahl der zeichen vor dem trennzeichen
	var sign_pra_count_int = 0;
	//anzahl der Zeichen nach dem trennzeichen
	var sign_suf_count_int = 0;
	
	for (var i = 0; i < tmp_time_string.length; i++)
	{
		if (sign_count_int > 0)
		{
			sign_suf_count_int++;
		}
		
		if (tmp_time_string.substr(i, 1) == ":")
		{
			sign_count_int++;
		}
		
		if (sign_count_int == 0)
		{
			sign_pra_count_int++;
		}
	}
	//es darf nur ein Trennzeichen geben
	if (sign_count_int == 1)
	{
		if (tmp_time_string.length == 5)
		{
			var time_array = tmp_time_string.split(":");
			var hour_int = TS_intval(time_array[0]);
			var minute_int = TS_intval(time_array[1]);
			
			if (hour_int >= 0 && hour_int <= 23 && minute_int >= 0 && minute_int <= 59)
			{
				//Zeiten runden
				if (TS_round_time_boole == true)
				{
					return TS_round_time(tmp_time_string);
				}
				else
				{
					return tmp_time_string;
				}
			}
			else
			{
				return "";
			} 
		}
		else if (sign_pra_count_int == 1 && sign_suf_count_int == 2)//bei stunden kleiner 10 fuehrende 0 ansetzten
		{
			tmp_time_string = "0"+tmp_time_string;
			var time_array = tmp_time_string.split(":");
			var hour_int = TS_intval(time_array[0]);
			var minute_int = TS_intval(time_array[1]);
			
			if (hour_int >= 0 && hour_int <= 23 && minute_int >= 0 && minute_int <= 59)
			{
				//Zeiten runden
				if (TS_round_time_boole == true)
				{
					return TS_round_time(tmp_time_string);
				}
				else
				{
					return tmp_time_string;
				}
			}
			else
			{
				return "";
			}
		}
		else
		{
			return "";
		}
	}
	else
	{
		return "";
	}
}

/**
* Rundet Zeitangaben auf volle viertel stunden ab oder auf
* @param string time
* @return string
*/
function TS_round_time(time)
{
	var time_array = time.split(":");
	var minute = TS_intval(time_array[1]);
	var stunde = TS_intval(time_array[0]);
	
	if (minute > 0 && minute <= 7)
	{
		minute = 0;
	}
	else if (minute >= 8 && minute <= 22)
	{
		minute = 15;
	}
	else if (minute >= 23 && minute <= 37)
	{
		minute = 30;
	}
	else if (minute >= 38 && minute <= 52)
	{
		minute = 45;
	}
	else if (minute >= 53)
	{
		minute = 0;
		stunde++;
		if (stunde == 24)
		{
			stunde = 0;
		}
	}
	
	if (stunde < 10)
	{
		stunde = "0" + stunde;
	}
	
	if (minute < 10)
	{
		minute = "0" + minute;
	}
	return stunde+":"+minute;
}

/**
* Wandelt den uebergebenen Wert in einen Integer Wert
* @param string string
* @return int
*/
function TS_intval(string)
{
	var tmp_int = parseInt(parseFloat(string));
	if (isNaN(tmp_int))
	{
		tmp_int = 0;
	} 
	return tmp_int;
}
/**
* Wandelt den uebergebenen Wert in einen Float Wert
* @param string string
* @return float
*/
function TS_floatval(string)
{
	var tmp_float = parseFloat(string.replace(/\D+/, "."));
	if (isNaN(tmp_float))
	{
		tmp_float = 0;
	} 
	return tmp_float;
}
/**
* Rundet einen Floatwert auf zwei stellen nach dem Komma
* @param float float
* @return float 
*/
function TS_round(float)
{
	float = float * 100;
	float = Math.round(float);
	float = float / 100;
	return float;
}