<?php
	class Project
	{
		private $request_data = array();

		public function set_request_data($request_data_array)
		{
			$this->request_data = $request_data_array;
		}

		/**
		 * Sammelt zu einem Projekt und einem Monat alle notwenigen Daten
		 * @param int $pro_id
		 * @param string $year_month Y-m
		 * @param string $status_type approved= es werden nur
		 * @return mixed false = wenn keine Daten vorhanden sind, array = wenn daten vorhanden sind
		 */
		public function get_project_data($pro_id, $year_month, $status_type = 'approved')
		{
			$cdb = new MySql();
			$kal = new Kalender();

			$return_array = array();

			$year = substr($year_month, 0, 4);
			$month = substr($year_month, 5, 2);

			//Qualifikation auslesen
			//nur Qualis mit Userzuordnungen
			$project_info = $this->get_project($pro_id, $year, $month);

			if ($project_info !== false)
			{
				//Qualifikationsdaten im return array Speichern
				$return_array['project_info'] = $project_info;
				//User Daten Speichern
				$return_array['user_info'] = array();
				//Freie Tage der User Speichern
				$return_array['user_away_info'] = array();
				//Speichert den Staus des Abwesenheitsgrundes
				$return_array['user_away_status'] = array();
				//anzahl der abwesenden user pro projekt und tag
				$return_array['user_away_count'] = array();

				$year_month = $year.'-'.$month;
				//alle User die dieser Qualifikation zugeordnet wurden
				$sql = $cdb->select('SELECT t1.user_id, t2.vorname, t2.nachname FROM hdb_user_projekt t1
									LEFT JOIN hdb_user t2 ON t1.user_id=t2.user_id
									LEFT JOIN hdb_projekte t3 ON t1.projekt_id=t3.projekt_id
									WHERE t1.projekt_id='.$pro_id." AND t1.anzeigen='j' AND t2.anzeigen='j' ORDER BY t2.sort_name ASC");
				while ($result = $cdb->fetch_array($sql))
				{
					$date_data_exist = false;

					//Stundenzettel kontrollieren
					$sub_sql = $cdb->select('SELECT t1.datum, t1.absence_id FROM hdb_stz t1
											LEFT JOIN hdb_absence_type t2 ON t1.absence_id=t2.absence_type_id
											WHERE t1.user_id='.$result['user_id']." AND LEFT(t1.datum, 7)='$year_month' AND t1.absence_id>0 AND t2.application=1");
					while ($sub_result = $cdb->fetch_array($sub_sql))
					{
						if (isset($sub_result['absence_id']) and !empty($sub_result['absence_id']))
						{
							$date_data_exist = true;
							$return_array['user_away_info'][$result['user_id']][$sub_result['datum']] = $sub_result['absence_id'];

							if (!isset($return_array['user_away_count'][$sub_result['datum']]))
							{
								$return_array['user_away_count'][$sub_result['datum']] = 1;
							}
							else
							{
								$return_array['user_away_count'][$sub_result['datum']]++;
							}
						}
					}

					//der monat ist der aktuelle bzw. in der zukunft
					if (intval($year.$month) >= intval(date('Ym')))
					{
						if ($status_type == 'approved')
						{
							$sub_where = 'WHERE t1.user_id='.$result['user_id']." AND LEFT(t1.date_from, 7)<='$year_month' AND LEFT(t1.date_to, 7)>='$year_month' AND t1.status='approved' AND t1.display=1 AND t2.application=1";
						}
						else
						{
							$sub_where = 'WHERE t1.user_id='.$result['user_id']." AND LEFT(t1.date_from, 7)<='$year_month' AND LEFT(t1.date_to, 7)>='$year_month' AND (t1.status='approved' OR t1.status='open') AND t1.display=1 AND t2.application=1";
						}

						//nach daten in den abwesenheitsanträgen suchen
						$sub_sql = $cdb->select("SELECT t1.as_id, t1.absence_type_id, t1.date_from, t1.date_to, t1.status,
												(
												SELECT CASE WHEN t1.status='approved' THEN 1
												WHEN t1.status='open' THEN 2
												WHEN t1.status='rejected' THEN 3
												ELSE 4 END
												) AS tbl_sort
												FROM hdb_absence_list t1
												LEFT JOIN hdb_absence_type t2 ON t1.absence_type_id=t2.absence_type_id
												$sub_where ORDER BY tbl_sort ASC");
						while ($sub_result = $cdb->fetch_array($sub_sql))
						{
							if (isset($sub_result['as_id']) and !empty($sub_result['as_id']))
							{
								$date_data_exist = true;

								if ($sub_result['date_from'] == $sub_result['date_to'])
								{
									$date_array = array();
									$date_array[0]['iso'] = $sub_result['date_from'];
								}
								else
								{
									$date_array = $kal->get_difference($sub_result['date_from'], $sub_result['date_to']);
								}

								for ($i = 0; $i < count($date_array); $i++)
								{
									$tmp_date = $date_array[$i]['iso'];
									if (substr($tmp_date, 0, 7) == $year_month)
									{
										if (!isset($return_array['user_away_info'][$result['user_id']][$tmp_date]))
										{
											//$return_array['user_away_info'][user_id][Y-m-d] = absence_type_id
											$return_array['user_away_info'][$result['user_id']][$tmp_date] = $sub_result['absence_type_id'];
											$return_array['user_away_status'][$result['user_id']][$tmp_date] = $sub_result['status'];

											if (!isset($return_array['user_away_count'][$tmp_date]))
											{
												$return_array['user_away_count'][$tmp_date] = 1;
											}
											else
											{
												$return_array['user_away_count'][$tmp_date]++;
											}
										}
										elseif (!isset($return_array['user_away_status'][$result['user_id']][$tmp_date]) or ($return_array['user_away_status'][$result['user_id']][$tmp_date] != 'approved' and $sub_result['status'] == 'approved'))
										{
											$return_array['user_away_info'][$result['user_id']][$tmp_date] = $sub_result['absence_type_id'];
											$return_array['user_away_status'][$result['user_id']][$tmp_date] = $sub_result['status'];
										}
									}
								}
							}
						}
					}

					//noch nicht gespeicherte antraege
					if (isset($this->request_data) and !empty($this->request_data))
					{
						if ($this->request_data['user_id'] == $result['user_id'])
						{
							foreach ($this->request_data['dates'] as $tmp_date)
							{
								if (substr($tmp_date, 0, 7) == $year_month)
								{
									$date_data_exist = true;
									if (!isset($return_array['user_away_info'][$this->request_data['user_id']][$tmp_date]))
									{
										$return_array['user_away_info'][$this->request_data['user_id']][$tmp_date] = $this->request_data['absence_type_id'];
										$return_array['user_away_status'][$this->request_data['user_id']][$tmp_date] = 'no_submitted';

										if (!isset($return_array['user_away_count'][$tmp_date]))
										{
											$return_array['user_away_count'][$tmp_date] = 1;
										}
										else
										{
											$return_array['user_away_count'][$tmp_date]++;
										}
									}
								}
							}
						}
					}

					if ($date_data_exist == true)
					{
						if (!isset($return_array['user_info'][$result['user_id']]))
						{
							//$return_array['user_info'][user_id] = nachname, vorname;
							$return_array['user_info'][$result['user_id']] = $result['nachname'].', '.$result['vorname'];
						}
					}
				}

				if (!empty($return_array['user_info']))
				{
					return $return_array;
				}
				else
				{
					return false;
				}
			}
			//keine Qualifikation gefunden
			else
			{
				return false;
			}
		}

		/**
		 * Gibt fuer ein oder alle Projekte Daten zurueck
		 * @param int $pro_id
		 * @param int $year
		 * @param string $month
		 * @return mixed, false oder array
		 */
		public function get_project($pro_id = 0, $year = '', $month= '')
		{
			if ($pro_id > 0)
			{
				return $this->get_one_project($pro_id, $year, $month);
			}
			else
			{
				return $this->get_all_projects($year, $month);
			}
		}

		/**
		 * Gibt zu allen Projekten Daten zurueck
		 * @param int $year
		 * @param string $month
		 * @return mixed, false oder array
		 */
		private function get_all_projects($year = '', $month = '')
		{
			$cdb = new MySql();

			$return_array = array();

			if (!empty($year) and !empty($month))
			{
				$tmp_year_month_int = $year.$month;
				$tmp_year_month_string = $year.'-'.$month;

				$where = "WHERE (anzeigen='j' OR LEFT(del_time, 6)>='$tmp_year_month_int') AND LEFT(start_datum, 7)<='$tmp_year_month_string' AND LEFT(end_datum ,7)>='$tmp_year_month_string'";
			}
			elseif (!empty($year))
			{
				$where = "WHERE (anzeigen='j' OR LEFT(del_time, 4)>='$year') AND LEFT(start_datum, 4)<='$year' AND LEFT(end_datum ,4)>='$year'";
			}
			else
			{
				$where = "WHERE anzeigen='j'";
			}

			$sql = $cdb->select("SELECT projekt_id, name, kurzname FROM hdb_projekte $where");
			while ($result = $cdb->fetch_array($sql))
			{
				if (isset($result['projekt_id']) and !empty($result['projekt_id']))
				{
					if (!empty($year) and !empty($month))
					{
						$tmp_year_month_int = $year.$month;

						$sub_where = 'WHERE t1.projekt_id='.$result['projekt_id']." AND (t1.anzeigen='j' OR LEFT(t1.del_time, 7)>='$tmp_year_month_int') AND t2.anzeigen='j'";
					}
					elseif (!empty($year))
					{
						$sub_where = 'WHERE t1.projekt_id='.$result['projekt_id']." AND (t1.anzeigen='j' OR LEFT(t1.del_time, 4)>='$year') AND t2.anzeigen='j'";
					}
					else
					{
						$sub_where = 'WHERE t1.projekt_id='.$result['projekt_id']." AND t1.anzeigen='j' AND t2.anzeigen='j'";
					}

					$sub_sql = $cdb->select('SELECT COUNT(t1.user_id) AS count_id FROM hdb_user_projekt t1
											LEFT JOIN hdb_user t2 ON t1.user_id=t2.user_id
											'.$sub_where);
					$user_result = $cdb->fetch_array($sub_sql);
					$result['user_count'] = $user_result['count_id'];

					//keine zuordnung vorhanden
					if (!empty($user_result['count_id']))
					{
						$return_array[] = $result;
					}
				}
			}

			if (empty($return_array))
			{
				return false;
			}
			else
			{
				return $return_array;
			}
		}

		/**
		 * Gibt zu einem Projekt Daten zurueck
		 * @param $pro_id
		 * @param int $year
		 * @param string $month
		 * @return mixed, false oder array
		 */
		private function get_one_project($pro_id, $year = '', $month = '')
		{
			$cdb = new MySql();

			if (!empty($year) and !empty($month))
			{
				$tmp_year_month_int = $year.$month;
				$tmp_year_month_string = $year.'-'.$month;
				$where = "WHERE projekt_id=$pro_id AND (anzeigen='j' OR LEFT(del_time, 6)>='$tmp_year_month_int') AND LEFT(start_datum, 7)<='$tmp_year_month_string' AND LEFT(end_datum ,7)>='$tmp_year_month_string'";
			}
			elseif (!empty($year))
			{
				$where = "WHERE projekt_id=$pro_id AND (anzeigen='j' OR LEFT(del_time, 4)>='$year') AND LEFT(start_datum, 4)<='$year' AND LEFT(end_datum ,4)>='$year'";
			}
			else
			{
				$where = "WHERE projekt_id=$pro_id AND anzeigen='j'";
			}

			$sql = $cdb->select("SELECT projekt_id, name, kurzname FROM hdb_projekte $where");
			$result = $cdb->fetch_array($sql);

			if (isset($result['projekt_id']) and !empty($result['projekt_id']))
			{
				if (!empty($year) and !empty($month))
				{
					$tmp_year_month_int = $year.$month;

					$sub_where = 'WHERE t1.projekt_id='.$result['projekt_id']." AND (t1.anzeigen='j' OR LEFT(t1.del_time, 7)>='$tmp_year_month_int') AND t2.anzeigen='j'";
				}
				elseif (!empty($year))
				{
					$sub_where = 'WHERE t1.projekt_id='.$result['projekt_id']." AND (t1.anzeigen='j' OR LEFT(t1.del_time, 4)>='$year') AND t2.anzeigen='j'";
				}
				else
				{
					$sub_where = 'WHERE t1.projekt_id='.$result['projekt_id']." AND t1.anzeigen='j' AND t2.anzeigen='j'";
				}

				$sub_sql = $cdb->select('SELECT COUNT(t1.user_id) AS count_id FROM hdb_user_projekt t1
										LEFT JOIN hdb_user t2 ON t1.user_id=t2.user_id
										'.$sub_where);
				$user_result = $cdb->fetch_array($sub_sql);
				$result['user_count'] = $user_result['count_id'];

				//keine zuordnung vorhanden
				if (empty($user_result['count_id']))
				{
					return false;
				}
				else
				{
					return $result;
				}
			}
			else
			{
				return false;
			}
		}

		/**
		 * Prueft ob es min. eine Projekt mit Userzuordnungen gibt
		 * @param $year_month
		 * @return unknown_type
		 */
		public function exist_with_assignment($year_month = '')
		{
			$cdb = new MySql();

			if (empty($year_month))
			{
				$where = '';
			}
			//nur das jahr vorhanden
			elseif (strlen($year_month) == 4)
			{
				$where = " AND LEFT(t1.start_datum, 4)<='$year_month' AND LEFT(end_datum, 4)>='$year_month'";
			}
			//jahr und monat
			elseif (strlen($year_month) == 7)
			{
				$where = " AND LEFT(t1.start_datum, 7)<='$year_month' AND LEFT(end_datum, 7)>='$year_month'";
			}
			else
			{
				$where = '';
			}

			$sql = $cdb->select("SELECT t1.projekt_id FROM hdb_projekte t1
								LEFT JOIN hdb_user_projekt t2 ON t1.projekt_id=t2.projekt_id
								LEFT JOIN hdb_user t3 ON t2.user_id=t3.user_id
								WHERE t1.anzeigen='j' AND t2.anzeigen='j' AND t3.anzeigen='j'$where");
			$result = $cdb->fetch_array($sql);

			if (isset($result['projekt_id']) and $result['projekt_id'] > 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}

		/**
		 * Gibt fuer den Jahresurlaubsplan die HTML td fuer die Projektzeile zurueck
		 * @param int $user_count
		 * @param int $user_away_count
		 * @param int $min_headcount
		 * @param int $critical_headcount
		 * @return string
		 */
		public function get_project_status_td($user_count = 0, $user_away_count = 0, $min_headcount = 0, $critical_headcount = 0)
		{
			//keine user abwesend
			if ($user_away_count == 0)
			{
				return '<td width="3%">&nbsp;</td>';
			}
			//keine pruefung erwuenscht
			elseif ($min_headcount == 0)
			{
				return '<td width="3%" class="quali_ok">nbsp;</td>';
			}
			//zugeordnete User sind weniger als der mindestbestand
			elseif ($user_count <= $min_headcount)
			{
				return '<td width="3%" class="quali_error">&nbsp;</td>';
			}
			//zugeordnete User sind weniger als der kritischebestand
			elseif ($user_count <= $critical_headcount)
			{
				return '<td width="3%" class="quali_critical">&nbsp;</td>';
			}
			else
			{
				$persons_present = $user_count - $user_away_count;

				if ($persons_present <= $min_headcount)
				{
					return '<td width="3%" class="quali_error">&nbsp;</td>';
				}
				elseif ($persons_present <= $critical_headcount)
				{
					return '<td width="3%" class="quali_critical">&nbsp;</td>';
				}
				else
				{
					return '<td width="3%" class="quali_ok">&nbsp;</td>';
				}
			}
		}
	}
?>