<?php
	class Qualification
	{
		private $request_data = array();

		public function set_request_data($request_data_array)
		{
			$this->request_data = $request_data_array;
		}

		/**
		 * Sammelt zu einer Qualifikation und einem Monat alle notwenigen Daten
		 * @param int $quali_id
		 * @param string $year_month Y-m
		 * @param string $status_type approved= es werden nur
		 * @return mixed false = wenn keine Daten vorhanden sind, array = wenn daten vorhanden sind
		 */
		public function get_quali_data($quali_id, $year_month, $status_type = 'approved')
		{
			$cdb = new MySql();
			$kal = new Kalender();

			$return_array = array();

			$year = substr($year_month, 0, 4);
			$month = substr($year_month, 5, 2);

			//Qualifikation auslesen
			//nur Qualis mit Userzuordnungen
			$quali_info = $this->get_qualification($quali_id);

			if ($quali_info !== false)
			{
				//Qualifikationsdaten im return array Speichern
				$return_array['quali_info'] = $quali_info;
				//User Daten Speichern
				$return_array['user_info'] = array();
				//Freie Tage der User Speichern
				$return_array['user_away_info'] = array();
				//Speichert den Staus des Abwesenheitsgrundes
				$return_array['user_away_status'] = array();
				//anzahl der abwesenden user pro quali und tag
				$return_array['user_away_count'] = array();

				$year_month = $year.'-'.$month;
				//alle User die dieser Qualifikation zugeordnet wurden
				$sql = $cdb->select('SELECT t1.user_id, t2.vorname, t2.nachname FROM hdb_user_qualifikation t1
									LEFT JOIN hdb_user t2 ON t1.user_id=t2.user_id
									LEFT JOIN hdb_qualifikation t3 ON t1.quali_id=t3.quali_id
									WHERE t1.quali_id='.$quali_id." AND t2.anzeigen='j' ORDER BY t3.qualifikation ASC, t2.sort_name ASC");
				while ($result = $cdb->fetch_array($sql))
				{
					$date_data_exist = false;

					//Stundenzettel kontrollieren
					$sub_sql = $cdb->select('SELECT t1.datum, t1.absence_id FROM hdb_stz t1
											LEFT JOIN hdb_absence_type t2 ON t1.absence_id=t2.absence_type_id
											WHERE t1.user_id='.$result['user_id']." AND LEFT(t1.datum, 7)='$year_month' AND t1.absence_id>0 AND t2.application=1");
					while ($sub_result = $cdb->fetch_array($sub_sql))
					{
						if (isset($sub_result['absence_id']) and !empty($sub_result['absence_id']))
						{
							$date_data_exist = true;
							$return_array['user_away_info'][$result['user_id']][$sub_result['datum']] = $sub_result['absence_id'];

							if (!isset($return_array['user_away_count'][$sub_result['datum']]))
							{
								$return_array['user_away_count'][$sub_result['datum']] = 1;
							}
							else
							{
								$return_array['user_away_count'][$sub_result['datum']]++;
							}
						}
					}

					//der monat ist der aktuelle bzw. in der zukunft
					if (intval($year.$month) >= intval(date('Ym')))
					{
						if ($status_type == 'approved')
						{
							$sub_where = 'WHERE t1.user_id='.$result['user_id']." AND LEFT(t1.date_from, 7)<='$year_month' AND LEFT(t1.date_to, 7)>='$year_month' AND t1.status='approved' AND t1.display=1 AND t2.application=1";
						}
						else
						{
							$sub_where = 'WHERE t1.user_id='.$result['user_id']." AND LEFT(t1.date_from, 7)<='$year_month' AND LEFT(t1.date_to, 7)>='$year_month' AND (t1.status='approved' OR t1.status='open') AND t1.display=1 AND t2.application=1";
						}

						//nach daten in den abwesenheitsanträgen suchen
						$sub_sql = $cdb->select("SELECT t1.as_id, t1.absence_type_id, t1.date_from, t1.date_to, t1.status,
												(
												SELECT CASE WHEN t1.status='approved' THEN 1
												WHEN t1.status='open' THEN 2
												WHEN t1.status='rejected' THEN 3
												ELSE 4 END
												) AS tbl_sort
												FROM hdb_absence_list t1
												LEFT JOIN hdb_absence_type t2 ON t1.absence_type_id=t2.absence_type_id
												$sub_where ORDER BY tbl_sort ASC");
						while ($sub_result = $cdb->fetch_array($sub_sql))
						{
							if (isset($sub_result['as_id']) and !empty($sub_result['as_id']))
							{
								$date_data_exist = true;

								if ($sub_result['date_from'] == $sub_result['date_to'])
								{
									$date_array = array();
									$date_array[0]['iso'] = $sub_result['date_from'];
								}
								else
								{
									$date_array = $kal->get_difference($sub_result['date_from'], $sub_result['date_to']);
								}

								for ($i = 0; $i < count($date_array); $i++)
								{
									$tmp_date = $date_array[$i]['iso'];
									if (substr($tmp_date, 0, 7) == $year_month)
									{
										if (!isset($return_array['user_away_info'][$result['user_id']][$tmp_date]))
										{
											//$return_array['user_away_info'][user_id][Y-m-d] = absence_type_id
											$return_array['user_away_info'][$result['user_id']][$tmp_date] = $sub_result['absence_type_id'];
											$return_array['user_away_status'][$result['user_id']][$tmp_date] = $sub_result['status'];

											if (!isset($return_array['user_away_count'][$tmp_date]))
											{
												$return_array['user_away_count'][$tmp_date] = 1;
											}
											else
											{
												$return_array['user_away_count'][$tmp_date]++;
											}
										}
										elseif (!isset($return_array['user_away_status'][$result['user_id']][$tmp_date]) or ($return_array['user_away_status'][$result['user_id']][$tmp_date] != 'approved' and $sub_result['status'] == 'approved'))
										{
											$return_array['user_away_info'][$result['user_id']][$tmp_date] = $sub_result['absence_type_id'];
											$return_array['user_away_status'][$result['user_id']][$tmp_date] = $sub_result['status'];
										}
									}
								}
							}
						}
					}

					//noch nicht gespeicherte antraege
					if (isset($this->request_data) and !empty($this->request_data))
					{
						if ($this->request_data['user_id'] == $result['user_id'])
						{
							foreach ($this->request_data['dates'] as $tmp_date)
							{
								if (substr($tmp_date, 0, 7) == $year_month)
								{
									$date_data_exist = true;
									if (!isset($return_array['user_away_info'][$this->request_data['user_id']][$tmp_date]))
									{
										$return_array['user_away_info'][$this->request_data['user_id']][$tmp_date] = $this->request_data['absence_type_id'];
										$return_array['user_away_status'][$this->request_data['user_id']][$tmp_date] = 'no_submitted';

										if (!isset($return_array['user_away_count'][$tmp_date]))
										{
											$return_array['user_away_count'][$tmp_date] = 1;
										}
										else
										{
											$return_array['user_away_count'][$tmp_date]++;
										}
									}
								}
							}
						}
					}

					if ($date_data_exist == true)
					{
						if (!isset($return_array['user_info'][$result['user_id']]))
						{
							//$return_array['user_info'][user_id] = nachname, vorname;
							$return_array['user_info'][$result['user_id']] = $result['nachname'].', '.$result['vorname'];
						}
					}
				}

				if (!empty($return_array['user_info']))
				{
					return $return_array;
				}
				else
				{
					return false;
				}
			}
			//keine Qualifikation gefunden
			else
			{
				return false;
			}
		}

		/**
		 * Prueft ob zum uebergebenen User ein Abwesenheitsgrund existiert
		 * @param int $user_id
		 * @param string $status
		 * @param int $year
		 * @param string $month
		 * @return boole
		 */
		private function absence_in_this_month_exists($user_id, $status, $year, $month)
		{
			$cdb = new MySql();

			$year_month = $year.'-'.$month;

			//Stundenzettel kontrollieren
			$sub_sql = $cdb->select('SELECT t1.absence_id FROM hdb_stz t1
									LEFT JOIN hdb_absence_type t2 ON t1.absence_id=t2.absence_type_id
									WHERE t1.user_id='.$user_id." AND LEFT(t1.datum, 7)='$year_month' AND t1.absence_id>0 AND t2.application=1");
			$sub_result = $cdb->fetch_array($sub_sql);

			if (isset($sub_result['absence_id']) and !empty($sub_result['absence_id']))
			{
				return true;
			}

			if (intval($year.$month) >= intval(date('Ym')))
			{
				if ($status == 'approved')
				{
					$sub_where = 'WHERE t1.user_id='.$user_id." AND LEFT(t1.date_from, 7)<='$year_month' AND LEFT(t1.date_to, 7)>='$year_month' AND t1.status='approved' AND t1.display=1 AND t2.application=1";
				}
				else
				{
					$sub_where = 'WHERE t1.user_id='.$user_id." AND LEFT(t1.date_from, 7)<='$year_month' AND LEFT(t1.date_to, 7)>='$year_month' AND (t1.status='approved' OR t1.status='open') AND t1.display=1 AND t2.application=1";
				}

				//nach daten in den abwesenheitsanträgen suchen
				$sub_sql = $cdb->select('SELECT t1.as_id FROM hdb_absence_list t1
										LEFT JOIN hdb_absence_type t2 ON t1.absence_type_id=t2.absence_type_id
										'.$sub_where);
				$sub_result = $cdb->fetch_array($sub_sql);

				if (isset($sub_result['as_id']) and !empty($sub_result['as_id']))
				{
					return true;
				}
			}

			if (isset($this->request_data) and !empty($this->request_data))
			{
				if ($this->request_data['user_id'] == $user_id)
				{
					foreach ($this->request_data['dates'] as $request_date)
					{
						if (substr($request_date, 0, 7) == $year.'-'.$month)
						{
							return true;
						}
					}
				}
			}

			return false;
		}

		/**
		 * Gibt fuer eine Qualifikation fuer einen Tag die ensprechende Statusfarbe zurück
		 * @param int $user_count
		 * @param int $user_away_count
		 * @param int $min_headcount
		 * @param int $critical_headcount
		 * @return string
		 */
		public function get_quali_status_td($user_count, $user_away_count, $min_headcount, $critical_headcount)
		{
			//keine user abwesend
			if ($user_away_count == 0)
			{
				return '<td width="3%">&nbsp;</td>';
			}
			//keine pruefung erwuenscht
			elseif ($min_headcount == 0)
			{
				return '<td width="3%" class="quali_ok">nbsp;</td>';
			}
			//zugeordnete User sind weniger als der mindestbestand
			elseif ($user_count <= $min_headcount)
			{
				return '<td width="3%" class="quali_error">&nbsp;</td>';
			}
			//zugeordnete User sind weniger als der kritischebestand
			elseif ($user_count <= $critical_headcount)
			{
				return '<td width="3%" class="quali_critical">&nbsp;</td>';
			}
			else
			{
				$persons_present = $user_count - $user_away_count;

				if ($persons_present <= $min_headcount)
				{
					return '<td width="3%" class="quali_error">&nbsp;</td>';
				}
				elseif ($persons_present <= $critical_headcount)
				{
					return '<td width="3%" class="quali_critical">&nbsp;</td>';
				}
				else
				{
					return '<td width="3%" class="quali_ok">&nbsp;</td>';
				}
			}
		}

		/**
		 * Gibt die Qualifikationen zu einem User zurueck
		 * @param int $user_id
		 * @return array
		 */
		public function get_user_qualifications($user_id)
		{
			$cdb = new MySql();

			$quali_array = array();
			$sql = $cdb->select('SELECT t2.* FROM hdb_user_qualifikation t1
								LEFT JOIN hdb_qualifikation t2 ON t1.quali_id=t2.quali_id
								WHERE t1.user_id='.$user_id);
			while ($result = $cdb->fetch_array($sql))
			{
				$quali_array[] = $result;
			}
			return $quali_array;
		}

		/**
		 * Gibt eine oder mehrere Qualifikationen zurueck.
		 * @param int $q_id
		 * @param boole $min_headcount
		 * @param boole $only_with_mappings
		 * @return mixed
		 */
		public function get_qualification($q_id = 0, $min_headcount = true, $only_with_mappings = true)
		{
			if ($q_id > 0)
			{
				return $this->get_one_qualification($q_id, $min_headcount, $only_with_mappings);
			}
			else
			{
				return $this->get_all_qualification($min_headcount, $only_with_mappings);
			}
		}

		/**
		 * Gibt alle Qualifikationen zurueck
		 * @param boole $min_headcount
		 * @param boole $only_with_mappings
		 * @return mixed
		 */
		private function get_all_qualification($min_headcount, $only_with_mappings)
		{
			$cdb = new MySql();

			if ($min_headcount == true)
			{
				$where_string = 'WHERE min_headcount>0';
			}
			else
			{
				$where_string = '';
			}

			$return_array = array();
			$sql = $cdb->select('SELECT * FROM hdb_qualifikation '.$where_string.' ORDER BY qualifikation ASC');
			while ($result = $cdb->fetch_array($sql))
			{
				$user_sql = $cdb->select('SELECT COUNT(t1.user_id) as count_id FROM hdb_user_qualifikation t1
										LEFT JOIN hdb_user t2 ON t1.user_id=t2.user_id
										WHERE t1.quali_id='.$result['quali_id']." AND t2.anzeigen='j'");
				$user_result = $cdb->fetch_array($user_sql);
				$result['user_count'] = $user_result['count_id'];

				if ($only_with_mappings == true)
				{
					if (!empty($user_result['count_id']))
					{
						if (!empty($index))
						{
							if (isset($result[$index]))
							{
								$return_array[] = $result[$index];
							}
						}
						else
						{
							$return_array[] = $result;
						}
					}
				}
				else
				{
					if (!empty($index))
					{
						if (isset($result[$index]))
						{
							$return_array[] = $result[$index];
						}
					}
					else
					{
						$return_array[] = $result;
					}
				}
			}

			if (!empty($return_array))
			{
				return $return_array;
			}
			else
			{
				return false;
			}
		}

		/**
		 * Gibt die Daten zu einer Qualifikation zurueck
		 * @param int $q_id
		 * @param boole $min_headcount
		 * @param boole $only_with_mappings
		 * @return mixed
		 */
		private function get_one_qualification($q_id, $min_headcount, $only_with_mappings)
		{
			$cdb = new MySql();

			if ($min_headcount == true)
			{
				$where_string = ' AND min_headcount>0';
			}
			else
			{
				$where_string = '';
			}

			$sql = $cdb->select('SELECT * FROM hdb_qualifikation WHERE quali_id='.$q_id.$where_string);
			$result = $cdb->fetch_array($sql);

			if (isset($result['quali_id']) and $result['quali_id'] > 0)
			{
				$user_sql = $cdb->select('SELECT COUNT(t1.user_id) AS count_id FROM hdb_user_qualifikation t1
										LEFT JOIN hdb_user t2 ON t1.user_id=t2.user_id
										WHERE t1.quali_id='.$result['quali_id']." AND t2.anzeigen='j'");
				$user_result = $cdb->fetch_array($user_sql);
				$result['user_count'] = $user_result['count_id'];

				//nur qualis mit zuordnungen
				if ($only_with_mappings == true)
				{
					//keine zuordnung vorhanden
					if (empty($user_result['count_id']))
					{
						return false;
					}
				}

				return $result;
			}
			else
			{
				return false;
			}
		}

		/**
		 * Prueft ob min eine Qualifikation mit einem Minheadcount von groesser 0 existiert
		 * @return boole
		 */
		public function exist_with_minheadcount()
		{
			$cdb = new MySql();

			$sql = $cdb->select('SELECT quali_id FROM hdb_qualifikation WHERE min_headcount>0');
			while ($result = $cdb->fetch_array($sql))
			{
				$user_sql = $cdb->select('SELECT t1.user_id FROM hdb_user_qualifikation t1
										LEFT JOIN hdb_user t2 ON t1.user_id=t2.user_id
										WHERE t1.quali_id='.$result['quali_id']." AND t2.anzeigen='j'");
				$user_result = $cdb->fetch_array($user_sql);

				if (isset($user_result['user_id']) and $user_result['user_id'] > 0)
				{
					return true;
				}
			}

			return false;
		}
	}
?>