<?php
	/**
	 * form reload blocker (prevents multiple data entry - the form will be sent only one time)
	 *
	 * @author Soeren Pieper <soeren.pieper@docemos.de> / Martin Ufer <martin.ufer@docemos.de>
	 * @copyright Copyright (C) 2009  docemos GmbH
	 * @package time-o-meter
	 *
	 * This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
	 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
	 * You should have received a copy of the GNU General Public License along with this program; if not, see http://www.gnu.org/licenses/.
	 */

	/**
	 * form reload blocker (prevents multiple data entry - the form will be sent only one time)
	 * @package time-o-meter
	 * @subpackage classes
	 */
	class Reload
	{
		/**
		* Erstellt einen Eintrag mit einer eindeutigen ID und gibt diesen als hidden wert zurueck.
		* Die Klasse "MySql" wird fuer die Datenbankabfragen eingebunden.
		* @param string $retrun, echo = direkte ausgabe per echo
		* @return string
		*/
		public function create($return = 'echo')
		{
			$cdb = new MySql;

			$key = md5(uniqid(rand()));

			if ($cdb->insert("INSERT INTO hdb_reload (reload_id, expire_time) VALUES ('$key', '".date('YmdHis')."')"))
			{
				$this->del_reload_id();

				if ($return == 'echo')
				{
					echo '<input type="hidden" name="reload_sperre_string" value="'.$key.'" />'."\r\n";
				}
				else
				{
					return '<input type="hidden" name="reload_sperre_string" value="'.$key.'" />';
				}
			}
			else
			{
				if ($return == 'echo')
				{
					echo '';
				}
				else
				{
					return '';
				}
			}
		}

		/**
		* prueft ob die uebergebene Id vorhanden ist und gibt bei erfolg TRUE zurueck.
		* @param string $key, Reload ID
		* @return bool
		*/
		public function check($key)
		{
			$cdb = new MySql;

			$sql = $cdb->select("SELECT reload_id FROM hdb_reload WHERE reload_id='$key'");
			$result = $cdb->fetch_array($sql);

			if (isset($result['reload_id']) and !empty($result['reload_id']))
			{
				$this->del_reload_id($key);
				return TRUE;
			}
			else
			{
				return FALSE;
			}
		}

		/**
		* Entfernt alle Reload IDs die aelter als 30 min sind.
		* @param string $key, Reload ID
		*/
		public function del_reload_id($key = '')
		{
			$cdb = new MySql;

			if (!empty($key))
			{
				$cdb->delete("DELETE FROM hdb_reload WHERE reload_id='$key' LIMIT 1");
			}
			else
			{
				$del_time = date('YmdHis',time() - 1800);
				$cdb->delete("DELETE FROM hdb_reload WHERE expire_time < '$del_time'");
			}
		}
	}
?>