<?php
	/**
	 * search- and filteroptions storage class (stores form settings in $GLOBALS['TOM_VAR'] and provides data-exchange between $GLOBALS['TOM_VAR'] and $_POST)
	 *
	 * @author Soeren Pieper <soeren.pieper@docemos.de> / Martin Ufer <martin.ufer@docemos.de>
	 * @copyright Copyright (C) 2009  docemos GmbH
	 * @package time-o-meter
	 *
	 * This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
	 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
	 * You should have received a copy of the GNU General Public License along with this program; if not, see http://www.gnu.org/licenses/.
	 */

	/**
	 * search- and filteroptions storage class (stores form settings in $GLOBALS['TOM_VAR'] and provides data-exchange between $GLOBALS['TOM_VAR'] and $_POST)
	 * @package time-o-meter
	 * @subpackage classes
	 */
	class SaveFilter
	{
		/**
		* Speichert $_POST arrays in $GLOBALS['TOM_VAR'] oder von $GLOBALS['TOM_VAR'] in $_POST. Achtung keine Mehrdimensionale Array verwenden
		* @return array
		*/
		public function start()
		{
			//Vom Blaettern Werte in POST wandeln
			if (isset($_GET) and count($_GET) > 0 and isset($_GET['blseite']))
			{
				$GLOBALS['TOM_VAR']['sfo'] = array();
				foreach ($_GET as $i => $v)
				{
					if ($i != 'blseite')
					{
						$_POST[$i] = $v;
						$GLOBALS['TOM_VAR']['sfo'][$i] = $v;
					}
				}
			}
			//Speichert $_POST in $GLOBALS['TOM_VAR']
			elseif (isset($_POST) and count($_POST) > 0)
			{
				$GLOBALS['TOM_VAR']['sfo'] = array();
				foreach ($_POST as $i => $v)
				{
					$GLOBALS['TOM_VAR']['sfo'][$i] = $v;
				}
			}
			//Speichert $GLOBALS['TOM_VAR'] in $_POST
			elseif (isset($GLOBALS['TOM_VAR']['sfo']) and count($GLOBALS['TOM_VAR']['sfo']) > 0)
			{
				foreach ($GLOBALS['TOM_VAR']['sfo'] as $i => $v)
				{
					$_POST[$i] = $v;
				}
			}
		}

		/**
		* Loescht alle Filteroptionen aus der Session
		* @return void
		*/
		public function clear()
		{
			if (isset($GLOBALS['TOM_VAR']['sfo']))
			{
				unset($GLOBALS['TOM_VAR']['sfo']);
			}
		}
	}
?>