<?php
	/**
	 * output of timesheet data
	 *
	 * @author Soeren Pieper <soeren.pieper@docemos.de> / Martin Ufer <martin.ufer@docemos.de>
	 * @copyright Copyright (C) 2009  docemos GmbH
	 * @package time-o-meter
	 *
	 * This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
	 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
	 * You should have received a copy of the GNU General Public License along with this program; if not, see http://www.gnu.org/licenses/.
	 */

	/**
	 * output of timesheet data
	 * @package time-o-meter
	 * @subpackage classes
	 */
	class TimeSheetOutput
	{
		/**
		 * Haupttabelle mit ueberschrift
		 *
		 * @return string
		 */
		protected function get_time_sheet()
		{
			$return_string = $this->get_js();
			$return_string .= 	"\n".'<table cellpadding="0" cellspacing="0" border="0" width="100%">
									<tr valign="middle">
										<td class="main_table_header" width="100%">'.get_text('100', 'return', 'decode_on') /*Stundenzettel*/.' '.$this->get_month_name($this->setup_array['month']).' '.$this->setup_array['year'].'</td>
									</tr>
									<tr><td><img src="'.TOM_ABS_URL.'template/'.$GLOBALS['setup_array']['template'].'/image/_spacer.gif" width="1" height="4" border="0" alt="" /></td></tr>
									<tr>
										<td class="main_table_content">';
			$return_string .= 				"\n".'<form method="post" action="index.php'.$GLOBALS['gv']->create_get_string().'" name="TimeSheet" id="TimeSheet" enctype="multipart/form-data" accept-charset="UTF-8">'."\n";
			$return_string .=				$this->get_hidden_input();
			$return_string .=				$this->get_time_sheet_header();
			$return_string .=				'<br /><br />';
			$return_string .=				$this->get_time_sheet_table();
			$return_string .=				$this->get_button();
			$return_string .=				$this->get_dyn_area();
			$return_string .= 				'</form>';

			//PDF Optionen nur bei Monatsanzeige ausgeben
			if ($this->setup_array['return'] == 'show' and $this->setup_array['show'] == 'month')
			{
				$return_string .=			$this->get_time_sheet_pdf_option();
			}
			$return_string .=			'</td>
									</tr>
								</table>';

			return $return_string;
		}
		/**
		 * Gibt den Absendebutton aus
		 *
		 * @return string
		 */
		protected function get_button()
		{
			if ($this->setup_array['return'] == 'edit')
			{
				$return_string = '';
				$return_string .= '<br /><table cellpadding="0" cellspacing="0" border="0" width="100%">';
				$return_string .= 	'<tr>';
				$return_string .= 		'<td align="center">';
				$return_string .=			get_button(get_text('', 'return', 'decode_on', 'save') /*Speichern*/, 'tick.png', 'onclick="document.TimeSheet.submit();"');
				$return_string .= 		'</td>';
				$return_string .= 	'</tr>';
				$return_string .= '</table>';
				return $return_string;
			}
			else
			{
				return '';
			}
		}

		/**
		 * Gibt die Hiddenfelder fuer das Forumlar aus
		 *
		 * @return string
		 */
		protected function get_hidden_input()
		{
			if ($this->setup_array['return'] == 'edit')
			{
				$chk = new Checksum;
				$re = new Reload;

				$data_array = array('job_string'	=> 'edit_stz',
									'user' 			=> $this->setup_array['user_id'],
									'month'			=> $this->setup_array['month'],
									'year'			=> $this->setup_array['year']);

				$return_string = '';
				foreach ($data_array as $i => $v)
				{
					$return_string .= '<input type="hidden" name="'.$i.'" value="'.$v.'" />';
				}
				$return_string .= $chk->GetHidden($data_array);
				$return_string .= $re->create('return');
				return $return_string;
			}
			else
			{
				return '';
			}
		}

		/**
		 * Gibt die Kommentar- und Projektzeiteingabemasken aus
		 *
		 * @return string
		 */
		protected function get_dyn_area()
		{
			$return_string = '';
			$return_string .=	'<div id="dyn_area">'."\n";
			//Tageskommentar
			$return_string .=		'<div id="dyn_area_day_comment" class="stz_dyn_area_box" style="display:none;">'."\n";
			$return_string .=			'<div id="dyn_area_day_comment_header" class="stz_dyn_area_header"></div>'."\n";
			$return_string .=			'<div class="stz_dyn_area_content">'."\n";
			$return_string .=				'<textarea class="ipt_350" cols="20" rows="5" name="dyn_day_comment"></textarea>'."\n";
			$return_string .=			'</div>'."\n";
			$return_string .=			'<table cellpadding="0" cellspacing="0" border="0" width="100%">';
			$return_string .=				'<tr>';
			if ($this->setup_array['return'] == 'edit')
			{
				$return_string .=					'<td width="45%" align="right">';
				$return_string .=						get_button(get_text('', 'return', 'decode_on', 'close') /*Schliessen*/, 'cancel.png', 'onclick="TS_exit_day_comment();"');
				$return_string .=					'</td>';
				$return_string .=					'<td width="10%">&nbsp;</td>';
				$return_string .=					'<td width="45%">';
				$return_string .=						get_button(get_text(614, 'return', 'decode_on') /*uebernehmen*/, 'tick.png', 'onclick="TS_close_day_comment();"');
				$return_string .=					'</td>';
			}
			else
			{
				$return_string .=					'<td width="100%" align="center">';
				$return_string .=						get_button(get_text('', 'return', 'decode_on', 'close') /*Schliessen*/, 'cancel.png', 'onclick="TS_exit_day_comment();"');
				$return_string .=					'</td>';
			}
			$return_string .=				'</tr>';
			$return_string .=			'</table>'."\n";
			$return_string .=		'</div>'."\n\n";
			//Projektkommentar
			$return_string .=		'<div id="dyn_area_pro_comment" class="stz_dyn_area_box" style="display:none;">'."\n";
			$return_string .=			'<div id="dyn_area_pro_comment_header" class="stz_dyn_area_header"></div>'."\n";
			$return_string .=			'<div class="stz_dyn_area_content">'."\n";
			$return_string .=				'<textarea class="ipt_350" cols="20" rows="5" name="dyn_pro_comment"></textarea>'."\n";
			$return_string .=			'</div>'."\n";
			$return_string .=			'<table cellpadding="0" cellspacing="0" border="0" width="100%">';
			$return_string .=				'<tr>';
			if ($this->setup_array['return'] == 'edit')
			{
				$return_string .=					'<td width="45%" align="right">';
				$return_string .=						get_button(get_text('', 'return', 'decode_on', 'close') /*Schliessen*/, 'cancel.png', 'onclick="TS_exit_pro_comment();"');
				$return_string .=					'</td>';
				$return_string .=					'<td width="10%">&nbsp;</td>';
				$return_string .=					'<td width="45%">';
				$return_string .=						get_button(get_text(614, 'return', 'decode_on') /*uebernehmen*/, 'tick.png', 'onclick="TS_close_pro_comment();"');
				$return_string .=					'</td>';
			}
			else
			{
				$return_string .=					'<td width="100%" align="center">';
				$return_string .=						get_button(get_text('', 'return', 'decode_on', 'close') /*Schliessen*/, 'cancel.png', 'onclick="TS_exit_pro_comment();"');
				$return_string .=					'</td>';
			}
			$return_string .=				'</tr>';
			$return_string .=			'</table>'."\n";
			$return_string .=		'</div>'."\n\n";
			//Projektzeiten
			$return_string .=		'<div id="dyn_area_pro_time" class="stz_dyn_area_box" style="display:none;">'."\n";
			$return_string .=			'<div id="dyn_area_pro_time_header" class="stz_dyn_area_header"></div>'."\n";
			$return_string .=			'<div class="stz_dyn_area_content">'."\n";
			$return_string .=				'<table cellpadding="0" cellspacing="0" border="0" width="350">'."\n";
			$return_string .=					'<tr align="center">'."\n";
			$return_string .=						'<td width="25">&nbsp;</td>'."\n";
			$return_string .=						'<td width="75">'.get_text('', 'return', 'decode_on', 'kommen') /*Kommen*/.'</td>'."\n";
			$return_string .=						'<td width="75">'.get_text('', 'return', 'decode_on', 'pause') /*Pause*/.'</td>'."\n";
			$return_string .=						'<td width="75">'.get_text('', 'return', 'decode_on', 'gehen') /*Gehen*/.'</td>'."\n";
			$return_string .=						'<td width="75">'.get_text('', 'return', 'decode_on', 'ist_zeit') /*Ist-Zeit*/.'</td>'."\n";
			$return_string .=						'<td width="25">&nbsp;</td>'."\n";
			$return_string .=					'</tr>'."\n";
			$return_string .=					'<tr align="center">'."\n";
			$return_string .=						'<td>&nbsp;</td>'."\n";
			$return_string .=						'<td><input type="text" name="pro_time_kommen" class="stz_ipt_50" maxlength="5" onblur="TS_start_pro_time(\'kommen\');" /></td>'."\n";
			$return_string .=						'<td><input type="text" name="pro_time_pause" class="stz_ipt_25" maxlength="3" onblur="TS_start_pro_time(\'pause\');" /></td>'."\n";
			$return_string .=						'<td><input type="text" name="pro_time_gehen" class="stz_ipt_50" maxlength="5" onblur="TS_start_pro_time(\'gehen\');" /></td>'."\n";
			$return_string .=						'<td id="pro_time_result"></td>'."\n";
			$return_string .=						'<td>&nbsp;</td>'."\n";
			$return_string .=					'</tr>'."\n";
			$return_string .=				'</table>'."\n";
			$return_string .=			'</div>'."\n";
			$return_string .=			'<table cellpadding="0" cellspacing="0" border="0" width="100%">';
			$return_string .=				'<tr>';
			if ($this->setup_array['return'] == 'edit')
			{
				$return_string .=					'<td width="45%" align="right">';
				$return_string .=						get_button(get_text('', 'return', 'decode_on', 'close') /*Schliessen*/, 'cancel.png', 'onclick="TS_exit_pro_time();"');
				$return_string .=					'</td>';
				$return_string .=					'<td width="10%">&nbsp;</td>';
				$return_string .=					'<td width="45%">';
				$return_string .=						get_button(get_text(614, 'return', 'decode_on') /*uebernehmen*/, 'tick.png', 'onclick="TS_close_pro_time();"');
				$return_string .=					'</td>';
			}
			else
			{
				$return_string .=					'<td width="100%" align="center">';
				$return_string .=						get_button(get_text('', 'return', 'decode_on', 'close') /*Schliessen*/, 'cancel.png', 'onclick="TS_exit_pro_time();"');
				$return_string .=					'</td>';
			}
			$return_string .=				'</tr>';
			$return_string .=			'</table>'."\n";
			$return_string .=		'</div>'."\n";
			$return_string .=	'</div>';

			return $return_string;
		}

		/**
		 * Stundenzetteltabelle
		 *
		 * @return string
		 */
		protected function get_time_sheet_table()
		{
			$return_string = '';
			//Keine Projekte vorhanden
			if (count($this->project_array) == 0)
			{
				$return_string .= '<table cellpadding="2" cellspacing="0" border="0" width="100%" class="border">';
				$return_string .= $this->get_time_sheet_table_header(true , false);
				$return_string .= $this->get_time_sheet_table_days(false);
				$return_string .= '</table>';
				$return_string .= $this->get_time_sheet_table_uebertrag(false);
			}
			else
			{
				$return_string .= '<table cellpadding="0" cellspacing="0" border="0" style="table-layout:fixed; width:100%;">';
				$return_string .= 	'<tr valign="top">';
				$return_string .= 		'<td style="width:70%;">';
				$return_string .= 			'<table cellpadding="2" cellspacing="0" border="0" width="100%" class="stz_main_table">';
				$return_string .= 				$this->get_time_sheet_table_header(true, true);
				$return_string .= 				$this->get_time_sheet_table_days(false);
				$return_string .= 			'</table>';
				$return_string .= 		'</td>';
				$return_string .= 		'<td style="width:30%;">';
				$return_string .= 			'<div style="width:100%; overflow:scroll; overflow-x:scroll; overflow-y:auto;">';
				$return_string .= 				$this->get_time_sheet_table_project();
				$return_string .= 			'</div>';
				$return_string .= 		'</td>';
				$return_string .= 	'</tr>';
				$return_string .= '</table>';
				$return_string .= $this->get_time_sheet_table_uebertrag(true);
			}
			return $return_string;
		}

		/**
		 * Jeden Tag bzw. tr des Stundenzettels abarbeiten
		 *
		 * @param boole $show_projects
		 * @return string
		 */
		protected function get_time_sheet_table_days($show_projects)
		{
			//Hintergrundfarbe fuer das tr
			$this->tmp_data_save_array['tr_bg'] = 1;

			$return_string = '';
			for ($i = 0; $i < count($this->setup_array['days']); $i++)
			{
				$day = intval(substr($this->setup_array['days'][$i]['day'], -2));
				$day_name = $this->get_day_name($this->setup_array['days'][$i]['day'], 'K');

				//Gibt an ob bei der Ausgabe Edit die eingabefelder ausgegeben werden sollen
				//Es werden keine Eingabefelder ausgegeben wenn der Tag bereits abgeschlossen oder der Monatsstundenzettel noch nicht existiert.
				$this->show_tr_line = $this->setup_array['days'][$i]['show'];

				//headerzeile nochmal einblenden
				if (!isset($this->tmp_data_save_array['header_line_int']) and $i > 10 and $day_name == 'Mo')
				{
					if (count($this->project_array) == 0)
					{
						$return_string .= $this->get_time_sheet_table_header(false, false);
					}
					else
					{
						$return_string .= $this->get_time_sheet_table_header(false, true);
					}
					$this->tmp_data_save_array['header_line_int'] = $i;
				}

				$return_string .= '<tr align="center" class="stz_table_tr_bg_'.$this->tmp_data_save_array['tr_bg'].'">';
				$return_string .= $this->get_time_sheet_table_datum($this->setup_array['days'][$i]['day'], $day_name, $day);
				$return_string .= $this->get_time_sheet_table_kommen($day);
				$return_string .= $this->get_time_sheet_table_pause($day);
				$return_string .= $this->get_time_sheet_table_gehen($day);
				$return_string .= $this->get_time_sheet_table_istzeit($day);
				$return_string .= $this->get_time_sheet_table_abwesenheit($day);
				$return_string .= $this->get_time_sheet_table_zeit($day);
				$return_string .= $this->get_time_sheet_table_kommentar($day);

				//Es sind Projekte vorhanden
				if (count($this->project_array) > 0)
				{
					$return_string .= $this->get_time_sheet_table_nzs($day);
				}

				$return_string .= "</tr>\n";

				//Hintergrundfarbe wechseln
				if ($this->tmp_data_save_array['tr_bg'] == 1)
				{
					$this->tmp_data_save_array['tr_bg']++;
				}
				else
				{
					$this->tmp_data_save_array['tr_bg'] = 1;
				}
			}
			return $return_string;
		}

		/**
		 * Gibt die erste Spalte, mit der Datums und Wochentagsangabe, im Stundenzettel aus.
		 *
		 * @param string $date
		 * @param string $day_name
		 * @param int $day
		 * @return string
		 */
		protected function get_time_sheet_table_datum($date, $day_name, $day)
		{
			//Regulaerer Arbeitstag
			if ($this->setup_day_array[$day]['reg_tag'] === true)
			{
				$style = '';
			}
			//Wochenende
			elseif ($this->setup_day_array[$day]['wochenende'] === true)
			{
				$style = ' class="stz_freeday_bg"';
			}
			//Feiertage
			elseif ($this->setup_day_array[$day]['feiertag'] === true)
			{
				$style = ' class="stz_holiday_bg"';
			}
			//Halbtags
			elseif ($this->setup_day_array[$day]['halbtags'] === true)
			{
				$style = ' class="stz_freeday_bg"';
			}

			$return_string = '';
			$return_string .= '<td align="right"'.$style.'>'.substr($date, -2).'.</td>';
			$return_string .= '<td align="left"'.$style.'>'.$day_name.'</td>';
			return $return_string;
		}

		/**
		 * Spalte Kommen
		 *
		 * @param int $day
		 * @return string
		 */
		protected function get_time_sheet_table_kommen($day)
		{
			$return_string = '';

			//inputfeld ausgeben
			if ($this->setup_array['return'] == 'edit' and $this->show_tr_line === true)
			{
				//Bezahlter Abwesenheitsgrund Readonly
				$read_only_string = '';
				if (isset($this->setup_array['paid_absence_typ'][$day]) and $this->setup_array['paid_absence_typ'][$day] === true)
				{
					$read_only_string = ' readonly="readonly"';
				}

				if (isset($_POST['kommen'][$day]) and !empty($_POST['kommen'][$day]))
				{
					$return_string .= '<td><input type="text" name="kommen['.$day.']"'.$this->get_ipt_style($_POST['kommen'][$day], 'kommen').'maxlength="5" value="'.$_POST['kommen'][$day].'" onblur="TS_start_time(\'kommen\', '.$day.');"'.$read_only_string.' /></td>';
				}
				else
				{
					$return_string .= '<td><input type="text" name="kommen['.$day.']" class="stz_ipt_50" maxlength="5" ondblclick="TS_set_time(\'kommen\', '.$day.');" onblur="TS_start_time(\'kommen\', '.$day.');"'.$read_only_string.' /></td>';
				}
			}
			else
			{
				if (isset($_POST['kommen'][$day]) and !empty($_POST['kommen'][$day]))
				{
					$return_string .= '<td'.$this->get_ipt_style($_POST['kommen'][$day], 'kommen', false).'>'.$_POST['kommen'][$day].'</td>';
				}
				else
				{
					$return_string .= '<td>&nbsp;</td>';
				}
			}
			return $return_string;
		}

		/**
		 * Spalte Pause
		 *
		 * @param int $day
		 * @return string
		 */
		protected function get_time_sheet_table_pause($day)
		{
			$return_string = '';

			//inputfeld ausgeben
			if ($this->setup_array['return'] == 'edit' and $this->show_tr_line === true)
			{
				//Bezahlter Abwesenheitsgrund Readonly
				$read_only_string = '';
				if (isset($this->setup_array['paid_absence_typ'][$day]) and $this->setup_array['paid_absence_typ'][$day] === true)
				{
					$read_only_string = ' readonly="readonly"';
				}

				if (isset($_POST['pause'][$day]))
				{
					$return_string .= '<td><input type="text" name="pause['.$day.']" class="stz_ipt_25" maxlength="3" value="'.$_POST['pause'][$day].'" onfocus="TS_pausenzeit('.$day.')" onblur="TS_start_time(\'pause\', '.$day.');"'.$read_only_string.' /></td>';
				}
				else
				{
					$return_string .= '<td><input type="text" name="pause['.$day.']" class="stz_ipt_25" maxlength="3" onfocus="TS_pausenzeit('.$day.')" onblur="TS_start_time(\'pause\', '.$day.');"'.$read_only_string.' /></td>';
				}
			}
			else
			{
				if (isset($_POST['pause'][$day]))
				{
					$return_string .= '<td>'.$_POST['pause'][$day].'</td>';
				}
				else
				{
					$return_string .= '<td>&nbsp;</td>';
				}
			}
			return $return_string;
		}

		/**
		 * Spalte Gehen
		 *
		 * @param int $day
		 * @return string
		 */
		protected function get_time_sheet_table_gehen($day)
		{
			$return_string = '';
			//inputfeld ausgeben
			if ($this->setup_array['return'] == 'edit' and $this->show_tr_line === true)
			{
				//Bezahlter Abwesenheitsgrund Readonly
				$read_only_string = '';
				if (isset($this->setup_array['paid_absence_typ'][$day]) and $this->setup_array['paid_absence_typ'][$day] === true)
				{
					$read_only_string = ' readonly="readonly"';
				}

				if (isset($_POST['gehen'][$day]) and !empty($_POST['gehen'][$day]))
				{
					$return_string .= '<td><input type="text" name="gehen['.$day.']"'.$this->get_ipt_style($_POST['gehen'][$day], 'gehen').'maxlength="5" value="'.$_POST['gehen'][$day].'" onblur="TS_start_time(\'gehen\', '.$day.');"'.$read_only_string.' /></td>';
				}
				else
				{
					$return_string .= '<td><input type="text" name="gehen['.$day.']" class="stz_ipt_50" maxlength="5" ondblclick="TS_set_time(\'gehen\', '.$day.');" onblur="TS_start_time(\'gehen\', '.$day.');"'.$read_only_string.' /></td>';
				}
			}
			else
			{
				if (isset($_POST['gehen'][$day]) and !empty($_POST['gehen'][$day]))
				{
					$return_string .= '<td'.$this->get_ipt_style($_POST['gehen'][$day], 'gehen', false).'>'.$_POST['gehen'][$day].'</td>';
				}
				else
				{
					$return_string .= '<td>&nbsp;</td>';
				}
			}
			return $return_string;
		}

		/**
		 * Spalte IsZeit
		 *
		 * @param int $day
		 * @return string
		 */
		protected function get_time_sheet_table_istzeit($day)
		{
			$return_string = '';
			//inputfeld ausgeben
			if (isset($this->tmp_data_save_array['timesheet']['istzeit'][$day]) and !empty($this->tmp_data_save_array['timesheet']['istzeit'][$day]))
			{
				$return_string .= '<td id="istzeit_'.$day.'"'.$this->get_ipt_style($this->tmp_data_save_array['timesheet']['istzeit'][$day], 'istzeit', false).'>'.$this->tmp_data_save_array['timesheet']['istzeit'][$day].'</td>';
			}
			else
			{
				$return_string .= '<td id="istzeit_'.$day.'">&nbsp;</td>';
			}
			return $return_string;
		}

		/**
		 * Spalte Abwesenheitsgrund
		 *
		 * @param int $day
		 * @return string
		 */
		protected function get_time_sheet_table_abwesenheit($day)
		{
			$return_string = '';

			//pruefen ob ein abwesenheitsgrund ausgewaehlt wurde
			if (!isset($_POST['abwesenheit'][$day]))
			{
				$_POST['abwesenheit'][$day] = 0;
			}

			//Am Wochenende wird kein Abwesenheitsgrund benoetigt
			if ($this->setup_day_array[$day]['wochenende'] === true and $_POST['abwesenheit'][$day] == 0)
			{
				$return_string .= '<td>&nbsp;</td>';
			}
			else
			{
				//inputfeld ausgeben
				if ($this->setup_array['return'] == 'edit' and $this->show_tr_line === true)
				{
					$return_string .= '<td>';
					$return_string .= '<select name="abwesenheit['.$day.']" class="stz_select_75" onchange="TS_set_absence('.$day.')">';
					$return_string .= '<option value="0">'.get_text('', 'return', 'decode_on', 'please_select') /*Bitte waehlen*/.'</option>';
					foreach ($this->absence_array as $absence_id_int => $absence_data_array)
					{
						if ($_POST['abwesenheit'][$day] == $absence_id_int)
						{
							$return_string .= '<option value="'.$absence_id_int.'" selected="selected">'.$absence_data_array['absence_name'].'</option>';
						}
						elseif ($absence_data_array['display'] != 0)
						{
							$return_string .= '<option value="'.$absence_id_int.'">'.$absence_data_array['absence_name'].'</option>';
						}
					}

					$return_string .= '</select>';
					$return_string .= '</td>';
				}
				else
				{
					//Kein Abwesenheitsgrund
					if ($_POST['abwesenheit'][$day] == 0)
					{
						$return_string .= '<td>&nbsp;</td>';
					}
					//Abwesenheitsgrund vorhanden
					elseif (isset($this->absence_array[$_POST['abwesenheit'][$day]]))
					{
						$return_string .= '<td>'.$this->absence_array[$_POST['abwesenheit'][$day]]['absence_name'].'</td>';
					}
					//sollte eigendlich nie der fall sein es sei den der Abwesenheitsgrund wurde aus der DB geloescht
					else
					{
						$return_string .= '<td>&nbsp;</td>';
					}
				}
			}
			return $return_string;
		}

		/**
		 * Spalte Zeit
		 *
		 * @param int $day
		 * @return string
		 */
		protected function get_time_sheet_table_zeit($day)
		{
			$return_string = '';
			//inputfeld ausgeben
			if (isset($this->tmp_data_save_array['timesheet']['zeit'][$day]) and !empty($this->tmp_data_save_array['timesheet']['zeit'][$day]))
			{
				$return_string .= '<td id="zeit_'.$day.'">'.$this->tmp_data_save_array['timesheet']['zeit'][$day].'</td>';
			}
			else
			{
				$return_string .= '<td id="zeit_'.$day.'">&nbsp;</td>';
			}
			return $return_string;
		}

		/**
		 * Spalte Tageskommentar
		 *
		 * @param int $day
		 * @return string
		 */
		protected function get_time_sheet_table_kommentar($day)
		{
			$return_string = '';
			//inputfeld ausgeben
			if ($this->setup_array['return'] == 'edit' and $this->show_tr_line === true)
			{
				if (isset($_POST['kommentar'][$day]) and !empty($_POST['kommentar'][$day]))
				{
					$return_string .= '<td><img src="'.TOM_ABS_URL.'template/'.$GLOBALS['setup_array']['template'].'/image/table.png" id="cdi_'.$day.'" width="16" height="16" border="0" class="image_button" alt="" title="'.get_text(862, 'return', 'decode_on') /*Kommentar anzeigen*/.'" onclick="TS_open_day_comment(\''.$day.'\');" /></td>';
				}
				else
				{
					$return_string .= '<td><img src="'.TOM_ABS_URL.'template/'.$GLOBALS['setup_array']['template'].'/image/table_add.png" id="cdi_'.$day.'" width="16" height="16" border="0" class="image_button" alt="" title="'.get_text(863, 'return', 'decode_on') /*Kommentar bearbeiten*/.'" onclick="TS_open_day_comment(\''.$day.'\');" /></td>';
				}
			}
			else
			{
				if (isset($_POST['kommentar'][$day]) and !empty($_POST['kommentar'][$day]))
				{
					$return_string .= '<td><img src="'.TOM_ABS_URL.'template/'.$GLOBALS['setup_array']['template'].'/image/table.png" id="cdi_'.$day.'" width="16" height="16" border="0" class="image" alt="" title="'.get_text(862, 'return', 'decode_on') /*Kommentar anzeigen*/.'" onclick="TS_open_day_comment(\''.$day.'\');" /></td>';
				}
				else
				{
					$return_string .= '<td>&nbsp;</td>';
				}
			}
			return $return_string;
		}

		/**
		 * Spalte NZS
		 *
		 * @param int $day
		 * @return string
		 */
		protected function get_time_sheet_table_nzs($day)
		{
			$return_string = '';
			//inputfeld ausgeben
			if (isset($this->tmp_data_save_array['timesheet']['nzs'][$day]) and !empty($this->tmp_data_save_array['timesheet']['nzs'][$day]))
			{
				$return_string .= '<td id="nzs_'.$day.'">'.$this->tmp_data_save_array['timesheet']['nzs'][$day].'</td>';
			}
			else
			{
				$return_string .= '<td id="nzs_'.$day.'">&nbsp;</td>';
			}
			return $return_string;
		}

		/**
		 * Erstellt die Tabelle fuer die Darstellung der Projekte
		 *
		 * @return string
		 */
		protected function get_time_sheet_table_project()
		{
			$return_string = '';
			//Beite der Tabelle fuer die Projektlegende bestimmen
			$project_count_int = count($this->project_array);
			$project_table_width_int = $project_count_int * $this->setup_array['project_td_width'];

			//Projekttabelle
			$return_string .= '<table cellpadding="2" cellspacing="0" border="0" width="'.$project_table_width_int.'" class="stz_project_table">';

			//Der Projekttabelle den Tabellenheader hinzufuegen
			$return_string .= $this->get_time_sheet_table_header_projects(true);

								//Wechsel der Hintergrundfarbe
								$this->tmp_data_save_array['tr_bg'] = 1;
								//Tage abarbeiten
								for($j = 0; $j < count($this->setup_array['days']); $j++)
								{
									//Tageszahl 1 - 31
									$day = intval(substr($this->setup_array['days'][$j]['day'], -2));

									//Gibt an ob bei der Ausgabe Edit die eingabefelder ausgegeben werden sollen
									//Es werden keine Eingabefelder ausgegeben wenn der Tag bereits abgeschlossen oder der Monatsstundenzettel noch nicht existiert.
									$this->show_tr_line = $this->setup_array['days'][$j]['show'];

									//pruefen ob der Tabellenheader nochmal eingeblendet werden soll
									if (isset($this->tmp_data_save_array['header_line_int']) and $this->tmp_data_save_array['header_line_int'] == $j)
									{
			$return_string .=			$this->get_time_sheet_table_header_projects(false);
									}
									//tr fuer eine Tagesausgabe
			$return_string .=		'<tr align="center" class="stz_table_tr_bg_'.$this->tmp_data_save_array['tr_bg'].'">';
									// je ein td fuer ein Projekt je tag
									for ($i = 0; $i < $project_count_int; $i++)
									{
			$return_string .= 			$this->get_time_sheet_table_td_projects($day, $i);
									}
			$return_string .= 		'</tr>'."\n";

									//Hintergrundfarbe wechseln
									if ($this->tmp_data_save_array['tr_bg'] == 1)
									{
										$this->tmp_data_save_array['tr_bg']++;
									}
									else
									{
										$this->tmp_data_save_array['tr_bg'] = 1;
									}
								}

			$return_string .= '</table>';

			return $return_string;
		}

		/**
		 * Erstellt die Ausgabe fuer ein Projekt je Tag
		 *
		 * @param int $day
		 * @param int $project_index_int
		 * @return string
		 */
		protected function get_time_sheet_table_td_projects($day, $project_index_int)
		{
			$return_string = '<td>';

			if ($this->setup_array['return'] == 'edit' and $this->show_tr_line === true)
			{
				//Bezahlter Abwesenheitsgrund Readonly
				$read_only_string = '';
				if (isset($this->setup_array['paid_absence_typ'][$day]) and $this->setup_array['paid_absence_typ'][$day] === true)
				{
					$read_only_string = ' readonly="readonly"';
				}

				//Projektstunden
				if (isset($_POST['projektzeit'][$day][$this->project_array[$project_index_int]['id']]['stunden']) and !empty($_POST['projektzeit'][$day][$this->project_array[$project_index_int]['id']]['stunden']))
				{
					$return_string .= '<input type="text" name="projektzeit['.$day.']['.$this->project_array[$project_index_int]['id'].'][stunden]" class="stz_ipt_25" maxlength="5" value="'.$_POST['projektzeit'][$day][$this->project_array[$project_index_int]['id']]['stunden'].'" onblur="TS_project_time('.$this->project_array[$project_index_int]['id'].', '.$day.');"'.$read_only_string.' />&nbsp;';
				}
				else
				{
					$return_string .= '<input type="text" name="projektzeit['.$day.']['.$this->project_array[$project_index_int]['id'].'][stunden]" class="stz_ipt_25" maxlength="5" onblur="TS_project_time('.$this->project_array[$project_index_int]['id'].', '.$day.');"'.$read_only_string.' />&nbsp;';
				}
				//Projektzeiten kommen pause gehen
				if (isset($_POST['projektzeit'][$day][$this->project_array[$project_index_int]['id']]['kommen']) and !empty($_POST['projektzeit'][$day][$this->project_array[$project_index_int]['id']]['kommen']))
				{
					$return_string .= '<img src="'.TOM_ABS_URL.'template/'.$GLOBALS['setup_array']['template'].'/image/time.png" id="tpi_'.$day.'_'.$this->project_array[$project_index_int]['id'].'" width="16" height="16" border="0" class="image_button" alt="" title="'.get_text(864, 'return', 'decode_on') /*Projektzeiten anzeigen*/.'" onclick="TS_open_projekt_time('.$day.', '.$this->project_array[$project_index_int]['id'].')" />&nbsp;';
				}
				else
				{
					$return_string .= '<img src="'.TOM_ABS_URL.'template/'.$GLOBALS['setup_array']['template'].'/image/time_add.png" id="tpi_'.$day.'_'.$this->project_array[$project_index_int]['id'].'" width="16" height="16" border="0" class="image_button" alt="" title="'.get_text(865, 'return', 'decode_on') /*Projektzeiten bearbeiten*/.'" onclick="TS_open_projekt_time('.$day.', '.$this->project_array[$project_index_int]['id'].')" />&nbsp;';
				}
				//Projektkommentar
				if (isset($_POST['projektkommentar'][$day][$this->project_array[$project_index_int]['id']]) and !empty($_POST['projektkommentar'][$day][$this->project_array[$project_index_int]['id']]))
				{
					//Speichern das ein Projektkommentar vorhanden ist
					$this->setup_array['projektkommentar_exists'][$this->project_array[$project_index_int]['id']] = true;
					$return_string .= '<img src="'.TOM_ABS_URL.'template/'.$GLOBALS['setup_array']['template'].'/image/table.png" id="cpi_'.$day.'_'.$this->project_array[$project_index_int]['id'].'" width="16" height="16" border="0" class="image_button" alt="" title="'.get_text(862, 'return', 'decode_on') /*Kommentar anzeigen*/.'" onclick="TS_open_pro_comment('.$day.', '.$this->project_array[$project_index_int]['id'].')" />';
				}
				else
				{
					$return_string .= '<img src="'.TOM_ABS_URL.'template/'.$GLOBALS['setup_array']['template'].'/image/table_add.png" id="cpi_'.$day.'_'.$this->project_array[$project_index_int]['id'].'" width="16" height="16" border="0" class="image_button" alt="" title="'.get_text(863, 'return', 'decode_on') /*Kommentar bearbeiten*/.'" onclick="TS_open_pro_comment('.$day.', '.$this->project_array[$project_index_int]['id'].')" />';
				}
			}
			else
			{
				//Projektstunden
				if (isset($_POST['projektzeit'][$day][$this->project_array[$project_index_int]['id']]['stunden']) and !empty($_POST['projektzeit'][$day][$this->project_array[$project_index_int]['id']]['stunden']))
				{
					$return_string .= $_POST['projektzeit'][$day][$this->project_array[$project_index_int]['id']]['stunden'];
				}
				//Projektzeiten kommen pause gehen
				if (isset($_POST['projektzeit'][$day][$this->project_array[$project_index_int]['id']]['kommen']) and !empty($_POST['projektzeit'][$day][$this->project_array[$project_index_int]['id']]['kommen']))
				{
					$return_string .= '<img src="'.TOM_ABS_URL.'template/'.$GLOBALS['setup_array']['template'].'/image/time.png" id="tpi_'.$day.'_'.$this->project_array[$project_index_int]['id'].'" width="16" height="16" border="0" class="image_button" alt="" title="'.get_text(864, 'return', 'decode_on') /*Projektzeiten anzeigen*/.'" onclick="TS_open_projekt_time('.$day.', '.$this->project_array[$project_index_int]['id'].')" />';
				}
				else
				{
					$return_string .= '&nbsp;';
				}
				//Projektkommentar
				if (isset($_POST['projektkommentar'][$day][$this->project_array[$project_index_int]['id']]) and !empty($_POST['projektkommentar'][$day][$this->project_array[$project_index_int]['id']]))
				{
					//Speichern das ein Projektkommentar vorhanden ist
					$this->setup_array['projektkommentar_exists'][$this->project_array[$project_index_int]['id']] = true;
					$return_string .= '<img src="'.TOM_ABS_URL.'template/'.$GLOBALS['setup_array']['template'].'/image/table.png"  id="cpi_'.$day.'_'.$this->project_array[$project_index_int]['id'].'" width="16" height="16" border="0" class="image_button" alt="" title="'.get_text(862, 'return', 'decode_on') /*Kommentar anzeigen*/.'" onclick="TS_open_pro_comment('.$day.', '.$this->project_array[$project_index_int]['id'].')" />';
				}
				else
				{
					$return_string .= '&nbsp;';
				}
			}
			$return_string .= '</td>';
			return $return_string;
		}

		/**
		 * Erstellt die Headezeile fuer die Projekttabelle
		 *
		 * @param boole $show_colgroup
		 * @return string
		 */
		protected function get_time_sheet_table_header_projects($show_colgroup)
		{
			//Projektanzahl
			$project_count_int = count($this->project_array);
			//Tabellenbreite
			$project_table_width_int = $project_count_int * $this->setup_array['project_td_width'];

			$return_string = '';

			//Breitenangabe fuer die Projektspalte
			if ($show_colgroup === true)
			{
				$return_string .= '<colgroup>';
									for($i = 0; $i < $project_count_int; $i++)
									{
				$return_string .=		'<col width="'.$this->setup_array['project_td_width'].'" />';
									}
				$return_string .= '</colgroup>'."\n";
			}

			//Headerzeiel fuer die Projekttabelle
			$return_string .= 	'<tr valign="top" align="center">
									<td class="table_header" colspan="'.$project_count_int.'">
										'.get_text(607, 'return', 'decode_on') /*Zeit je Projekt*/.'
										<table cellpadding="0" cellspacing="0" border="0" width="'.$project_table_width_int.'">
											<tr align="center">';
											//je ein td pro Projekt
											for($i = 0; $i < $project_count_int; $i++)
											{
			$return_string .=					'<td width="'.$this->setup_array['project_td_width'].'" class="table_header">'.$this->project_array[$i]['kurzname'].'</td>';
											}
			$return_string .=				'</tr>
										</table>
									</td>
								</tr>'."\n";
			return $return_string;
		}

		/**
		 * Gibt fuer den Stundenzettel die Headerzeile aus (ohne Projektspalten)
		 * @param boole $show_colgroup
		 * @param boole $show_project
		 * @return string
		 */
		protected function get_time_sheet_table_header($show_colgroup, $show_project)
		{
			$return_string = '';
			//Breitenangaben fuer die Tabelle
			if ($show_colgroup === true)
			{
				$return_string .=	'<colgroup>
										<col width="5%" />
										<col width="5%" />
										<col width="10%" />
										<col width="10%" />
										<col width="10%" />
										<col width="10%" />
										<col width="20%" />
										<col width="10%" />';

				//Mit Projektausgabe
				//In diesem Fall wir die Spalte NZS ausgegeben
				if ($show_project === true)
				{
					$return_string .=	'<col width="15%" />
										<col width="5%" />';
				}
				else
				{
					$return_string .=	'<col width="20%" />';
				}

				$return_string .=		'</colgroup>';
			}

			$return_string .=		'<tr class="table_tr_bg_2" valign="top" align="center">
										<td class="table_header" colspan="2">'.get_text('', 'return', 'decode_on', 'datum') /*Datum*/.'<br /><br /></td>
										<td class="table_header">'.get_text('', 'return', 'decode_on', 'kommen') /*Kommen*/.'</td>
										<td class="table_header">'.get_text('', 'return', 'decode_on', 'pause') /*Pause*/.'</td>
										<td class="table_header">'.get_text('', 'return', 'decode_on', 'gehen') /*Gehen*/.'</td>
										<td class="table_header">'.get_text('', 'return', 'decode_on', 'ist_zeit') /*Ist-Zeit*/.'</td>
										<td class="table_header">'.get_text(602, 'return', 'decode_on') /*Abwesenheit*/.'</td>
										<td class="table_header">'.get_text('', 'return', 'decode_on', 'zeit_plus_minus') /*Zeit (+/-)*/.'</td>
										<td class="table_header">'.get_text('', 'return', 'decode_on', 'kommentar') /*Kommentar*/.'</td>';
			if ($show_project === true)
			{
				$return_string .=		'<td class="table_header">'.get_text('', 'return', 'decode_on', 'nzs_kurz') /*NZS*/.'</td>';
			}
			$return_string .=		'</tr>';

			return $return_string;
		}

		/**
		 * Gibt den Kopfbereich mit uebertraegen und Projektlegende aus
		 *
		 * @return string
		 */
		protected function get_time_sheet_header()
		{
			//Aufruf vom Adminbereich aus
			if (isset($_GET['VCS']))
			{
				$return_string = '<a href="index.php'.$GLOBALS['gv']->create_get_string('?fileinc=overview_stz').'">&laquo;'.get_text('', 'return', 'decode_on', 'back')/*zurueck*/.'</a><br /><br />';
			}
			//aufruf von der loginstartseite
			else
			{
				$return_string = '<a href="../main/index.php'.$GLOBALS['gv']->create_get_string('?fileinc=&amp;clear_sf=1').'">&laquo;'.get_text('', 'return', 'decode_on', 'back')/*zurueck*/.'</a><br /><br />';
			}
			$return_string .= '<table cellpadding="4" cellspacing="0" width="100%" class="table_content">
								<tr valign="top">
									<td width="20%">
										<strong>'.get_text('', 'return', 'decode_on', 'mitarbeiter') /*Mitarbeiter*/.':</strong><br /><br />
										<strong>'.get_text('', 'return', 'decode_on', 'uebertrag') /*uebertrag*/.' ('.get_text('', 'return', 'decode_on', 'vormonat') /*Vormonat*/.'):</strong><br />
										<strong>'.get_text(598, 'return', 'decode_on') /*Wochenarbeitszeit*/.':</strong><br />
										<strong>'.get_text('', 'return', 'decode_on', 'resturlaub') /*Resturlaub*/.':</strong><br />
									</td>
									<td width="20%">
										'.$this->setup_array['vorname'].' '.$this->setup_array['nachname'].'<br /><br />
										'.$this->setup_array['startwert_stunden'].' h<br />
										'.$this->setup_array['min_weektime'].' h<br />
										'.$this->setup_array['startwert_urlaub'].'<br />
									</td>
									<td width="60%" rowspan="4" style="border-left:solid 1px;">
										<strong>'.get_text('', 'return', 'decode_on', 'projektlegende') /*Projektlegende*/.':</strong><br />
										<table cellpadding="0" cellspacing="0" width="100%">
											<tr>
												<td width="20%"><strong>'.get_text(597, 'return', 'decode_on') /*Kuerzel*/.'</strong></td>
												<td width="55%"><strong>'.get_text('', 'return', 'decode_on', 'projektname') /*Projektname*/.'</strong></td>
												<td width="25%"><strong>'.get_text('', 'return', 'decode_on', 'projektnr_intern') /*Projektnr. intern*/.'</strong></td>
											</tr>';
											for($i = 0; $i < count($this->project_array); $i++)
											{
			$return_string .=					'<tr valign="top"><td>'.$this->project_array[$i]['kurzname'].'</td><td>'.$this->project_array[$i]['name'].'</td><td>'.$this->project_array[$i]['nr'].'</td></tr>';
											}
			$return_string .=			'</table>
									</td>
								</tr>
							</table>';
			return $return_string;
		}

		/**
		 * Gibt die Monatsuebertraege aus
		 *
		 * @param boole $show_project
		 * @return string
		 */
		protected function get_time_sheet_table_uebertrag($show_project)
		{
			if ($this->setup_array['show'] == 'day')
			{
				$day_display = ' style="display:none;"';
			}
			else
			{
				$day_display = '';
			}
			if ($this->setup_array['show'] == 'week')
			{
				$week_display = ' style="display:none;"';
			}
			else
			{
				$week_display = '';
			}

			$return_string = '';
			$return_string .= '<br /><table cellpadding="0" cellspacing="0" border="0" width="100%" class="border"'.$day_display.'>';
			$return_string .= 	'<tr valign="top">';
			$return_string .= 		'<td width="50%">';
			$return_string .= 			'<table cellpadding="2" cellspacing="0" border="0" width="100%">';
			$return_string .=				'<colgroup>';
			$return_string .=					'<col width="40%" />';
			$return_string .=					'<col width="20%" />';
			$return_string .=					'<col width="40%" />';
			$return_string .= 				'</colgroup>'."\n";
			if ($show_project === true)
			{
				$return_string .= 				'<tr>';
				$return_string .= 					'<td align="right"><strong>'.get_text('', 'return', 'decode_on', 'summe') /*Summe*/.' '.get_text('', 'return', 'decode_on', 'nzs_kurz') /*NZS*/.':</strong></td>';
				$return_string .= 					'<td align="right" id="nzs_all">';
				$return_string .= 						$this->setup_array['month_nzsstunden'].' h';
				$return_string .= 					'</td>';
				$return_string .= 					'<td>&nbsp;</td>';
				$return_string .= 				'</tr>';
			}
			$return_string .= 				'<tr>';
			$return_string .= 					'<td align="right"><strong>'.get_text('', 'return', 'decode_on', 'summe') /*Summe*/.' '.get_text('', 'return', 'decode_on', 'ist_zeit') /*Ist-Zeit*/.':</strong></td>';
			$return_string .= 					'<td align="right" id="istzeit_all">';
			$return_string .= 						$this->setup_array['month_iststunden'].' h';
			$return_string .= 					'</td>';
			$return_string .= 					'<td>&nbsp;</td>';
			$return_string .= 				'</tr>';
			$return_string .= 				'<tr'.$week_display.'>';
			$return_string .= 					'<td align="right"><strong>'.get_text('', 'return', 'decode_on', 'summe') /*Summe*/.' '.get_text('', 'return', 'decode_on', 'zeit_plus_minus') /*Zeit (+/-)*/.':</strong></td>';
			$return_string .= 					'<td align="right" id="zeit_all">';
			$return_string .= 						$this->setup_array['month_iststunden'] - $this->setup_array['month_sollstunden'] + $this->setup_array['month_absence_time'].' h' ;
			$return_string .= 					'</td>';
			$return_string .= 					'<td>&nbsp;</td>';
			$return_string .= 				'</tr>';
			$return_string .= 				'<tr'.$week_display.'>';
			$return_string .= 					'<td align="right"><strong>'.get_text(268, 'return', 'decode_on') /*Stundenuebertrag*/.':</strong></td>';
			$return_string .= 					'<td align="right" id="uebertrag_all">';
			$return_string .= 						$this->setup_array['month_iststunden'] + $this->setup_array['month_absence_time'] + $this->setup_array['startwert_stunden'] - $this->setup_array['month_sollstunden'].' h' ;
			$return_string .= 					'</td>';
			$return_string .= 					'<td>&nbsp;</td>';
			$return_string .= 				'</tr>';
			$return_string .= 				'<tr'.$week_display.'>';
			$return_string .= 					'<td align="right"><strong>'.get_text('', 'return', 'decode_on', 'resturlaub') /*Resturlaub*/.':</strong></td>';
			$return_string .= 					'<td align="right" id="urlaub_all">';
			$return_string .= 						$this->setup_array['startwert_urlaub'] - $this->setup_array['month_urlaub_count'];
			$return_string .= 					'</td>';
			$return_string .= 					'<td>&nbsp;</td>';
			$return_string .= 				'</tr>';
			$return_string .=			'</table>';
			$return_string .= 		'</td>';
			$return_string .= 		'<td width="50%">';

			if ($show_project === true)
			{
				//Projekttabelle
				$return_string .=				'<table cellpadding="2" cellspacing="0" border="0" width="100%">';
				$return_string .=					'<colgroup>';
				$return_string .=						'<col width="40%" />';
				$return_string .=						'<col width="20%" />';
				$return_string .=						'<col width="40%" />';
				$return_string .= 					'</colgroup>'."\n";
													for($i = 0; $i < count($this->project_array); $i++)
													{
				$return_string .= 						'<tr>';
				$return_string .= 							'<td align="right"><strong>'.$this->project_array[$i]['kurzname'].':</strong></td>';
															if (isset($this->setup_array['month_project_iststunden'][$this->project_array[$i]['id']]))
															{
				$return_string .= 								'<td align="right" id="pro_time_all_'.$this->project_array[$i]['id'].'">'.$this->setup_array['month_project_iststunden'][$this->project_array[$i]['id']].' h</td>';
															}
															else
															{
				$return_string .= 								'<td align="right" id="pro_time_all_'.$this->project_array[$i]['id'].'">0 h</td>';
															}
				$return_string .= 							'<td>&nbsp;</td>';
				$return_string .= 						'</tr>';
													}
				$return_string .=				'</table>';
			}
			else
			{
				$return_string .=		'&nbsp;';
			}
			$return_string .= 		'</td>';
			$return_string .= 	'</tr>';
			$return_string .= '</table>';

			return $return_string;
		}

		/**
		 * Gibt den JS Teil fuer die Berechnungen des Stundenzettels aus
		 *
		 * @return string
		 */
		public function get_js()
		{
			$return_string = '';
			$return_istzeit_string = '';
			$return_zeit_string = '';
			$return_nzs_string = '';
			$return_absence_string = '';
			$return_absence_full_day_string = '';
			$return_urlaub_string = '';
			$return_kommentar_string = '';
			$return_projekt_time_e_string = '';
			$return_projekt_time_string = '';

			$return_string .= "\n".'<script type="text/javascript">'."\n".'<!--'."\n";

			if (isset($GLOBALS['setup_array']['stz_round_time']) and $GLOBALS['setup_array']['stz_round_time'] == 'j')
			{
				$return_string .= 'var TS_round_time_boole = true;'."\n";
			}
			else
			{
				$return_string .= 'var TS_round_time_boole = false;'."\n";
			}

			//Istzeit einstellungen
			$return_istzeit_string .= 'var TS_istzeit = new Array();'."\n";
			//Zeit einstellungen (ueberstunden)
			$return_zeit_string .= 'var TS_zeit = new Array();'."\n";
			//nzs stunden
			$return_nzs_string .= 'var TS_nzs = new Array();'."\n";
			//Urlaub
			$return_urlaub_string .= 'var TS_urlaub = new Array();'."\n";

			//Kommentare
			$return_kommentar_string .= 'var TS_note = new Array();'."\n";
			//Projektzeiten hiddenfeld existiert
			$return_projekt_time_e_string .= 'var TS_pro_Te = new Array();'."\n";
			//Projektstunden
			$return_projekt_time_string .= 'var TS_pro_T = new Array();'."\n";

			//Tageseinstellungen
			$return_string .= 'var TS_day_setup = new Array();'."\n";
			//Jeden Tag der Darstellung abarbeiten
			foreach ($this->setup_day_array as $day => $setup)
			{
				//kommentar
				$return_kommentar_string .= "\n".'TS_note['.$day.'] = new Array();'."\n";
				$return_kommentar_string .= 'TS_note['.$day.'][0] = 0;'."\n";
				//Projektzeiten hiddenfeld existiert
				$return_projekt_time_e_string .= "\n".'TS_pro_Te['.$day.'] = new Array();'."\n";
				//Projektstunden
				$return_projekt_time_string .= "\n".'TS_pro_T['.$day.'] = new Array();'."\n";
				foreach ($this->project_array as $project_data)
				{
					//Projektstunden
					if (isset($_POST['projektzeit'][$day][$project_data['id']]['stunden']) and !empty($_POST['projektzeit'][$day][$project_data['id']]['stunden']))
					{
						$return_projekt_time_string .= 'TS_pro_T['.$day.']['.$project_data['id'].'] = '.$_POST['projektzeit'][$day][$project_data['id']]['stunden'].';'."\n";
					}
					else
					{
						$return_projekt_time_string .= 'TS_pro_T['.$day.']['.$project_data['id'].'] = 0;'."\n";
					}
					$return_kommentar_string .= 'TS_note['.$day.']['.$project_data['id'].'] = 0;'."\n";
					$return_projekt_time_e_string .= 'TS_pro_Te['.$day.']['.$project_data['id'].'] = 0;'."\n";
				}

				//urlaub
				$return_urlaub_string .= 'TS_urlaub['.$day.'] = '.$this->tmp_data_save_array['timesheet']['urlaub'][$day].';'."\n";

				//istzeit einstellungen
				if (isset($this->tmp_data_save_array['timesheet']['istzeit'][$day]) and !empty($this->tmp_data_save_array['timesheet']['istzeit'][$day]))
				{
					$return_istzeit_string .= 'TS_istzeit['.$day.'] = '.$this->tmp_data_save_array['timesheet']['istzeit'][$day].';'."\n";
				}
				else
				{
					$return_istzeit_string .= 'TS_istzeit['.$day.'] = 0;'."\n";
				}

				//Zeit einstellungen (ueberstunden)
				if (isset($this->tmp_data_save_array['timesheet']['zeit'][$day]) and !empty($this->tmp_data_save_array['timesheet']['zeit'][$day]))
				{
					$return_zeit_string .= 'TS_zeit['.$day.'] = '.$this->tmp_data_save_array['timesheet']['zeit'][$day].';'."\n";
				}
				else
				{
					$return_zeit_string .= 'TS_zeit['.$day.'] = 0;'."\n";
				}

				if (isset($this->tmp_data_save_array['timesheet']['nzs'][$day]) and !empty($this->tmp_data_save_array['timesheet']['nzs'][$day]))
				{
					$return_nzs_string .= 'TS_nzs['.$day.'] = '.$this->tmp_data_save_array['timesheet']['nzs'][$day].';'."\n";
				}
				else
				{
					$return_nzs_string .= 'TS_nzs['.$day.'] = 0;'."\n";
				}

				//Tageseinstellungen fuer JS ausgabe
				$return_string .= 'TS_day_setup['.$day.'] = new Object();'."\n";
				foreach ($setup as $index => $value)
				{
					if ($value === true)
					{
						$tmp_string = 'true';
					}
					elseif ($value === false)
					{
						$tmp_string = 'false';
					}
					else
					{
						$tmp_string = $value;
					}
					$return_string .= 'TS_day_setup['.$day.']["'.$index.'"] = '.$tmp_string.';'."\n";
				}
				$return_string .= "\n";
			}

			$return_string .= $return_istzeit_string."\n";
			$return_string .= $return_zeit_string."\n";
			$return_string .= $return_nzs_string."\n";

			//ProjektIds ausgeben
			$tmp_project_id_string = '';
			$tmp_project_name_string = '';
			$return_string .= 'var TS_pro_id = new Array('.$tmp_project_id_string.');'."\n";
			foreach ($this->project_array as $index => $project_data)
			{
				$tmp_project_name_string .= 'TS_pro_name['.$project_data['id'].'] = "'.$project_data['kurzname'].'";'."\n";

				$return_string .= 'TS_pro_id['.$index.'] = '.$project_data['id'].";\n";
			}

			$return_string .= 'var TS_pro_name = new Array();'."\n";
			$return_string .= $tmp_project_name_string;

			//NZS und Projektberechnung durchfuehren
			if (count($this->project_array) == 0)
			{
				$return_string .= 'var TS_project_exists = false;'."\n";
			}
			else
			{
				$return_string .= 'var TS_project_exists = true;'."\n";
			}

			//Abwesenheitsgrund
			$return_absence_string .= 'var TS_absence = new Array();'."\n";
			foreach ($this->absence_array as $id => $data)
			{
				if ($data['working_time'] == 1)
				{
					$return_absence_string .= 'TS_absence['.$id.'] = true;'."\n";
				}
				else
				{
					$return_absence_string .= 'TS_absence['.$id.'] = false;'."\n";
				}
			}

			$return_string .= $return_absence_string."\n";

			//Abwesenheitsgrund fuer den gesamten tag verwenden
			$return_absence_full_day_string .= 'var TS_absence_full_day = new Array();'."\n";
			foreach ($this->absence_array as $id => $data)
			{
				if ($data['total_day'] == 'j')
				{
					$return_absence_full_day_string .= 'TS_absence_full_day['.$id.'] = true;'."\n";
				}
				else
				{
					$return_absence_full_day_string .= 'TS_absence_full_day['.$id.'] = false;'."\n";
				}
			}

			$return_string .= $return_absence_full_day_string."\n";

			$return_string .= $return_urlaub_string."\n";
			$return_string .= $return_kommentar_string."\n";
			$return_string .= $return_projekt_time_e_string."\n";
			$return_string .= $return_projekt_time_string."\n";

			$return_string .= 'var TS_urlaub_start = '.floatval($this->setup_array['startwert_urlaub']).';'."\n";
			$return_string .= 'var TS_stunden_start = '.floatval($this->setup_array['startwert_stunden']).';'."\n";
			//Sollstunden fuer den Monat
			$return_string .= 'var TS_sollstunden_month = '.floatval($this->setup_array['month_sollstunden']).';'."\n";
			//Tage des Monats
			$return_string .= 'var TS_month_day_count = '.$this->setup_array['month_day_count'].';'."\n";

			$return_string .= 'var TS_open_comment_day = 0;'."\n";
			$return_string .= 'var TS_open_comment_pro = new Array();'."\n"; //index 0 tag, index 1 projekt
			$return_string .= 'var TS_open_time_pro = new Array();'."\n"; //index 0 tag, index 1 projekt

			$return_string .= 'var TS_open_day_comment_header = "'.get_text(866, 'return', 'decode_on') /*Tageskommentar*/.'";'."\n";
			$return_string .= 'var TS_open_pro_comment_header = "'.get_text(867, 'return', 'decode_on') /*Projektkommentar*/.'";'."\n";
			$return_string .= 'var TS_open_pro_time_header = "'.get_text(868, 'return', 'decode_on') /*Projektzeiten*/.'";'."\n";

			//Temporaeres Zwischenspeichern der Projektzeiten
			$return_string .= 'var TS_tmp_pro_time = new Array();'."\n";

			$return_string .= 'var TS_month = "'.$this->setup_array['month'].'";'."\n";
			$return_string .= 'var TS_year = "'.$this->setup_array['year'].'";'."\n";
			$return_string .= 'var TS_user = '.$this->setup_array['user_id'].';'."\n";
			$return_string .= 'var TS_pausen_zeit = '.$this->setup_array['pausenzeit'].';'."\n";
			$return_string .= 'var TS_img_pfad = "'.TOM_ABS_URL.'template/'.$GLOBALS['setup_array']['template'].'/image/'.'";'."\n";

			$return_string .= 'var txt_TS_pdf_submit = "'.get_text(1044, 'return', 'decode_off') /*Bitte w&auml;hlen Sie min. ein Projekt aus!*/.'";'."\n";
			
			$return_string .= '// -->'."\n".'</script>'."\n";

			$return_string .= "\n".'<script type="text/javascript" src="'.TOM_ABS_URL.'inc/TimeSheet.js?v='.TOM_VERSION.'"></script>'."\n";

			return $return_string;
		}

		/**
		 * Gibt fuer das ipt Feld kommenbzw. gehen einen Style entsprechend der anfgangzeit bzw. endzeit aus
		 *
		 * @param string $time
		 * @param string $type
		 * @return string
		 */
		protected function get_ipt_style($time, $type, $is_ipt = true)
		{
			//kommenzeit
			if ($type == 'kommen')
			{
				//nur die stunde verwenden
				$time = intval(substr($time, 0, 2));
				//Warnung ausgeben
				if ($time < $this->setup_array['report_vor'])
				{
					//Inputfeld
					if ($is_ipt == true)
					{
						return ' class="stz_ipt_50_warning" ';
					}
					//kein inputfeld
					else
					{
						return ' class="stz_warning" ';
					}
				}
				//keine Warnung
				else
				{
					//inputfeld
					if ($is_ipt == true)
					{
						return ' class="stz_ipt_50" ';
					}
					//kein inputfeld
					else
					{
						return '';
					}
				}
			}
			//gehenzeit
			elseif ($type == 'gehen')
			{
				//zeit in float wandeln
				$time = floatval(str_replace(':', '.', $time));
				//warnung ausgeben
				if ($time >= $this->setup_array['report_nach'])
				{
					//inputfeld
					if ($is_ipt == true)
					{
						return ' class="stz_ipt_50_warning" ';
					}
					//kein inputfeld
					else
					{
						return ' class="stz_warning" ';
					}
				}
				//kein warnung
				else
				{
					//inputfeld
					if ($is_ipt == true)
					{
						return ' class="stz_ipt_50" ';
					}
					//kein inputfeld
					else
					{
						return '';
					}
				}
			}
			//istzeit
			elseif ($type == 'istzeit')
			{
				//warnung ausgeben
				if ($time > $this->setup_array['report_mehr'])
				{
					return ' class="stz_warning" ';
				}
				else
				{
					return '';
				}
			}
		}

		/**
		 * Gibt einstelloptionen fuer die PDF-Ausgabe aus
		 *
		 */
		protected function get_time_sheet_pdf_option()
		{
			$cs = new Checksum;

			$project_count_int = count($this->project_array);

			$return_string = '';
			$return_string .= '<form method="post" action="../report/pdf_stz.php'.$GLOBALS['gv']->create_get_string().'" name="PDFTimeSheet" id="PDFTimeSheet" enctype="multipart/form-data" target="_blank" accept-charset="UTF-8">';

			$return_string .= $cs->GetHidden(array('user_id_int' => $this->setup_array['user_id'],
													'month_string' => $this->setup_array['month'],
													'year_int' => $this->setup_array['year']));

			$return_string .= '<input type="hidden" name="user_id_int" value="'.$this->setup_array['user_id'].'" />
								<input type="hidden" name="month_string" value="'.$this->setup_array['month'].'" />
								<input type="hidden" name="year_int" value="'.$this->setup_array['year'].'" />';

			$return_string .= '<br /><table cellpadding="0" cellspacing="0" border="0" width="100%" class="table_content">'."\n";

			$return_string .= '<colgroup>
								<col width="15%" />
								<col width="85%" />
								</colgroup>'."\n";

			$return_string .= '<tr><td align="center" colspan="2"><br /><strong>'.get_text(581, 'return').'</strong><br /></td></tr>'."\n";//PDF Optionen

			$return_string .= '<tr><td colspan="2">&nbsp;<input type="radio" name="pdf_type" value="day" checked="checked" onclick="TS_pdf_set_type('.$project_count_int.');" />&nbsp;'.get_text(582, 'return').'</td></tr>'."\n";//Tagesbezogener Stundenzettel
			$return_string .= '<tr><td colspan="2">&nbsp;<input type="radio" name="pdf_type" value="project" onclick="TS_pdf_set_type('.$project_count_int.');" />&nbsp;'.get_text(583, 'return').'</td></tr>'."\n";//Projektbezogener Stundenzettel
			$return_string .= '<tr><td colspan="2">&nbsp;'.get_text(585, 'return').':&nbsp;<span id="pdf_page_width">&nbsp;</span></td></tr>'."\n";//Aktuelle Breite

			$return_string .= '<tr><td colspan="2"><br />'."\n";

			//Keine Projekte
			if ($project_count_int == 0)
			{
				$return_string .= '<table cellpadding="2" cellspacing="0" border="0" width="100%" class="border">'."\n";
				$return_string .= $this->get_time_sheet_table_header(true , false);
				$return_string .= 	'<tr>'."\n";
				$return_string .= 		'<td colspan="2" align="center"><input type="checkbox" name="pdf[datum]" value="1" checked="checked" onclick="TS_pdf_width(0, \'NULL\');" /></td>'."\n";
				$return_string .= 		'<td align="center"><input type="checkbox" name="pdf[kommen]" value="1" checked="checked" onclick="TS_pdf_width(0, \'NULL\');" /></td>'."\n";
				$return_string .= 		'<td align="center"><input type="checkbox" name="pdf[pause]" value="1" checked="checked" onclick="TS_pdf_width(0, \'NULL\');" /></td>'."\n";
				$return_string .= 		'<td align="center"><input type="checkbox" name="pdf[gehen]" value="1" checked="checked" onclick="TS_pdf_width(0, \'NULL\');" /></td>'."\n";
				$return_string .= 		'<td align="center"><input type="checkbox" name="pdf[istzeit]" value="1" checked="checked" onclick="TS_pdf_width(0, \'NULL\');" /></td>'."\n";
				$return_string .= 		'<td align="center"><input type="checkbox" name="pdf[abwesenheit]" value="1" checked="checked" onclick="TS_pdf_width(0, \'NULL\');" /></td>'."\n";
				$return_string .= 		'<td align="center"><input type="checkbox" name="pdf[zeit]" value="1" checked="checked" onclick="TS_pdf_width(0, \'NULL\');" /></td>'."\n";
				$return_string .= 		'<td align="center"><input type="checkbox" name="pdf[kommentar]" value="1" checked="checked" onclick="TS_pdf_width(0, \'NULL\');" /></td>'."\n";
				$return_string .= 	'</tr>'."\n";
				$return_string .= '</table>'."\n";
				$return_string .= '<table cellpadding="0" cellspacing="0" border="0" width="100%">'."\n";
				$return_string .= 	'<tr valign="top">'."\n";
				$return_string .= 		'<td width="100%" align="center"><br />'."\n";
				$return_string .=			'<table cellpadding="2" cellspacing="0" border="0" width="30%" class="border">'."\n";
				$return_string .=				'<tr>'."\n";
				$return_string .=					'<td><input type="checkbox" name="pdf[option][month_overall]" value="1" checked="checked" />&nbsp;'.get_text(634, 'return').'</td>'."\n";//Monatsgesamtwerte
				$return_string .= 				'</tr>'."\n";
				$return_string .=			'</table>'."\n";
				$return_string .= 		'<input type="hidden" name="no_project_exists" value="1" />'."\n";
				$return_string .= 		'</td>'."\n";
				$return_string .= 	'</tr>'."\n";
				$return_string .= '</table>'."\n";
			}
			//Projekte vorhanden
			else
			{
				//Beite der Tabelle fuer die Projektlegende bestimmen
				$project_table_width_int = $project_count_int * $this->setup_array['project_td_width'];

				$return_string .= '<table cellpadding="0" cellspacing="0" border="0" style="table-layout:fixed; width:100%;">'."\n";
				$return_string .= 	'<tr valign="top">'."\n";
				$return_string .= 		'<td style="width:70%;">'."\n";
				$return_string .= 			'<table cellpadding="2" cellspacing="0" border="0" width="100%" class="stz_main_table">'."\n";
				$return_string .= 				$this->get_time_sheet_table_header(true, true);
				$return_string .= 				'<tr>'."\n";
				$return_string .= 					'<td colspan="2" align="center"><input type="checkbox" name="pdf[datum]" value="1" checked="checked" onclick="TS_pdf_width('.$project_count_int.', \'NULL\');" /></td>'."\n";
				$return_string .= 					'<td align="center"><input type="checkbox" name="pdf[kommen]" value="1" checked="checked" onclick="TS_pdf_width('.$project_count_int.', \'NULL\');" /></td>'."\n";
				$return_string .= 					'<td align="center"><input type="checkbox" name="pdf[pause]" value="1" checked="checked" onclick="TS_pdf_width('.$project_count_int.', \'NULL\');" /></td>'."\n";
				$return_string .= 					'<td align="center"><input type="checkbox" name="pdf[gehen]" value="1" checked="checked" onclick="TS_pdf_width('.$project_count_int.', \'NULL\');" /></td>'."\n";
				$return_string .= 					'<td align="center"><input type="checkbox" name="pdf[istzeit]" value="1" checked="checked" onclick="TS_pdf_width('.$project_count_int.', \'NULL\');" /></td>'."\n";
				$return_string .= 					'<td align="center"><input type="checkbox" name="pdf[abwesenheit]" value="1" checked="checked" onclick="TS_pdf_width('.$project_count_int.', \'NULL\');" /></td>'."\n";
				$return_string .= 					'<td align="center"><input type="checkbox" name="pdf[zeit]" value="1" checked="checked" onclick="TS_pdf_width('.$project_count_int.', \'NULL\');" /></td>'."\n";
				$return_string .= 					'<td align="center"><input type="checkbox" name="pdf[kommentar]" value="1" checked="checked" onclick="TS_pdf_width('.$project_count_int.', \'NULL\');" /></td>'."\n";
				$return_string .= 					'<td align="center"><input type="checkbox" name="pdf[nzs]" value="1" onclick="TS_pdf_width('.$project_count_int.', \'NULL\');" /></td>'."\n";
				$return_string .= 				'</tr>'."\n";
				$return_string .= 			'</table>'."\n";
				$return_string .= 		'</td>'."\n";
				$return_string .= 		'<td style="width:30%;">'."\n";
				$return_string .= 			'<div style="width:100%; overflow:scroll; overflow-x:scroll; overflow-y:auto;">'."\n";
				//Projekttabelle
				$return_string .= 				'<table cellpadding="2" cellspacing="0" border="0" width="'.$project_table_width_int.'" class="stz_project_table">'."\n";
				$return_string .= 					$this->get_time_sheet_table_header_projects(true);
				$return_string .= 					'<tr>'."\n";
														for ($i = 0; $i < $project_count_int; $i++)
														{
															$return_string .= '<td align="center">';
															$return_string .= '<input type="checkbox" id="pdf_projekt_'.$i.'" name="pdf[projekt]['.$this->project_array[$i]['id'].']" value="1" onclick="TS_pdf_width('.$project_count_int.', '.$i.');" title="'.get_text(106, 'return').'" />';//Projektstunden
															//Projektkommentar vorhanden
															if (isset($this->setup_array['projektkommentar_exists'][$this->project_array[$i]['id']]) and $this->setup_array['projektkommentar_exists'][$this->project_array[$i]['id']] == true)
															{
																$return_string .= '<input type="checkbox" id="pdf_projektkommentar_'.$i.'" name="pdf[projektkommentar]['.$this->project_array[$i]['id'].']" value="1" onclick="TS_pdf_width('.$project_count_int.', '.$i.');" disabled="disabled" title="'.get_text(867, 'return').'" />';//Projektkommentar
															}
															else
															{
																$return_string .= '<input type="checkbox" id="pdf_projektkommentar_'.$i.'" name="pdf[projektkommentar]['.$this->project_array[$i]['id'].']" value="1" onclick="TS_pdf_width('.$project_count_int.', '.$i.');" disabled="disabled" style="display:none" />';
															}
															$return_string .= '</td>'."\n";
														}
				$return_string .= 					'</tr>'."\n";
				$return_string .= 				'</table>'."\n";
				$return_string .= 			'</div>'."\n";
				$return_string .= 		'</td>'."\n";
				$return_string .= 	'</tr>'."\n";
				$return_string .= 	'<tr>'."\n";
				$return_string .= 		'<td colspan="2" align="center"><br />'."\n";
				$return_string .= 			'<table cellpadding="2" cellspacing="0" border="0" width="30%" class="border">'."\n";
				$return_string .= 				'<tr>'."\n";
				$return_string .= 					'<td><input type="checkbox" name="pdf[option][month_overall]" value="1" checked="checked" />&nbsp;'.get_text(634, 'return').'</td>'."\n";//Monatsgesamtwerte
				$return_string .= 				'</tr>'."\n";
				$return_string .= 				'<tr>'."\n";
				$return_string .= 					'<td><input type="checkbox" name="pdf[option][projekt_legende]" value="1" checked="checked" />&nbsp;'.get_text(586, 'return').'</td>'."\n";//Projektlegende erstellen
				$return_string .= 				'</tr>'."\n";
				$return_string .= 				'<tr>'."\n";
				$return_string .= 					'<td><input type="checkbox" name="pdf[option][signature]" value="1" checked="checked" />&nbsp;'.get_text(587, 'return').'</td>'."\n";//Unterschriftsfeld je Projekt erstellen
				$return_string .= 				'</tr>'."\n";
				$return_string .= 				'<tr>'."\n";
				$return_string .= 					'<td><input type="checkbox" name="pdf[option][only_projecttime]" value="1" />&nbsp;'.get_text(725, 'return').'</td>'."\n";//Nur Projektzeiten ausgeben
				$return_string .= 				'</tr>'."\n";
				$return_string .= 			'</table>'."\n";
				$return_string .= 		'</td>'."\n";
				$return_string .= 	'</tr>'."\n";
				$return_string .= '</table>'."\n";
			}
			$return_string .= '</td>'."\n";
			$return_string .= '</tr>'."\n";
			$return_string .= '<tr>'."\n";
			$return_string .= '<td align="center" colspan="2">'.get_button(get_text(588, 'return'), 'page_white_acrobat.png',  'onclick="TS_pdf_submit('.$project_count_int.');"').'</td>'."\n";//PDF Erstellen
			$return_string .= '</tr>'."\n";
			$return_string .= '</table>'."\n";
			$return_string .= '</form>';
			$return_string .= '<script type="text/javascript">
								<!--
									TS_pdf_width('.$project_count_int.');
								// -->
								</script>';

			return $return_string;
		}
	}
?>