<?php
	/**
	 * this include-file contains a collection of useful functions
	 * @package time-o-meter
	 * @subpackage inc
	 */

	/**
	 * nur fuer Entwicklungszwecke / only for testing
	 */
	function print_r_pre($array)
	{
		echo '<pre>';
			print_r($array);
		echo '</pre>';
	}

	/**
	 * Umgeht den Fehler der empty() Funktion beim int 0 wert
	 * @param mixed $var
	 * @return boole
	 */
	function _empty($var)
	{
		if (empty($var))
		{
			if ("$var" === "0")
			{
				return false;
			}
			else
			{
				return true;
			}
		}
		else
		{
			return false;
		}
	}

	/**
	 * Liest fuer die PDF ausgabe Farbcodes aus der aktuellen CSS aus und gibt die Farbwerte zurueck
	 * @param array
	 * @return array
	 */
	function get_pdf_bgcolor($style)
	{
		//pruefen ob CSS Datei vorhanden ist
		if (file_exists(TOM_ABS_PFAD.'template/'.$GLOBALS['setup_array']['template'].'/screen.css'))
		{
			//CSS Datei ist readable
			if ($h = @fopen(TOM_ABS_PFAD.'template/'.$GLOBALS['setup_array']['template'].'/screen.css', 'r'))
			{
				//Speichert alle linien mit uebereinstimmungen
				$css_lines = array();

				while (!feof($h))
				{
					//Leerzeichen am enfang und ende entfernen
					$line = trim(fgets($h));
					//Leerzeichen in der Zeile entfernen
					$line = str_replace(' ', '', $line);

					//Stylearray abarbeiten
					for ($i = 0; $i < count($style); $i++)
					{
						//Zeile enthaelt informationen zum gesuchen style
						if (strpos($line, '.'.$style[$i].'{') !== false)
						{
							$css_lines[$i] = $line;
						}
					}
				}

				//Ergebnisse gefunden
				if (count($css_lines) > 0)
				{
					$result = array();
					for ($i = 0; $i < count($style); $i++)
					{
						if (isset($css_lines[$i]))
						{
							$tmp_hex_result = substr($css_lines[$i], strlen('.'.$style[$i].'{background-color:#'), 6);

							$tmp_dezi_1 = hexdec(substr($tmp_hex_result, 0, 2));
							$tmp_dezi_2 = hexdec(substr($tmp_hex_result, 2, 2));
							$tmp_dezi_3 = hexdec(substr($tmp_hex_result, 4, 2));

							$result[$i] = array('hex'			=>	$tmp_hex_result,
												'dezi_string'	=>	$tmp_dezi_1.','.$tmp_dezi_2.','.$tmp_dezi_3,
												'dezi'			=>	array($tmp_dezi_1, $tmp_dezi_2, $tmp_dezi_3));
						}
						else
						{
							$result[$i] = array();
						}
					}
					return $result;
				}
				else
				{
					return array();
				}
			}
			else
			{
				return array();
			}
		}
		else
		{
			return array();
		}
	}

	/**
	 * Erstellt einen Div Button
	 * @param string $txt
	 * @param string $img
	 * @param string $js_code
	 * @return string
	 */
	function get_button($txt, $img, $js_code, $type = '', $tabindex = 0)
	{
		$button = new Button();

		if (!empty($js_code))
		{
			$js_string = ' '.trim($js_code);
		}
		else
		{
			$js_string = '';
		}

		$button_result = $button->get_button(html_entity_decode($txt, ENT_QUOTES), $img);
		if ($button_result !== false and isset($button_result['width']) and isset($button_result['height']) and $button_result['width'] > 0 and $button_result['height'] > 0)
		{
			if (!empty($tabindex))
			{
				$js_string .= ' tabindex="'.$tabindex.'"';
			}

			if (empty($type))
			{
				return '<div style="margin-top:5px; margin-bottom:5px;"><img src="'.$button_result['url'].'" width="'.$button_result['width'].'" height="'.$button_result['height'].'" border="0" alt="" class="image_button"'.$js_string.' /></div>';
			}
			elseif ($type == 'submit')
			{
				return '<div style="margin-top:5px; margin-bottom:5px;"><input type="image" src="'.$button_result['url'].'" alt="Submit" style="border:0px;"'.$js_string.' /></div>';
			}
			else
			{
				return '<div style="margin-top:5px; margin-bottom:5px;"><img src="'.$button_result['url'].'" width="'.$button_result['width'].'" height="'.$button_result['height'].'" border="0" alt="" class="image_button"'.$js_string.' /></div>';
			}
		}
		else
		{
			return '<div style="height:18px; margin-top:5px; margin-bottom:5px; min-width:134px;">
				<table border="0" cellpadding="0" cellspacing="0">
					<tr style="cursor:pointer;"'.$js_string.'>
						<td width="5"><img src="../template/default/image/_button1.png" width="5" height="18" border="0" alt="" class="image" /></td>
						<td nowrap="nowrap" style="background-image:url(../template/default/image/_button2.png); background-repeat:repeat-x; padding-left:4px; padding-right:4px; padding-bottom:1px; text-align:left;">'.$txt.'</td>
						<td width="24" style="background-image:url(../template/default/image/_button2.png); background-repeat:repeat-x; padding-right:4px; vertical-align:middle; text-align:right;"><img src="../template/default/image/'.$img.'" width="16" height="16" border="0" alt="" class="image" /></td>
						<td width="5"><img src="../template/default/image/_button3.png" width="5" height="18" border="0" alt="" class="image" /></td>
					</tr>
					<tr style="line-height:1px;">
						<td>&#160;</td>
						<td><img src="../template/default/image/_spacer.gif" width="100" height="1" border="0" alt="" /></td>
						<td colspan="2">&#160;</td>
					</tr>
				</table>
			</div>';
		}
	}

	/**
	* Blaetternfunktion
	* @param int $CurrentPage, Aktuelle Seitenzahl
	* @param int $DataCount, Gesamtzahl aller Datensaetze
	* @param int $PageMax, Anzahl an ausgaben pro Seite
	* @param array $variablen, Array mit Varaibalen die als Get an die links angehaengt werden sollen z.B. $_POST
	* @param string $pfad, Pfad wor die einzelnen Links hingehen sollen
	* @return array
	*/
	function blaettern($current_page, $data_count, $page_max, $variablen, $pfad)
	{
		$return = array();
		$return['txt'] = '';
		//variablen in get string aendern
		if (is_array($variablen) and count($variablen) > 0)
		{
			$get_variablen = '';
			foreach ($variablen as $i => $v)
			{
				if ($i != 'submit' and $i != 'blseite')
				{
					if (empty($get_variablen))
					{
						$get_variablen = '?'.$i.'='.$v;
					}
					else
					{
						$get_variablen .= '&amp;'.$i.'='.$v;
					}
				}
			}
		}

		//gesamtseiten zahl ermitteln
		if ($data_count > 0)
		{
			$gesamt_seiten_int = ceil($data_count / $page_max);
		}
		else
		{
			$gesamt_seiten_int = 0;
		}
		if ($gesamt_seiten_int == 0)
		{
			$gesamt_seiten_int = 1;
			$startergebnis = 0;
		}
		else
		{
			$startergebnis = $current_page * $page_max - $page_max + 1;
		}

		//ergebnisse der seite errechnen
		$endergebnis = $current_page * $page_max;
		if ($endergebnis > $data_count)
		{
			$endergebnis = $data_count;
		}

		$return['txt'] .= get_text('', 'return', 'decode_on', 'page'); /*Seite*/
		$return['txt'] .= '&nbsp;'.$current_page.'&nbsp;';
		$return['txt'] .= get_text(67, 'return', 'decode_on'); /*von*/
		$return['txt'] .= '&nbsp;'.$gesamt_seiten_int.'&nbsp;-&nbsp;';
		$return['txt'] .= get_text(68, 'return', 'decode_on'); /*Ergebnisse*/
		$return['txt'] .= '&nbsp;'.$startergebnis.'&nbsp;';
		if ($startergebnis > 0)
		{
			$return['txt'] .= get_text(69, 'return', 'decode_on'); /*bis*/
			$return['txt'] .= '&nbsp;'.$endergebnis.'&nbsp;';
			$return['txt'] .= get_text(67, 'return', 'decode_on'); /*von*/
			$return['txt'] .= '&nbsp;'.$data_count;
		}
		$return['txt'] .= '<br />';

		if (isset($get_variablen) and !empty($get_variablen))
		{
			$get_variablen .= '&amp;blseite=';
		}
		else
		{
			$get_variablen = '?blseite=';
		}

		//erste seite und eine seite zurueck
		if ($current_page != 1)
		{
			//get string fuer link bearbeiten
			$letzte_seite = $current_page - 1;
			$return['txt'] .= '<a href="'.$pfad.$GLOBALS['gv']->create_get_string($get_variablen.'1').'"><strong>['.get_text(72, 'return', 'decode_on')/*erste Seite*/.']</strong></a>';
			$return['txt'] .= '<a href="'.$pfad.$GLOBALS['gv']->create_get_string($get_variablen.$letzte_seite).'">&nbsp;<strong>['.get_text(73, 'return', 'decode_on')/*eine Seite zurueck*/.']</strong></a>';
		}
		//Blaettern link
		$anzahl_seiten_vor_und_nach_aktueller_seite = 5;
		$start_seiten_anzeige = $current_page - $anzahl_seiten_vor_und_nach_aktueller_seite;
		$ende_seiten_anzeige = $current_page + $anzahl_seiten_vor_und_nach_aktueller_seite;

		if ($gesamt_seiten_int > 1)
		{
			$for_anzahl = 1;
			$start_punkt = 'j';
			$end_punkte = 'j';
			for ($i = 1; $i <= $gesamt_seiten_int; $i++)
			{
				if ($i < $start_seiten_anzeige and $start_punkt == 'j')
				{
					$return['txt'] .= ' ...';
					$start_punkt = 'n';
				}
				if ($i >= $start_seiten_anzeige and $i <= $ende_seiten_anzeige)
				{
					if ($for_anzahl == 1)
					{
						$return['txt'] .= '&nbsp;';
					}
					if ($i == $current_page)
					{
						$return['txt'] .= '<strong><u>'.$i.'</u></strong> ';
					}
					else
					{
						$return['txt'] .= '<a href="'.$pfad.$GLOBALS['gv']->create_get_string($get_variablen.$i).'"><strong>'.$i.'</strong></a> ';
					}
					$for_anzahl++;
				}
				if ($i > $ende_seiten_anzeige and $end_punkte == 'j')
				{
					$return['txt'] .= '... ';
					$end_punkte = 'n';
				}
			}

		}

		//letzte seite und eine seite weiter
		if ($current_page != $gesamt_seiten_int)
		{
			$eine_seite_weiter = $current_page + 1;
			$return['txt'] .= '<a href="'.$pfad.$GLOBALS['gv']->create_get_string($get_variablen.$eine_seite_weiter).'"><strong>['.get_text(70, 'return', 'decode_on')/*eine Seite weiter*/.']</strong></a>';
			$return['txt'] .= '&nbsp;<a href="'.$pfad.$GLOBALS['gv']->create_get_string($get_variablen.$gesamt_seiten_int).'"><strong>['.get_text(71, 'return', 'decode_on')/*letzte Seite*/.']</strong></a>';
		}

		if (substr($return['txt'],-6) != '<br />')
		{
			$return['txt'] .= '<br />';
		}

		//LIMIT erstellen
		$limit_start = $current_page * $page_max - $page_max;
		$return['limit'] = " LIMIT $limit_start, $page_max";

		return $return;
	}

	/**
	* Sprachen aus den Testetabelle auslesen. Nur Systemtexte.
	* @param int $TXTID
	* @param string $RETURN
	* @param strind $RETRUNMODE
	* @param string $TXTKEY
	* @param array $VARIABLE, enthaelt Werte die in den Textstring eingefuegt werden sollen
	* @return string
	*/
	function get_text($TXTID, $RETURN = 'echo', $RETRUNMODE = 'decode_on', $TXTKEY = '', $VARIABLE = array())
	{
		$gt = new GetText;

		$txt = $gt->Get_Text($TXTID, $TXTKEY, 'return', $RETRUNMODE, $VARIABLE);

		if ($RETURN == 'echo')
		{
			echo $txt;
		}
		else
		{
			return $txt;
		}
	}

	/**
	 * Prueft ob die uebergebene IP im IP_array vorkommt
	 * @param string $request_ip
	 * @param array $ip_array
	 * @return boole
	 */
	function chk_request_ip($request_ip, $ip_array)
	{
		//Lokaler bzw. aufruf vom eigenen Server
		if ($request_ip == '127.0.0.1' or $request_ip == $_SERVER['SERVER_ADDR'])
		{
			return true;
		}

		//direkter treffer
		if (array_search($request_ip, $ip_array) !== false)
		{
			return true;
		}
		//Pruefen ob eine IP mit * einen treffer ergibt
		else
		{
			//Alle IP Adressen mit einem * finden
			$tmp_ip_array = array();
			foreach ($ip_array as $ip)
			{
				if (strpos($ip, '*') !== false)
				{
					$tmp_ip_array[] = $ip;
				}
			}

			//IP Adressen mit * vorhanden
			if (count($tmp_ip_array) > 0)
			{
				//Request IP Adresse zerlegen
				$request_ip_array = explode('.', $request_ip);

				foreach ($tmp_ip_array as $ip)
				{
					//zulaessige IP Adresse zerlegen
					$ip_array = explode('.', $ip);

					$chk_ip = true;
					foreach ($ip_array as $i => $v)
					{
						//Request block ist vorhanden
						if (isset($request_ip_array[$i]))
						{
							//Bei * keine Pruefung
							if ($v != '*')
							{
								//keine uebereinstimmung
								if ($v != $request_ip_array[$i])
								{
									$chk_ip = false;
								}
							}
						}
						else
						{
							$chk_ip = false;
						}
					}

					if ($chk_ip === true)
					{
						return true;
					}
				}
			}
			else
			{
				return false;
			}
		}
	}

	/**
	 * Erstellt ein array mit den Hexadezimalwerte fuer alle Webfarben
	 * @return array
	 */
	function get_web_color_array()
	{
		$color_array = array();
		$tmp_hex_r = '';
		$tmp_hex_g = '';
		$tmp_hex_b = '';

		for ($r = 0x00; $r < 256; $r += 0x33)
		{
			for ($g = 0x00; $g < 256; $g += 0x33)
			{
				for ($b = 0x00; $b < 256; $b += 0x33)
				{
					$tmp_hex_r = dechex($r);
					$tmp_hex_g = dechex($g);
					$tmp_hex_b = dechex($b);

					if (strlen($tmp_hex_r) == 1)
					{
						$tmp_hex_r = '0'.$tmp_hex_r;
					}

					if (strlen($tmp_hex_g) == 1)
					{
						$tmp_hex_g = '0'.$tmp_hex_g;
					}

					if (strlen($tmp_hex_b) == 1)
					{
						$tmp_hex_b = '0'.$tmp_hex_b;
					}
					$color_array[] = $tmp_hex_r.$tmp_hex_g.$tmp_hex_b;
				}
			}
		}
		return $color_array;
	}
?>