<?php
	/**
	 * main navigation
	 * this include-file contains the menu-structure
	 * @package time-o-meter
	 * @subpackage inc
	 */

	//Menuepunkte
	//ACHTUNG: Wenn die Filteroptionsdaten aus der SESSION entfernt werden sollen beim aufruf einer neuen Seite muss im Link clear_sf=1 stehen
	$menue = array();
	$menue[0]['main'] = array('name' => 'Home', 'js_id' => 'menue_home', 'img' => 'house.png', 'link' => '../main/index.php'.$gv->create_get_string('?fileinc=&amp;clear_sf=1'));

	$menue[1]['main'] = array('name' => get_text(844, 'return', 'decode_on') /*Zeiterfassung*/, 'js_id' => 'menue_time', 'img' => 'time.png');
	$menue[1]['sub'][] = array('name' => get_text(845, 'return', 'decode_on') /*Stundenzettel anzeigen*/, 'img' => 'bullet_green.png','link' => '../stz/index.php'.$gv->create_get_string('?fileinc=show_stz&amp;stz=show_activ&amp;clear_sf=1'));
	$menue[1]['sub'][] = array('name' => get_text(846, 'return', 'decode_on') /*Stundenzettel bearbeiten*/, 'img' => 'bullet_green.png','link' => '../stz/index.php'.$gv->create_get_string('?fileinc=show_stz&amp;stz=edit&amp;clear_sf=1'));
	$menue[1]['sub'][] = array('name' => get_text(808, 'return', 'decode_on') /*Stundenzettel-Archiv*/, 'img' => 'bullet_green.png', 'link' => '../stz/index.php'.$gv->create_get_string('?fileinc=archiv&amp;clear_sf=1'));

	if (defined('USER_GROUP_ID') and $access->check_group(USER_GROUP_ID, 'admin_stz'))
	{
		$menue[1]['sub'][] = array('name' => get_text(810, 'return', 'decode_on') /*uebertragsverwaltung*/, 'img' => 'bullet_red.png', 'link' => '../stz/index.php'.$gv->create_get_string('?fileinc=carry&amp;clear_sf=1'));
		$menue[1]['sub'][] = array('name' => get_text(272, 'return', 'decode_on') /*uebertragskorrektur hinzufuegen*/, 'img' => 'bullet_red.png', 'link' => '../stz/index.php'.$gv->create_get_string('?fileinc=carry_add&amp;clear_sf=1'));
		$menue[1]['sub'][] = array('name' => get_text(825, 'return', 'decode_on') /*Personalstundenzetteluebersicht*/, 'img' => 'bullet_red.png', 'link' => '../stz/index.php'.$gv->create_get_string('?fileinc=overview_stz&amp;clear_sf=1'));
	}

	$menue[2]['main'] = array('name' => get_text(602, 'return', 'decode_on') /*Abwesenheit*/, 'js_id' => 'menue_holiday', 'img' => 'weather_sun.png', 'link' => '../holiday/index.php'.$gv->create_get_string('?fileinc=overview_absence&amp;clear_sf=1'));
	$menue[2]['sub'][] = array('name' => get_text(1042, 'return', 'decode_on') /*Abwesenheits&uuml;bersicht*/, 'img' => 'bullet_green.png', 'link' => '../holiday/index.php'.$gv->create_get_string('?fileinc=overview_absence&amp;clear_sf=1'));
	$menue[2]['sub'][] = array('name' => get_text(1029, 'return', 'decode_on') /*Absence request*/, 'img' => 'bullet_green.png','link' => '../holiday/index.php'.$gv->create_get_string('?fileinc=add_absence&amp;clear_sf=1'));
	$menue[2]['sub'][] = array('name' => get_text(119, 'return', 'decode_on') /*Jahresurlaubsplan*/, 'img' => 'bullet_green.png','link' => '../holiday/index.php'.$gv->create_get_string('?fileinc=year_holiday&amp;clear_sf=1'));

	if (defined('USER_GROUP_ID') and ($access->check_group(USER_GROUP_ID, 'admin_antrag_read') or $access->check_group(USER_GROUP_ID, 'admin_antrag_write')))
	{
		$menue[2]['sub'][] = array('name' => get_text(1041, 'return', 'decode_on') /*Abwesenheits&uuml;bersicht (Personal)*/, 'img' => 'bullet_red.png','link' => '../holiday/index.php'.$gv->create_get_string('?fileinc=overview_holiday_admin&amp;clear_sf=1'));
	}

	if (defined('USER_GROUP_ID') and ($access->check_group(USER_GROUP_ID, 'admin_project_read') or $access->check_group(USER_GROUP_ID, 'admin_project_write')))
	{
		$menue[3]['main'] = array('name' => get_text(772, 'return', 'decode_on') /*Projektverwaltung*/, 'js_id' => 'menue_project', 'img' => 'folder_table.png', 'link' => '../project/index.php'.$gv->create_get_string('?fileinc=main&amp;clear_sf=1'));
		$menue[3]['sub'][] = array('name' => get_text(773, 'return', 'decode_on') /*Projektuebersicht*/, 'img' => 'bullet_red.png', 'link' => '../project/index.php'.$gv->create_get_string('?fileinc=main&amp;clear_sf=1'));

		if ($access->check_group(USER_GROUP_ID, 'admin_project_write'))
		{
			$menue[3]['sub'][] = array('name' => get_text(562, 'return', 'decode_on') /*Projekt hinzufuegen*/, 'img' => 'bullet_red.png', 'link' => '../project/index.php'.$gv->create_get_string('?fileinc=project_add&amp;clear_sf=1'));
		}
		if ($access->check_group(USER_GROUP_ID, 'admin_reports_read'))
		{
			$menue[3]['sub'][] = array('name' => get_text(675, 'return', 'decode_on') /*Projektstundenreport*/, 'img' => 'bullet_red.png', 'link' => '../project/index.php'.$gv->create_get_string('?fileinc=project_report_hours&amp;clear_sf=1'));
		}
	}

	// hier muessen verschiedene zugriffsrechte geprueft werden:
	// personal lesen/schreiben, reports lesen(/schreiben?), krankheitstagereport lesen
	if (defined('USER_GROUP_ID') and ($access->check_group(USER_GROUP_ID, 'admin_user_read') or $access->check_group(USER_GROUP_ID, 'admin_user_write') or $access->check_group(USER_GROUP_ID, 'admin_reports_health_read') or $access->check_group(USER_GROUP_ID, 'admin_reports_read')))
	{
		$menue[4]['main'] = array('name' => get_text(0, 'return', 'decode_on', 'personal') /*Personal*/, 'js_id' => 'menue_user', 'img' => 'user.png', 'link' => '../user/index.php'.$gv->create_get_string('?fileinc=&amp;clear_sf=1'));

		if ($access->check_group(USER_GROUP_ID, 'admin_user_read'))
		{
			$menue[4]['sub'][] = array('name' => get_text(831, 'return', 'decode_on') /*Personalverwaltung*/, 'img' => 'bullet_red.png', 'link' => '../user/index.php'.$gv->create_get_string('?fileinc=&amp;clear_sf=1'));
		}

		if ($access->check_group(USER_GROUP_ID, 'admin_user_write'))
		{
			$menue[4]['sub'][] = array('name' => get_text(663, 'return', 'decode_on') /*Mitarbeiter hinzufuegen*/, 'img' => 'bullet_red.png', 'link' => '../user/index.php'.$gv->create_get_string('?fileinc=user_add&amp;clear_sf=1'));
		}

		if ($access->check_group(USER_GROUP_ID, 'admin_reports_health_read'))
		{
			$menue[4]['sub'][] = array('name' => get_text(1056, 'return', 'decode_on') /*Abwesenheitstage*/, 'img' => 'bullet_red.png', 'link' => '../user/index.php'.$gv->create_get_string('?fileinc=user_sick_day&amp;clear_sf=1'));
		}

		if ($access->check_group(USER_GROUP_ID, 'admin_reports_read'))
		{
			$menue[4]['sub'][] = array('name' => get_text(836, 'return', 'decode_on') /*Gesamtstundenreport*/, 'img' => 'bullet_red.png', 'link' => '../user/index.php'.$gv->create_get_string('?fileinc=user_working_time&amp;clear_sf=1'));
			$menue[4]['sub'][] = array('name' => get_text(110, 'return', 'decode_on') /*Geburtstagsliste*/, 'img' => 'bullet_red.png', 'link' => '../user/index.php'.$gv->create_get_string('?fileinc=user_birthday_list&amp;clear_sf=1'));
		}
	}

	//FIXME
	/*
		if (defined('USER_GROUP_ID') && $access->check_group(USER_GROUP_ID,'admin_reisekosten'))
		{
			$menue[5]['main'] = array('name' => 'Reisekosten', 'js_id' => 'menue_travel_costs', 'img' => 'money.png');
			$menue[5]['sub'][] = array('name' => 'uebersicht', 'link' => '#');
		}
	*/

	$menue[6]['main'] = array('name' => get_text(103, 'return', 'decode_on') /*Mitteilungen*/, 'js_id' => 'menue_message', 'img' => 'email.png', 'link' => '../message/index.php'.$gv->create_get_string('?fileinc=&amp;clear_sf=1'));
	$menue[6]['sub'][] = array('name' => get_text(99, 'return', 'decode_on') /*uebersicht*/, 'img' => 'bullet_green.png', 'link' => '../message/index.php'.$gv->create_get_string('?fileinc=&amp;clear_sf=1'));

	if (defined('USER_GROUP_ID') and $access->check_group(USER_GROUP_ID, 'admin_message_write'))
	{
		$menue[6]['sub'][] = array('name' => get_text(264, 'return', 'decode_on') /*Mitteilung schreiben*/, 'img' => 'bullet_red.png', 'link' => '../message/index.php'.$gv->create_get_string('?fileinc=message_add'));
	}
	/*
	$menue[6]['sub'][] = array('name' => 'uebersicht', 'link' => '../message/index.php?fileinc=&amp;clear_sf=1');
	$menue[6]['sub'][] = array('name' => 'Mitteilung schreiben', 'link' => '../message/index.php?fileinc=message_add&amp;clear_sf=1');
	*/

	//konfiguration des downloadbereiches pruefen
	if (!isset($setup_array['dms_url']))
	{
		$setup_array['dms_url'] = '';
	}
	if (!isset($setup_array['dms_projects']))
	{
		$setup_array['dms_projects'] = array();
	}
	if (!isset($setup_array['dms_user']))
	{
		$setup_array['dms_user'] = '';
	}
	if (!isset($setup_array['dms_pw']))
	{
		$setup_array['dms_pw'] = '';
	}

	// nur anzeigen, wenn dms einwandfrei konfiguriert
	if (strlen($setup_array['dms_url']) > 0 && strlen($setup_array['dms_user']) > 0 && strlen($setup_array['dms_pw']) > 0 && count($setup_array['dms_projects']) > 0)
	{
		$menue[7]['main'] = array('name' => get_text(837, 'return', 'decode_on') /*Downloadbereich*/, 'js_id' => 'menue_download', 'img' => 'disk.png', 'link' => '../download/index.php'.$gv->create_get_string('?fileinc=&amp;clear_sf=1'));
	}

	if (defined('USER_GROUP_ID') and $access->check_group(USER_GROUP_ID, 'admin_backup'))
	{
		$menue[8]['main'] = array('name' => get_text(97, 'return', 'decode_on') /*Backup*/, 'js_id' => 'menue_backup', 'img' => 'drive_disk.png', 'link' => '../backup/index.php'.$gv->create_get_string('?fileinc=&amp;clear_sf=1'));
		$menue[8]['sub'][] = array('name' => get_text(99, 'return', 'decode_on') /*uebersicht*/, 'img' => 'bullet_red.png', 'link' => '../backup/index.php'.$gv->create_get_string('?fileinc=&amp;clear_sf=1'));
		$menue[8]['sub'][] = array('name' => get_text(65, 'return', 'decode_on') /*Backup erstellen*/, 'img' => 'bullet_red.png', 'link' => '../backup/index.php'.$gv->create_get_string('?fileinc=backup_add&amp;clear_sf=1'));
	}

	if (defined('USER_GROUP_ID') and $access->check_group(USER_GROUP_ID, 'admin_log'))
	{
		$menue[9]['main'] = array('name' => get_text(120, 'return', 'decode_on') /*Logbuch*/, 'js_id' => 'menue_logbook', 'img' => 'report.png', 'link' => '../log/index.php'.$gv->create_get_string('?fileinc=&amp;clear_sf=1'));
		$menue[9]['sub'][] = array('name' => get_text(99, 'return', 'decode_on') /*uebersicht*/, 'img' => 'bullet_red.png', 'link' => '../log/index.php'.$gv->create_get_string('?fileinc=main&amp;clear_sf=1'));
		$menue[9]['sub'][] = array('name' => get_text(0, 'return', 'decode_on', 'login') /*Login*/.'/'.get_text('', 'return', 'decode_on', 'logout') /*Logout*/, 'img' => 'bullet_red.png', 'link' => '../log/index.php'.$gv->create_get_string('?fileinc=login&amp;clear_sf=1'));
		$menue[9]['sub'][] = array('name' => get_text(100, 'return', 'decode_on') /*Stundenzettel*/, 'img' => 'bullet_red.png', 'link' => '../log/index.php'.$gv->create_get_string('?fileinc=stz&amp;clear_sf=1'));
	}

	// nur fuer user mit adminrechten im bereich setup
	if (defined('USER_GROUP_ID') and $access->check_group(USER_GROUP_ID, 'admin_setup'))
	{
		$menue[10]['main'] = array('name' => get_text(98, 'return', 'decode_on') /*Einstellungen*/, 'js_id' => 'menue_setup', 'img' => 'cog.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(99, 'return', 'decode_on') /*uebersicht*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(202, 'return', 'decode_on') /*Grundeinstellungen*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_basic&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(0, 'return', 'decode_on', 'auto_backup') /*Auto-Backup*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_backup&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(510, 'return', 'decode_on') /*Logo-Verwaltung*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_logo&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(111, 'return', 'decode_on') /*Benutzergruppen*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_groups&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(0, 'return', 'decode_on', 'email') /*E-Mail*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_mail&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(793, 'return', 'decode_on') /*Feiertage &amp; halbe Arbeitstage*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_ft&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(791, 'return', 'decode_on') /*Abwesenheitsgraende verwalten*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_awg&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(115, 'return', 'decode_on') /*Mitarbeiterstatus & Qualifikation*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_ma_sq&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(100, 'return', 'decode_on') /*Stundenzettel*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_stz&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(837, 'return', 'decode_on') /*Downloadbereich*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_dms&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(744, 'return', 'decode_on') /*Sprachverwaltung*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_spr&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(955, 'return', 'decode_on') /*PDF-Verwaltung*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_pdf&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(977, 'return', 'decode_on') /*Webservice*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_webservice&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(1043, 'return', 'decode_on') /*LDAP*/, 'img' => 'bullet_red.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=setup_ldap&amp;clear_sf=1'));
		$menue[10]['sub'][] = array('name' => get_text(736, 'return', 'decode_on') /*Benutzerkonto verwalten*/, 'img' => 'bullet_green.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=edit_useraccount&amp;clear_sf=1'));
	}
	else
	{
		$menue[10]['main'] = array('name' => get_text(98, 'return', 'decode_on') /*Einstellungen*/, 'js_id' => 'menue_setup', 'img' => 'cog.png', 'link' => '../setup/index.php'.$gv->create_get_string('?fileinc=edit_useraccount&amp;clear_sf=1'));
	}

	$menue[11]['main'] = array('name' => get_text(93, 'return', 'decode_on') /*Hilfe*/, 'js_id' => 'menue_help', 'img' => 'help.png');
	$menue[11]['sub'][] = array('name' => get_text(876, 'return', 'decode_on') /*Hinweise fuer Anwender*/, 'img' => 'bullet_green.png', 'link' => '../help/index.php'.$gv->create_get_string('?fileinc=&amp;clear_sf=1'));

	// hilfe nur fuer user mit adminrechten im bereich setup
	if (defined('USER_GROUP_ID') and $access->check_group(USER_GROUP_ID, 'admin_setup'))
	{
		$menue[11]['sub'][] = array('name' => get_text(877, 'return', 'decode_on') /*Hinweise fuer Administratoren*/, 'img' => 'bullet_red.png', 'link' => '../help/index.php'.$gv->create_get_string('?fileinc=admin_help&amp;clear_sf=1'));
	}
?>