<?php
	/**
	 * Login-Page
	 * this site contains the login-form
	 * @package time-o-meter
	 * @subpackage login
	 */

	/**
	 * Ausgabe des HTML-Headers zulassen
	 * @ignore
	 */
	define('PAGE_AREA','LOGIN');

	/**
	 * include-sammlung einbinden
	 */
	require_once('../inc/include.php');

	//Aufgerufene URL mit der in der Config vergleichen und gegebenenfalls anpassen
	if (isset($_SERVER['SCRIPT_URI']) and !empty($_SERVER['SCRIPT_URI']))
	{
		if(TOM_ABS_URL != substr($_SERVER['SCRIPT_URI'], 0, strlen(TOM_ABS_URL)))
		{
			header("Location: ".TOM_ABS_URL);
			exit();
		}
	}
	elseif(isset($_SERVER['HTTP_HOST']) and isset($_SERVER['REQUEST_URI']))
	{
		$http = 'http://';

		if (isset($_SERVER['HTTPS']) and !empty($_SERVER['HTTPS']) and $_SERVER['HTTPS'] != 'off')
		{
			$http = 'https://';
		}

		if(TOM_ABS_URL != substr($http.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'], 0, strlen(TOM_ABS_URL)))
		{
			header("Location: ".TOM_ABS_URL);
			exit();
		}
	}

	/*
	//nur bei Demo installation
	if (file_exists('_demo_login.php'))
	{
		require_once('_demo_login.php');
	}
	*/

	//Loginpruefung
	if (isset($_POST['action_login_string']) and $_POST['action_login_string'] == 'j')
	{
		//Logindaten pruefen
		$result = $login->chk_login($_POST['pw'], $_POST['username']);

		if ($result['login'] == true)
		{
			//Benutzegruppe pruefen
			$sql = $cdb->select('SELECT t2.group_access FROM hdb_user t1
								LEFT JOIN hdb_usergroups t2 ON t1.group_id=t2.group_id
								WHERE t1.user_id='.USER_ID);
			$bg_result = $cdb->fetch_array($sql);

			//Benutzergruppendaten
			$usergroup = @unserialize($bg_result['group_access']);

			//min. Recht vorhanden
			if (is_array($usergroup) and isset($usergroup['user_all']) and $usergroup['user_all'] == 'j')
			{
				$get_string = '?action=login&'.$gv->get_index_name().'='.$result['global_var'];
				header("Location: ../main/index.php$get_string");
				exit();
			}
			else
			{
				if (isset($result['global_var']))
				{
					$login->logout($result['global_var']);
				}
				else
				{
					$login->logout();
				}
				$meldung_array['error'][] = get_text('','return','decode_on','fehler_zugriffsrechte');/*Sie besitzen nicht die notwendigen Zugriffsrechte fuer diesen Bereich.*/
			}
		}
		else
		{
			if (isset($result['error']) and is_array($result['error']))
			{
				foreach ($result['error'] as $v)
				{
					if ($v == 1){$meldung_array['error'][] = get_text(195,'return');/*Bitte geben Sie Ihr Passwort an.*/}
					elseif ($v == 2){$meldung_array['error'][] = get_text(196,'return');/*Bitte geben Sie Ihren Benutzernamen an.*/}
					elseif ($v == 3 or $v == 7 or $v == 8){$meldung_array['error'][] = get_text('','return','decode_on','fehler')/*Es ist ein Fehler aufgetreten.*/.' '.get_text(197,'return');/*Bitte versuchen Sie es zu einem spaeteren Zeitpunkt noch einmal.*/}
					elseif ($v == 4){$meldung_array['error'][] = get_text(198,'return');/*Zu den angegebenen Logindaten ist kein Benutzeraccount vorhanden.*/}
					elseif ($v == 5){$meldung_array['error'][] = get_text(199,'return');/*Ihr Account wurde deaktiviert. Bitte wenden Sie sich an den Systemadministrator.*/}
					elseif ($v == 6){$meldung_array['error'][] = get_text(200,'return')/*Ihr Account wurde bis zum*/.' '.$date->create_date($result['timeout']).' '.date("H:i:s",$result['timeout']).' '.get_text(201,'return')/*deaktiviert*/.'.';}
				}
			}
		}
	}
	elseif (isset($_GET['lost_pw_string']) and !empty($_GET['lost_pw_string']) and strlen($_GET['lost_pw_string']) == 32)
	{
		$sql = $cdb->select("SELECT * FROM hdb_user_lostpw WHERE request_key='".$_GET['lost_pw_string']."' AND user_ip='".$_SERVER['REMOTE_ADDR']."' AND create_time>'".date('YmdHis', time() - 86400)."'");
		$result = $cdb->fetch_array($sql);

		if (isset($result['request_key']) and !empty($result['request_key']))
		{
			//Passwort
			$cp = new CryptPw;

			$user_id = $result['user_id'];
			$new_pw = substr(md5(uniqid(rand(), true)), 0, 4).'_'.substr(md5(uniqid(rand(), true)), 4, 4).'_'.substr(md5(uniqid(rand(), true)), 8, 4);
			$new_crypt_pw = $cp->encode_pw($new_pw);

			if ($cdb->update("UPDATE hdb_user SET pw='$new_crypt_pw' WHERE user_id=$user_id"))
			{
				//Key wird nicht mehr benoetigt
				$cdb->delete("DELETE FROM hdb_user_lostpw WHERE request_key='".$_GET['lost_pw_string']."' LIMIT 1");
				$meldung_array['ok'][] = get_text(702, 'return').': '.$new_pw;//Ihr neues Passwort lautet
			}
			else
			{
				$meldung_array['error'][] = get_text(83, 'return');//Es ist ein Fehler aufgetreten.
			}
		}
		else
		{
			$meldung_array['error'][] = get_text(83, 'return');//Es ist ein Fehler aufgetreten.
		}
	}
	//es wird kein Menue oder Userdaten ausgegeben
	$show_lite_header_bool = true;
	//Header Datei
	require_once(TOM_ABS_PFAD.'template/'.$setup_array['template'].'/header.php');
?>
	<table cellpadding="0" cellspacing="0" width="100%" border="0">
		<?php
			if (isset($demo_login_txt) and !empty($demo_login_txt))
			{
		?>
			<tr>
				<td colspan="3">
					<table cellpadding="0" cellspacing="0" width="100%" border="0">
						<tr valign="top">
							<td width="48%" style="padding:5px;"><?php echo $demo_login_txt;?></td>
							<td width="4%">&nbsp;</td>
							<td width="48%" style="padding:5px;"><?php echo $demo_login_txt_en;?></td>
						</tr>
					</table>
					<br /><br />
				</td>
			</tr>
		<?php
			}
		?>
		<tr>
			<td width="33%">&nbsp;</td>
			<td width="33%">
				<table cellpadding="0" cellspacing="0" border="0" width="100%">
					<tr valign="middle">
						<td class="main_table_header" width="100%"><?php get_text('', 'echo', 'decode_on', 'login'); /*Login*/?></td>
					</tr>
					<tr><td><img src="<?php echo TOM_ABS_URL.'template/'.$setup_array['template'].'/image/_spacer.gif'; ?>" width="1" height="4" border="0" alt="" /></td></tr>
					<tr>
						<td class="main_table_content">
							<form action="index.php" method="post" name="login_form" accept-charset="UTF-8">
								<input type="hidden" name="action_login_string" value="j" />
								<table cellpadding="2" cellspacing="0" border="0" width="100%">
									<tr>
										<td width="50%"><?php get_text('', 'echo', 'decode_on', 'username'); /*Benutzername*/?>:</td>
										<td width="50%"><input type="text" name="username" class="ipt_100" tabindex="1" /></td>
									</tr>
									<tr>
										<td><?php get_text('', 'echo', 'decode_on', 'pw'); /*Passwort*/?>:</td>
										<td><input type="password" name="pw" class="ipt_100" tabindex="2" /></td>
									</tr>
									<tr>
										<td colspan="2" align="center">
											<br />
											<?php
												echo get_button(get_text('', 'return', 'decode_on', 'login') /*Login*/, 'tick.png', 'onclick="document.login_form.submit();"', 'submit', 3);

												if (isset($setup_array['maintenance_mode']) && $setup_array['maintenance_mode'] == 'j')
												{
													echo '<br />';
													get_text('', 'echo', 'decode_on', 'wartungsmodus_aktiv'); /*Das System befindet sich im Wartungsmodus.*/
													echo '<br />';
													get_text('', 'echo', 'decode_on', 'login_disabled'); /*Derzeit ist leider kein Login m&ouml;glich.*/
												}
											?>
										</td>
									</tr>
									<tr style="line-height:12px;"><td colspan="2">&nbsp;</td></tr>
									<tr>
										<td colspan="2" align="center">
											<?php
												//Bei aktivem LDAP Login Passwortvergessen deaktivieren
												if ($setup_array['ldap']['active'] == false)
												{
													echo '<a href="lost_pw.php" style="font-size:10px;">'.get_text(707, 'return').'</a>';//Passwort vergessen
												}
												else
												{
													echo '&nbsp;';
												}
											?>
										</td>
									</tr>
								</table>
							</form>
						</td>
					</tr>
				</table>
			</td>
			<td width="33%">&nbsp;</td>
		</tr>
		<tr>
			<td class="main_table_content">
				<table cellpadding="2" cellspacing="0" border="0" width="100%">
					<colgroup>
						<col width="50%" />
						<col width="50%" />
					</colgroup>
					<tr>
						<td colspan="2"><strong><?php get_text('684');//Kontaktdaten ?>:</strong></td>
					</tr>
					<?php
						if (!empty($setup_array['contact_name']))
						{
					?>
					<tr>
						<td><?php get_text('', 'echo', 'decode_on', 'ansprechpartner');//Ansprechpartner ?>:</td>
						<td><?php echo $setup_array['contact_name']; ?></td>
					</tr>
					<?php
						}
						if (!empty($setup_array['contact_tel']))
						{
					?>
					<tr>
						<td><?php get_text('', 'echo', 'decode_on', 'telefon');//Telefon ?>:</td>
						<td><?php echo $setup_array['contact_tel']; ?></td>
					</tr>
					<?php
						}
						if (!empty($setup_array['contact_fax']))
						{
					?>
					<tr>
						<td><?php get_text('', 'echo', 'decode_on', 'fax');//Fax ?>:</td>
						<td><?php echo $setup_array['contact_fax']; ?></td>
					</tr>
					<?php
						}
						if (!empty($setup_array['contact_mail']))
						{
					?>
					<tr>
						<td><?php get_text('', 'echo', 'decode_on', 'email');//E-Mail ?>:</td>
						<td><?php echo $setup_array['contact_mail']; ?></td>
					</tr>
					<?php
						}
					?>
				</table>
			</td>
			<td colspan="2">&nbsp;</td>
		</tr>
	</table>
	<script type="text/javascript">
		<!--
		document.login_form.username.focus();
		-->
	</script>
<?php
	//Footer
	require_once(TOM_ABS_PFAD.'template/'.$setup_array['template'].'/footer.php');
?>