<?php
	/**
	 * this file contains all actions for the message-folder
	 * @package time-o-meter
	 * @subpackage message
	 */

	// message hinzufuegen
	if ($_POST['job_string'] == 'add_message')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST daten pruefen
			if ($chk_var->error_count_int == 0 and isset($_POST['mitarbeiter_ids']) and count($_POST['mitarbeiter_ids']) > 0)
			{
				//Mailklasse
				$mail = new Mailer;

				$timestamp = time();
				$timestamp = date("YmdHis", $timestamp);

				// message in db speichern
				if ($cdb->insert("INSERT INTO hdb_mitteilungen (betreff, message, versandzeit) values('".$_POST['betreff']."', '".$_POST['mitteilung']."', '$timestamp')"))
				{
					$message_id = $cdb->get_last_insert_id();

					//Doppelte Werte entfernen
					$empfanger_array = array_unique($_POST['mitarbeiter_ids']);

					$error_count = 0;
					$user_mail_array = array();

					// alle empfaenger der message speichern
					foreach ($empfanger_array as $v)
					{
						//sollte eigendlich immer der fall sein
						if (is_numeric($v))
						{
							//emailadresse auslesen
							$sql = $cdb->select("SELECT email FROM hdb_user WHERE user_id=$v AND anzeigen='j' AND login_aktiv='j'");
							$result = $cdb->fetch_array($sql);

							if (!empty($result['email']))
							{
								if (!$cdb->insert("INSERT INTO hdb_mitteilungen_recipients (message_id, user_id) values($message_id, $v)"))
								{
									$error_count++;
								}
								else
								{
									//Usermailadressen fuer den Spaeteren Mailversand Speichern
									$user_mail_array[] = html_entity_decode($result['email'], ENT_QUOTES);
								}
							}
						}
					}

					//doppelte emailadressen entfernen
					$user_mail_array = array_unique($user_mail_array);

					//Betreff
					$subject = html_entity_decode($_POST['betreff'], ENT_QUOTES);

					//body
					$body = str_replace("\n", '<br />', $_POST['mitteilung']);

					foreach ($user_mail_array as $mail_adress)
					{
						//Mails Versenden
						if (!$mail->send_html_mail($subject, $body, $mail_adress))
						{
							$error_count++;
						}
					}

					if ($error_count == 0)
					{
						$meldung_array['ok'][] = get_text(750, 'return', 'decode_on'); //Die Mitteilung wurde gesendet.
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/.' '.get_text('766', 'return', 'decode_on') /*Es konnten nicht alle E-Mails gesendet werden!*/, WARNING, __LINE__);
					}

				}
				else
				{
					$meldung_array['error'][] = setError(get_text('144', 'return', 'decode_on'), WARNING, __LINE__); //Die Mitteilung konnte leider nicht versendet werden.
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}

		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}

		$GLOBALS['TOM_VAR']['fileinc'] = 'main';
	}
	//Mitteilungen ausblenden
	elseif ($_POST['job_string'] == 'del_message')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST daten pruefen
			if ($chk_var->error_count_int == 0 and isset($_POST['messageid_int']) and is_numeric($_POST['messageid_int']))
			{
				$error_count = 0;
				// ist der betreffende user admin oder hat message-schreibrechte?
				if ($access->check_group(USER_GROUP_ID, 'admin_message_write'))
				{
					// dann message im adminbereich ausblenden
					if (!$cdb->update("UPDATE hdb_mitteilungen SET anzeigen_admin='n' WHERE message_id='".$_POST['messageid_int']."' LIMIT 1"))
					{
						$error_count++;
					}
				}

				// auoeerdem immer fuer den betreffenden user persoenlich ausblenden
				if (!$cdb->update("UPDATE hdb_mitteilungen_recipients SET anzeigen_user='n' WHERE message_id=".$_POST['messageid_int']." and user_id=".USER_ID))
				{
					$error_count++;
				}

				if ($error_count == 0)
				{
					$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'del_ok'); /*Der Datensatz wurde geloescht.*/
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'main';
	}
	//Loescht alle selektierten Mitteilungen (bzw. blendet sie aus)
	elseif ($_POST['job_string'] == 'del_all_messages')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST daten pruefen
			if ($chk_var->error_count_int == 0 && is_array($_POST['message_array']))
			{
				//Administrative Rechte
				$access_rights_del = $access->check_group(USER_GROUP_ID, 'admin_message_write');

				$error_count = 0;

				foreach ($_POST['message_array'] as $m_id)
				{
					if (is_numeric($m_id))
					{
						// ist der betreffende user admin oder hat message-schreibrechte?
						if ($access_rights_del)
						{
							// dann message im adminbereich ausblenden
							if (!$cdb->update("UPDATE hdb_mitteilungen SET anzeigen_admin='n' WHERE message_id=$m_id LIMIT 1"))
							{
								$error_count++;
							}
						}

						// ausserdem immer fuer den betreffenden user persoenlich ausblenden
						if (!$cdb->update("UPDATE hdb_mitteilungen_recipients SET anzeigen_user='n' WHERE message_id=$m_id and user_id=".USER_ID))
						{
							$error_count++;
						}
					}
				}

				if ($error_count == 0)
				{
					$meldung_array['ok'][] = get_text('757', 'return', 'decode_on'); /*Die Datensaetze wurden geloescht.*/
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'message_del_all';
	}
?>