<?php
	/**
	 * PDF output of a holiday request form
	 * @package time-o-meter
	 * @subpackage report
	 */

	/**
	 * include-sammlung einbinden
	 */
	require_once('../inc/include.php');

	//Variablenpruefung
	if ($chk_sum->Chk($_GET['VCS']) === true)
	{
		$sql = $cdb->select('SELECT t1.date_from, t1.date_to, t1.day_count, t1.request_timestamp, t1.status, t1.comment, t2.vorname, t2.nachname, t3.absence_name FROM hdb_absence_list t1
							LEFT JOIN hdb_user t2 ON t1.user_id=t2.user_id
							LEFT JOIN hdb_absence_type t3 ON t1.absence_type_id=t3.absence_type_id
							WHERE t1.as_id='.$_GET['as_id_int']);
		$result = $cdb->fetch_array($sql);

		$pdf_setup_array = array();

		$pdf_setup_array['header']['type'] = 1;
		$pdf_setup_array['header']['logo_type'] = $setup_array['pdf_logo_template'];
		$pdf_setup_array['header']['txt'][] = get_text(1029, 'return', 'decode_pdf')/*Abwesenheitsantrag*/. mb_convert_encoding(' ('.$result['absence_name'].')', 'UTF-8');
		$pdf_setup_array['header']['txt'][] = mb_convert_encoding(html_entity_decode($result['vorname'].' '.$result['nachname'], ENT_QUOTES), 'UTF-8');
		$pdf_setup_array['header']['txt'][] = get_text(179, 'return', 'decode_pdf');//Mitarbeiter
		$pdf_setup_array['header']['txt'][] = mb_convert_encoding($kal->win_to_time($result['request_timestamp'], 'date'), 'UTF-8');
		$pdf_setup_array['header']['txt'][] = get_text(618, 'return', 'decode_pdf');//Beantragt am
		$pdf_setup_array['header']['margin'] = 5;

		$pdf_setup_array['footer']['type'] = 1;
		$pdf_setup_array['footer']['logo_count'] = 1;
		$pdf_setup_array['footer']['txt'][] = mb_convert_encoding($result['absence_name'], 'UTF-8');
		$pdf_setup_array['footer']['txt'][] = get_text(354, 'return', 'decode_pdf');//Dokument
		$pdf_setup_array['footer']['txt'][] = mb_convert_encoding($kal->iso_to_free(date('Y-m-d')), 'UTF-8');
		$pdf_setup_array['footer']['txt'][] = get_text(261, 'return', 'decode_pdf');//Datum
		$pdf_setup_array['footer']['txt'][] = get_text(67, 'return', 'decode_pdf');//von
		$pdf_setup_array['footer']['txt'][] = get_text(66, 'return', 'decode_pdf');//Seite
		$pdf_setup_array['footer']['margin'] = 10;

		$pdf_setup_array['page']['margin'] = array(	'left'	=> 10,
													'right'	=> 10,
													'bottom'=> 25);

		// create new PDF document
		$pdf = new Pdf($pdf_setup_array, 'P');

		// add a page
		$pdf->AddPage();

		$pdf->Ln(25);
		//Tabellenkopf
		$tbl = '<table border="0" cellpadding="2" cellspacing="0">
					<tr style="background-color:#FFFFFF;color:#000000;">
						<td width="'.$pdf->get_mm_for_pdf(60).'" colspan="2">'.get_text(1065, 'return', 'decode_pdf')/*Abwesenheitstyp*/.'</td>
						<td width="'.$pdf->get_mm_for_pdf(100).'">'.mb_convert_encoding($result['absence_name'], 'UTF-8').'</td>
					</tr>';

		if ($result['date_from'] != $result['date_to'])
		{
			$tbl .= '	<tr style="background-color:#FFFFFF;color:#000000;">
							<td width="'.$pdf->get_mm_for_pdf(50).'" rowspan="2">'.get_text(602, 'return', 'decode_pdf')/*Abwesenheit*/.'</td>
							<td width="'.$pdf->get_mm_for_pdf(10).'">'.get_text(181, 'return', 'decode_pdf')/*von*/.'</td>
							<td width="'.$pdf->get_mm_for_pdf(100).'">'.mb_convert_encoding($kal->iso_to_free($result['date_from']), 'UTF-8').'</td>
						</tr>
						<tr style="background-color:#FFFFFF;color:#000000;">
							<td width="'.$pdf->get_mm_for_pdf(10).'">'.get_text(182, 'return', 'decode_pdf')/*bis*/.'</td>
							<td width="'.$pdf->get_mm_for_pdf(100).'">'.mb_convert_encoding($kal->iso_to_free($result['date_to']), 'UTF-8').'</td>
						</tr>';
		}
		else
		{
			$tbl .= '	<tr style="background-color:#FFFFFF;color:#000000;">
							<td width="'.$pdf->get_mm_for_pdf(50).'">'.get_text(602, 'return', 'decode_pdf')/*Abwesenheit*/.'</td>
							<td width="'.$pdf->get_mm_for_pdf(10).'">'.get_text(180, 'return', 'decode_pdf')/*am*/.'</td>
							<td width="'.$pdf->get_mm_for_pdf(100).'">'.mb_convert_encoding($kal->iso_to_free($result['date_from']), 'UTF-8').'</td>
						</tr>';
		}

		$tbl .= '	<tr style="background-color:#FFFFFF;color:#000000;">
						<td width="'.$pdf->get_mm_for_pdf(60).'" colspan="2">'.get_text(185, 'return', 'decode_pdf')/*Anzahl Arbeitstage*/.'</td>
						<td width="'.$pdf->get_mm_for_pdf(100).'">'.mb_convert_encoding($result['day_count'], 'UTF-8').'</td>
					</tr>
					<tr style="background-color:#FFFFFF;color:#000000;">
						<td width="'.$pdf->get_mm_for_pdf(60).'" colspan="2">'.get_text(603, 'return', 'decode_pdf')/*Kommentar*/.'</td>
						<td width="'.$pdf->get_mm_for_pdf(100).'">'.mb_convert_encoding($result['comment'], 'UTF-8').'</td>
					</tr>
				</table>';
		$pdf->writeHTML($tbl, true, false, false, false, '');

		//Seitenbreite
		$page_width = $pdf->get_page_size();

		$box_width = ($page_width - 20) / 3;

		$pdf->Ln(20);
		//Unterschriftslinien
		$pdf->Line($pdf->GetX(), $pdf->GetY(), $pdf->GetX() + $box_width, $pdf->GetY());
		$pdf->Line($pdf->GetX() + $box_width + 10, $pdf->GetY(), $pdf->GetX() + $box_width  + $box_width + 10, $pdf->GetY());
		$pdf->Line($pdf->GetX() + $box_width + $box_width + 20, $pdf->GetY(), $pdf->GetX() + $box_width  + $box_width  + $box_width + 20, $pdf->GetY());

		//Unterschriftsbezeichnungen
		$pdf->Cell($box_width, 4, mb_convert_encoding(get_text(620, 'return', 'decode_pdf').'/'.get_text(261, 'return', 'decode_pdf'), 'UTF-8'), 0, 0, 'C');//Ort / Dateum
		$pdf->SetX($pdf->GetX() + 10);
		$pdf->Cell($box_width, 4, mb_convert_encoding(get_text(621, 'return', 'decode_pdf'), 'UTF-8'), 0, 0, 'C');//Unterschrift (Mitarbeiter)
		$pdf->SetX($pdf->GetX() + 10);
		$pdf->Cell($box_width, 4, mb_convert_encoding(get_text(622, 'return', 'decode_pdf'), 'UTF-8'), 0, 0, 'C');//Unterschrift (Projektleiter)

		$pdf->Output('holiday.pdf', 'I');
	}
	else
	{
		//FIXME das sollte vielleicht als PDF ausgegeben werden
		echo setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
	}
?>