<?php
	/**
	 * PDF output of a font demo
	 * @package time-o-meter
	 * @subpackage report
	 */

	/**
	 * include-sammlung einbinden
	 */
	require_once('../inc/include.php');

	$pdf_setup_array = array();

	$pdf_setup_array['header']['type'] = 2;
	$pdf_setup_array['header']['logo_type'] = $setup_array['pdf_logo_template'];
	if (isset($_GET['font']) and !empty($_GET['font']))
	{
		$pdf_setup_array['header']['txt'][] = 'Font-Demo - '.$_GET['font'];
	}
	else
	{
		$pdf_setup_array['header']['txt'][] = 'Font-Demo';
	}
	$pdf_setup_array['header']['margin'] = 5;

	$pdf_setup_array['footer']['type'] = 1;
	$pdf_setup_array['footer']['logo_count'] = 1;
	$pdf_setup_array['footer']['txt'][] = 'Font-Demo';
	$pdf_setup_array['footer']['txt'][] = get_text(354, 'return', 'decode_pdf');//Dokument
	$pdf_setup_array['footer']['txt'][] = mb_convert_encoding($kal->iso_to_free(date('Y-m-d')), 'UTF-8');
	$pdf_setup_array['footer']['txt'][] = get_text(261, 'return', 'decode_pdf');//Datum
	$pdf_setup_array['footer']['txt'][] = get_text(67, 'return', 'decode_pdf');//von
	$pdf_setup_array['footer']['txt'][] = get_text(66, 'return', 'decode_pdf');//Seite
	$pdf_setup_array['footer']['margin'] = 10;

	$pdf_setup_array['page']['margin'] = array(	'left'	=> 10,
												'right'	=> 10,
												'bottom'=> 25);

	// create new PDF document
	$pdf = new Pdf($pdf_setup_array, 'P');

	if (isset($_GET['font']) and !empty($_GET['font']))
	{
		$pdf->SetFont($_GET['font'], '', 7);
	}
	else
	{
		$pdf->SetFont('helvetica', '', 7);
	}

	// add a page
	$pdf->AddPage();
	$tbl = '<table border="1" cellpadding="2" cellspacing="0">
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Arabisches Alphabet / Arabic alphabet</strong></td>
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Bulgarisch / Bulgaria</strong></td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'">ا , ب , ت , ث , ج , ح , خ , د , ذ , ر , ز , س , ش , ص , ض , ط , ظ , ع , غ , ف , ق , ك , ل , م , ن , ه , و</td>
					<td width="'.$pdf->get_mm_for_pdf(95).'">А, Б, В, Г, Д, Е, Ж, З, И, Й, К, Л, М, Н, О, П, Р, С, Т, У, Ф, Х, Ц, Ч, Ш, Щ, Ъ, Ь, Ю, Я, а, б, в, г, g, е, ж, з, и, й, к, л, м, н, о, n, р, с, m, у, ф, х, ц, ч, ш, щ, ъ, ь, ю, я</td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Dänisch / Danish</strong></td>
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Deutsch / German</strong></td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'">Æ, æ, Ø, ø, Å, å</td>
					<td width="'.$pdf->get_mm_for_pdf(95).'">Ä, ä, Ö, ö, Ü, ü, ß</td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Griechisch / Greek</strong></td>
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Lettisch / Latvian</strong></td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'">Α, α, Β, β, Γ, γ, Δ, δ, Ε, ε, Ζ, ζ, Η, η, Θ, θ, Ι, ι, Κ, κ, Λ, λ, Μ, μ, Ν, ν, Ξ, ξ, Ο, ο, Π, π, Ρ, ρ, Σ, σ, Τ, τ, Υ, υ, Φ, φ, Χ, χ, Ψ, ψ, Ω, ω, Ϝ, ϝ, Ϛ, ϛ, Ϟ, ϟ</td>
					<td width="'.$pdf->get_mm_for_pdf(95).'">a, ā, b, c, č, d, e, ē, f, g, ģ, h, i, ī, j, k, ķ, l, ļ, m, n, ņ, o, p, r, s, š, t, u, ū, v, z, ž</td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Polnisch / Polish</strong></td>
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Portugiesisch / Portuguese</strong></td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'">A, Ą, B, C, Ć, D, E, Ę, F, G, H, I, J, K, L, Ł, M, N, Ń, O, Ó, P, R, S, Ś, T, U, W, Y, Z, Ź, Ż</td>
					<td width="'.$pdf->get_mm_for_pdf(95).'">Á, Â, Ã, À, Ç, É, Ê, Í, Ó, Ô, Õ, Ú, Ü</td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Rumänisch / Romanian</strong></td>
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Russisch / Russian</strong></td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'">a, ă, â, b, c, d, e, f, g, h, i, î, j, k, l, m, n, o, p, q, r, s, ș, t, ț, u, v, w, x, y, z</td>
					<td width="'.$pdf->get_mm_for_pdf(95).'">А, а, Б, б, В, в, Г, г, Д, д, Е, е, Ё, ё, Ж, ж, З, з, И, и, Й, й, К, к, Л, л, М, м, Н, н, О, о, П, п, Р, р, С, с, Т, т, У, у, Ф, ф, Х, х, Ц, ц, Ч, ч, Ш, ш, Щ, щ, Ъ, ъ, Ы, ы, Ь, ь, Э, э, Ю, ю, Я, я</td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Schwedisch / Swedish</strong></td>
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Slowakisch / Slovak</strong></td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'">Å, Ä, Ö, å, ä, ö</td>
					<td width="'.$pdf->get_mm_for_pdf(95).'">Á, á, Ä, ä, Č, č, Ď, ď, É, é, Í, í, Ľ, ľ, Ĺ, ĺ, Ň, ň, Ó, ó, Ô, ô, Ŕ, ŕ, Š, š, Ť, ť, Ú, ú, Ý, ý, Ž, ž</td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Tschechisch / Czech</strong></td>
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Türkisch / Turkish</strong></td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'">A, Á, B, C, Č, D, Ď, E, É, Ě, F, G, H, Ch, I, Í, J, K, L, M, N, Ň, O, Ó, P, Q, R, Ř, S, Š, T, Ť, U, Ú, Ů, V, W, X, Y, Ý, Z, Ž</td>
					<td width="'.$pdf->get_mm_for_pdf(95).'">a, b, c, ç, d, e, f, g, ğ, h, ı, i, j, k, l, m, n, o, ö, p, r, s, ş, t, u, ü, v, y, z</td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Ungarisch / Hungarian</strong></td>
					<td width="'.$pdf->get_mm_for_pdf(95).'"><strong>Sonstiges / other</strong></td>
				</tr>
				<tr style="background-color:#FFFFFF;color:#000000;">
					<td width="'.$pdf->get_mm_for_pdf(95).'">A, Á, B, C, Cs, D, Dz, Dzs, E, É, F, G, Gy, H, I, Í, J, K, L, Ly, M, N, Ny, O, Ó, Ö, Ő, P, Q, R, S, Sz, T, Ty, U, Ú, Ü, Ű, V, W, X, Y, Z, Zs</td>
					<td width="'.$pdf->get_mm_for_pdf(95).'">°, ^,!, ", §, $, %, &, /, {, (, [, ), ], =, }, ?, \, `,´, *, +, ~, \', #, -, _, :, ., ;, <, >, |, €, @</td>
				</tr>
			</table>';
	$pdf->writeHTML($tbl, true, false, false, false, '');

	$pdf->Output('font_demo.pdf', 'I');
?>