<?php
	/**
	 * PDF output (annual holiday overview)
	 * @package time-o-meter
	 * @subpackage report
	 */

	/**
	 * include-sammlung einbinden
	 */
	require_once('../inc/include.php');

	//Urlaubs- Gleitzeitklasse
	$hd = new Holiday;
	$kal = new Kalender();

	if (isset($_POST['year_int']) and !empty($_POST['year_int']))
	{
		$year = $_POST['year_int'];
	}
	else
	{
		$year = date('Y');
	}

	//Tabelleninhalt
	if (isset($_POST['month_int']) and !empty($_POST['month_int']))
	{
		$for_month_start = $_POST['month_int'];
		$for_month_end = $_POST['month_int'];
	}
	else
	{
		$for_month_start = 1;
		$for_month_end = 12;
	}

	$pdf_setup_array = array();

	$pdf_setup_array['header']['type'] = 2;
	$pdf_setup_array['header']['logo_type'] = $setup_array['pdf_logo_template'];
	$pdf_setup_array['header']['txt'][] = get_text(119, 'return', 'decode_pdf').' '.$year;//Jahresurlaubsplan
	$pdf_setup_array['header']['margin'] = 5;

	$pdf_setup_array['footer']['type'] = 1;
	$pdf_setup_array['footer']['logo_count'] = 1;
	$pdf_setup_array['footer']['txt'][] = get_text(119, 'return', 'decode_pdf');//Jahresurlaubsplan
	$pdf_setup_array['footer']['txt'][] = get_text(354, 'return', 'decode_pdf');//Dokument
	$pdf_setup_array['footer']['txt'][] = mb_convert_encoding($kal->iso_to_free(date('Y-m-d')), 'UTF-8');
	$pdf_setup_array['footer']['txt'][] = get_text(261, 'return', 'decode_pdf');//Datum
	$pdf_setup_array['footer']['txt'][] = get_text(67, 'return', 'decode_pdf');//von
	$pdf_setup_array['footer']['txt'][] = get_text(66, 'return', 'decode_pdf');//Seite
	$pdf_setup_array['footer']['margin'] = 10;

	$pdf_setup_array['page']['margin'] = array(	'left'	=> 10,
												'right'	=> 10,
												'bottom'=> 25);

	$bg_color_array = array();

	// create new PDF document
	$pdf = new Pdf($pdf_setup_array, 'L');

	// add a page
	$pdf->AddPage();

	$tbl = '';
	for ($i = $for_month_start; $i <= $for_month_end; $i++)
	{
		//Monat
		if ($i < 10)
		{
			$month = "0$i";
		}
		else
		{
			$month = $i;
		}

		//Timestamp fuer monatsersten
		$time_stamp = mktime(0, 0, 0, $month, 1, $year);
		//Anzahl der Tage im monat
		$days = date('t', $time_stamp);

		//Userdaten fuer den Aktuellen monat
		$user_data = array();
		$user_data = $hd->get_pdf_data($year, $i, $_POST['filter_user_int']);

		//User fuer den Monat vorhanden
		if (count($user_data) > 0)
		{

			//Erste Zeile eines Monats "Mitarbeiter	Jahr / Monat"
			$tbl .= '<tr>
						<td width="'.$pdf->get_mm_for_pdf(60).'"><b>'.get_text(179, 'return', 'decode_pdf')/* Mitarbeiter */.'</b></td>
						<td width="'.$pdf->get_mm_for_pdf(217).'" align="center"><b>'.$year.'/'.$month.'</b></td>
					</tr>';


			//Zweite Zeile mit der Anzahl der Tage
			$tbl .= '<tr>
						<td width="'.$pdf->get_mm_for_pdf(60).'"></td>';

			for ($day_int = 1; $day_int <= 31; $day_int++)
			{
				if ($day_int <= $days)
				{
					if($day_int < 10)
					{
						$day_string = '0'.$day_int;
					}
					else
					{
						$day_string = $day_int;
					}

					if ($kal->is_weekend($year.'-'.$month.'-'.$day_string))
					{
						$tbl .= '<td width="'.$pdf->get_mm_for_pdf(7).'" style="background-color:#7994C3;" align="center">'.$day_int.'</td>';
					}
					else
					{
						$tbl .= '<td width="'.$pdf->get_mm_for_pdf(7).'" align="center">'.$day_int.'</td>';
					}
				}
			}

			if ($days < 31)
			{
				if ($days == 28)
				{
					$tbl .= '<td width="'.$pdf->get_mm_for_pdf(21).'" colspan="3"></td>';
				}
				else
				{
					$tbl .= '<td width="'.$pdf->get_mm_for_pdf(7).'"></td>';
				}
			}

			$tbl .= '</tr>';

			//Userzeilen
			foreach ($user_data as $user_index => $user_d)
			{
				$tbl .= '<tr>
							<td width="'.$pdf->get_mm_for_pdf(60).'"><b>'.mb_convert_encoding(html_entity_decode($user_d['vorname'].' '.$user_d['nachname'], ENT_QUOTES), 'UTF-8').'</b></td>';
				for ($day_int = 1; $day_int <= 31; $day_int++)
				{
					if ($day_int <= $days)
					{
						if ($day_int < 10)
						{
							$day = "0$day_int";
						}
						else
						{
							$day = $day_int;
						}

						//Abwesenheitsgrund vorhanden
						if (isset($user_d['holiday']["$year-$month-$day"]) and !empty($user_d['holiday']["$year-$month-$day"]))
						{
							$bg_color = $hd->get_absence_color($user_d['holiday']["$year-$month-$day"]);
							if (!empty($bg_color))
							{
								if (!isset($bg_color_array[$user_d['holiday']["$year-$month-$day"]]))
								{
									$bg_color_array[$user_d['holiday']["$year-$month-$day"]] = $bg_color;
								}
								$tbl .= '<td width="'.$pdf->get_mm_for_pdf(7).'" style="background-color:#'.$bg_color.';"></td>';
							}
							else
							{
								$tbl .= '<td width="'.$pdf->get_mm_for_pdf(7).'"></td>';
							}
						}
						//kein Freier Tag
						else
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf(7).'"></td>';
						}
					}
				}

				if ($days < 31)
				{
					if ($days == 28)
					{
						$tbl .= '<td width="'.$pdf->get_mm_for_pdf(21).'" colspan="3"></td>';
					}
					else
					{
						$tbl .= '<td width="'.$pdf->get_mm_for_pdf(7).'"></td>';
					}
				}
				$tbl .= '</tr>';
			}

			//Lerrzeile nach jedem Monat
			$tbl .= '<tr>
						<td width="'.$pdf->get_mm_for_pdf(277).'" colspan="32"></td>
					</tr>';
		}
	}

	if (!empty($tbl))
	{
		$pdf->writeHTML('<table border="1" cellpadding="2" cellspacing="0">'.$tbl.'</table>', true, false, false, false, '');

		if (!empty($bg_color_array))
		{
			//Legende
			$pdf->Ln(5);
			$tbl = '<table border="0" cellpadding="2" cellspacing="0">';
			foreach ($bg_color_array as $absence_id => $bg_color)
			{
				$sql = $cdb->select('SELECT absence_name FROM hdb_absence_type WHERE absence_type_id='.$absence_id);
				$result = $cdb->fetch_array($sql);

				$tbl .= '<tr>';
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(7).'" style="background-color:#'.$bg_color.';"></td>';
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(25).'">'.$result['absence_name'].'</td>';
				$tbl .= '</tr>';
			}
			$tbl .= '</table>';
			$pdf->writeHTML($tbl, true, false, false, false, '');
		}
	}

	$pdf->Output('holiday_year.pdf', 'I');
?>