<?php
	/**
	 * PDF output of a holiday request form
	 * @package time-o-meter
	 * @subpackage report
	 */

	/**
	 * include-sammlung einbinden
	 */
	require_once('../inc/include.php');

	//Zugriffsrechte
	if ($access->check_group(USER_GROUP_ID, 'admin_project_read') and $access->check_group(USER_GROUP_ID, 'admin_reports_read'))
	{
		$tsr = new TimeSheetReport;

		if (isset($_POST['filter_project_int']) and isset($_POST['filter_date_string']))
		{
			$report_type = '';
			//NZS stunden fuer ein Jahr ausgeben
			if ($_POST['filter_project_int'] < 0 and strlen($_POST['filter_date_string']) == 4)
			{
				$report_type = 'year_nzs';
			}
			//NZS fuer einen Monat
			elseif ($_POST['filter_project_int'] < 0 and strlen($_POST['filter_date_string']) == 7)
			{
				$report_type = 'month_nzs';
			}
			//Projektstunden fuer ein Jahr
			elseif ($_POST['filter_project_int'] > 0 and strlen($_POST['filter_date_string']) == 4)
			{
				$report_type = 'year_project';
			}
			//Projektstunden fuer einen Monat
			elseif ($_POST['filter_project_int'] > 0 and strlen($_POST['filter_date_string']) == 7)
			{
				$report_type = 'month_project';
			}
			//Mobatsdarstellung alle Projekte
			elseif ($_POST['filter_project_int'] == 0 and strlen($_POST['filter_date_string']) == 7)
			{
				$report_type = 'month_all';
			}

			if (!empty($report_type))
			{
				if ($report_type == 'year_nzs' or $report_type == 'month_nzs')
				{
					require_once ('pdf_project_hours_nzs.php');
				}
				elseif ($report_type == 'year_project' or $report_type == 'month_project' or $report_type == 'month_all')
				{
					if ($report_type == 'year_project' and isset($_POST['pdf_project_hours_table']) and $_POST['pdf_project_hours_table'] == 1)
					{
						require_once ('pdf_project_hours_table.php');
					}
					else
					{
						require_once ('pdf_project_hours_all.php');
					}
				}
			}
		}
	}
?>