<?php
	/**
	 * PDF output of project hours
	 * @package time-o-meter
	 * @subpackage report
	 */
	//Zugriffsrechte
	if ($access->check_group(USER_GROUP_ID, 'admin_project_read') and $access->check_group(USER_GROUP_ID, 'admin_reports_read'))
	{
		$result = $tsr->report_project_hours($_POST['filter_date_string'], $_POST['filter_project_int'], 'array');

		$data = $tsr->get_pdf_pie_chart_data($result, $report_type);
		/*
		 * PDF Erstellung Start
		 */
		$pdf_setup_array = array();

		$pdf_setup_array['header']['type'] = 2;
		$pdf_setup_array['header']['logo_type'] = $setup_array['pdf_logo_template'];
		$pdf_setup_array['header']['txt'][] = get_text(868, 'return', 'decode_pdf').' '.get_text(606, 'return', 'decode_pdf').' '.mb_convert_encoding(str_replace('-', '/', $_POST['filter_date_string']), 'UTF-8');//Projektzeiten NZS

		$pdf_setup_array['header']['margin'] = 5;

		$pdf_setup_array['footer']['type'] = 1;
		$pdf_setup_array['footer']['logo_count'] = 1;
		$pdf_setup_array['footer']['txt'][] = get_text(868, 'return', 'decode_pdf').' '.get_text(606, 'return', 'decode_pdf').' '.mb_convert_encoding(str_replace('-', '/', $_POST['filter_date_string']), 'UTF-8');//Projektzeiten
		$pdf_setup_array['footer']['txt'][] = get_text(354, 'return', 'decode_pdf');//Dokument
		$pdf_setup_array['footer']['txt'][] = mb_convert_encoding($kal->iso_to_free(date('Y-m-d')), 'UTF-8');
		$pdf_setup_array['footer']['txt'][] = get_text(261, 'return', 'decode_pdf');//Datum
		$pdf_setup_array['footer']['txt'][] = get_text(67, 'return', 'decode_pdf');//von
		$pdf_setup_array['footer']['txt'][] = get_text(66, 'return', 'decode_pdf');//Seite
		$pdf_setup_array['footer']['margin'] = 10;

		$pdf_setup_array['page']['margin'] = array(	'left'	=> 10,
													'right'	=> 10,
													'bottom'=> 25);

		// create new PDF document
		$pdf = new Pdf($pdf_setup_array, 'P');

		// add a page
		$pdf->AddPage();

		if (count($data) > 0)
		{
			$page_with = $pdf->get_page_size();

			//Diagramm mittig plazieren
			$xc = $pdf->GetX() + $page_with / 2;
			$yc = $pdf->GetY() + 50;
			$r = 40;

			$grad = 0;
			$bg_color_array = array();
			$for_count = count($data) - 1;
			for ($i = 0; $i <= $for_count; $i++)
			{
				if ($data[$i]['degree'] > 0)
				{
					$bg_color = $tsr->get_pdf_pie_bg_color();
					$bg_color_array[] = $bg_color;
					$pdf->SetFillColor($bg_color[0], $bg_color[1], $bg_color[2]);

					//FIXME Alles was kleiner 1 ist fuehrt zu einem Fehler in der Darstellung
					if ($data[$i]['degree'] >= 1)
					{
						//letztes Teilstück auf 360 grad ausrunden
						//sieht sonst bei einigen darstellungen etwas komisch aus
						if ($i == $for_count)
						{
							$pdf->PieSector($xc, $yc, $r, $grad, 360);
						}
						else
						{
							$pdf->PieSector($xc, $yc, $r, $grad, $grad + $data[$i]['degree']);
						}

						$grad += $data[$i]['degree'];
					}
				}
				else
				{
					$bg_color_array[] = '';
				}
			}

			$tbl = '<table border="1" cellpadding="2" cellspacing="0">
					<thead>
						<tr>';
			if ($report_type == 'year_nzs')
			{
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(60).'" colspan="2"><b>'.get_text(266, 'return', 'decode_pdf').'</b></td>';//Monat
			}
			else
			{
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(60).'" colspan="2"><b>'.get_text(179, 'return', 'decode_pdf').'</b></td>';//Mitarbeiter
			}

			$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf(15).'"><b>'.get_text(414, 'return', 'decode_pdf')/*Stunden*/.'</b></td>
							<td width="'.$pdf->get_mm_for_pdf(15).'"><b>'.get_text(952, 'return', 'decode_pdf')/*Prozent*/.'</b></td>
							<td width="'.$pdf->get_mm_for_pdf(10).'"></td>
							<td width="'.$pdf->get_mm_for_pdf(60).'" colspan="2"><b>'.get_text(179, 'return', 'decode_pdf')/*Mitarbeiter*/.'</b></td>
							<td width="'.$pdf->get_mm_for_pdf(15).'"><b>'.get_text(414, 'return', 'decode_pdf')/*Stunden*/.'</b></td>
							<td width="'.$pdf->get_mm_for_pdf(15).'"><b>'.get_text(952, 'return', 'decode_pdf')/*Prozent*/.'</b></td>
						</tr>
					</thead>';

			$while = true;

			$array_count = 0;
			while ($while === true)
			{
				$tbl .= '<tr>';

				if (isset($data[$array_count]))
				{
					if (isset($bg_color_array[$array_count]) and is_array($bg_color_array[$array_count]))
					{
						$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf(5).'" style="background-color:#'.dechex($bg_color_array[$array_count][0]).dechex($bg_color_array[$array_count][1]).dechex($bg_color_array[$array_count][2]).';"></td>';
					}
					else
					{
						$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf(5).'"></td>';
					}

					$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf(55).'">'.$data[$array_count]['name'].'</td>
								<td width="'.$pdf->get_mm_for_pdf(15).'">'.$data[$array_count]['hour'].' h</td>
								<td width="'.$pdf->get_mm_for_pdf(15).'">'.$data[$array_count]['percent'].' %</td>';
				}
				else
				{
					$while = false;
					$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf(90).'"></td>';
				}
				$array_count++;

				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(10).'"></td>';

				if (isset($data[$array_count]))
				{
					if (isset($bg_color_array[$array_count]) and is_array($bg_color_array[$array_count]))
					{
						$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf(5).'" style="background-color:#'.dechex($bg_color_array[$array_count][0]).dechex($bg_color_array[$array_count][1]).dechex($bg_color_array[$array_count][2]).';"></td>';
					}
					else
					{
						$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf(5).'"></td>';
					}

					$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf(55).'">'.$data[$array_count]['name'].'</td>
								<td width="'.$pdf->get_mm_for_pdf(15).'">'.$data[$array_count]['hour'].' h</td>
								<td width="'.$pdf->get_mm_for_pdf(15).'">'.$data[$array_count]['percent'].' %</td>';
				}
				else
				{
					$while = false;
					$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf(90).'"></td>';
				}
				$array_count++;
				$tbl .= '</tr>';

				if (!isset($data[$array_count]))
				{
					$while = false;
				}
			}

			$tbl .= '</table>';

			$pdf->SetY($pdf->GetY() + $yc + 10);
			$pdf->writeHTML($tbl, true, false, false, false, '');
		}
		$pdf->Output('project_hour_nzs.pdf', 'I');
	}
?>