<?php
	/**
	 * PDF output of project hours
	 * @package time-o-meter
	 * @subpackage report
	 */
	//Zugriffsrechte
	if ($access->check_group(USER_GROUP_ID, 'admin_project_read') and $access->check_group(USER_GROUP_ID, 'admin_reports_read'))
	{
		$result = array();
		if (!isset($_POST['pdf_project_hours_table_last_twelve']) or empty($_POST['pdf_project_hours_table_last_twelve']))
		{
			$result = $tsr->report_project_hours($_POST['filter_date_string'], $_POST['filter_project_int'], 'array');
		}
		//letzten zwoelf monate
		else
		{
			$kal = new Kalender();
			$sql = $cdb->select('SELECT start_datum, end_datum FROM hdb_projekte WHERE projekt_id='.$_POST['filter_project_int']);
			$result_date = $cdb->fetch_array($sql);

			$pro_start_int = str_replace('-', '', substr($result_date['start_datum'], 0, 7));

			$report_start_array = $kal->date_calculator(date('Y-m-d'), '', -12, '');
			$report_start_int = str_replace('-', '', $report_start_array[0]);

			if ($report_start_int < $pro_start_int)
			{
				$report_start_date = substr($result_date['start_datum'], 0, 7).'-01';
			}
			else
			{
				$report_start_date = substr($report_start_array[0], 0, 7).'-01';
			}

			$report_month_array = array();
			for ($i = 1; $i <= 12; $i++)
			{
				$tmp_date_array = $kal->date_calculator($report_start_date, '', $i, '');

				$result += $tsr->report_project_hours(substr($tmp_date_array[0], 0, 7), $_POST['filter_project_int'], 'array');
			}
		}

		$data = $tsr->get_pdf_table_data($result);

		if (is_array($data) and count($data) > 0)
		{
			$pdf_setup_array = array();

			$pdf_setup_array['header']['type'] = 2;
			$pdf_setup_array['header']['logo_type'] = $setup_array['pdf_logo_template'];
			$pdf_setup_array['header']['txt'][] = get_text(868, 'return', 'decode_pdf').' '.mb_convert_encoding($data['general']['projectname'], 'UTF-8');//Projektzeiten
			$pdf_setup_array['header']['margin'] = 5;
			$pdf_setup_array['footer']['type'] = 1;
			$pdf_setup_array['footer']['logo_count'] = 1;
			$pdf_setup_array['footer']['txt'][] = get_text(868, 'return', 'decode_pdf');//Projektzeiten
			$pdf_setup_array['footer']['txt'][] = get_text(354, 'return', 'decode_pdf');//Dokument
			$pdf_setup_array['footer']['txt'][] = mb_convert_encoding($kal->iso_to_free(date('Y-m-d')), 'UTF-8');
			$pdf_setup_array['footer']['txt'][] = get_text(261, 'return', 'decode_pdf');//Datum
			$pdf_setup_array['footer']['txt'][] = get_text(67, 'return', 'decode_pdf');//von
			$pdf_setup_array['footer']['txt'][] = get_text(66, 'return', 'decode_pdf');//Seite
			$pdf_setup_array['footer']['margin'] = 10;

			$pdf_setup_array['page']['margin'] = array(	'left'	=> 10,
														'right'	=> 10,
														'bottom'=> 25);

			// create new PDF document
			$pdf = new Pdf($pdf_setup_array, 'L');

			// add a page
			$pdf->AddPage();

			$page_width = $pdf->get_page_size();
			$colum_width = round($page_width / 14, 2);

			$tbl = '<table border="1" cellpadding="2" cellspacing="0">
						<tr>';
			$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf($colum_width).'"></td>';

			foreach ($data['month_data'] as $month => $month_data)
			{
				$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf($colum_width).'" align="rigth"><b>'.str_replace('-', '/', $month).'</b></td>';
			}
			$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf($colum_width).'" align="rigth"><b>'.get_text(392, 'return', 'decode_pdf')/*Summe*/.':</b></td>';
			$tbl .= 	'</tr>';

			//Projektstunden je monat oder gesamt vorhanden
			if (isset($data['general']['project_hour_per_month']) or isset($data['general']['project_hour_per_overall']))
			{
				$tbl .= 	'<tr>';
				$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf($colum_width).'"><b>'.get_text(356, 'return', 'decode_pdf')/*Sollstunden*/.'</b></td>';

				//Projektstunden je monat
				if (isset($data['general']['project_hour_per_month']))
				{
					for ($i = 1; $i <=12; $i++)
					{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($colum_width).'" align="rigth">'.$data['general']['project_hour_per_month'].'</td>';
					}
				}
				elseif (isset($data['general']['project_hour_per_overall']))
				{
					$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf(round($colum_width * 12, 2)).'" colspan="12" align="center">'.$data['general']['project_hour_per_overall'].'</td>';
				}

				$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf($colum_width).'" align="rigth">'.round($data['general']['project_hour_all_month'], 2).'</td>';

				$tbl .= 	'</tr>';
			}

			$percent_array = array();
			$tbl .= 	'<tr>';
				$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf($colum_width).'"><b>'.get_text(391, 'return', 'decode_pdf')/*Ist-Zeit*/.'</b></td>';
				foreach ($data['month_data'] as $month => $month_data)
				{
					if (isset($month_data['percent']))
					{
						$percent_array[] = $month_data['percent'];
					}

					if ($month_data['month_hour'] > 0)
					{
						$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf($colum_width).'" align="rigth">'.$month_data['month_hour'].' h</td>';
					}
					else
					{
						$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf($colum_width).'"></td>';
					}
				}
				$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf($colum_width).'" align="rigth">'.round($data['general']['project_actual_hour'], 2).'</td>';
			$tbl .= 	'</tr>';

			if (count($percent_array) > 0)
			{
				$tbl .= 	'<tr>';
				$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf($colum_width).'"><b>'.get_text(952, 'return', 'decode_pdf')/*Prozent*/.'</b></td>';
				foreach ($percent_array as $percent)
				{
					if ($percent > 0)
					{
						$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf($colum_width).'" align="rigth">'.$percent.' %</td>';
					}
					else
					{
						$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf($colum_width).'"></td>';
					}
				}
				$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf($colum_width).'"></td>';
				$tbl .= 	'</tr>';
			}

			$tbl .= '</table>';
			$pdf->writeHTML($tbl, true, false, false, false, '');

			$x = $pdf->GetX();
			$y = $pdf->GetY();
			//Aussenrahmen
			$pdf->Rect($x, $y, $page_width, 138);

			//Innenrahmen
			$pdf->Rect($x + 10, $y + 5, $page_width - 20, 120);

			//Querlinien
			$y_plus = 0;
			for ($i = 1; $i <= 3; $i++)
			{
				$y_plus += 30;
				$pdf->Line($x + 10, $y + 5 + $y_plus, $x + $page_width - 10, $y + 5 + $y_plus);
			}
			//senkrechte linien
			$x_plus = 0;
			for ($i = 1; $i <= 12; $i++)
			{
				$x_plus += round(($page_width - 30) / 12, 2);
				$pdf->Line($x + 5 + $x_plus, $y + 5 + 119, $x + 5 + $x_plus, $y + 5 + 121);
			}

			//monatsbezeichnungen bezeichnung
			$x_plus = 0;
			foreach ($data['month_data'] as $month => $month_data)
			{
				$x_plus += round(($page_width - 30) / 12, 2);
				$pdf->Text($x + $x_plus, $y + 5 + 123, str_replace('-', '/', $month));
			}

			//linke senkrechte bezeichnung
			if ($data['general']['hour_max'] < 100)
			{
				$hour_line = 100;
			}
			else
			{
				$hour_line = substr($data['general']['hour_max'], 0, 1) + 1;
				for ($i = 1; $i < strlen(intval($data['general']['hour_max'])); $i++)
				{
					$hour_line .= '0';
				}
				$hour_line = intval($hour_line);
			}
			$left_hour_chart = $hour_line;

			//Querlinien
			$pdf->SetTextColor(255, 0, 0);
			$y_plus = 0;
			$org_hour_line = $hour_line;
			for ($i = 1; $i <= 5; $i++)
			{
				if ($i == 5)
				{
					$pdf->Text($x + 1, $y + 5 + $y_plus, '0 h');
				}
				else
				{
					$pdf->Text($x + 1, $y + 5 + $y_plus, $hour_line.' h');
				}
				$y_plus += 30;
				$hour_line -= round($org_hour_line / 4, 2);
			}
			$pdf->SetTextColor(0, 0, 0);

			//stundenpunkte eintragen
			$x_plus = 0;
			$y_ratio = $org_hour_line / 100;
			$pdf->SetFillColor(255, 0, 0);
			$hour_points_array = array();
			foreach ($data['month_data'] as $month => $month_data)
			{
				if ($month_data['month_hour'] > 0)
				{
					$x_plus += round(($page_width - 30) / 12, 2);
					$y_minus = round($month_data['month_hour'] * 120 / $org_hour_line, 2);

					$rect_x = $x + 4.5 + $x_plus;
					$rect_y = $y + 5 + 120 - 1 - $y_minus;

					$hour_points_array[] = array(	'x'	=> $rect_x,
													'y'	=> $rect_y);

					$pdf->Rect($rect_x, $rect_y, 1, 1, 'F');
				}
				else
				{
					$x_plus += round(($page_width - 30) / 12, 2);
				}
			}

			$pdf->SetFillColor(255, 0, 0);

			//Stundenlinien eintragen
			if (count ($hour_points_array) > 0)
			{
				$line_count = 0;
				$while = true;
				while ($while === true)
				{
					if (isset($hour_points_array[$line_count]) and isset($hour_points_array[$line_count + 1]))
					{
						$start = $hour_points_array[$line_count];
						$end = $hour_points_array[$line_count + 1];

						$pdf->Line($start['x'] + 0.5, $start['y'] + 0.5, $end['x'] + 0.5, $end['y'] + 0.5, array('width' => 0.1, 'cap' => 'round', 'join' => 'round', 'dash' => 4, 'color' => array(255, 0, 0)));

						$line_count++;

						if (!isset($hour_points_array[$line_count]))
						{
							$while = false;
						}
					}
					else
					{
						$while = false;
					}
				}
			}

			if (isset($data['general']['project_hour_per_month']) or isset($data['general']['project_hour_per_overall']))
			{
				if ($data['general']['percent_max'] < 100)
				{
					$max_percent = 100;
				}
				else
				{
					$max_percent = substr($data['general']['percent_max'], 0 ,1) + 1;

					for ($i = 1; $i < strlen(intval($data['general']['percent_max'])); $i++)
					{
						$max_percent .= '0';
					}

					$max_percent = intval($max_percent);
				}
			}
			//rechte senkrechte bezeichnung
			if (isset($max_percent))
			{

				$pdf->SetTextColor(0, 0, 255);
				//Querlinien
				$y_plus = 0;
				$percent_line = $max_percent;
				for ($i = 1; $i <= 5; $i++)
				{
					if ($i == 5)
					{
						$pdf->Text($x + 11 + $page_width - 20, $y + 5 + $y_plus, '0 %');
					}
					else
					{
						$pdf->Text($x + 11 + $page_width - 20, $y + 5 + $y_plus, $percent_line.' %');
					}
					$y_plus += 30;
					$percent_line -= round($max_percent / 4);
				}
				$pdf->SetTextColor(0, 0, 0);

				//prozentpunkte eintragen
				$x_plus = 0;
				$pdf->SetFillColor(0, 0, 255);
				$percent_points_array = array();
				foreach ($data['month_data'] as $month => $month_data)
				{
					if ($month_data['percent'] > 0)
					{
						$x_plus += round(($page_width - 30) / 12, 2);
						$y_minus = round($month_data['percent'] * 120 / $max_percent, 2);

						$rect_x = $x + 4.5 + $x_plus;
						$rect_y = $y + 5 + 120 - 1 - $y_minus;

						$percent_points_array[] = array('x'	=> $rect_x,
														'y'	=> $rect_y);

						$pdf->Rect($rect_x, $rect_y, 1, 1, 'F');
					}
					else
					{
						$x_plus += round(($page_width - 30) / 12, 2);
					}
				}

				//Stundenlinien eintragen
				if (count ($percent_points_array) > 0)
				{
					$line_count = 0;
					$while = true;
					while ($while === true)
					{
						if (isset($percent_points_array[$line_count]) and isset($percent_points_array[$line_count + 1]))
						{
							$start = $percent_points_array[$line_count];
							$end = $percent_points_array[$line_count + 1];

							$pdf->Line($start['x'] + 0.5, $start['y'] + 0.5, $end['x'] + 0.5, $end['y'] + 0.5, array('width' => 0.1, 'cap' => 'round', 'join' => 'round', 'dash' => 4, 'color' => array(0, 0, 255)));

							$line_count++;

							if (!isset($percent_points_array[$line_count]))
							{
								$while = false;
							}
						}
						else
						{
							$while = false;
						}
					}
				}
			}

			$pdf->SetLineStyle(array('width' => 0.1, 'dash' => 0, 'color' => array(0, 0, 0)));

			$pdf->Output('project_hour_table.pdf', 'I');
		}
	}
?>