<?php
	/**
	 * PDF output of a timesheet
	 * @package time-o-meter
	 * @subpackage report
	 */

	/**
	 * include-sammlung einbinden
	 */
	require_once('../inc/include.php');

	//Variablenpruefung
	if ($chk_sum->Chk($_POST['VCS']) === true)
	{
		$tsr = new TimeSheetReport;
		$ts = new TimeSheet;

		//erstell ein Array mit Informationen fuer die Darstellung
		$result = $tsr->report_pdf_stz();

		//keine Fehler aufgetretten
		if ($result !== false)
		{
			//unterschriftsfelder
			if (isset($_POST['pdf']['option']['signature']) and $_POST['pdf']['option']['signature'] == 1)
			{
				$signature = true;
			}
			else
			{
				$signature = false;
			}
			//Projektlegende
			if (isset($_POST['pdf']['option']['projekt_legende']) and $_POST['pdf']['option']['projekt_legende'] == 1)
			{
				$projekt_legende = true;
			}
			else
			{
				$projekt_legende = false;
			}
			//Monatsgesamtwerte
			if (isset($_POST['pdf']['option']['month_overall']) and $_POST['pdf']['option']['month_overall'] == 1)
			{
				$month_overall = true;
			}
			else
			{
				$month_overall = false;
			}
			//Nur Projektzeiten ausgeben
			if (isset($_POST['pdf']['option']['only_projecttime']) and $_POST['pdf']['option']['only_projecttime'] == 1)
			{
				$only_projecttime = true;
			}
			else
			{
				$only_projecttime = false;
			}
			//keine Projekte im STZ vorhanden
			if (isset($_POST['no_project_exists']) and $_POST['no_project_exists'] == 1)
			{
				$no_project_exists = true;
			}
			else
			{
				$no_project_exists = false;
			}


			//POSTDATEN aus Formular loesch, diese werden nicht mehr benoetigt sind alle in $result vorhanden
			unset($_POST);
			//erstellt ein array $ts->setup_array mit stz daten
			$ts->start_time_sheet($result['user_id'], $result['month_string'], $result['year_int'], 'month', 'pdf');

			/*
			 * PDF Erstellung Start
			 */
			$pdf_setup_array = array();

			$pdf_setup_array['header']['type'] = 1;
			$pdf_setup_array['header']['logo_type'] = $setup_array['pdf_logo_template'];
			$pdf_setup_array['header']['txt'][] = mb_convert_encoding(get_text(100, 'return', 'decode_pdf').' '.html_entity_decode($kal->get_kalender_text($result['month_int'], 'month_name'), ENT_QUOTES).' '.$result['year_int'], 'UTF-8');//Stundenzettel September 2008
			$pdf_setup_array['header']['txt'][] = mb_convert_encoding(html_entity_decode($ts->setup_array['vorname'].' '.$ts->setup_array['nachname'], ENT_QUOTES), 'UTF-8');//Mitarbeiter
			$pdf_setup_array['header']['txt'][] = get_text(179, 'return', 'decode_pdf');//Mitarbeiter

			if ($only_projecttime == false)
			{
				$pdf_setup_array['header']['txt'][] = mb_convert_encoding($ts->setup_array['startwert_stunden'].' h', 'UTF-8');//Stundenübertrag
				$pdf_setup_array['header']['txt'][] = get_text(268, 'return', 'decode_pdf');//Stundenübertrag
				$pdf_setup_array['header']['txt'][] = mb_convert_encoding($ts->setup_array['startwert_urlaub'], 'UTF-8');//Resturlaub
				$pdf_setup_array['header']['txt'][] = get_text(207, 'return', 'decode_pdf');//Resturlaub
				$pdf_setup_array['header']['txt'][] = mb_convert_encoding($ts->setup_array['min_weektime'].' h', 'UTF-8');//Wochenarbeitszeit
				$pdf_setup_array['header']['txt'][] = get_text(598, 'return', 'decode_pdf');//Wochenarbeitszeit
			}
			$pdf_setup_array['header']['margin'] = 5;

			$pdf_setup_array['footer']['type'] = 1;
			$pdf_setup_array['footer']['logo_count'] = 1;
			$pdf_setup_array['footer']['txt'][] = mb_convert_encoding(get_text(100, 'return', 'decode_pdf').' '.html_entity_decode($kal->get_kalender_text($result['month_int'], 'month_name'), ENT_QUOTES).' '.$result['year_int'], 'UTF-8');//Stundenzettel September 2008
			$pdf_setup_array['footer']['txt'][] = get_text(354, 'return', 'decode_pdf');//Dokument
			$pdf_setup_array['footer']['txt'][] = mb_convert_encoding($kal->iso_to_free(date('Y-m-d')), 'UTF-8');
			$pdf_setup_array['footer']['txt'][] = get_text(261, 'return', 'decode_pdf');//Datum
			$pdf_setup_array['footer']['txt'][] = get_text(67, 'return', 'decode_pdf');//von
			$pdf_setup_array['footer']['txt'][] = get_text(66, 'return', 'decode_pdf');//Seite
			$pdf_setup_array['footer']['margin'] = 10;

			$pdf_setup_array['page']['margin'] = array(	'left'	=> 10,
														'right'	=> 10,
														'bottom'=> 25);

			// create new PDF document
			$pdf = new Pdf($pdf_setup_array, $result['page_format']);

			// add a page
			$pdf->AddPage();

			$tbl = '<table border="1" cellpadding="2" cellspacing="0">
					<thead>
						<tr>';
							for ($i = 0; $i < count($result['column']); $i++)
							{
								$tmp_array = $result['column'][$i];

								if ($tmp_array['type'] == 'project' and isset($tmp_array['comment']) and $tmp_array['comment'] == true)
								{
			$tbl .= 				'<td width="'.$pdf->get_mm_for_pdf($tmp_array['width'] + $result['column'][$i + 1]['width']).'" colspan="2" align="center"><b>'.mb_convert_encoding($tmp_array['name'], 'UTF-8').'</b></td>';
								}
								//Projektkommentarspalten ignorieren
								elseif ($tmp_array['type'] != 'project_comment')
								{
			$tbl .= 				'<td width="'.$pdf->get_mm_for_pdf($tmp_array['width']).'" align="center"><b>'.mb_convert_encoding($tmp_array['name'], 'UTF-8').'</b></td>';
								}
							}
			$tbl .= 	'</tr>
					</thead>';

			//Zeilen abarbeiten
			$bg_color = 'E5E5E5';
			for ($line = 0; $line < count($ts->setup_array['days']); $line++)
			{
				$day_string = substr($ts->setup_array['days'][$line]['day'], -2);
				$day_int = intval($day_string);

				$tbl .= '<tr style="background-color:#'.$bg_color.';">';

				for ($cell = 0; $cell < count($result['column']); $cell++)
				{
					//Datum
					if ($result['column'][$cell]['type'] == 'datum')
					{
						$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'" align="center">'.mb_convert_encoding($day_string.'. '.$ts->get_day_name($ts->setup_array['days'][$line]['day'], 'K'), 'UTF-8').'</td>';
					}
					//kommen
					elseif($result['column'][$cell]['type'] == 'kommen')
					{
						if (isset($_POST['kommen'][$day_int]) and !empty($_POST['kommen'][$day_int]))
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'" align="center">'.mb_convert_encoding($_POST['kommen'][$day_int], 'UTF-8').'</td>';
						}
						else
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'"></td>';
						}
					}
					//Pause
					elseif($result['column'][$cell]['type'] == 'pause')
					{
						if (isset($_POST['pause'][$day_int]) and !empty($_POST['pause'][$day_int]))
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'" align="center">'.mb_convert_encoding($_POST['pause'][$day_int], 'UTF-8').'</td>';
						}
						else
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'"></td>';
						}
					}
					//gehen
					elseif($result['column'][$cell]['type'] == 'gehen')
					{
						if (isset($_POST['gehen'][$day_int]) and !empty($_POST['gehen'][$day_int]))
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'" align="center">'.mb_convert_encoding($_POST['gehen'][$day_int], 'UTF-8').'</td>';
						}
						else
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'"></td>';
						}
					}
					//Istzeit
					elseif($result['column'][$cell]['type'] == 'istzeit')
					{
						if (isset($ts->tmp_data_save_array['timesheet']['istzeit'][$day_int]) and !empty($ts->tmp_data_save_array['timesheet']['istzeit'][$day_int]))
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'" align="center">'.mb_convert_encoding($ts->tmp_data_save_array['timesheet']['istzeit'][$day_int], 'UTF-8').'</td>';
						}
						else
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'"></td>';
						}
					}
					//Abwesenheit
					elseif($result['column'][$cell]['type'] == 'abwesenheit')
					{
						if (isset($_POST['abwesenheit'][$day_int]) and !empty($_POST['abwesenheit'][$day_int]) and isset($ts->absence_array[$_POST['abwesenheit'][$day_int]]['absence_name']) and !empty($ts->absence_array[$_POST['abwesenheit'][$day_int]]['absence_name']))
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'" align="center">'.mb_convert_encoding(html_entity_decode($ts->absence_array[$_POST['abwesenheit'][$day_int]]['absence_name'], ENT_QUOTES), 'UTF-8').'</td>';
						}
						else
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'"></td>';
						}
					}
					//Zeit
					elseif($result['column'][$cell]['type'] == 'zeit')
					{
						if (isset($ts->tmp_data_save_array['timesheet']['zeit'][$day_int]) and !empty($ts->tmp_data_save_array['timesheet']['zeit'][$day_int]))
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'" align="center">'.mb_convert_encoding($ts->tmp_data_save_array['timesheet']['zeit'][$day_int], 'UTF-8').'</td>';
						}
						else
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'"></td>';
						}
					}
					//Kommentar
					elseif($result['column'][$cell]['type'] == 'kommentar')
					{
						if (isset($_POST['kommentar'][$day_int]) and !empty($_POST['kommentar'][$day_int]))
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'">'.mb_convert_encoding(html_entity_decode($_POST['kommentar'][$day_int], ENT_QUOTES), 'UTF-8').'</td>';
						}
						else
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'"></td>';
						}
					}
					//NZS
					elseif($result['column'][$cell]['type'] == 'nzs')
					{
						if (isset($ts->tmp_data_save_array['timesheet']['nzs'][$day_int]) and !empty($ts->tmp_data_save_array['timesheet']['nzs'][$day_int]))
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'" align="center">'.mb_convert_encoding($ts->tmp_data_save_array['timesheet']['nzs'][$day_int], 'UTF-8').'</td>';
						}
						else
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'"></td>';
						}
					}
					//Projekt
					elseif($result['column'][$cell]['type'] == 'project')
					{
						if (isset($_POST['projektzeit'][$day_int][$result['column'][$cell]['p_id']]['stunden']) and !empty($_POST['projektzeit'][$day_int][$result['column'][$cell]['p_id']]['stunden']))
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'" align="center">'.mb_convert_encoding($_POST['projektzeit'][$day_int][$result['column'][$cell]['p_id']]['stunden'], 'UTF-8').'</td>';
						}
						else
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'"></td>';
						}
					}
					//Projektkommentar
					elseif($result['column'][$cell]['type'] == 'project_comment')
					{
						if (isset($_POST['projektkommentar'][$day_int][$result['column'][$cell]['p_id']]) and !empty($_POST['projektkommentar'][$day_int][$result['column'][$cell]['p_id']]))
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'">'.mb_convert_encoding(html_entity_decode($_POST['projektkommentar'][$day_int][$result['column'][$cell]['p_id']], ENT_QUOTES), 'UTF-8').'</td>';
						}
						else
						{
							$tbl .= '<td width="'.$pdf->get_mm_for_pdf($result['column'][$cell]['width']).'"></td>';
						}
					}
				}
				$tbl .= '</tr>';
				if ($bg_color == 'E5E5E5')
				{
					$bg_color = 'FFFFFF';
				}
				else
				{
					$bg_color = 'E5E5E5';
				}
			}

			$tbl .= '</table>';

			//Stz Tabelle Schreiben
			$pdf->writeHTML($tbl, true, false, false, false, '');

			$page_width = $pdf->get_page_size();

			//Monatsgesamtwerte
			if ($month_overall == true)
			{
				$pdf->Ln(5);
				$tbl = '<table border="1" cellpadding="2" cellspacing="0">
						<thead>
							<tr>';
				$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf($page_width - 40).'"><b>'.mb_convert_encoding(get_text(399, 'return', 'decode_pdf')/*Bezeichnung*/, 'UTF-8').'</b></td>';
				$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf(40).'" align="center"><b>'.mb_convert_encoding(get_text(635, 'return', 'decode_pdf')/*Werte*/, 'UTF-8').'</b></td>';
				$tbl .= 	'</tr>
						</thead>';

				if ($only_projecttime == false)
				{
					if (!$no_project_exists)
					{
						$tbl .= '<tr>
									<td width="'.$pdf->get_mm_for_pdf($page_width - 40).'">'.get_text(392, 'return', 'decode_pdf').' ('.get_text(606, 'return', 'decode_pdf').'):</td>
									<td width="'.$pdf->get_mm_for_pdf(40).'" align="center">'.$ts->setup_array['month_nzsstunden'].' h</td>
								</tr>';//Summe (NZS)
					}
					$tbl .= '<tr>
								<td width="'.$pdf->get_mm_for_pdf($page_width - 40).'">'.get_text(392, 'return', 'decode_pdf').' ('.get_text(391, 'return', 'decode_pdf').'):</td>
								<td width="'.$pdf->get_mm_for_pdf(40).'" align="center">'.$ts->setup_array['month_iststunden'].' h</td>
							</tr>';//Summe (Ist-Zeit)
					$tmp_cal = $ts->setup_array['month_iststunden'] - $ts->setup_array['month_sollstunden'] + $ts->setup_array['month_absence_time'];
					$tbl .= '<tr>
								<td width="'.$pdf->get_mm_for_pdf($page_width - 40).'">'.get_text(392, 'return', 'decode_pdf').' '.get_text(393, 'return', 'decode_pdf').':</td>
								<td width="'.$pdf->get_mm_for_pdf(40).'" align="center">'.$tmp_cal.' h</td>
							</tr>';//Summe Zeit (+/-)
					$tmp_cal = $ts->setup_array['month_iststunden'] + $ts->setup_array['month_absence_time'] + $ts->setup_array['startwert_stunden'] - $ts->setup_array['month_sollstunden'];
					$tbl .= '<tr>
								<td width="'.$pdf->get_mm_for_pdf($page_width - 40).'">'.get_text(268, 'return', 'decode_pdf').':</td>
								<td width="'.$pdf->get_mm_for_pdf(40).'" align="center">'.$tmp_cal.' h</td>
							</tr>';//Stundenuebertrag
					$tmp_cal = $ts->setup_array['startwert_urlaub'] - $ts->setup_array['month_urlaub_count'];
					$tbl .= '<tr>
								<td width="'.$pdf->get_mm_for_pdf($page_width - 40).'">'.get_text(207, 'return', 'decode_pdf').':</td>
								<td width="'.$pdf->get_mm_for_pdf(40).'" align="center">'.$tmp_cal.'</td>
							</tr>';//Resturlaub
				}

				for ($i = 0; $i < count($result['column']); $i++)
				{
					if ($result['column'][$i]['type'] == 'project')
					{
						if (isset($ts->setup_array['month_project_iststunden'][$result['column'][$i]['p_id']]))
						{
							$tbl .= '<tr>
										<td width="'.$pdf->get_mm_for_pdf($page_width - 40).'">'.get_text(212, 'return', 'decode_pdf').' '.$result['column'][$i]['name'].':</td>
										<td width="'.$pdf->get_mm_for_pdf(40).'" align="center">'.$ts->setup_array['month_project_iststunden'][$result['column'][$i]['p_id']].' h</td>
									</tr>';
						}
						else
						{
							$tbl .= '<tr>
										<td width="'.$pdf->get_mm_for_pdf($page_width - 40).'">'.get_text(212, 'return', 'decode_pdf').' '.$result['column'][$i]['name'].':</td>
										<td width="'.$pdf->get_mm_for_pdf(40).'" align="center"></td>
									</tr>';
						}
					}
				}

				$tbl .= '</table>';
				$pdf->writeHTML($tbl, true, false, false, false, '');
			}

			//Projektlegende
			if ($projekt_legende == true)
			{
				$pdf->Ln(5);
				$tbl = '<table border="1" cellpadding="2" cellspacing="0">
						<thead>
							<tr>';
				$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf(40).'"><b>'.get_text(292, 'return', 'decode_pdf')/*Projektkuerzel*/.'</b></td>';
				$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf($page_width - 120).'"><b>'.get_text(291, 'return', 'decode_pdf')/*Projektname*/.'</b></td>';
				$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf(40).'"><b>'.get_text(305, 'return', 'decode_pdf')/*Projektnr. des Kunden*/.'</b></td>';
				$tbl .= 		'<td width="'.$pdf->get_mm_for_pdf(40).'"><b>'.get_text(306, 'return', 'decode_pdf')/*Projektnr. (intern)*/.'</b></td>';
				$tbl .= 	'</tr>
						</thead>';

				for ($i = 0; $i < count($result['column']); $i++)
				{
					if ($result['column'][$i]['type'] == 'project')
					{
						$sql = $cdb->select('SELECT name, kurzname, nr_kunde, nr_intern FROM hdb_projekte WHERE projekt_id='.$result['column'][$i]['p_id']);
						$p_result = $cdb->fetch_array($sql);

						$tbl .= '<tr>';
						$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf(40).'">'.mb_convert_encoding(html_entity_decode($p_result['kurzname'], ENT_QUOTES), 'UTF-8').'</td>';
						$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf($page_width - 120).'">'.mb_convert_encoding(html_entity_decode($p_result['name'], ENT_QUOTES), 'UTF-8').'</td>';
						$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf(40).'">'.mb_convert_encoding(html_entity_decode($p_result['nr_kunde'], ENT_QUOTES), 'UTF-8').'</td>';
						$tbl .= 	'<td width="'.$pdf->get_mm_for_pdf(40).'">'.mb_convert_encoding(html_entity_decode($p_result['nr_intern'], ENT_QUOTES), 'UTF-8').'</td>';
						$tbl .= '</tr>';
					}
				}

				$tbl .= '</table>';
				$pdf->writeHTML($tbl, true, false, false, false, '');
			}

			//Unterschriftenfelder
			if ($signature == true)
			{
				//$pdf->Ln(5);
				$signature_array = array();
				for ($i = 0; $i < count($result['column']); $i++)
				{
					if ($result['column'][$i]['type'] == 'project')
					{
						$signature_array[] = $result['column'][$i]['name'];
					}
				}

				if (count($signature_array) > 0)
				{
					$array_count = 0;
					$while_boole = true;

					$sign_block = ($page_width - 6) / 4;

					while($while_boole == true)
					{
						$pdf->Ln(5);

						//pruefen ob unterschriftsfeld noch auf die seite passt
						if ($pdf->GetY() + 15 > $pdf->get_max_writable_height())
						{
							$pdf->AddPage();
							$pdf->Ln(5);
						}

						$x = $pdf->GetX();
						$y = $pdf->GetY();

						if (isset($signature_array[$array_count]))
						{
							//Unterschrift Projektleiter
							$pdf->Text($pdf->_GetX($x), $pdf->_GetY($y), get_text(622, 'return', 'decode_pdf').' '.$signature_array[$array_count]);
							//Ort/Datum
							$pdf->Text($pdf->_GetX($x), $pdf->_GetY($y) + 15, get_text(620, 'return', 'decode_pdf').'/'.get_text(261, 'return', 'decode_pdf'));
							//Unterschrift
							$pdf->Text($pdf->_GetX($x) + $sign_block + 2, $pdf->_GetY($y) + 15, get_text(636, 'return', 'decode_pdf'));

							//Linie Ort/Datum
							$pdf->Line($pdf->_GetX($x), $pdf->_GetY($y) + 12, $pdf->_GetX($x) + $sign_block, $pdf->_GetY($y) + 12);
							//Linie Unterschrift
							$pdf->Line($pdf->_GetX($x) + $sign_block + 2, $pdf->_GetY($y) + 12, $pdf->_GetX($x) + $sign_block + $sign_block, $pdf->_GetY($y) + 12);

							$array_count++;
						}

						if (isset($signature_array[$array_count]))
						{
							//Unterschrift Projektleiter
							$pdf->Text($pdf->_GetX($x) + $sign_block + $sign_block + 4, $pdf->_GetY($y), get_text(622, 'return', 'decode_pdf').' '.$signature_array[$array_count]);
							//Ort/Datum
							$pdf->Text($pdf->_GetX($x) + $sign_block + $sign_block + 4, $pdf->_GetY($y) + 15, get_text(620, 'return', 'decode_pdf').'/'.get_text(261, 'return', 'decode_pdf'));
							//Unterschrift
							$pdf->Text($pdf->_GetX($x) + $sign_block + $sign_block + $sign_block + 6, $pdf->_GetY($y) + 15, get_text(636, 'return', 'decode_pdf'));

							//Linie Ort/Datum
							$pdf->Line($pdf->_GetX($x) + $sign_block + $sign_block + 4, $pdf->_GetY($y) + 12, $pdf->_GetX($x) + $sign_block + $sign_block + $sign_block + 4, $pdf->_GetY($y) + 12);
							//Linie Unterschrift
							$pdf->Line($pdf->_GetX($x) + $sign_block + $sign_block + $sign_block + 6, $pdf->_GetY($y) + 12, $pdf->_GetX($x) + $sign_block + $sign_block + $sign_block + $sign_block, $pdf->_GetY($y) + 12);

							$array_count++;
						}

						//Keine weiteren Unterschrifsfelder vorhanden
						if (!isset($signature_array[$array_count]))
						{
							$while_boole = false;
						}
						//Abstand fuer die naechste zeile
						else
						{
							$pdf->Ln(15);
						}
					}
				}
			}


			$pdf->Output('timesheet.pdf', 'I');
		}
		else
		{
			//FIXME das sollte vielleicht als PDF ausgegeben werden
			echo setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
		}
	}
	else
	{
		//FIXME das sollte vielleicht als PDF ausgegeben werden
		echo setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
	}
?>