<?php
/**
	 * PDF output
	 * @package time-o-meter
	 * @subpackage report
	 */

	/**
	 * include-sammlung einbinden
	 */
	require_once('../inc/include.php');

	//Varaiablenpruefung
	if ($chk_sum->Chk($_GET['VCS']) === true)
	{
		$sql = $cdb->select('SELECT vorname, nachname FROM hdb_user WHERE user_id='.USER_ID);
		$result = $cdb->fetch_array($sql);

		$pdf_setup_array = array();

		$pdf_setup_array['header']['type'] = 1;
		$pdf_setup_array['header']['logo_type'] = $setup_array['pdf_logo_template'];
		$pdf_setup_array['header']['txt'][] = get_text(100, 'return', 'decode_pdf').' - '.$_GET['year_int'];//Stundenzettel
		$pdf_setup_array['header']['txt'][] = mb_convert_encoding(html_entity_decode($result['vorname'].' '.$result['nachname'], ENT_QUOTES), 'UTF-8');
		$pdf_setup_array['header']['txt'][] = get_text(179, 'return', 'decode_pdf');//Mitarbeiter
		$pdf_setup_array['header']['txt'][] = $_GET['year_int'];
		$pdf_setup_array['header']['txt'][] = get_text(265, 'return', 'decode_pdf');//Jahr
		$pdf_setup_array['header']['margin'] = 5;

		$pdf_setup_array['footer']['type'] = 1;
		$pdf_setup_array['footer']['logo_count'] = 1;
		$pdf_setup_array['footer']['txt'][] = get_text(100, 'return', 'decode_pdf').' - '.$_GET['year_int'];//Stundenzettel
		$pdf_setup_array['footer']['txt'][] = get_text(354, 'return', 'decode_pdf');//Dokument
		$pdf_setup_array['footer']['txt'][] = mb_convert_encoding($kal->iso_to_free(date('Y-m-d')), 'UTF-8');
		$pdf_setup_array['footer']['txt'][] = get_text(261, 'return', 'decode_pdf');//Datum
		$pdf_setup_array['footer']['txt'][] = get_text(67, 'return', 'decode_pdf');//von
		$pdf_setup_array['footer']['txt'][] = get_text(66, 'return', 'decode_pdf');//Seite
		$pdf_setup_array['footer']['margin'] = 10;

		$pdf_setup_array['page']['margin'] = array(	'left'	=> 10,
													'right'	=> 10,
													'bottom'=> 25);

		// create new PDF document
		$pdf = new Pdf($pdf_setup_array, 'L');

		// add a page
		$pdf->AddPage();

		//Tabellenkopf
		$tbl = '<table border="1" cellpadding="2" cellspacing="0">
					<tr style="background-color:#FFFFFF;color:#000000;">
						<td width="'.$pdf->get_mm_for_pdf(37).'" rowspan="2">Zeitraum</td>
						<td width="'.$pdf->get_mm_for_pdf(22).'" rowspan="2" align="center">'.get_text('', 'return', 'decode_pdf', 'sollstunden').'</td>
						<td width="'.$pdf->get_mm_for_pdf(22).'" rowspan="2" align="center">'.get_text('', 'return', 'decode_pdf', 'ist_zeit').'</td>
						<td width="'.$pdf->get_mm_for_pdf(22).'" rowspan="2" align="center">'.get_text('', 'return', 'decode_pdf', 'urlaubstage').'</td>
						<td width="'.$pdf->get_mm_for_pdf(22).'" rowspan="2" align="center">'.get_text(108, 'return', 'decode_pdf').'</td>'./*Krankheitstage*/'
						<td width="'.$pdf->get_mm_for_pdf(32).'" rowspan="2" align="center">'.get_text(185, 'return', 'decode_pdf').'</td>'./*Anzahl der Arbeitstage*/'
						<td width="'.$pdf->get_mm_for_pdf(120).'" colspan="6" align="center">'.get_text(185, 'return', 'decode_pdf').'</td>'./*Anzahl der Arbeitstage*/'
					</tr>
					<tr>
						<td width="'.$pdf->get_mm_for_pdf(20).'" align="center">'.get_text(986, 'return', 'decode_pdf').'</td>'./*kleiner gleich 6 Stunden*/'
						<td width="'.$pdf->get_mm_for_pdf(20).'" align="center">'.get_text(987, 'return', 'decode_pdf').'</td>'./*ueber 6 Stunden*/'
						<td width="'.$pdf->get_mm_for_pdf(20).'" align="center">'.get_text(988, 'return', 'decode_pdf').'</td>'./*ueber 8 Stunden*/'
						<td width="'.$pdf->get_mm_for_pdf(20).'" align="center">'.get_text(989, 'return', 'decode_pdf').'</td>'./*ueber 10 Stunden*/'
						<td width="'.$pdf->get_mm_for_pdf(20).'" align="center">'.get_text(990, 'return', 'decode_pdf').'</td>'./*ueber 12 Stunden*/'
						<td width="'.$pdf->get_mm_for_pdf(20).'" align="center">'.get_text(991, 'return', 'decode_pdf').'</td>'./*ueber 14 Stunden*/'
					</tr>';

		$total_sollstunden = 0;
		$total_bezahlt_zeit = 0;
		$total_urlaub = 0;
		$total_krank = 0;
		$total_work_days = 0;
		$total_work_days_smaller_six = 0;
		$total_work_days_six = 0;
		$total_work_days_eight = 0;
		$total_work_days_ten = 0;
		$total_work_days_twelve = 0;
		$total_work_days_fourteen = 0;

		$sql = $cdb->select("SELECT datum, sollstunden, summe_bezahlt_zeit, summe_urlaub, summe_krank FROM hdb_stz_monat WHERE user_id=".USER_ID." AND YEAR(datum)='".$_GET['year_int']."' AND abgeschlossen='j' ORDER BY datum ASC");
		while($result = $cdb->fetch_array($sql))
		{
			$month_string = substr($result['datum'], 5, 2);
			$tbl .= '<tr>';
				//Zeitraum
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(37).'">'.$_GET['year_int'].' '.$kal->get_kalender_text($month_string, 'month_name').'</td>';

				//Sollzeit
				if (empty($result['sollstunden']))
				{
					$result['sollstunden'] = 0;
				}
				$total_sollstunden += $result['sollstunden'];
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(22).'" align="center">'.$result['sollstunden'].' h</td>';

				//Ist-Zeit
				if (empty($result['summe_bezahlt_zeit']))
				{
					$result['summe_bezahlt_zeit'] = 0;
				}
				$total_bezahlt_zeit += $result['summe_bezahlt_zeit'];
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(22).'" align="center">'.$result['summe_bezahlt_zeit'].' h</td>';

				//Urlaub
				if (empty($result['summe_urlaub']))
				{
					$result['summe_urlaub'] = 0;
				}
				$total_urlaub += $result['summe_urlaub'];
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(22).'" align="center">'.$result['summe_urlaub'].'</td>';

				//Krankheitstage
				if (empty($result['summe_krank']))
				{
					$result['summe_krank'] = 0;
				}
				$total_krank += $result['summe_krank'];
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(22).'" align="center">'.$result['summe_krank'].'</td>';

				//Anzahl Arbeitstage
				$count_sql = $cdb->select("SELECT COUNT(stz_id) AS count FROM hdb_stz WHERE user_id=".USER_ID." AND LEFT(datum, 7)='".$_GET['year_int']."-$month_string' AND ist_zeit>0");
				$count_result = $cdb->fetch_array($count_sql);
				$total_work_days += $count_result['count'];
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(32).'" align="center">'.$count_result['count'].'</td>';

				//Anzahl Arbeitstage kleiner gleich 6 stunden
				$count_sql = $cdb->select("SELECT COUNT(stz_id) AS count FROM hdb_stz WHERE user_id=".USER_ID." AND LEFT(datum, 7)='".$_GET['year_int']."-$month_string' AND ist_zeit>0 AND ist_zeit<=6");
				$count_result = $cdb->fetch_array($count_sql);
				$total_work_days_smaller_six += $count_result['count'];
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(20).'" align="center">'.$count_result['count'].'</td>';

				//Anzahl Arbeitstage ueber 6 stunden
				$count_sql = $cdb->select("SELECT COUNT(stz_id) AS count FROM hdb_stz WHERE user_id=".USER_ID." AND LEFT(datum, 7)='".$_GET['year_int']."-$month_string' AND ist_zeit>6 AND ist_zeit<=8");
				$count_result = $cdb->fetch_array($count_sql);
				$total_work_days_six += $count_result['count'];
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(20).'" align="center">'.$count_result['count'].'</td>';

				//Anzahl Arbeitstage ueber 8 stunden
				$count_sql = $cdb->select("SELECT COUNT(stz_id) AS count FROM hdb_stz WHERE user_id=".USER_ID." AND LEFT(datum, 7)='".$_GET['year_int']."-$month_string' AND ist_zeit>8 AND ist_zeit<=10");
				$count_result = $cdb->fetch_array($count_sql);
				$total_work_days_eight += $count_result['count'];
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(20).'" align="center">'.$count_result['count'].'</td>';

				//Anzahl Arbeitstage ueber 10 stunden
				$count_sql = $cdb->select("SELECT COUNT(stz_id) AS count FROM hdb_stz WHERE user_id=".USER_ID." AND LEFT(datum, 7)='".$_GET['year_int']."-$month_string' AND ist_zeit>10 AND ist_zeit<=12");
				$count_result = $cdb->fetch_array($count_sql);
				$total_work_days_ten += $count_result['count'];
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(20).'" align="center">'.$count_result['count'].'</td>';

				//Anzahl Arbeitstage ueber 12 stunden
				$count_sql = $cdb->select("SELECT COUNT(stz_id) AS count FROM hdb_stz WHERE user_id=".USER_ID." AND LEFT(datum, 7)='".$_GET['year_int']."-$month_string' AND ist_zeit>12 AND ist_zeit<=14");
				$count_result = $cdb->fetch_array($count_sql);
				$total_work_days_twelve += $count_result['count'];
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(20).'" align="center">'.$count_result['count'].'</td>';

				//Anzahl Arbeitstage ueber 14 stunden
				$count_sql = $cdb->select("SELECT COUNT(stz_id) AS count FROM hdb_stz WHERE user_id=".USER_ID." AND LEFT(datum, 7)='".$_GET['year_int']."-$month_string' AND ist_zeit>14");
				$count_result = $cdb->fetch_array($count_sql);
				$total_work_days_fourteen += $count_result['count'];
				$tbl .= '<td width="'.$pdf->get_mm_for_pdf(20).'" align="center">'.$count_result['count'].'</td>';
			$tbl .= '</tr>';
		}

		$tbl .= '<tr>';
			//Zeitraum
			$tbl .= '<td width="'.$pdf->get_mm_for_pdf(37).'"><strong>'.$_GET['year_int'].' - '.get_text(309, 'return', 'decode_pdf').'</strong></td>';//gesamt
			//Sollzeit
			$tbl .= '<td width="'.$pdf->get_mm_for_pdf(22).'" align="center"><strong>'.$total_sollstunden.' h</strong></td>';
			//Ist-Zeit
			$tbl .= '<td width="'.$pdf->get_mm_for_pdf(22).'" align="center"><strong>'.$total_bezahlt_zeit.' h</strong></td>';
			//Urlaub
			$tbl .= '<td width="'.$pdf->get_mm_for_pdf(22).'" align="center"><strong>'.$total_urlaub.'</strong></td>';
			//Krankheitstage
			$tbl .= '<td width="'.$pdf->get_mm_for_pdf(22).'" align="center"><strong>'.$total_krank.'</strong></td>';
			//Anzahl Arbeitstage
			$tbl .= '<td width="'.$pdf->get_mm_for_pdf(32).'" align="center"><strong>'.$total_work_days.'</strong></td>';
			//Anzahl Arbeitstage kleiner gleich 6 stunden
			$tbl .= '<td width="'.$pdf->get_mm_for_pdf(20).'" align="center"><strong>'.$total_work_days_smaller_six.'</strong></td>';
			//Anzahl Arbeitstage ueber 6 stunden
			$tbl .= '<td width="'.$pdf->get_mm_for_pdf(20).'" align="center"><strong>'.$total_work_days_six.'</strong></td>';
			//Anzahl Arbeitstage ueber 8 stunden
			$tbl .= '<td width="'.$pdf->get_mm_for_pdf(20).'" align="center"><strong>'.$total_work_days_eight.'</strong></td>';
			//Anzahl Arbeitstage ueber 10 stunden
			$tbl .= '<td width="'.$pdf->get_mm_for_pdf(20).'" align="center"><strong>'.$total_work_days_ten.'</strong></td>';
			//Anzahl Arbeitstage ueber 12 stunden
			$tbl .= '<td width="'.$pdf->get_mm_for_pdf(20).'" align="center"><strong>'.$total_work_days_twelve.'</strong></td>';
			//Anzahl Arbeitstage ueber 14 stunden
			$tbl .= '<td width="'.$pdf->get_mm_for_pdf(20).'" align="center"><strong>'.$total_work_days_fourteen.'</strong></td>';
		$tbl .= '</tr>';

		$tbl .= '</table>';
		$pdf->writeHTML($tbl, true, false, false, false, '');

		$pdf->Output('timesheet_year.pdf', 'I');
	}
	else
	{
		//FIXME das sollte vielleicht als PDF ausgegeben werden
		echo setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
	}
?>