<?php
	/**
	 * PDF output (userlist)
	 * @package time-o-meter
	 * @subpackage report
	 */

	/**
	 * include-sammlung einbinden
	 */
	require_once('../inc/include.php');

	//Varaiablenpruefung
	if ($chk_sum->Chk($_POST['VCS']) === true)
	{
		$pdf_setup_array = array();

		$pdf_setup_array['header']['type'] = 2;
		$pdf_setup_array['header']['logo_type'] = $setup_array['pdf_logo_template'];
		$pdf_setup_array['header']['txt'][] = get_text(107, 'return', 'decode_pdf');//Mitarbeiterliste
		$pdf_setup_array['header']['margin'] = 5;

		$pdf_setup_array['footer']['type'] = 1;
		$pdf_setup_array['footer']['logo_count'] = 1;
		$pdf_setup_array['footer']['txt'][] = get_text(107, 'return', 'decode_pdf');//Mitarbeiterliste
		$pdf_setup_array['footer']['txt'][] = get_text(354, 'return', 'decode_pdf');//Dokument
		$pdf_setup_array['footer']['txt'][] = mb_convert_encoding($kal->iso_to_free(date('Y-m-d')), 'UTF-8');
		$pdf_setup_array['footer']['txt'][] = get_text(261, 'return', 'decode_pdf');//Datum
		$pdf_setup_array['footer']['txt'][] = get_text(67, 'return', 'decode_pdf');//von
		$pdf_setup_array['footer']['txt'][] = get_text(66, 'return', 'decode_pdf');//Seite
		$pdf_setup_array['footer']['margin'] = 10;

		$pdf_setup_array['page']['margin'] = array(	'left'	=> 10,
													'right'	=> 10,
													'bottom'=> 25);

		// create new PDF document
		$pdf = new Pdf($pdf_setup_array, 'P');

		// add a page
		$pdf->AddPage();

		//Tabellenkopf
		$tbl = '<table border="1" cellpadding="2" cellspacing="0">
					<thead>
						<tr style="background-color:#FFFFFF;color:#000000;">
							<td width="'.$pdf->get_mm_for_pdf(50).'"><b>'.get_text(179, 'return', 'decode_pdf')/*Mitarbeiter*/.'</b></td>
							<td width="'.$pdf->get_mm_for_pdf(35).'"><b>'.get_text(205, 'return', 'decode_pdf')/*Personalnr.*/.'</b></td>
							<td width="'.$pdf->get_mm_for_pdf(70).'"><b>'.get_text(204, 'return', 'decode_pdf')/*E-Mail*/.'</b></td>
							<td width="'.$pdf->get_mm_for_pdf(35).'"><b>'.get_text(208, 'return', 'decode_pdf')/*Status*/.'</b></td>
						</tr>
					</thead>';

		/*
		*	ORDER
		*/
		if ($_POST['filter_order_int'] == 2)
		{
			$order = 'ORDER BY t1.sort_name DESC';
		}
		else
		{
			// mitarbeiterliste aufsteigend nach name sortieren
			$order = 'ORDER BY t1.sort_name ASC';
		}

		/*
		*	WHERE
		*/
		$where_array = array();

		if (is_numeric($_POST['filter_projekt_int']) and $_POST['filter_projekt_int'] > 0)
		{
			$where_array[] = 't4.projekt_id='.$_POST['filter_projekt_int'];
		}

		if (is_numeric($_POST['filter_status_int']) and $_POST['filter_status_int'] > 0)
		{
			$where_array[] = 't2.mastatus_id='.$_POST['filter_status_int'];
		}

		if ($_POST['filter_aktiv_string'] == 'j' or $_POST['filter_aktiv_string'] == 'n')
		{
			$where_array[] = "t1.anzeigen='".$_POST['filter_aktiv_string']."'";
		}

		if (is_numeric($_POST['filter_usergroup_int']) and $_POST['filter_usergroup_int'] > 0)
		{
			$where_array[] = 't3.group_id='.$_POST['filter_usergroup_int'];
		}

		$where = '';

		if (count($where_array) > 0)
		{
			foreach ($where_array as $v)
			{
				if (empty($where))
				{
					$where = 'WHERE '.$v;
				}
				else
				{
					$where .= ' AND '.$v;
				}
			}
		}

		$bg_color = 'E5E5E5';
		$sql = $cdb->select("SELECT DISTINCT(t1.user_id), t1.vorname, nachname, t1.email, t1.personalnr, t2.status FROM hdb_user t1
							LEFT JOIN hdb_ma_status t2 ON t1.mastatus_id=t2.mastatus_id
							LEFT JOIN hdb_usergroups t3 ON t1.group_id=t3.group_id
							LEFT JOIN hdb_user_projekt t4 ON t1.user_id=t4.user_id
							$where $order");

		while ($result = $cdb->fetch_array($sql))
		{
			$tbl .= '<tr style="background-color:#'.$bg_color.';color:#000000;">
					   <td width="'.$pdf->get_mm_for_pdf(50).'">'.mb_convert_encoding(html_entity_decode($result['vorname'].' '.$result['nachname'], ENT_QUOTES), 'UTF-8').'</td>
					   <td width="'.$pdf->get_mm_for_pdf(35).'">'.mb_convert_encoding(html_entity_decode($result['personalnr'], ENT_QUOTES), 'UTF-8').'</td>
					   <td width="'.$pdf->get_mm_for_pdf(70).'">'.mb_convert_encoding(html_entity_decode($result['email'], ENT_QUOTES), 'UTF-8').'</td>
					   <td width="'.$pdf->get_mm_for_pdf(35).'">'.mb_convert_encoding(html_entity_decode($result['status'], ENT_QUOTES), 'UTF-8').'</td>
					</tr>';
			if ($bg_color == 'E5E5E5')
			{
				$bg_color = 'FFFFFF';
			}
			else
			{
				$bg_color = 'E5E5E5';
			}
		}

		$tbl .= '</table>';

		$pdf->writeHTML($tbl, true, false, false, false, '');

		$pdf->Output('user_list.pdf', 'I');
	}
	else
	{
		//FIXME das sollte vielleicht als PDF ausgegeben werden
		echo setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
	}
?>