<?php
	/**
	 * this file contains all actions for the setup-folder
	 * @package time-o-meter
	 * @subpackage setup
	 */


	// grundeinstellungen bearbeiten (basic-settings)
	if ($_POST['job_string'] == 'edit_basic_setup')
	{
		//Realodsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{

				// Pflichtfeldpruefung
				$pflichtfelder = 0;
				if (empty($_POST['application_name']))	{$pflichtfelder++;}
				if (empty($_POST['footer_text']))		{$pflichtfelder++;}
				if (empty($_POST['maintenance_mode']))	{$pflichtfelder++;}
				if (empty($_POST['date_format']))		{$pflichtfelder++;}
				if (empty($_POST['contact_name']))		{$pflichtfelder++;}
				if (empty($_POST['contact_tel']) and empty($_POST['contact_fax']) and empty($_POST['contact_mail'])){$pflichtfelder++;}
				if (empty($_POST['logbook']))			{$pflichtfelder++;}
				if (empty($_POST['min_pw_len']) or !is_numeric($_POST['min_pw_len'])) {$pflichtfelder++;}
				if (empty($_POST['min_username_len']) or !is_numeric($_POST['min_username_len'])) {$pflichtfelder++;}
				if (_empty($_POST['holiday_overview_qualification'])) {$pflichtfelder++;}
				if (_empty($_POST['holiday_overview_project'])) {$pflichtfelder++;}
				if (!isset($_POST['login_cookie_int']) or !is_numeric($_POST['login_cookie_int'])) {$pflichtfelder++;}

				//Alle Pflichtfelder vorhanden
				if ($pflichtfelder == 0)
				{
					//Logincookie aktiv
					if ($_POST['login_cookie_int'] == 1)
					{
						$login_cookie = true;
					}
					else
					{
						$login_cookie = false;
					}

					if ($_POST['holiday_overview_qualification'] == 1)
					{
						$overview_qualification = true;
					}
					else
					{
						$overview_qualification = false;
					}

					if ($_POST['holiday_overview_project'] == 1)
					{
						$overview_project = true;
					}
					else
					{
						$overview_project = false;
					}

					// setup-array
					$setup_array = array('application_name'	=>	$_POST['application_name'],
										'footer_text'		=>	$_POST['footer_text'],
										'maintenance_mode'	=>	$_POST['maintenance_mode'],
										'date_format'		=>	$_POST['date_format'],
										'contact_name'		=>	$_POST['contact_name'],
										'contact_tel'		=>	$_POST['contact_tel'],
										'contact_fax'		=>	$_POST['contact_fax'],
										'contact_mail'		=>	$_POST['contact_mail'],
										'logbook'			=>	$_POST['logbook'],
										'min_pw_len'		=>	$_POST['min_pw_len'],
										'min_username_len'	=>	$_POST['min_username_len'],
										'login_cookie'		=>	$login_cookie,
										'database_version'	=>	TOM_VERSION,
										'holiday'			=> array('overview_qualification' => $overview_qualification,
																	'overview_project'	=> $overview_project)
										);


					if ($setup->update_setup($setup_array))
					{
						$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'main';
	}
	// Logoupload
	elseif ($_POST['job_string'] == 'add_logo')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				// pruefen ob Datei vorhanden
				if (isset($_FILES['logo']))
				{
					// gegebenenfalls neuen Dateinamen vergeben
					if (!isset($_POST['new_logoname']) or empty($_POST['new_logoname']))
					{
						$new_file_name_string = $_FILES['logo']['name'];
					}
					else
					{
						$new_file_name_string = $_POST['new_logoname'].'.jpg';
					}

					// pruefen ob Dateiname schon vorhanden ist
					$all_file_names_array = array();

					$dir = opendir(TOM_ABS_PFAD.'files/logo/');

					while (false !== ($file = readdir($dir)))
					{
						if ($file != '.' and $file != '..')
						{
							$all_file_names_array[] = $file;
						}
					}

					if (!in_array($new_file_name_string, $all_file_names_array))
					{
						// Bildgroessenwuensche pruefen

						// Breite
						if (isset($_POST['new_max_width']) and !empty($_POST['new_max_width']))
						{
							if (is_numeric($_POST['new_max_width']) and $_POST['new_max_width'] <= 270)
							{
								$new_max_width_int = $_POST['new_max_width'];
							}
							else
							{
								$new_max_width_int = 270;
							}
						}
						else
						{
							$new_max_width_int = 270;
						}

						// Hoehe
						if (isset($_POST['new_max_height']) and !empty($_POST['new_max_height']))
						{
							if (is_numeric($_POST['new_max_height']) and $_POST['new_max_height'] <= 100)
							{
								$new_max_height_int = $_POST['new_max_height'];
							}
							else
							{
								$new_max_height_int = 100;
							}
						}
						else
						{
							$new_max_height_int = 100;
						}

						$upload_dir_string = TOM_ABS_PFAD.'files/logo/';

						// uploadklasse einbinden
						$upload = new Upload;

						$result_array = $upload->image_upload($_FILES['logo'], $new_file_name_string, $upload_dir_string, 20480, array($new_max_width_int, $new_max_height_int, 'j'), array('jpg', 'jpeg', 'jpe'));

						if (!isset($result_array['error']) and isset($result_array['name']))
						{
							$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('716', 'return', 'decode_on') /*Der Angegebene Dateiname Existiert bereits.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_logo';
	} // Ende Logoupload
	// Neues Hauptlogo setzen
	elseif ($_POST['job_string'] == 'set_logo')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//CHecksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// dateiname des bisherigen logos
					$logo_alt_string = $setup_array['logo_name'];

					// bisheriges logo loeschen
					if (file_exists(TOM_ABS_PFAD.'template/'.$logo_alt_string))
					{
						unlink(TOM_ABS_PFAD.'template/'.$logo_alt_string);
					}

					// setup-array vorbereiten
					$setup_array = array('logo_name' => $_POST['logo_string']);

					if ($setup->update_setup($setup_array))
					{
						// kopiert das Logo in einen ungeschuetzen Bereich und benennt es ggf. um
						if (copy(TOM_ABS_PFAD.'files/logo/'.$_POST['logo_string'], TOM_ABS_PFAD.'template/'.$_POST['logo_string']))
						{
							$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_logo';

	} // ENDE Neues Hauptlogo setzen
	// Logo loeschen
	elseif ($_POST['job_string'] == 'del_logo')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Variablenpruefung
				if ($chk_sum->Chk($_POST['VCS']))
				{
					if (file_exists(TOM_ABS_PFAD.'files/logo/'.$_POST['logo_string']))
					{
						if (unlink(TOM_ABS_PFAD.'files/logo/'.$_POST['logo_string']))
						{
							$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_logo';
	} // ENDE Logo loeschen
	// passwort und/oder sprache aendern
	elseif ($_POST['job_string'] == 'edit_account')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;

					if (!isset($_POST['user_language']) or empty($_POST['user_language'])){$pflichtfelder++;}

					// pruefen, ob pw auch geaendert werden soll
					if (isset($_POST['change_pw']) && $_POST['change_pw'] == 'j')
					{
						if (!isset($_POST['current_pw']) or empty($_POST['current_pw'])){$pflichtfelder++;}
						if (!isset($_POST['new_pw']) or empty($_POST['new_pw']))		{$pflichtfelder++;}
						if (!isset($_POST['new_pw2']) or empty($_POST['new_pw2']))		{$pflichtfelder++;}
					}

					if ($pflichtfelder == 0)
					{
						// nur ausfuehren, wenn pw geaendert werden soll!
						if (isset($_POST['change_pw']) && $_POST['change_pw'] == 'j')
						{
							// passwortlaenge (min 8 zeichen)
							$pw_length = TOM_PW_MIN_LENGTH;

							// passwortlaenge pruefen
							if (strlen($_POST['new_pw']) >= $pw_length)
							{
								// passworteingaben vergleichen
								if ($_POST['new_pw'] == $_POST['new_pw2'])
								{
									// pruefen ob das pw den sicherheitsvorschriften entspricht
									$big_letter = 0;
									$small_letter = 0;
									$number = 0;
									$special_chars = 0;


									for ($i = 0; $i < strlen($_POST['new_pw']); $i++)
									{
										$tmp_sign = substr($_POST['new_pw'], $i, 1);

										if (preg_match('/\d/', $tmp_sign))
										{
											$number++;
										}
										elseif (preg_match('/[a-z]/', $tmp_sign))
										{
											$small_letter++;
										}
										elseif (preg_match('/[A-Z]/', $tmp_sign))
										{
											$big_letter++;
										}
										else
										{
											$special_chars++;
										}
									}

									// passwort-sicherheit ist ok
									if ($number > 0 and $small_letter > 0 and $big_letter > 0 and $special_chars > 0)
									{
										// PWs verschluesseln
										$cp = new CryptPw;

										$current_pw = $cp->encode_pw($_POST['current_pw']);
										$new_pw = $cp->encode_pw($_POST['new_pw']);

										// aenderungen uebernehmen
										if ($cdb->update("UPDATE hdb_user SET
														pw='$new_pw',
														sprache_id='".$_POST['user_language']."'
														WHERE user_id='".USER_ID."' AND pw='".$current_pw."'
														LIMIT 1"))

										{
											if ($cdb->get_affected_rows() == 1)
											{
												$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
											}
											else
											{
												$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
											}
										}
										else
										{
											$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
										}
									}
									else
									{
										$meldung_array['error'][] = setError(get_text('780', 'return', 'decode_on') /*Das gewuenschte Passwort entspricht nicht dem erforderlichen Sicherheitsstandard!*/, WARNING, __LINE__);
									}
								}
								else
								{
									$meldung_array['error'][] = get_text('128', 'return', 'decode_on'); //Die eingegebenen Passwoerter stimmen nicht ueberein!
								}
							} // ende passwortlaenge pruefen
							else
							{
								$meldung_array['error'][] = get_text('129', 'return', 'decode_on') /*Das gewaehlte Passwort ist zu kurz, die Mindestlaenge betraegt*/.' '.$pw_length.' '.get_text('130', 'return', 'decode_on'); /*Zeichen!*/
							}
						} // ENDE pw aenderung
						// keine pw-aenderung gewuenscht, daher nur sprache updaten
						else
						{
							// derzeitige user-sprache auslesen
							$sql_usersprache = $cdb->select("SELECT sprache_id FROM hdb_user WHERE user_id='".USER_ID."'");
							$result_usersprache = $cdb->fetch_array($sql_usersprache);

							// pruefen, ob aenderungen erforderlich
							if ($_POST['user_language'] != $result_usersprache['sprache_id'])
							{
								// aenderungen uebernehmen
								if ($cdb->update("UPDATE hdb_user SET
												sprache_id='".$_POST['user_language']."'
												WHERE user_id='".USER_ID."'
												LIMIT 1"))
								{
									if ($cdb->get_affected_rows() == 1)
									{
										$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); //Die aenderungen wurden gespeichert.
									}
									else
									{
										$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
									}
								}
								else
								{
									$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
								}
							}

						} // ENDE keine pw-aenderung gewuenscht, daher nur sprache updaten
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'main';
	} // ende passwort und/oder sprache aendern
	// benutzergruppen und zugriffsrechte bearbeiten
	elseif ($_POST['job_string'] == 'group_edit')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;

					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						if (is_numeric($_POST['groupid_int']))
						{
							$zugriffsrechte_array = array();

							if (isset($_POST['admin_reisekosten']))
							{
								$zugriffsrechte_array ['admin_reisekosten'] = $_POST['admin_reisekosten'];
							}
							else
							{
								$zugriffsrechte_array ['admin_reisekosten'] = 'n';
							}

							if (isset($_POST['admin_stz']))
							{
								$zugriffsrechte_array ['admin_stz'] = $_POST['admin_stz'];
							}
							else
							{
								$zugriffsrechte_array ['admin_stz'] = 'n';
							}

							if (isset($_POST['admin_message_write']))
							{
								$zugriffsrechte_array ['admin_message_write'] = $_POST['admin_message_write'];
							}
							else
							{
								$zugriffsrechte_array ['admin_message_write'] = 'n';
							}

							if (isset($_POST['admin_reports_health_read']))
							{
								$zugriffsrechte_array ['admin_reports_health_read'] = $_POST['admin_reports_health_read'];
							}
							else
							{
								$zugriffsrechte_array ['admin_reports_health_read'] = 'n';
							}

							if (isset($_POST['admin_reports_read']))
							{
								$zugriffsrechte_array ['admin_reports_read'] = $_POST['admin_reports_read'];
							}
							else
							{
								$zugriffsrechte_array ['admin_reports_read'] = 'n';
							}

							if (isset($_POST['admin_reports_write']))
							{
								$zugriffsrechte_array ['admin_reports_write'] = $_POST['admin_reports_write'];
							}
							else
							{
								$zugriffsrechte_array ['admin_reports_write'] = 'n';
							}

							if (isset($_POST['admin_antrag_read']))
							{
								$zugriffsrechte_array ['admin_antrag_read'] = $_POST['admin_antrag_read'];
							}
							else
							{
								$zugriffsrechte_array ['admin_antrag_read'] = 'n';
							}

							if (isset($_POST['admin_antrag_write']))
							{
								$zugriffsrechte_array ['admin_antrag_write'] = $_POST['admin_antrag_write'];
							}
							else
							{
								$zugriffsrechte_array ['admin_antrag_write'] = 'n';
							}

							if (isset($_POST['admin_user_read']))
							{
								$zugriffsrechte_array ['admin_user_read'] = $_POST['admin_user_read'];
							}
							else
							{
								$zugriffsrechte_array ['admin_user_read'] = 'n';
							}

							if (isset($_POST['admin_user_write']))
							{
								$zugriffsrechte_array ['admin_user_write'] = $_POST['admin_user_write'];
							}
							else
							{
								$zugriffsrechte_array ['admin_user_write'] = 'n';
							}

							if (isset($_POST['admin_project_read']))
							{
								$zugriffsrechte_array ['admin_project_read'] = $_POST['admin_project_read'];
							}
							else
							{
								$zugriffsrechte_array ['admin_project_read'] = 'n';
							}

							if (isset($_POST['admin_project_write']))
							{
								$zugriffsrechte_array ['admin_project_write'] = $_POST['admin_project_write'];
							}
							else
							{
								$zugriffsrechte_array ['admin_project_write'] = 'n';
							}

							if (isset($_POST['admin_backup']))
							{
								$zugriffsrechte_array ['admin_backup'] = $_POST['admin_backup'];
							}
							else
							{
								$zugriffsrechte_array ['admin_backup'] = 'n';
							}

							if (isset($_POST['admin_setup']))
							{
								$zugriffsrechte['admin_setup'] = $_POST['admin_setup'];
							}
							else
							{
								$zugriffsrechte_array['admin_setup'] = 'n';
							}

							if (isset($_POST['admin_log']))
							{
								$zugriffsrechte_array ['admin_log'] = $_POST['admin_log'];
							}
							else
							{
								$zugriffsrechte_array ['admin_log'] = 'n';
							}

							if (isset($_POST['user_all']))
							{
								$zugriffsrechte_array ['user_all'] = $_POST['user_all'];
							}
							else
							{
								$zugriffsrechte_array ['user_all'] = 'n';
							}


							if ($access->update_group($_POST['groupid_int'], $_POST['bezeichnung'], $zugriffsrechte_array ))
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_groups';
	} // ende benutzergruppen und zugriffsrechte bearbeiten
	// benutzergruppen hinzufuegen
	elseif ($_POST['job_string'] == 'group_add')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;

					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						$zugriffsrechte_array = array();

						if (isset($_POST['admin_reisekosten']))
						{
							$zugriffsrechte_array ['admin_reisekosten'] = $_POST['admin_reisekosten'];
						}
						else
						{
							$zugriffsrechte_array ['admin_reisekosten'] = 'n';
						}

						if (isset($_POST['admin_stz']))
						{
							$zugriffsrechte_array ['admin_stz'] = $_POST['admin_stz'];
						}
						else
						{
							$zugriffsrechte_array ['admin_stz'] = 'n';
						}

						if (isset($_POST['admin_message_write']))
						{
							$zugriffsrechte_array ['admin_message_write'] = $_POST['admin_message_write'];
						}
						else
						{
							$zugriffsrechte_array ['admin_message_write'] = 'n';
						}

						if (isset($_POST['admin_reports_read']))
						{
							$zugriffsrechte_array ['admin_reports_read'] = $_POST['admin_reports_read'];
						}
						else
						{
							$zugriffsrechte_array ['admin_reports_read'] = 'n';
						}

						if (isset($_POST['admin_reports_write']))
						{
							$zugriffsrechte_array ['admin_reports_write'] = $_POST['admin_reports_write'];
						}
						else
						{
							$zugriffsrechte_array ['admin_reports_write'] = 'n';
						}

						if (isset($_POST['admin_antrag_read']))
						{
							$zugriffsrechte_array ['admin_antrag_read'] = $_POST['admin_antrag_read'];
						}
						else
						{
							$zugriffsrechte_array ['admin_antrag_read'] = 'n';
						}

						if (isset($_POST['admin_antrag_write']))
						{
							$zugriffsrechte_array ['admin_antrag_write'] = $_POST['admin_antrag_write'];
						}
						else
						{
							$zugriffsrechte_array ['admin_antrag_write'] = 'n';
						}

						if (isset($_POST['admin_user_read']))
						{
							$zugriffsrechte_array ['admin_user_read'] = $_POST['admin_user_read'];
						}
						else
						{
							$zugriffsrechte_array ['admin_user_read'] = 'n';
						}

						if (isset($_POST['admin_user_write']))
						{
							$zugriffsrechte_array ['admin_user_write'] = $_POST['admin_user_write'];
						}
						else
						{
							$zugriffsrechte_array ['admin_user_write'] = 'n';
						}

						if (isset($_POST['admin_project_read']))
						{
							$zugriffsrechte_array ['admin_project_read'] = $_POST['admin_project_read'];
						}
						else
						{
							$zugriffsrechte_array ['admin_project_read'] = 'n';
						}

						if (isset($_POST['admin_project_write']))
						{
							$zugriffsrechte_array ['admin_project_write'] = $_POST['admin_project_write'];
						}
						else
						{
							$zugriffsrechte_array ['admin_project_write'] = 'n';
						}

						if (isset($_POST['admin_backup']))
						{
							$zugriffsrechte_array ['admin_backup'] = $_POST['admin_backup'];
						}
						else
						{
							$zugriffsrechte_array ['admin_backup'] = 'n';
						}

						if (isset($_POST['admin_setup']))
						{
							$zugriffsrechte['admin_setup'] = $_POST['admin_setup'];
						}
						else
						{
							$zugriffsrechte_array ['admin_setup'] = 'n';
						}

						if (isset($_POST['admin_log']))
						{
							$zugriffsrechte_array ['admin_log'] = $_POST['admin_log'];
						}
						else
						{
							$zugriffsrechte_array ['admin_log'] = 'n';
						}

						if (isset($_POST['user_all']))
						{
							$zugriffsrechte_array ['user_all'] = $_POST['user_all'];
						}
						else
						{
							$zugriffsrechte_array ['user_all'] = 'n';
						}

						if ($access->insert_group($_POST['bezeichnung'], $zugriffsrechte_array ))
						{
							$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_groups';
	} // ende benutzergruppen hinzufuegen
	// benutzergruppen loeschen
	elseif ($_POST['job_string'] == 'group_del')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					if (is_numeric($_POST['groupid_int']))
					{
						if ($cdb->select("DELETE FROM hdb_usergroups WHERE group_id='".$_POST['groupid_int']."' LIMIT 1"))
						{
							if ($cdb->get_affected_rows() == 1)
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'del_ok'); /*Der Datensatz wurde geloescht.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_groups';
	} // ende benutzergruppen loeschen
	// auto-backup-einstellungen bearbeiten
	elseif ($_POST['job_string'] == 'edit_backup_setup')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// email-adressen aus freitexteingabe
					if (!empty($_POST['email_recipients']))
					{
						$backup_email_recipients = $_POST['email_recipients'];
					}
					else
					{
						$backup_email_recipients = '';
					}

					// backup-zeiten als array aufbereiten
					$backup_array = array();

					if (isset($_POST['auto_backup']) && is_array($_POST['auto_backup']) && count($_POST['auto_backup']) > 0)
					{
						foreach ($_POST['auto_backup'] as $array_key => $array_value)
						{
							$backup_array[$array_key] = $array_value;
						}
					}

					if (!isset($backup_array['Mo']['uhrzeit1'])){$backup_array['Mo']['uhrzeit1'] = '';}
					if (!isset($backup_array['Mo']['uhrzeit2'])){$backup_array['Mo']['uhrzeit2'] = '';}
					if (!isset($backup_array['Mo']['uhrzeit3'])){$backup_array['Mo']['uhrzeit3'] = '';}

					if (!isset($backup_array['Di']['uhrzeit1'])){$backup_array['Di']['uhrzeit1'] = '';}
					if (!isset($backup_array['Di']['uhrzeit2'])){$backup_array['Di']['uhrzeit2'] = '';}
					if (!isset($backup_array['Di']['uhrzeit3'])){$backup_array['Di']['uhrzeit3'] = '';}

					if (!isset($backup_array['Mi']['uhrzeit1'])){$backup_array['Mi']['uhrzeit1'] = '';}
					if (!isset($backup_array['Mi']['uhrzeit2'])){$backup_array['Mi']['uhrzeit2'] = '';}
					if (!isset($backup_array['Mi']['uhrzeit3'])){$backup_array['Mi']['uhrzeit3'] = '';}

					if (!isset($backup_array['Do']['uhrzeit1'])){$backup_array['Do']['uhrzeit1'] = '';}
					if (!isset($backup_array['Do']['uhrzeit2'])){$backup_array['Do']['uhrzeit2'] = '';}
					if (!isset($backup_array['Do']['uhrzeit3'])){$backup_array['Do']['uhrzeit3'] = '';}

					if (!isset($backup_array['Fr']['uhrzeit1'])){$backup_array['Fr']['uhrzeit1'] = '';}
					if (!isset($backup_array['Fr']['uhrzeit2'])){$backup_array['Fr']['uhrzeit2'] = '';}
					if (!isset($backup_array['Fr']['uhrzeit3'])){$backup_array['Fr']['uhrzeit3'] = '';}

					if (!isset($backup_array['Sa']['uhrzeit1'])){$backup_array['Sa']['uhrzeit1'] = '';}
					if (!isset($backup_array['Sa']['uhrzeit2'])){$backup_array['Sa']['uhrzeit2'] = '';}
					if (!isset($backup_array['Sa']['uhrzeit3'])){$backup_array['Sa']['uhrzeit3'] = '';}

					if (!isset($backup_array['So']['uhrzeit1'])){$backup_array['So']['uhrzeit1'] = '';}
					if (!isset($backup_array['So']['uhrzeit2'])){$backup_array['So']['uhrzeit2'] = '';}
					if (!isset($backup_array['So']['uhrzeit3'])){$backup_array['So']['uhrzeit3'] = '';}


					if (isset($_POST['auto_backup_master_zeit1']))
					{
						$backup_array['daily']['uhrzeit1'] = $_POST['auto_backup_master_zeit1'];
					}
					else
					{
						$backup_array['daily']['uhrzeit1'] = '';
					}

					if (isset($_POST['auto_backup_master_zeit2']))
					{
						$backup_array['daily']['uhrzeit2'] = $_POST['auto_backup_master_zeit2'];
					}
					else
					{
						$backup_array['daily']['uhrzeit2'] = '';
					}

					if (isset($_POST['auto_backup_master_zeit3']))
					{
						$backup_array['daily']['uhrzeit3'] = $_POST['auto_backup_master_zeit3'];
					}
					else
					{
						$backup_array['daily']['uhrzeit3'] = '';
					}


					ksort($backup_array['Mo']);
					ksort($backup_array['Di']);
					ksort($backup_array['Mi']);
					ksort($backup_array['Do']);
					ksort($backup_array['Fr']);
					ksort($backup_array['Sa']);
					ksort($backup_array['So']);

					// setup-array aktualisieren
					$setup_array = array(
										'auto_backup_aktiv' => $_POST['auto_backup_aktiv'],
										'auto_backup' => $backup_array,
										'backup_mail_senden' => $_POST['backup_mail_senden'],
										'backup_mail_recipients' => $backup_email_recipients
										);

					if ($setup->update_setup($setup_array))
					{
						$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = '';
	} // ENDE auto-backup-einstellungen bearbeiten
	// feiertag(e) hinzufuegen (vordefinierte feiertage)
	elseif ($_POST['job_string'] == 'add_ft_default')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;

					if (!isset($_POST['default_key']) or empty($_POST['default_key'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						if ($cdb->insert("INSERT INTO hdb_feiertage (default_array_key,type) VALUES ('".$_POST['default_key']."','default')"))
						{
							if ($cdb->get_affected_rows() == 1)
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'insert_ok'); /*Der Datensatz wurde eingetragen.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ft';
	} // ENDE feiertag(e) hinzufuegen (vordefinierte feiertage)
	// feiertag hinzufuegen (fester, unbeweglicher feiertag)
	elseif ($_POST['job_string'] == 'add_ft_fest')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;

					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfelder++;}
					if (!isset($_POST['feiertag_monat']) or empty($_POST['feiertag_monat'])){$pflichtfelder++;}
					if (!isset($_POST['feiertag_tag']) or empty($_POST['feiertag_tag'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						// pruefen, ob dieses datum bereits als feiertag eingetragen wurde
						if (!$kal->is_holiday(date("Y").'-'.$_POST['feiertag_monat'].'-'.$_POST['feiertag_tag'],'','date'))
						{
							if ($cdb->insert("INSERT INTO hdb_feiertage (bezeichnung,monat,tag,type) VALUES ('".$_POST['bezeichnung']."','".$_POST['feiertag_monat']."','".$_POST['feiertag_tag']."','annual')"))
							{
								if ($cdb->get_affected_rows() == 1)
								{
									$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'insert_ok'); /*Der Datensatz wurde eingetragen.*/
								}
								else
								{
									$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
								}
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('706', 'return', 'decode_on') /*fuer das angegebene Datum existiert bereits ein Feiertag.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ft';
	} // ENDE feiertag hinzufuegen (fester, unbeweglicher feiertag)
	// feiertag hinzufuegen (bewegliche feiertage - einmaliger eintrag)
	elseif ($_POST['job_string'] == 'add_ft_beweglich')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;

					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfelder++;}
					if (!isset($_POST['datum']) or empty($_POST['datum'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						// datum aufsplitten
						$datum_string 		= $kal->free_to_iso($_POST['datum']);
						$temp_datum_array 	= explode('-', $datum_string);
						$jahr 				= $temp_datum_array[0];
						$monat 				= $temp_datum_array[1];
						$tag 				= $temp_datum_array[2];

						// pruefen, ob dieses datum bereits als feiertag eingetragen wurde
						if (!$kal->is_holiday($jahr.'-'.$monat.'-'.$tag, '', 'date'))
						{
							if ($cdb->insert("INSERT INTO hdb_feiertage (bezeichnung,jahr,monat,tag,type) VALUES ('".$_POST['bezeichnung']."','".$jahr."','".$monat."','".$tag."','unique')"))
							{
								if ($cdb->get_affected_rows() == 1)
								{
									$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'insert_ok'); /*Der Datensatz wurde eingetragen.*/
								}
								else
								{
									$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
								}
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('706', 'return', 'decode_on') /*fuer das angegebene Datum existiert bereits ein Feiertag.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ft';
	} // ENDE feiertag hinzufuegen (bewegliche feiertage - einmaliger eintrag)
	// halben arbeitstag hinzufuegen (fester, unbeweglicher tag)
	elseif ($_POST['job_string'] == 'add_halbtag_fest')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;

					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfelder++;}
					if (!isset($_POST['feiertag_monat']) or empty($_POST['feiertag_monat'])){$pflichtfelder++;}
					if (!isset($_POST['feiertag_tag']) or empty($_POST['feiertag_tag'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						// pruefen, ob dieses datum bereits als feiertag eingetragen wurde
						if (!$kal->is_holiday(date("Y").'-'.$_POST['feiertag_monat'].'-'.$_POST['feiertag_tag'],'','date'))
						{
							if ($cdb->insert("INSERT INTO hdb_feiertage (bezeichnung,monat,tag,type,halbe_sollstunden) VALUES ('".$_POST['bezeichnung']."','".$_POST['feiertag_monat']."','".$_POST['feiertag_tag']."','annual','j')"))
							{
								if ($cdb->get_affected_rows() == 1)
								{
									$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'insert_ok'); /*Der Datensatz wurde eingetragen.*/
								}
								else
								{
									$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
								}
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('706', 'return', 'decode_on') /*fuer das angegebene Datum existiert bereits ein Feiertag.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ft';
	} // ENDE halben arbeitstag hinzufuegen (fester, unbeweglicher tag)
	// feiertag bearbeiten (fester, unbeweglicher feiertag)
	elseif ($_POST['job_string'] == 'edit_ft_fest')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;
					if (!isset($_POST['ftid_int']) or !is_numeric($_POST['ftid_int'])){$pflichtfelder++;}
					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfelder++;}
					if (!isset($_POST['feiertag_monat']) or empty($_POST['feiertag_monat'])){$pflichtfelder++;}
					if (!isset($_POST['feiertag_tag']) or empty($_POST['feiertag_tag'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						$sql = $cdb->select("SELECT ft_id FROM hdb_feiertage WHERE ft_id=".$_POST['ftid_int']." AND type='annual'");
						$result = $cdb->fetch_array($sql);

						if (isset($result['ft_id']) and $result['ft_id'] > 0)
						{
							if ($cdb->update("UPDATE hdb_feiertage SET bezeichnung='".$_POST['bezeichnung']."', monat='".$_POST['feiertag_monat']."', tag='".$_POST['feiertag_tag']."' WHERE ft_id='".$_POST['ftid_int']."' LIMIT 1"))
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('706', 'return', 'decode_on') /*fuer das angegebene Datum existiert bereits ein Feiertag oder ein Arbeitstag mit...*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ft';
	} // ENDE feiertag bearbeiten (fester, unbeweglicher feiertag)
	// feiertag bearbeiten (bewegliche feiertage - einmaliger eintrag)
	elseif ($_POST['job_string'] == 'edit_ft_beweglich')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;
					if (!isset($_POST['ftid_int']) or !is_numeric($_POST['ftid_int'])){$pflichtfelder++;}
					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfelder++;}
					if (!isset($_POST['datum']) or empty($_POST['datum'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						// datum aufsplitten
						$datum_string 		= $kal->free_to_iso($_POST['datum']);
						$temp_datum_array 	= explode("-", $datum_string);
						$jahr 				= $temp_datum_array[0];
						$monat 				= $temp_datum_array[1];
						$tag 				= $temp_datum_array[2];

						$sql = $cdb->select("SELECT ft_id FROM hdb_feiertage WHERE ft_id=".$_POST['ftid_int']." AND type='unique'");
						$result = $cdb->fetch_array($sql);

						if (isset($result['ft_id']) and $result['ft_id'] > 0)
						{
							if ($cdb->update("UPDATE hdb_feiertage SET bezeichnung='".$_POST['bezeichnung']."', jahr='".$jahr."', monat='".$monat."', tag='".$tag."' WHERE ft_id='".$_POST['ftid_int']."' LIMIT 1"))
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('706', 'return', 'decode_on') /*fuer das angegebene Datum existiert bereits ein Feiertag oder ein Arbeitstag mit...*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ft';
	} // ENDE feiertag bearbeiten (bewegliche feiertage - einmaliger eintrag)
	// halben arbeitstag bearbeiten (fester, unbeweglicher tag)
	elseif ($_POST['job_string'] == 'edit_halbtag_fest')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;
					if (!isset($_POST['ftid_int']) or !is_numeric($_POST['ftid_int'])){$pflichtfelder++;}
					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfelder++;}
					if (!isset($_POST['feiertag_monat']) or empty($_POST['feiertag_monat'])){$pflichtfelder++;}
					if (!isset($_POST['feiertag_tag']) or empty($_POST['feiertag_tag'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						$sql = $cdb->select("SELECT ft_id FROM hdb_feiertage WHERE ft_id=".$_POST['ftid_int']." AND type='annual'");
						$result = $cdb->fetch_array($sql);

						if (isset($result['ft_id']) and $result['ft_id'] > 0)
						{
							if ($cdb->update("UPDATE hdb_feiertage SET bezeichnung='".$_POST['bezeichnung']."', monat='".$_POST['feiertag_monat']."', tag='".$_POST['feiertag_tag']."' WHERE ft_id='".$_POST['ftid_int']."' LIMIT 1"))
							{
								if ($cdb->get_affected_rows() == 1)
								{
									$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
								}
								else
								{
									$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
								}
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('706', 'return', 'decode_on') /*fuer das angegebene Datum existiert bereits ein Feiertag oder ein Arbeitstag mit...*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ft';
	} // ENDE halben arbeitstag bearbeiten (fester, unbeweglicher tag)
	// feiertag/halben arbeitstag loeschen
	elseif ($_POST['job_string'] == 'del_ft')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;
					if (!isset($_POST['ftid_int']) or !is_numeric($_POST['ftid_int'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						if ($cdb->delete("DELETE FROM hdb_feiertage WHERE ft_id='".$_POST['ftid_int']."' LIMIT 1"))
						{
							if ($cdb->get_affected_rows() == 1)
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'del_ok'); /*Der Datensatz wurde geloescht.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ft';
	} // ENDE feiertag/halben arbeitstag loeschen
	// abwesenheitsgrund hinzufuegen
	elseif ($_POST['job_string'] == 'add_awg')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;
					if (!isset($_POST['absence_name_string']) or empty($_POST['absence_name_string'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						if (!isset($_POST['working_time_int']))
						{
							$_POST['working_time_int'] = 0;
						}
						if (!isset($_POST['paid_int']))
						{
							$_POST['paid_int'] = 0;
						}
						if (!isset($_POST['total_day_int']))
						{
							$_POST['total_day_int'] = 0;
						}
						if (!isset($_POST['application_int']))
						{
							$_POST['application_int'] = 0;
						}
						if (!isset($_POST['approval_int']))
						{
							$_POST['approval_int'] = 0;
						}
						if ($_POST['application_int'] == 0)
						{
							$_POST['approval_int'] = 0;
						}
						if (!isset($_POST['absence_color_string']))
						{
							if ($_POST['application_int'] == 0)
							{
								$_POST['absence_color_string'] = '';
							}
							else
							{
								$_POST['absence_color_string'] = '000000';
							}
						}

						if ($cdb->delete("INSERT INTO hdb_absence_type (absence_name, working_time, paid, total_day, application, approval, color) VALUES ('".$_POST['absence_name_string']."', ".$_POST['working_time_int'].", ".$_POST['paid_int'].", ".$_POST['total_day_int'].", ".$_POST['application_int'].", ".$_POST['approval_int'].", '".$_POST['absence_color_string']."')"))
						{
							if ($cdb->get_affected_rows() == 1)
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'insert_ok'); /*Der Datensatz wurde eingetragen.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_awg';
	} // ENDE abwesenheitsgrund hinzufuegen
	// abwesenheitsgrund bearbeiten
	elseif ($_POST['job_string'] == 'edit_awg')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;
					if (!isset($_POST['absence_id_int']) or !is_numeric($_POST['absence_id_int'])){$pflichtfelder++;}
					if (!isset($_POST['absence_name_string']) or empty($_POST['absence_name_string'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						if (!isset($_POST['working_time_int']))
						{
							$_POST['working_time_int'] = 0;
						}
						if (!isset($_POST['paid_int']))
						{
							$_POST['paid_int'] = 0;
						}
						if (!isset($_POST['total_day_int']))
						{
							$_POST['total_day_int'] = 0;
						}
						if (!isset($_POST['application_int']))
						{
							$_POST['application_int'] = 0;
						}
						if (!isset($_POST['approval_int']))
						{
							$_POST['approval_int'] = 0;
						}
						if ($_POST['application_int'] == 0)
						{
							$_POST['approval_int'] = 0;
						}
						if (!isset($_POST['absence_color_string']))
						{
							if ($_POST['application_int'] == 0)
							{
								$_POST['absence_color_string'] = '';
							}
							else
							{
								$_POST['absence_color_string'] = '000000';
							}
						}

						if ($cdb->delete("UPDATE hdb_absence_type SET absence_name='".$_POST['absence_name_string']."',
																	working_time=".$_POST['working_time_int'].",
																	paid=".$_POST['paid_int'].",
																	total_day=".$_POST['total_day_int'].",
																	application=".$_POST['application_int'].",
																	approval=".$_POST['approval_int'].",
																	color='".$_POST['absence_color_string']."'
																	WHERE absence_type_id=".$_POST['absence_id_int']." LIMIT 1"))
						{
							if ($cdb->get_affected_rows() == 1)
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_awg';
	} // ENDE abwesenheitsgrund bearbeiten
	// abwesenheitsgrund loeschen
	elseif ($_POST['job_string'] == 'del_awg')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;
					if (!isset($_POST['absence_id_int']) or !is_numeric($_POST['absence_id_int'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						if ($cdb->delete('UPDATE hdb_absence_type SET display=0 WHERE absence_type_id='.$_POST['absence_id_int'].' LIMIT 1'))
						{
							if ($cdb->get_affected_rows() == 1)
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'del_ok'); /*Der Datensatz wurde geloescht.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_awg';
	} // ENDE abwesenheitsgrund loeschen
	// einstellungen/stz bearbeiten
	elseif ($_POST['job_string'] == 'edit_setup_stz')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				// setup-array
				$setup_array = array('stz_editierbar_bis'	=>	$_POST['stz_editierbar_bis'],
									'stz_pausenminuten'		=>	$_POST['stz_pausenminuten'],
									'stz_report_mehr_als'	=>	$_POST['stz_report_mehr_als'],
									'stz_report_nach'		=>	$_POST['stz_report_nach'],
									'stz_report_vor'		=>	$_POST['stz_report_vor'],
									'stz_round_time'		=>	$_POST['stz_round_time']);

				if ($setup->update_setup($setup_array))
				{
					$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'main';
	} // ende einstellungen/stz bearbeiten
	// mitarbeiterstatus hinzufugen
	elseif ($_POST['job_string'] == 'add_mas')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;

					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						if ($cdb->insert("INSERT INTO hdb_ma_status (status) VALUES ('".$_POST['bezeichnung']."')"))
						{
							if ($cdb->get_affected_rows() == 1)
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'insert_ok'); /*Der Datensatz wurde eingetragen.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ma_sq';
	} // ENDE mitarbeiterstatus hinzufuegen
	// mitarbeiterstatus loeschen
	elseif ($_POST['job_string'] == 'del_mas')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0 and is_numeric($_POST['mastatus_id']))
			{
				if ($cdb->delete("DELETE FROM hdb_ma_status WHERE mastatus_id='".$_POST['mastatus_id']."' LIMIT 1"))
				{
					$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'del_ok'); /*Der Datensatz wurde geloescht.*/
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ma_sq';
	} // ENDE mitarbeiterstatus loeschen
	// mitarbeiterstatus bearbeiten
	elseif ($_POST['job_string'] == 'edit_mas')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;

					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfelder++;}
					if (!isset($_POST['masid_int']) or !is_numeric($_POST['masid_int'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						if ($cdb->update("UPDATE hdb_ma_status SET status='".$_POST['bezeichnung']."' WHERE mastatus_id='".$_POST['masid_int']."' LIMIT 1"))
						{
							if ($cdb->get_affected_rows() == 1)
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ma_sq';
	} // ENDE mitarbeiterstatus bearbeiten
	// qualifikation hinzufuegen
	elseif ($_POST['job_string'] == 'add_maq')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;

					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfelder++;}
					if (!isset($_POST['min_headcount_int']) or !is_numeric($_POST['min_headcount_int'])) {$_POST['min_headcount_int'] = 0;}
					if (!isset($_POST['critical_headcount_int']) or !is_numeric($_POST['critical_headcount_int'])) {$_POST['critical_headcount_int'] = 0;}

					if ($pflichtfelder == 0)
					{
						if ($cdb->insert("INSERT INTO hdb_qualifikation (qualifikation , min_headcount, critical_headcount) VALUES ('".$_POST['bezeichnung']."', ".$_POST['min_headcount_int'].", ".$_POST['critical_headcount_int'].")"))
						{
							if ($cdb->get_affected_rows() == 1)
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'insert_ok'); /*Der Datensatz wurde eingetragen.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ma_sq';
	} // ENDE qualifikation hinzufuegen
	// qualifikation bearbeiten
	elseif ($_POST['job_string'] == 'edit_maq')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;

					if (!isset($_POST['bezeichnung']) or empty($_POST['bezeichnung'])){$pflichtfelder++;}
					if (!isset($_POST['qid_int']) or !is_numeric($_POST['qid_int'])){$pflichtfelder++;}
					if (!isset($_POST['min_headcount_int']) or !is_numeric($_POST['min_headcount_int'])) {$_POST['min_headcount_int'] = 0;}
					if (!isset($_POST['critical_headcount_int']) or !is_numeric($_POST['critical_headcount_int'])) {$_POST['critical_headcount_int'] = 0;}

					if ($pflichtfelder == 0)
					{
						if ($cdb->update("UPDATE hdb_qualifikation SET
										qualifikation='".$_POST['bezeichnung']."',
										min_headcount='".$_POST['min_headcount_int']."',
										critical_headcount='".$_POST['critical_headcount_int']."'
										WHERE quali_id='".$_POST['qid_int']."' LIMIT 1"))
						{
							if ($cdb->get_affected_rows() == 1)
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ma_sq';
	} // ENDE qualifikation bearbeiten
	//Mitarbeiter einer Quali zuordnen
	elseif ($_POST['job_string'] == 'add_user_maq')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Checksumme
				if ($chk_sum->Chk($_POST['VCS']))
				{
					// Pflichtfeldpruefung
					$pflichtfelder = 0;

					if (!isset($_POST['qid_int']) or empty($_POST['qid_int'])){$pflichtfelder++;}
					if (!isset($_POST['uid_int']) or empty($_POST['uid_int'])){$pflichtfelder++;}

					if ($pflichtfelder == 0)
					{
						if ($cdb->insert("INSERT INTO hdb_user_qualifikation (user_id, quali_id) VALUES (".$_POST['uid_int'].", ".$_POST['qid_int'].")"))
						{
							if ($cdb->get_affected_rows() == 1)
							{
								$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'insert_ok'); /*Der Datensatz wurde eingetragen.*/
							}
							else
							{
								$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
							}
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'maq_user_edit';
	}
	//mitarbeiter Qualifikationszuordnung loeschen
	elseif ($_POST['job_string'] == 'del_user_maq')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				// Pflichtfeldpruefung
				$pflichtfelder = 0;

				if (!isset($_POST['qid_int']) or empty($_POST['qid_int'])){$pflichtfelder++;}
				if (!isset($_POST['userid_int']) or empty($_POST['userid_int'])){$pflichtfelder++;}

				if ($pflichtfelder == 0)
				{
					if ($cdb->delete('DELETE FROM hdb_user_qualifikation WHERE user_id='.$_POST['userid_int'].' AND quali_id='.$_POST['qid_int'].' LIMIT 1'))
					{
						$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'del_ok'); /*Der Datensatz wurde geloescht.*/
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'maq_user_edit';
	}
	// qualifikation loeschen
	elseif ($_POST['job_string'] == 'del_maq')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST Daten pruefen
			if ($chk_var->error_count_int == 0 and is_numeric($_POST['qid_int']))
			{
				if ($cdb->delete("DELETE FROM hdb_qualifikation WHERE quali_id='".$_POST['qid_int']."' LIMIT 1"))
				{
					$cdb->delete('DELETE FROM hdb_user_qualifikation WHERE quali_id='.$_POST['qid_int']);

					$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'del_ok'); /*Der Datensatz wurde geloescht.*/
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'setup_ma_sq';
	} // ENDE qualifikation loeschen
	// edit_mail_setup
	elseif ($_POST['job_string'] == 'edit_mail_setup')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			$required_data = 0;

			$array_email_recipients_project_report = array();

			// empfaengerliste aufbereiten, wenn erforderlich
			if (is_array($_POST['project_report_mitarbeiter_ids']) && count($_POST['project_report_mitarbeiter_ids']) > 0)
			{
				foreach ($_POST['project_report_mitarbeiter_ids'] as $array_index => $user_id)
				{
					if (is_numeric($user_id))
					{
						$sql = $cdb->select("SELECT t1.user_id,t1.email AS user_mail FROM hdb_user t1 WHERE t1.user_id='".$user_id."'");
						$result = $cdb->fetch_array($sql);

						$array_email_recipients_project_report[] = array('email' => $result['user_mail'], 'type' => 'from_userlist', 'user_id' => $result['user_id']);
					}
				}
			}

			// email-adressen aus freitexteingabe ergaenzen
			if (!empty($_POST['project_report_email_recipients']))
			{
				$array_email_recipients_project_report[] = array('email' => $_POST['project_report_email_recipients'], 'type' => 'free_input', 'user_id' => '');
			}

			// empfaengerliste serialisieren
			$array_recipients_project_report = @serialize($array_email_recipients_project_report);

			$array_email_recipients = array();

			// empfaengerliste aufbereiten, wenn erforderlich
			if (is_array($_POST['mitarbeiter_ids']) && count($_POST['mitarbeiter_ids']) > 0)
			{
				foreach ($_POST['mitarbeiter_ids'] as $array_index => $user_id)
				{
					if (is_numeric($user_id))
					{
						$sql = $cdb->select("SELECT t1.user_id,t1.email AS user_mail FROM hdb_user t1 WHERE t1.user_id='".$user_id."'");
						$result = $cdb->fetch_array($sql);

						$array_email_recipients[] = array('email' => $result['user_mail'], 'type' => 'from_userlist', 'user_id' => $result['user_id']);
					}
				}
			}

			// email-adressen aus freitexteingabe ergaenzen
			if (!empty($_POST['email_recipients']))
			{
				$array_email_recipients[] = array('email' => $_POST['email_recipients'], 'type' => 'free_input', 'user_id' => '');
			}

			// empfaengerliste serialisieren
			$array_recipients = @serialize($array_email_recipients);

			$setup_array = array();

			// Versandeinstellungen fuer die E-Mailklasse

			//Absenderemailadresse
			if (isset($_POST['email_from_string']) and !empty($_POST['email_from_string']))
			{
				$setup_array['email_from'] = $_POST['email_from_string'];
			}
			else
			{
				$setup_array['email_from'] = '';
				$required_data++;
			}
			//Absendername
			if (isset($_POST['email_fromname_string']) and !empty($_POST['email_fromname_string']))
			{
				$setup_array['email_fromname'] = $_POST['email_fromname_string'];
			}
			else
			{
				$setup_array['email_fromname'] = '';
				$required_data++;
			}
			//Email Alternativer Body bei HTML Mails
			if (isset($_POST['email_altbody_string']) and !empty($_POST['email_altbody_string']))
			{
				$setup_array['email_altbody'] = $_POST['email_altbody_string'];
			}
			else
			{
				$setup_array['email_altbody'] = '';
				$required_data++;
			}
			//Absendetyp sendmail oder smto
			if (isset($_POST['email_sendtype_string']) and !empty($_POST['email_sendtype_string']))
			{
				$setup_array['email_sendtype'] = $_POST['email_sendtype_string'];
			}
			else
			{
				$setup_array['email_sendtype'] = 'sendmail';
			}

			//Sendmail als Postausgang verwenden
			if ($setup_array['email_sendtype'] == 'sendmail')
			{
				if (isset($_POST['email_sendmailpfad_string']) and !empty($_POST['email_sendmailpfad_string']))
				{
					$setup_array['email_sendmailpfad'] = $_POST['email_sendmailpfad_string'];
				}
				else
				{
					$setup_array['email_sendmailpfad'] = '';
					$required_data++;
				}

				//SMTP Einstellungen koennen leer sein
				$setup_array['email_smtpserver'] = '';
				$setup_array['email_smtpport'] = '';
				$setup_array['email_smtpsecure'] = '';
				$setup_array['email_smtpauth'] = '';
				$setup_array['email_smtpuser'] = '';
				$setup_array['email_smtppw'] = '';
			}
			//SMTP als Postausgang verwenden
			else
			{
				//Sendmailpfad kann leer bleiben
				$setup_array['email_sendmailpfad'] = '';
				//SMTP Server
				if (isset($_POST['email_smtpserver_string']) and !empty($_POST['email_smtpserver_string']))
				{
					$setup_array['email_smtpserver'] = $_POST['email_smtpserver_string'];
				}
				else
				{
					$setup_array['email_smtpserver'] = '';
					$required_data++;
				}
				// SMTP Port
				if (isset($_POST['email_smtpport_int']) and !empty($_POST['email_smtpport_int']))
				{
					$setup_array['email_smtpport'] = $_POST['email_smtpport_int'];
				}
				else
				{
					$setup_array['email_smtpport'] = '';
					$required_data++;
				}
				//SMTP Sicherheitseinstellungen
				if (isset($_POST['email_smtpsecure_string']) and !empty($_POST['email_smtpsecure_string']))
				{
					$setup_array['email_smtpsecure'] = $_POST['email_smtpsecure_string'];
				}
				else
				{
					$setup_array['email_smtpsecure'] = '';
				}
				//SMTP-Authentication
				if (isset($_POST['email_smtpauth_int']) and $_POST['email_smtpauth_int'] == 1)
				{
					$setup_array['email_smtpauth'] = true;
					//SMTP Benutzername
					if (isset($_POST['email_smtpuser_string']) and !empty($_POST['email_smtpuser_string']))
					{
						$setup_array['email_smtpuser'] = $_POST['email_smtpuser_string'];
					}
					else
					{
						$setup_array['email_smtpuser'] = '';
						$required_data++;
					}
					//SMTP Passwort
					if (isset($_POST['email_smtppw_string']) and !empty($_POST['email_smtppw_string']))
					{
						$setup_array['email_smtppw'] = $_POST['email_smtppw_string'];
					}
					else
					{
						$setup_array['email_smtppw'] = '';
						$required_data++;
					}
				}
				else
				{
					$setup_array['email_smtpauth'] = false;
				}
			}

			//FIXME: pflichtfeldpruefung auskommentiert, da fehlerhaft
			if(1==1)
			//if ($required_data == 0)
			{
				// setup-array aktualisieren
				$setup_array += array(
									'email_notification_project_report'	=> $_POST['project_report_email_notification'],
									'email_recipients_project_report'	=> $array_recipients_project_report,
									'email_notification'				=> $_POST['email_notification'],
									'email_recipients'					=> $array_recipients,
									'send_genehmigung'					=> $_POST['send_genehmigung'],
									'send_ablehnung'					=> $_POST['send_ablehnung'],
									'text_genehmigung'					=> $_POST['text_genehmigung'],
									'text_ablehnung'					=> $_POST['text_ablehnung']
									);

				if ($setup->update_setup($setup_array))
				{
					$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_pflichtfelder') /*Bitte fuellen Sie alle Pflichtfelder aus.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'main';
	} // ENDE edit_mail_setup
	//Downloadbereich DMS Einstellungen
	elseif ($_POST['job_string'] == 'edit_dms_setup')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//gegebenenfalls / am ende entfernen
				$_POST['dms_url'] = trim($_POST['dms_url']);
				if (substr($_POST['dms_url'], -1) == '/')
				{
					$_POST['dms_url'] = substr($_POST['dms_url'], 0, -1);
				}

				if (!isset($_POST['dms_project']))
				{
					$_POST['dms_project'] = array();
				}

				// setup-array
				$setup_array = array('dms_url'		=>	$_POST['dms_url'],
									'dms_projects'	=>	$_POST['dms_project'],
									'dms_user'		=>	$_POST['dms_user'],
									'dms_pw'		=>	$_POST['dms_pw']);

				if ($setup->update_setup($setup_array))
				{
					$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'main';
	}

	// spracheinstellungen bearbeiten (admin-sprachverwaltung)
	elseif ($_POST['job_string'] == 'edit_setup_spr')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				if (!isset($_POST['spr_enabled']) or !is_array($_POST['spr_enabled']))
				{
					$_POST['spr_enabled'] = array();
				}

				// temp. variable zum pruefen, ob alle updates erfolgreich waren
				$count_update_fehler = 0;

				// temp. array zum zwischenspeichern aller sprachen, die deaktiviert werden sollen
				$array_disable_sprache = array();

				// alle sprachen auslesen (ausser den sprachen, die IMMER aktiviert sein sollen)
				$sql_sprachen = $cdb->select("SELECT * FROM hdb_sprachen WHERE immer_anzeigen<>'j' ORDER BY bezeichnung ASC");
				while ($result_sprachen = $cdb->fetch_array($sql_sprachen))
				{
					if (in_array($result_sprachen['sprache_id'],$_POST['spr_enabled']))
					{
						if ($result_sprachen['anzeigen'] != 'j')
						{
							$cdb->update("UPDATE hdb_sprachen SET anzeigen='j' WHERE sprache_id='".$result_sprachen['sprache_id']."' LIMIT 1");
						}
					}
					else
					{
						$array_disable_sprache[] = $result_sprachen['sprache_id'];
						$cdb->update("UPDATE hdb_sprachen SET anzeigen='n' WHERE sprache_id='".$result_sprachen['sprache_id']."' LIMIT 1");
					}
				}

				// pruefen, ob alle zu deaktivierenden sprachen wirklich deaktiviert wurden
				foreach ($array_disable_sprache as $key => $value_sprache_id)
				{
					$sql = $cdb->select("SELECT anzeigen FROM hdb_sprachen WHERE sprache_id='".$value_sprache_id."' LIMIT 1");
					$result = $cdb->fetch_array($sql);

					if ($result['anzeigen'] != 'n')
					{
						$count_update_fehler++;
					}
					// bei allen usern, die noch eine deaktivierte sprache ausgewaehlt haben, einstellung auf hauptsprache zuruecksetzen.
					else
					{
						// wenn sich die default sprache geaendert hat, die neue sprache verwenden
						if ($_POST['default_spr'][0] != $setup_array['default_language'] && $_POST['default_spr'][0] > 0)
						{
							$cdb->update("UPDATE hdb_user SET sprache_id='".$_POST['default_spr'][0]."' WHERE sprache_id='".$value_sprache_id."'");
						}
						// sonst gespeicherte hauptsprache verwenden
						else
						{
							$cdb->update("UPDATE hdb_user SET sprache_id='".$setup_array['default_language']."' WHERE sprache_id='".$value_sprache_id."'");
						}
					}
				}

				// pruefen, ob alle zu aktivierenden sprachen wirklich aktiviert wurden
				foreach ($_POST['spr_enabled'] as $key => $value_sprache_id)
				{
					$sql = $cdb->select("SELECT anzeigen FROM hdb_sprachen WHERE sprache_id='".$value_sprache_id."' LIMIT 1");
					$result = $cdb->fetch_array($sql);

					if ($result['anzeigen'] != 'j')
					{
						$count_update_fehler++;
					}
				}

				// pruefung auswerten und meldung ausgeben
				if ($count_update_fehler == 0)
				{
					// nur ausfuehren, wenn die default sprache geaendert werden soll
					if ($_POST['default_spr'][0] != $setup_array['default_language'])
					{
						// default sprache in grundeinstellungen uebernehmen
						$setup_array['default_language'] = $_POST['default_spr'][0];

						// aenderungen im setup-array speichern
						if ($setup->update_setup($setup_array))
						{
							$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
						}
						else
						{
							$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
						}
					}
					else
					{
						$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}

			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}

		$GLOBALS['TOM_VAR']['fileinc'] = 'main';
	}
	//PDF-Einstellungen
	elseif ($_POST['job_string'] == 'edit_pdf_setup')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//default logotyp
				if (!isset($_POST['pdf_logo_typ']) or empty($_POST['pdf_logo_typ'])) {$_POST['pdf_logo_typ'] = 'a';}

				//default font
				if (!isset($_POST['pdf_font']) or empty($_POST['pdf_font'])) {$_POST['pdf_font'] = 'helvetica';}

				//default logos
				if (!isset($_POST['pdf_logo_1']) or empty($_POST['pdf_logo_1'])) {$_POST['pdf_logo_1'] = 'logo_default.jpg';}
				if (!isset($_POST['pdf_logo_2']) or empty($_POST['pdf_logo_2'])) {$_POST['pdf_logo_2'] = 'logo_default.jpg';}
				if (!isset($_POST['pdf_logo_3']) or empty($_POST['pdf_logo_3'])) {$_POST['pdf_logo_3'] = 'logo_default.jpg';}
				if (!isset($_POST['pdf_logo_4']) or empty($_POST['pdf_logo_4'])) {$_POST['pdf_logo_4'] = 'logo_default.jpg';}

				// setup-array
				$setup_array = array('pdf_logo_template'	=>	$_POST['pdf_logo_typ'],
									'pdf_logo'				=>	array($_POST['pdf_logo_1'], $_POST['pdf_logo_2'], $_POST['pdf_logo_3'], $_POST['pdf_logo_4']),
									'pdf_font'				=>	$_POST['pdf_font']);

				if ($setup->update_setup($setup_array))
				{
					$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'main';
	}
	//Webservice-Einstellungen
	elseif ($_POST['job_string'] == 'edit_webservice_setup')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				//Webservice wurde Aktiviert
				if (isset($_POST['webservice_aktiv_int']) and $_POST['webservice_aktiv_int'] == 1)
				{
					$tmp_setup_array['webservice_tom']['aktiv'] = 1;

					//funktionen vorhanden
					if (isset($_POST['webservice_functions']) and is_array($_POST['webservice_functions']) and count($_POST['webservice_functions']) > 0)
					{
						foreach ($_POST['webservice_functions'] as $function => $function_activ)
						{
							//funktion aktiviert
							if ($function_activ == 1)
							{
								$tmp_setup_array['webservice_tom']['functions'][$function] = 1;
							}
							else
							{
								$tmp_setup_array['webservice_tom']['functions'][$function] = 0;
							}
						}
					}
					//keine funktionen ausgewählt
					else
					{
						$tmp_setup_array['webservice_tom']['functions'] = array();
					}

					if (isset($_POST['webservice_ip_string']) and !empty($_POST['webservice_ip_string']))
					{
						$_POST['webservice_ip_string'] = trim($_POST['webservice_ip_string']);

						//mehrere ip adressen
						if (strpos($_POST['webservice_ip_string'], ',') !== false)
						{
							$tmp_setup_array['webservice_tom']['ip'] = array();
							$ip_array = explode(',', $_POST['webservice_ip_string']);

							foreach ($ip_array as $ip)
							{
								$ip = trim($ip);

								if (!empty($ip))
								{
									$tmp_setup_array['webservice_tom']['ip'][] = $ip;
								}
							}
						}
						//nur eine ip adresse
						else
						{
							$tmp_setup_array['webservice_tom']['ip'][] = $_POST['webservice_ip_string'];
						}
					}
					//keine ip Adressen
					else
					{
						$tmp_setup_array['webservice_tom']['ip'] = array();
					}
				}
				//Webservice wurde deaktiviert
				else
				{
					$tmp_setup_array['webservice_tom']['aktiv'] = 0;
					$tmp_setup_array['webservice_tom']['functions'] = array();
					$tmp_setup_array['webservice_tom']['ip'] = array();
				}

				$setup->del_setup_value('webservice_tom');
				if ($setup->update_setup($tmp_setup_array))
				{
					$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'main';
	}
	//LDAP-Einstellungen
	elseif ($_POST['job_string'] == 'edit_ldap_setup')
	{
		//Reloadsperre
		if (isset($_POST['reload_sperre_string']) and $reload->check($_POST['reload_sperre_string']))
		{
			//POST daten pruefen
			if ($chk_var->error_count_int == 0)
			{
				$tmp_setup_array = array();
				//Webservice wurde Aktiviert
				if (isset($_POST['active']) and $_POST['active'] == 1)
				{
					$tmp_setup_array['ldap']['active'] = true;
					if (isset($_POST['domain']) and !empty($_POST['domain']))
					{
						$domain_error = false;
						$tmp_setup_array['ldap']['domain'] = $_POST['domain'];
					}
					else
					{
						$domain_error = true;
						$tmp_setup_array['ldap']['domain'] = '';
					}

					//tom als zweit loginsystem
					if (isset($_POST['tom_login']) and $_POST['tom_login'] == 1)
					{
						$tmp_setup_array['ldap']['tom_login'] = true;
					}
					else
					{
						$tmp_setup_array['ldap']['tom_login'] = false;
					}

					//SSL
					if (isset($_POST['ssl']) and $_POST['ssl'] == 1)
					{
						$tmp_setup_array['ldap']['ssl'] = true;
					}
					else
					{
						$tmp_setup_array['ldap']['ssl'] = false;
					}

					//TLS
					if (isset($_POST['tls']) and $_POST['tls'] == 1)
					{
						$tmp_setup_array['ldap']['tls'] = true;
					}
					else
					{
						$tmp_setup_array['ldap']['tls'] = false;
					}

					//Loginnamen
					$loginname_error = true;
					if (isset($_POST['login_praefix']) and !empty($_POST['login_praefix']))
					{
						$tmp_setup_array['ldap']['loginname']['praefix'] = $_POST['login_praefix'];
					}
					else
					{
						$tmp_setup_array['ldap']['loginname']['praefix'] = '';
					}

					if (isset($_POST['user_data_1']) and !empty($_POST['user_data_1']))
					{
						$loginname_error = false;
						$tmp_setup_array['ldap']['loginname']['user_data_1'] = $_POST['user_data_1'];
					}
					else
					{
						$tmp_setup_array['ldap']['loginname']['user_data_1'] = '';
					}

					if (isset($_POST['login_separator_1']) and !empty($_POST['login_separator_1']))
					{
						$tmp_setup_array['ldap']['loginname']['separator_1'] = $_POST['login_separator_1'];
					}
					else
					{
						$tmp_setup_array['ldap']['loginname']['separator_1'] = '';
					}

					if (isset($_POST['user_data_2']) and !empty($_POST['user_data_2']))
					{
						$loginname_error = false;
						$tmp_setup_array['ldap']['loginname']['user_data_2'] = $_POST['user_data_2'];
					}
					else
					{
						$tmp_setup_array['ldap']['loginname']['user_data_2'] = '';
					}

					if (isset($_POST['login_separator_2']) and !empty($_POST['login_separator_2']))
					{
						$tmp_setup_array['ldap']['loginname']['separator_2'] = $_POST['login_separator_2'];
					}
					else
					{
						$tmp_setup_array['ldap']['loginname']['separator_2'] = '';
					}

					if (isset($_POST['user_data_3']) and !empty($_POST['user_data_3']))
					{
						$loginname_error = false;
						$tmp_setup_array['ldap']['loginname']['user_data_3'] = $_POST['user_data_3'];
					}
					else
					{
						$tmp_setup_array['ldap']['loginname']['user_data_3'] = '';
					}

					if (isset($_POST['login_suffix']) and !empty($_POST['login_suffix']))
					{
						$tmp_setup_array['ldap']['loginname']['suffix'] = $_POST['login_suffix'];
					}
					else
					{
						$tmp_setup_array['ldap']['loginname']['suffix'] = '';
					}
				}
				//LDAP wurde deaktiviert
				else
				{
					$loginname_error = false;
					$domain_error = false;

					$tmp_setup_array['ldap']['active'] = false;
					$tmp_setup_array['ldap']['domain'] = '';
					$tmp_setup_array['ldap']['tom_login'] = true;
					$tmp_setup_array['ldap']['ssl'] = true;
					$tmp_setup_array['ldap']['tls'] = true;
					$tmp_setup_array['ldap']['loginname']['praefix'] = '';
					$tmp_setup_array['ldap']['loginname']['user_data_1'] = '';
					$tmp_setup_array['ldap']['loginname']['separator_1'] = '';
					$tmp_setup_array['ldap']['loginname']['user_data_2'] = '';
					$tmp_setup_array['ldap']['loginname']['separator_2'] = '';
					$tmp_setup_array['ldap']['loginname']['user_data_3'] = '';
					$tmp_setup_array['ldap']['loginname']['suffix'] = '';
				}

				if ($domain_error == false and $loginname_error == false)
				{
					if ($setup->update_setup($tmp_setup_array))
					{
						$meldung_array['ok'][] = get_text('', 'return', 'decode_on', 'update_ok'); /*Die aenderungen wurden gespeichert.*/
					}
					else
					{
						$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
					}
				}
				else
				{
					$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler') /*Es ist ein Fehler aufgetreten.*/, WARNING, __LINE__);
				}
			}
			else
			{
				$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_variablen') /*Die Variablenpruefung ergab einen Fehler.*/, WARNING, __LINE__);
			}
		}
		else
		{
			$meldung_array['error'][] = setError(get_text('', 'return', 'decode_on', 'fehler_reloadsperre') /*Eine Reloadsperre hat das erneute Absenden der Anfrage verhindert!*/, WARNING, __LINE__);
		}
		$GLOBALS['TOM_VAR']['fileinc'] = 'main';
	}

	// refresh der Grundeinstellungen
	$setup_array = $setup->select_setup();
?>