<?php
	/**
	 * edit settings for an external document management system
	 * @package time-o-meter
	 * @subpackage setup
	 */

	$ldap = new LDAP();

	$ldap_exists = $ldap->ldap_exists();

	if (!isset($setup_array['ldap']))
	{
		$setup_array['ldap'] = array();;
	}

	if (!isset($setup_array['ldap']['active']))
	{
		$setup_array['ldap']['active'] = false;
	}

	if (!isset($setup_array['ldap']['tom_login']))
	{
		$setup_array['ldap']['tom_login'] = true;
	}

	if (!isset($setup_array['ldap']['domain']))
	{
		$setup_array['ldap']['domain'] = '';
	}

	if (!isset($setup_array['ldap']['ssl']))
	{
		$setup_array['ldap']['ssl'] = true;
	}

	if (!isset($setup_array['ldap']['tls']))
	{
		$setup_array['ldap']['tls'] = true;
	}

	if (!isset($setup_array['ldap']['loginname']['praefix']))
	{
		$setup_array['ldap']['loginname']['praefix'] = '';
	}

	if (!isset($setup_array['ldap']['loginname']['user_data_1']))
	{
		$setup_array['ldap']['loginname']['user_data_1'] = '';
	}

	if (!isset($setup_array['ldap']['loginname']['separator_1']))
	{
		$setup_array['ldap']['loginname']['separator_1'] = '';
	}

	if (!isset($setup_array['ldap']['loginname']['user_data_2']))
	{
		$setup_array['ldap']['loginname']['user_data_2'] = '';
	}

	if (!isset($setup_array['ldap']['loginname']['separator_2']))
	{
		$setup_array['ldap']['loginname']['separator_2'] = '';
	}

	if (!isset($setup_array['ldap']['loginname']['user_data_3']))
	{
		$setup_array['ldap']['loginname']['user_data_3'] = '';
	}

	if (!isset($setup_array['ldap']['loginname']['suffix']))
	{
		$setup_array['ldap']['loginname']['suffix'] = '';
	}

	if ($setup_array['ldap']['active'] == 0)
	{
		$disabled = ' disabled="disabled"';
	}
	else
	{
		$disabled = '';
	}

	$sql = $cdb->select('SELECT vorname, nachname, email, username FROM hdb_user WHERE user_id='.USER_ID);
	$result = $cdb->fetch_array($sql);

	//kein LDAP Support vorhanden
	if (!$ldap_exists)
	{
?>
		 <table cellpadding="0" cellspacing="0" border="0" width="100%">
			<tr valign="middle">
				<td class="info_table_header" width="100%"><?php get_text('', 'echo', 'decode_on', 'hinweis'); /*Hinweis*/?></td>
			</tr>
			<tr><td><img src="<?php echo TOM_ABS_URL.'template/'.$setup_array['template'].'/image/_spacer.gif'; ?>" width="1" height="4" border="0" alt="" /></td></tr>
			<tr>
				<td class="info_table_content">
					<ul><?php get_text('1067'); /*Achtung, Ihre aktuelle PHP-Konfiguration unterst&uuml;tzt keinen LDAP-Support. Wenn Sie einen LDAP-Server...*/?></ul>
				</td>
			</tr>
		</table>
		<br /><br />
<?php
	}
?>
<script type="text/javascript">
	<!--
	function set_ldap_loginname_example(return_type)
	{
		var paerfix = document.form_setup_ldap.login_praefix.value;
		var user_data_1 = document.form_setup_ldap.user_data_1.value;
		var login_separator_1 = document.form_setup_ldap.login_separator_1.value;
		var user_data_2 = document.form_setup_ldap.user_data_2.value;
		var login_separator_2 = document.form_setup_ldap.login_separator_2.value;
		var user_data_3 = document.form_setup_ldap.user_data_3.value;
		var suffix = document.form_setup_ldap.login_suffix.value;

		var first_name = '<?php echo html_entity_decode($result['vorname'], ENT_QUOTES, 'UTF-8'); ?>';
		var last_name = '<?php echo html_entity_decode($result['nachname'], ENT_QUOTES, 'UTF-8'); ?>';
		var email = '<?php echo html_entity_decode($result['email'], ENT_QUOTES, 'UTF-8'); ?>';
		var user_name = '<?php echo html_entity_decode($result['username'], ENT_QUOTES, 'UTF-8'); ?>';

		var ldap_loginname = '';

		if (paerfix != '')
		{
			ldap_loginname += paerfix;
		}

		if (user_data_1 == 'loginname')
		{
			ldap_loginname += user_name;
		}
		else if (user_data_1 == 'firstname')
		{
			ldap_loginname += first_name;
		}
		else if (user_data_1 == 'lastname')
		{
			ldap_loginname += last_name;
		}
		else if (user_data_1 == 'email')
		{
			ldap_loginname += email;
		}

		if (login_separator_1 != '')
		{
			ldap_loginname += login_separator_1;
		}

		if (user_data_2 == 'loginname')
		{
			ldap_loginname += user_name;
		}
		else if (user_data_2 == 'firstname')
		{
			ldap_loginname += first_name;
		}
		else if (user_data_2 == 'lastname')
		{
			ldap_loginname += last_name;
		}
		else if (user_data_2 == 'email')
		{
			ldap_loginname += email;
		}

		if (login_separator_2 != '')
		{
			ldap_loginname += login_separator_2;
		}

		if (user_data_3 == 'loginname')
		{
			ldap_loginname += user_name;
		}
		else if (user_data_3 == 'firstname')
		{
			ldap_loginname += first_name;
		}
		else if (user_data_3 == 'lastname')
		{
			ldap_loginname += last_name;
		}
		else if (user_data_3 == 'email')
		{
			ldap_loginname += email;
		}

		if (suffix != '')
		{
			ldap_loginname += suffix;
		}

		if (return_type == 'html')
		{
			document.getElementById('ldap_loginname').innerHTML = ldap_loginname;
		}
		else
		{
			return ldap_loginname;
		}
	}

	function active_ldap()
	{
		if (document.form_setup_ldap.active.checked == true)
		{
			document.form_setup_ldap.domain.disabled = false;
			document.form_setup_ldap.tom_login.disabled = false;
			document.form_setup_ldap.ssl[0].disabled = false;
			document.form_setup_ldap.ssl[1].disabled = false;
			document.form_setup_ldap.tls[0].disabled = false;
			document.form_setup_ldap.tls[1].disabled = false;
			document.form_setup_ldap.login_praefix.disabled = false;
			document.form_setup_ldap.user_data_1.disabled = false;
			document.form_setup_ldap.login_separator_1.disabled = false;
			document.form_setup_ldap.user_data_2.disabled = false;
			document.form_setup_ldap.login_separator_2.disabled = false;
			document.form_setup_ldap.user_data_3.disabled = false;
			document.form_setup_ldap.login_suffix.disabled = false;
		}
		else
		{
			document.form_setup_ldap.domain.disabled = true;
			document.form_setup_ldap.tom_login.disabled = true;
			document.form_setup_ldap.ssl[0].disabled = true;
			document.form_setup_ldap.ssl[1].disabled = true;
			document.form_setup_ldap.tls[0].disabled = true;
			document.form_setup_ldap.tls[1].disabled = true;
			document.form_setup_ldap.login_praefix.disabled = true;
			document.form_setup_ldap.user_data_1.disabled = true;
			document.form_setup_ldap.login_separator_1.disabled = true;
			document.form_setup_ldap.user_data_2.disabled = true;
			document.form_setup_ldap.login_separator_2.disabled = true;
			document.form_setup_ldap.user_data_3.disabled = true;
			document.form_setup_ldap.login_suffix.disabled = true;
		}
	}

	var ldap_server_chk = false;
	var ldap_login_chk = false;
	var ldap_user_chk = false;
	function ldap_server_test()
	{
		if (document.form_setup_ldap.active.checked == true)
		{
			var domain = document.form_setup_ldap.domain.value;

			var ssl = 'false';
			if (document.form_setup_ldap.ssl[0].checked == true)
			{
				ssl = 'true';
			}

			var tls = 'false';
			if (document.form_setup_ldap.tls[0].checked == true)
			{
				tls = 'true';
			}

			var ldap_login_name = set_ldap_loginname_example('return');

			var user_data_1 = document.form_setup_ldap.user_data_1.value;
			var user_data_2 = document.form_setup_ldap.user_data_2.value;
			var user_data_3 = document.form_setup_ldap.user_data_3.value;

			var separator_error = false;

			//erster und zweiter userdaten ausgewaehlt. pruefen ob trenner vorhanden ist
			if (user_data_1 != '' && user_data_2 != '')
			{
				if (document.form_setup_ldap.login_separator_1.value == '')
				{
					separator_error = true;
				}
			}

			if (user_data_2 != '' && user_data_3 != '')
			{
				if (document.form_setup_ldap.login_separator_2.value == '')
				{
					separator_error = true;
				}
			}

			if (separator_error == false)
			{
				if (domain != '')
				{
					if (ldap_login_name != '')
					{
						var pw = prompt("<?php get_text(1068, 'echo', 'decode_off'); /*Bitte geben Sie Ihr Passwort f&uuml;r den LDAP Server ein!*/?>", "");
						//XML Header erstellen
						var xmlHttp = GetXmlHttpRequest();
						if (xmlHttp)
						{
							//Abfrage
							xmlHttp.open('GET', JS_ABS_URL + 'setup/xml_ldap_test.php?domain_string=' + domain + '&ssl_string=' + ssl + '&tls_string=' + tls + '&ldap_login_name_string=' + ldap_login_name + '&pw_string=' + pw + '&user_data_1_string=' + user_data_1 + '&user_data_2_string=' + user_data_2 + '&user_data_3_string=' + user_data_3 + '&' + JS_GV_INDEX + '=' + JS_GV_KEY, true);
							xmlHttp.onreadystatechange = function()
							{
								if (xmlHttp.readyState == 4)
								{
									//XML Daten
									var FILEDATA = xmlHttp.responseXML;
									var data = FILEDATA.getElementsByTagName('ldap');

									var ldap_server_result = false;
									var ldap_login_result = false;
									var ldap_user_result = false;

									for (var j=0; j < data[0].childNodes.length; j++)
									{
										with(data[0].childNodes[j])
										{
											if (nodeName == "server")
											{
												if (firstChild.nodeValue == 'true')
												{
													ldap_server_result = true;
												}
											}
											if (nodeName == "login")
											{
												if (firstChild.nodeValue == 'true')
												{
													ldap_login_result = true;
												}
											}
											if (nodeName == "user")
											{
												if (firstChild.nodeValue == 'true')
												{
													ldap_user_result = true;
												}
											}
										}
									}

									if (ldap_server_result == true)
									{
										document.getElementById('ldap_server_test').innerHTML = '&radic;';
										document.getElementById('ldap_server_test').style.color = 'green';
										ldap_server_chk = true;
									}
									else
									{
										document.getElementById('ldap_server_test').innerHTML = '&times;';
										document.getElementById('ldap_server_test').style.color = 'red';
										ldap_server_chk = false;
									}
									if (ldap_login_result == true)
									{
										document.getElementById('ldap_login_test').innerHTML = '&radic;';
										document.getElementById('ldap_login_test').style.color = 'green';
										ldap_login_chk = true;
									}
									else
									{
										document.getElementById('ldap_login_test').innerHTML = '&times;';
										document.getElementById('ldap_login_test').style.color = 'red';
										ldap_login_chk = false;
									}
									if (ldap_user_result == true)
									{
										document.getElementById('ldap_user_test').innerHTML = '&radic;';
										document.getElementById('ldap_user_test').style.color = 'green';
										ldap_user_chk = true;
									}
									else
									{
										document.getElementById('ldap_user_test').innerHTML = '&times;';
										document.getElementById('ldap_user_test').style.color = 'red';
										ldap_user_chk = false;
									}
								}
							}
							xmlHttp.send(null);
						}
					}
					else
					{
						ldap_server_chk = false;
						ldap_login_chk = false;
						alert("<?php get_text(1069, 'echo', 'decode_off'); /*Bitte nehmen Sie die Einstellungen f&uuml;r den Loginnamen vor!*/?>");
					}
				}
				else
				{
					ldap_server_chk = false;
					ldap_login_chk = false;
					alert("<?php get_text(1070, 'echo', 'decode_off'); /*Bitte geben Sie min. eine Domain zu Ihrem LDAP Server an!*/?>");
				}
			}
			else
			{
				ldap_server_chk = false;
				ldap_login_chk = false;
				alert("<?php get_text(1071, 'echo', 'decode_off'); /*Bitte geben Sie einen Trenner zwischen den TOM Userdaten an!*/?>");
			}
		}
		else
		{
			ldap_server_chk = false;
			ldap_login_chk = false;
			alert("<?php get_text(1072, 'echo', 'decode_off'); /*Die LDAP-Verwendung ist deaktiviert!*/?>");
		}
	}

	function chk_form()
	{
		if (document.form_setup_ldap.active.checked == true)
		{
			if (document.form_setup_ldap.domain.value != '')
			{
				if (set_ldap_loginname_example('return') != '')
				{
					if (ldap_server_chk == true && ldap_login_chk == true && ldap_user_chk == true)
					{
						document.form_setup_ldap.submit();
					}
					else
					{
						if (confirm("<?php get_text(1073, 'echo', 'decode_off'); /*Sie haben die LDAP-Einstellungen nicht erfolgreich getestet! Wollen Sie die Einstellungen dennoch speichern?*/?>"))
						{
							document.form_setup_ldap.submit();
						}
					}
				}
				else
				{
					alert("<?php get_text(1074, 'echo', 'decode_off'); /*Bitte nehmen Sie die Einstellungen für den Loginnamen vor!*/?>");
				}
			}
			else
			{
				alert("<?php get_text(1070, 'echo', 'decode_off'); /*Bitte geben Sie min. eine Domain zu Ihrem LDAP Server an!*/?>");
			}
		}
		else
		{
			document.form_setup_ldap.submit();
		}
	}
	-->
</script>
<table cellpadding="0" cellspacing="0" border="0" width="100%">
	<tr valign="middle">
		<td class="main_table_header" width="100%"><?php get_text(98); //Einstellungen?> - <?php get_text('1075'); /*LDAP*/?></td>
	</tr>
	<tr><td><img src="<?php echo TOM_ABS_URL.'template/'.$setup_array['template'].'/image/_spacer.gif'; ?>" width="1" height="4" border="0" alt="" /></td></tr>
	<tr>
		<td class="main_table_content">
			<form name="form_setup_ldap" method="post" action="index.php<?php echo $gv->create_get_string(); ?>" accept-charset="UTF-8">
				<input type="hidden" name="job_string" value="edit_ldap_setup" />
				<?php
					//Reloadsperre
					$reload->create();
					//Checksumme
					echo $chk_sum->GetHidden(array('job_string'=>'edit_ldap_setup'));
				?>
				<table cellpadding="2" cellspacing="0" border="0" width="100%" class="table_content">
					<colgroup>
						<col width="30%" />
						<col width="70%" />
					</colgroup>
					<tr valign="top">
						<td colspan="2" class="padding_leftright_10">
							<?php get_text('1076'); /*Diese Seite dient zur Konfiguration eines LDAP Servers....*/?>
						</td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
					<tr valign="top">
						<td class="padding_left_10"><strong><?php get_text('1077'); /*LDAP Server verwenden*/?>:</strong></td>
						<td>
							<input type="checkbox" name="active" value="1"<?php if ($setup_array['ldap']['active'] == true){echo ' checked="checked"';} if (!$ldap_exists){echo ' disabled="disabled"';} else {echo ' onchange="active_ldap();"';} ?> />
						</td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
					<tr valign="top">
						<td colspan="2" class="padding_leftright_10">
							<?php get_text('1078'); /*Wenn Sie die Option &quot;TOM als Zweit-Loginsystem verwenden&quot; aktivieren, speichert TOM nach...*/?>
						</td>
					</tr>
					<tr valign="top">
						<td class="padding_left_10"><strong><?php get_text('1079'); /*Use TOM as secondary login system*/?>:</strong></td>
						<td>
							<input type="checkbox" name="tom_login" value="1"<?php if ($setup_array['ldap']['tom_login'] == true){echo ' checked="checked"';}echo $disabled; ?> onchange="active_ldap();" />
						</td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
					<tr valign="top">
						<td colspan="2" class="padding_leftright_10">
							<?php get_text('1080'); /*Domain of the LDAP server.*/?>
						</td>
					</tr>
					<tr valign="top">
						<td class="padding_left_10"><strong><?php get_text('1081'); /*Domain*/?>:*</strong></td>
						<td>
							<input type="text" name="domain" value="<?php echo $setup_array['ldap']['domain'];?>" class="ipt_200"<?php echo $disabled;?> />
						</td>
					</tr>
					<tr valign="top">
						<td class="padding_left_10"><strong><?php get_text('1082'); /*SSL verwenden*/?>:</strong></td>
						<td>
							<input type="radio" name="ssl" value="1"<?php if ($setup_array['ldap']['ssl'] == true){echo ' checked="checked"';}echo $disabled; ?> /> <?php get_text('', 'echo', 'decode_on', 'ja'); /*ja*/?>&nbsp;<input type="radio" name="ssl" value="0"<?php if ($setup_array['ldap']['ssl'] == false){echo ' checked="checked"';}echo $disabled; ?> /> <?php get_text('', 'echo', 'decode_on', 'nein'); /*nein*/?>
						</td>
					</tr>
					<tr valign="top">
						<td class="padding_left_10"><strong><?php get_text('1083'); /*TLS verwenden*/?>:</strong></td>
						<td>
							<input type="radio" name="tls" value="1"<?php if ($setup_array['ldap']['tls'] == true){echo ' checked="checked"';}echo $disabled; ?> /> <?php get_text('', 'echo', 'decode_on', 'ja'); /*ja*/?>&nbsp;<input type="radio" name="tls" value="0"<?php if ($setup_array['ldap']['tls'] == false){echo ' checked="checked"';}echo $disabled; ?> /> <?php get_text('', 'echo', 'decode_on', 'nein'); /*nein*/?>
						</td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
					<tr valign="top">
						<td colspan="2" class="padding_leftright_10">
							<?php get_text('1084'); /*Achtung, da TOM den LDAP Server nur zur Loginpr&uuml;fung verwendet, ist es...*/?>
						</td>
					</tr>
					<tr valign="top">
						<td class="padding_left_10"><strong><?php get_text('1085'); /*Loginname*/?>:*</strong></td>
						<td>
							<table cellpadding="2" cellspacing="0" border="0" width="100%">
								<tr align="center">
									<td width="10%"><?php get_text('1086'); /*Login-Pr&auml;fix*/?></td>
									<td width="20%"><?php get_text('1088'); /*TOM Userdaten*/?></td>
									<td width="10%"><?php get_text('1089'); /*Trenner*/?></td>
									<td width="20%"><?php get_text('1088'); /*TOM Userdaten*/?></td>
									<td width="10%"><?php get_text('1089'); /*Trenner*/?></td>
									<td width="20%"><?php get_text('1088'); /*TOM Userdaten*/?></td>
									<td width="10%"><?php get_text('1087'); /*Login-Suffix*/?></td>
								</tr>
								<tr align="center">
									<td><input type="text" name="login_praefix" class="ipt_50" value="<?php echo $setup_array['ldap']['loginname']['praefix']; ?>" onblur="set_ldap_loginname_example('html');"<?php echo $disabled; ?> /></td>
									<td>
										<select name="user_data_1" class="ipt_100" onchange="set_ldap_loginname_example('html');"<?php echo $disabled; ?>>
											<option value=""><?php get_text(1012);//Keine Auswahl ?></option>
											<option value="loginname"<?php if ($setup_array['ldap']['loginname']['user_data_1'] == 'loginname'){echo ' selected="selected"';} ?>><?php get_text(36);//Benutzername ?></option>
											<option value="firstname"<?php if ($setup_array['ldap']['loginname']['user_data_1'] == 'firstname'){echo ' selected="selected"';} ?>><?php get_text(211);//Vorname ?></option>
											<option value="lastname"<?php if ($setup_array['ldap']['loginname']['user_data_1'] == 'lastname'){echo ' selected="selected"';} ?>><?php get_text(210);//Nachname ?></option>
											<option value="email"<?php if ($setup_array['ldap']['loginname']['user_data_1'] == 'email'){echo ' selected="selected"';} ?>><?php get_text(204);//E-Mail ?></option>
										</select>
									</td>
									<td><input type="text" name="login_separator_1" class="ipt_50" value="<?php echo $setup_array['ldap']['loginname']['separator_1']; ?>" onblur="set_ldap_loginname_example('html');"<?php echo $disabled; ?> /></td>
									<td>
										<select name="user_data_2" class="ipt_100" onchange="set_ldap_loginname_example('html');"<?php echo $disabled; ?>>
											<option value=""><?php get_text(1012);//Keine Auswahl ?></option>
											<option value="loginname"<?php if ($setup_array['ldap']['loginname']['user_data_2'] == 'loginname'){echo ' selected="selected"';} ?>><?php get_text(36);//Benutzername ?></option>
											<option value="firstname"<?php if ($setup_array['ldap']['loginname']['user_data_2'] == 'firstname'){echo ' selected="selected"';} ?>><?php get_text(211);//Vorname ?></option>
											<option value="lastname"<?php if ($setup_array['ldap']['loginname']['user_data_2'] == 'lastname'){echo ' selected="selected"';} ?>><?php get_text(210);//Nachname ?></option>
											<option value="email"<?php if ($setup_array['ldap']['loginname']['user_data_2'] == 'email'){echo ' selected="selected"';} ?>><?php get_text(204);//E-Mail ?></option>
										</select>
									</td>
									<td><input type="text" name="login_separator_2" class="ipt_50" value="<?php echo $setup_array['ldap']['loginname']['separator_2']; ?>" onblur="set_ldap_loginname_example('html');"<?php echo $disabled; ?> /></td>
									<td>
										<select name="user_data_3" class="ipt_100" onchange="set_ldap_loginname_example('html');"<?php echo $disabled; ?>>
											<option value=""><?php get_text(1012);//Keine Auswahl ?></option>
											<option value="loginname"<?php if ($setup_array['ldap']['loginname']['user_data_3'] == 'loginname'){echo ' selected="selected"';} ?>><?php get_text(36);//Benutzername ?></option>
											<option value="firstname"<?php if ($setup_array['ldap']['loginname']['user_data_3'] == 'firstname'){echo ' selected="selected"';} ?>><?php get_text(211);//Vorname ?></option>
											<option value="lastname"<?php if ($setup_array['ldap']['loginname']['user_data_3'] == 'lastname'){echo ' selected="selected"';} ?>><?php get_text(210);//Nachname ?></option>
											<option value="email"<?php if ($setup_array['ldap']['loginname']['user_data_3'] == 'email'){echo ' selected="selected"';} ?>><?php get_text(204);//E-Mail ?></option>
										</select>
									</td>
									<td><input type="text" name="login_suffix" class="ipt_50" value="<?php echo $setup_array['ldap']['loginname']['suffix']; ?>" onblur="set_ldap_loginname_example('html');"<?php echo $disabled; ?> /></td>
								</tr>
								<tr>
									<td colspan="7">
										<?php get_text(1096);//Beispiel ?>: <strong><span id="ldap_loginname">&nbsp;</span></strong>
									</td>
								</tr>
							</table>
						</td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
					<tr valign="top">
						<td colspan="2" class="padding_leftright_10">
							<?php get_text(1090);//Bitte testen Sie Ihre LDAP-Einstellungen vor dem Speichern... ?>
						</td>
					</tr>
					<tr valign="top">
						<td class="padding_left_10"><strong><?php get_text(1091);//LDAP-Einstellungen testen ?>:</strong></td>
						<td>
							<table cellpadding="2" cellspacing="0" border="0" width="100%">
								<tr valign="top">
									<td width="30%">
										<a href="javascript:ldap_server_test();"><img src="<?php echo TOM_ABS_URL.'template/'.$setup_array['template'].'/image/error.png'; ?>" width="16" height="16" border="0" alt="" class="image" /> <u><?php get_text(1092);//Test starten ?></u></a>
									</td>
									<td width="70%">
										<?php get_text(1093);//Server-Verbindung erfolgreich getestet ?>: <strong><span id="ldap_server_test" style="color: red; font-size: 16px;">&times;</span></strong><br />
										<?php get_text(1094);//Zugangsdaten erfolgreich getestet ?>: <strong><span id="ldap_login_test" style="color: red; font-size: 16px">&times;</span></strong><br />
										<?php get_text(1095);//Eindeutige Benutzerkennung in TOM ?>: <strong><span id="ldap_user_test" style="color: red; font-size: 16px">&times;</span></strong>
									</td>
								</tr>
							</table>
						</td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
					<tr>
						<td>&#160;</td>
						<td><?php echo get_button(get_text('', 'return', 'decode_on', 'save') /*Speichern*/, 'tick.png', 'onclick="chk_form();"'); ?></td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
				</table>
			</form>
		</td>
	</tr>
</table>
<script type="text/javascript">
	<!--
	set_ldap_loginname_example('html');
	-->
</script>