<?php
	/**
	 * edit settings for Webservices
	 * @package time-o-meter
	 * @subpackage setup
	 */

	$webservice_functions = array();
	$webservice_functions_string = '';
	$tom_result = array();
	$access_result = array();
	$tom_wsdl_pfad = true;
	$access_wsdl_pfad = true;
	$tom_pfad_len = strlen(TOM_ABS_URL);

	//Webservicefunctionen auslesen
	if (file_exists(TOM_ABS_PFAD.'web_services/tom.wsdl'))
	{
		if (class_exists('SoapClient'))
		{
			try
			{
				$wsdl = @new SoapClient(TOM_ABS_PFAD.'web_services/tom.wsdl');
				$tmp_function_array = @$wsdl->__getFunctions();

				if (is_array($tmp_function_array))
				{
					sort($tmp_function_array);
					foreach($tmp_function_array as $function)
					{
						$tmp_function = $function;

						$tmp_function = str_replace('string ', '', $tmp_function);
						$tmp_function = str_replace('int ', '', $tmp_function);

						$pos = strpos($tmp_function, '(');

						if ($pos !== false)
						{
							$tmp_function = substr($tmp_function, 0, $pos);
							if (!empty($tmp_function))
							{
								$webservice_functions[] = $tmp_function;

								if (empty($webservice_functions_string))
								{
									$webservice_functions_string = '"'.$tmp_function.'"';
								}
								else
								{
									$webservice_functions_string .= ', "'.$tmp_function.'"';
								}
							}
						}
					}
				}
			}
			catch(Exception $e)
			{

			}
		}

		//TOM WSDL auslesen
		if (is_readable(TOM_ABS_PFAD.'web_services/tom.wsdl'))
		{
			$tom_wsdl = file_get_contents(TOM_ABS_PFAD.'web_services/tom.wsdl');
			preg_match('/<soap:address location="(.*)"\/>/', $tom_wsdl, $tom_result);

			if (isset($tom_result[1]) and !empty($tom_result[1]))
			{
				if (substr($tom_result[1], 0, $tom_pfad_len) != TOM_ABS_URL)
				{
					$tom_wsdl_pfad = false;
				}
			}
		}
	}

	//ACCESS WSDL Auslesen
	if (file_exists(TOM_ABS_PFAD.'web_services/access.wsdl') and is_readable(TOM_ABS_PFAD.'web_services/access.wsdl'))
	{
		$access_wsdl = file_get_contents(TOM_ABS_PFAD.'web_services/access.wsdl');
		preg_match('/<soap:address location="(.*)"\/>/', $access_wsdl, $access_result);

		if (isset($access_result[1]) and !empty($access_result[1]))
		{
			if (substr($access_result[1], 0, $tom_pfad_len) != TOM_ABS_URL)
			{
				$access_wsdl_pfad = false;
			}
		}
	}

	$read_only_boole = false;
	$disabled_string = '';
	if (isset($setup_array['webservice_tom']))
	{
		if (!isset($setup_array['webservice_tom']['aktiv']))
		{
			$setup_array['webservice_tom']['aktiv'] = 0;
			$read_only_boole = true;
			$disabled_string = ' disabled="disabled"';
		}

		if (!isset($setup_array['webservice_tom']['ip']))
		{
			$setup_array['webservice_tom']['ip'] = array();
		}

		if (!isset($setup_array['webservice_tom']['functions']))
		{
			$setup_array['webservice_tom']['functions'] = array();
		}

		foreach ($webservice_functions as $function)
		{
			if (!isset($setup_array['webservice_tom']['functions'][$function]))
			{
				$setup_array['webservice_tom']['functions'][$function] = 0;
			}
		}
	}
	//keine Webserviceeinstellungen vorhanden
	else
	{
		$setup_array['webservice_tom'] = array();
		$setup_array['webservice_tom']['aktiv'] = 0;

		$read_only_boole = true;
		$disabled_string = ' disabled="disabled"';

		$setup_array['webservice_tom']['ip'] = array();
		$setup_array['webservice_tom']['functions'] = array();
		foreach ($webservice_functions as $function)
		{
			$setup_array['webservice_tom']['functions'][$function] = 0;
		}
	}
?>
<script type="text/javascript">
	<!--
		function chk_webservice()
		{
			var webservice_functions = new Array(<?php echo $webservice_functions_string; ?>);
			if (document.form_setup_webservice.webservice_aktiv_int.checked == true)
			{
				for (var i = 0; i < webservice_functions.length; i++)
				{
					document.form_setup_webservice.elements["webservice_functions[" + webservice_functions[i] + "]"].disabled = false;
					document.form_setup_webservice.elements["webservice_functions[" + webservice_functions[i] + "]"].checked = true;
				}
				document.form_setup_webservice.webservice_ip_string.disabled = false;
			}
			else
			{
				for (var i = 0; i < webservice_functions.length; i++)
				{
					document.form_setup_webservice.elements["webservice_functions[" + webservice_functions[i] + "]"].disabled = true;
					document.form_setup_webservice.elements["webservice_functions[" + webservice_functions[i] + "]"].checked = false;
				}
				document.form_setup_webservice.webservice_ip_string.disabled = true;
				document.form_setup_webservice.webservice_ip_string.value = "";
			}
		}
	// -->
</script>
<table cellpadding="0" cellspacing="0" border="0" width="100%">
	<tr valign="middle">
		<td class="main_table_header" width="100%"><?php get_text(98); //Einstellungen?> - <?php get_text(977); //Webservice?></td>
	</tr>
	<tr><td><img src="<?php echo TOM_ABS_URL.'template/'.$setup_array['template'].'/image/_spacer.gif'; ?>" width="1" height="4" border="0" alt="" /></td></tr>
	<tr>
		<td class="main_table_content">
			<form name="form_setup_webservice" method="post" action="index.php<?php echo $gv->create_get_string(); ?>" accept-charset="UTF-8">
				<input type="hidden" name="job_string" value="edit_webservice_setup" />
				<?php
					//Reloadsperre
					$reload->create();
					//Checksumme
					echo $chk_sum->GetHidden(array('job_string'=>'edit_webservice_setup'));
				?>
				<table cellpadding="2" cellspacing="0" border="0" width="100%" class="table_content">
					<colgroup>
						<col width="30%" />
						<col width="70%" />
					</colgroup>
					<tr valign="top">
						<td colspan="2" class="padding_leftright_10">
							<?php get_text(978); //Diese Seite dient zur Konfiguration der Webservice-Funktionen...?>
						</td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
					<tr>
						<td class="padding_left_10"><strong><?php get_text(979); //Webservice aktivieren?>:</strong></td>
						<td><input type="checkbox" name="webservice_aktiv_int" value="1" onchange="chk_webservice();"<?php if ($setup_array['webservice_tom']['aktiv'] == 1){echo ' checked="checked"';}?> /></td>
					</tr>
					<tr valign="top">
						<td colspan="2" class="padding_leftright_10">
							<br /><?php get_text(980); //Nachfolgend finden Sie eine Liste aller zur...?>
						</td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
					<tr valign="top">
						<td class="padding_left_10"><strong><?php get_text(981); //Webservicefunktionen aktivieren?>:</strong></td>
						<td>
							<?php
								if (count($webservice_functions) > 0)
								{
									foreach ($webservice_functions as $function)
									{
										$checked = '';
										if ($setup_array['webservice_tom']['functions'][$function] == 1 and $read_only_boole == false)
										{
											$checked = ' checked="checked"';
										}
										echo '<input type="checkbox" name="webservice_functions['.$function.']" value="1"'.$checked.$disabled_string.' /> '.$function.'<br />';
									}
								}
								else
								{
									get_text(982); //Es wurden keine Webservicefunktionen gefunden!
								}
							?>
						</td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
					<tr valign="top">
						<td colspan="2" class="padding_leftright_10">
							<?php get_text(983); //Das folgende Eingabefeld dient zur...?>
						</td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
					<tr>
						<td class="padding_left_10"><strong><?php get_text(984); //Akzeptierte IP Adressen?>:</strong></td>
						<td>
							<?php
								$ip_string = '';
								foreach ($setup_array['webservice_tom']['ip'] as $ip)
								{
									if (empty($ip_string))
									{
										$ip_string = $ip;
									}
									else
									{
										$ip_string .= ', '.$ip;
									}
								}
							?>
							<input type="text" name="webservice_ip_string" value="<?php echo $ip_string; ?>" class="ipt_200"<?php echo $disabled_string; ?> />
						</td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
					<?php
						if ($tom_wsdl_pfad === false or $access_wsdl_pfad === false)
						{
					?>
							<tr>
								<td style="padding: 10px;" colspan="2">
									<div class="error_table_content">
										<ul>
										<?php
											$error_txt = get_text(985, 'return');
											$search_array = array('[WSDL_URL]', '[WS_URL]', '[FALSE_WS_URL]');
											if ($tom_wsdl_pfad === false)
											{
												$replace_array = array(TOM_ABS_URL.'web_services/tom.wsdl', TOM_ABS_URL.'web_services/tom.php', $tom_result[1]);
												echo '<li>'.str_replace($search_array, $replace_array, $error_txt).'</li>';//Die Webservice URL Angabe, in der Datei &quot;[WSDL_URL]&quot;, scheint fehlerhaft zu sein. Normalerweise sollte die URL &quot;[WS_URL]&quot; lauten. Bitte Pr&uuml;fen Sie die &quot;[WSDL_URL]&quot; Datei.
											}
											if ($access_wsdl_pfad === false)
											{
												$replace_array = array(TOM_ABS_URL.'web_services/access.wsdl', TOM_ABS_URL.'web_services/access.php', $access_result[1]);
												echo '<li>'.str_replace($search_array, $replace_array, $error_txt).'</li>';//Die Webservice URL Angabe, in der Datei &quot;[WSDL_URL]&quot;, scheint fehlerhaft zu sein. Normalerweise sollte die URL &quot;[WS_URL]&quot; lauten. Bitte Pr&uuml;fen Sie die &quot;[WSDL_URL]&quot; Datei.
											}
										?>
										</ul>
									</div>
								</td>
							</tr>
							<tr><td colspan="2">&#160;</td></tr>
					<?php
						}
					?>
					<tr>
						<td>&#160;</td>
						<td><?php echo get_button(get_text('', 'return', 'decode_on', 'save') /*Speichern*/, 'tick.png', 'onclick="document.form_setup_webservice.submit();"', 'submit'); ?></td>
					</tr>
					<tr><td colspan="2">&#160;</td></tr>
				</table>
			</form>
		</td>
	</tr>
</table>