<?php
	/**
	 * xml output of the ldap test
	 * @package time-o-meter
	 * @subpackage inc
	 */

	$show_header = 'n';

	/**
	 * include-sammlung einbinden
	 */
	require_once('../inc/include.php');

	header('Content-type: application/xml');
	header("Cache-Control: no-cache, must-revalidate");
	header("Expires: ".date('r', time() - 86400));
	$return = '<?xml version="1.0" encoding="utf-8"?>'."\n";
	$return .= "<root>\n";
	$return .= "<ldap>\n";

	$ldap_server = 'false';
	$ldap_login = 'false';
	$ldap_user = 'false';

	if (defined('USER_ID'))
	{
		if (isset($_GET['domain_string']) and !empty($_GET['domain_string']) and isset($_GET['ssl_string']) and !empty($_GET['ssl_string']) and isset($_GET['tls_string']) and !empty($_GET['tls_string']) and isset($_GET['ldap_login_name_string']) and !empty($_GET['ldap_login_name_string']) and isset($_GET['pw_string']) and !empty($_GET['pw_string']))
		{
			if (function_exists('ldap_connect'))
			{
				$domain = html_entity_decode($_GET['domain_string'], ENT_QUOTES);
				if ($domain != $_GET['domain_string'])
				{
					$domain = utf8_encode($domain);
				}

				$ssl = html_entity_decode($_GET['ssl_string'], ENT_QUOTES);
				if ($ssl == 'true')
				{
					$ssl = true;
				}
				else
				{
					$ssl = false;
				}

				$tls = html_entity_decode($_GET['tls_string'], ENT_QUOTES);
				if ($tls == 'true')
				{
					$tls = true;
				}
				else
				{
					$tls = false;
				}

				$ldap_login_name = html_entity_decode($_GET['ldap_login_name_string'], ENT_QUOTES);
				if ($ldap_login_name != $_GET['ldap_login_name_string'])
				{
					$ldap_login_name = utf8_encode($ldap_login_name);
				}

				$pw = html_entity_decode($_GET['pw_string'], ENT_QUOTES);
				if ($pw != $_GET['pw_string'])
				{
					$pw = utf8_encode($pw);
				}

				if ($ssl)
				{
					$ldap_h = @ldap_connect('ldaps://'.$domain, 636);
				}
				else
				{
					$ldap_h = @ldap_connect($domain);
				}

				if ($ldap_h)
				{
					ldap_set_option($ldap_h, LDAP_OPT_PROTOCOL_VERSION, 3);
        			ldap_set_option($ldap_h, LDAP_OPT_REFERRALS, 0);

        			if ($tls)
        			{
        				ldap_start_tls($ldap_h);
        			}

					$bind = @ldap_bind($ldap_h, $ldap_login_name, $pw);

					if ($bind)
					{
						$ldap_server = 'true';
						$ldap_login = 'true';
					}
					elseif (ldap_errno($ldap_h) != -1)
					{
						$ldap_server = 'true';
					}
				}
			}
		}

		if (isset($_GET['user_data_1_string']) and isset($_GET['user_data_2_string']) and isset($_GET['user_data_3_string']))
		{
			$where_array = array();
			if (!empty($_GET['user_data_1_string']))
			{
				if ($_GET['user_data_1_string'] == 'loginname')
				{
					$where_array[] = "username='{loginname}'";
				}
				elseif ($_GET['user_data_1_string'] == 'firstname')
				{
					$where_array[] = "vorname='{firstname}'";
				}
				elseif ($_GET['user_data_1_string'] == 'lastname')
				{
					$where_array[] = "nachname='{lastname}'";
				}
				elseif ($_GET['user_data_1_string'] == 'email')
				{
					$where_array[] = "email='{email}'";
				}
			}

			if (!empty($_GET['user_data_2_string']))
			{
				if ($_GET['user_data_2_string'] == 'loginname')
				{
					$where_array[] = "username='{loginname}'";
				}
				elseif ($_GET['user_data_2_string'] == 'firstname')
				{
					$where_array[] = "vorname='{firstname}'";
				}
				elseif ($_GET['user_data_2_string'] == 'lastname')
				{
					$where_array[] = "nachname='{lastname}'";
				}
				elseif ($_GET['user_data_2_string'] == 'email')
				{
					$where_array[] = "email='{email}'";
				}
			}

			if (!empty($_GET['user_data_3_string']))
			{
				if ($_GET['user_data_3_string'] == 'loginname')
				{
					$where_array[] = "username='{loginname}'";
				}
				elseif ($_GET['user_data_3_string'] == 'firstname')
				{
					$where_array[] = "vorname='{firstname}'";
				}
				elseif ($_GET['user_data_3_string'] == 'lastname')
				{
					$where_array[] = "nachname='{lastname}'";
				}
				elseif ($_GET['user_data_3_string'] == 'email')
				{
					$where_array[] = "email='{email}'";
				}
			}

			if (!empty($where_array))
			{
				$where = '';
				foreach ($where_array as $where_sql)
				{
					if (empty($where))
					{
						$where = 'WHERE '.$where_sql;
					}
					else
					{
						$where .= ' AND '.$where_sql;
					}
				}

				$where .= " AND login_aktiv='j' AND anzeigen='j'";

				$uniq_user = true;
				$sql = $cdb->select("SELECT vorname, nachname, email, username FROM hdb_user WHERE login_aktiv='j' AND anzeigen='j'");
				while ($result = $cdb->fetch_array($sql))
				{
					$tmp_where = $where;

					$tmp_where = str_replace('{loginname}', $result['username'], $tmp_where);
					$tmp_where = str_replace('{firstname}', $result['vorname'], $tmp_where);
					$tmp_where = str_replace('{lastname}', $result['nachname'], $tmp_where);
					$tmp_where = str_replace('{email}', $result['email'], $tmp_where);

					$count_sql = $cdb->select('SELECT COUNT(user_id) AS count_id FROM hdb_user '.$tmp_where);
					$count_result = $cdb->fetch_array($count_sql);

					if ($count_result['count_id'] > 1)
					{
						$uniq_user = false;
						break;
					}
				}

				if ($uniq_user)
				{
					$ldap_user = 'true';
				}
			}
		}
	}

	$return .= "<server>$ldap_server</server>\n";
	$return .= "<login>$ldap_login</login>\n";
	$return .= "<user>$ldap_user</user>\n";
	$return .= "</ldap>\n";
	$return .= "</root>";

	echo utf8_encode($return);
?>