<?php
	@ini_set('max_execution_time', 0);
	define('PAGE_AREA','CJ');
	require_once('inc/include.php');

	$update_to = '0.9.8.1';
	$update_from = '0.9.7 or 0.9.8';

	if (isset($_GET['step']) and $_GET['step'] == 2)
	{
		$backup = new MySqlBackup;
		$result = $backup->create_dump('auto', "Last Backup of $update_from ".date('YmdHis'));

		$error_array = array();

		$tbl_array = array();
		$sql = $cdb->select('SHOW TABLES');
		while ($tbl_result = $cdb->fetch_row($sql))
		{
			$tbl_array[] = $tbl_result[0];
		}

		//neue Tabellen erstellen
		if (!in_array('hdb_absence_list', $tbl_array))
		{
			if ($cdb->query("CREATE TABLE hdb_absence_list (
							 as_id int(10) unsigned NOT NULL auto_increment,
							 absence_type_id int(11) default NULL,
							 user_id int(11) default NULL,
							 date_from date default '0000-00-00',
							 date_to date default '0000-00-00',
							 day_count float unsigned default '0',
							 request_timestamp varchar(14) default NULL,
							 status set('open','approved','rejected') default 'approved',
							 comment text,
							 display tinyint(4) default '1',
							 PRIMARY KEY  (as_id)
							) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='alle abwesenheitsantraege'") === false)
			{
				$error_array['sql'][] = "CREATE TABLE hdb_absence_list (
										 as_id int(10) unsigned NOT NULL auto_increment,
										 absence_type_id int(11) default NULL,
										 user_id int(11) default NULL,
										 date_from date default '0000-00-00',
										 date_to date default '0000-00-00',
										 day_count float unsigned default '0',
										 request_timestamp varchar(14) default NULL,
										 status set('open','approved','rejected') default 'approved',
										 comment text,
										 display tinyint(4) default '1',
										 PRIMARY KEY  (as_id)
										) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='alle abwesenheitsantraege'";
			}
		}
		if (!in_array('hdb_absence_type', $tbl_array))
		{
			if ($cdb->query("CREATE TABLE hdb_absence_type (
							 absence_type_id int(10) unsigned NOT NULL auto_increment,
							 absence_name varchar(255) default NULL,
							 working_time tinyint(4) default '0',
							 paid tinyint(4) default '0',
							 total_day tinyint(4) default '0',
							 application tinyint(4) default '0',
							 approval tinyint(4) NOT NULL default '0',
							 color varchar(6) default NULL,
							 display tinyint(4) default '1',
							 PRIMARY KEY  (absence_type_id),
							 KEY application_index (application)
							) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='Liste aller Abwesenheitsgruende'") === false)
			{
				$error_array['sql'][] = "CREATE TABLE hdb_absence_type (
										 absence_type_id int(10) unsigned NOT NULL auto_increment,
										 absence_name varchar(255) default NULL,
										 working_time tinyint(4) default '0',
										 paid tinyint(4) default '0',
										 total_day tinyint(4) default '0',
										 application tinyint(4) default '0',
										 approval tinyint(4) NOT NULL default '0',
										 color varchar(6) default NULL,
										 display tinyint(4) default '1',
										 PRIMARY KEY  (absence_type_id),
										 KEY application_index (application)
										) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='Liste aller Abwesenheitsgruende'";
			}
		}
		if (!in_array('hdb_user_qualifikation', $tbl_array))
		{
			if ($cdb->query("CREATE TABLE hdb_user_qualifikation (
							 user_id int(10) unsigned default '0',
							 quali_id int(10) unsigned default '0',
							 KEY user_quali_index (user_id,quali_id),
							 KEY quali_index (quali_id)
							) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Zuordnung zwischen user und qualifikationen'") === false)
			{
				$error_array['sql'][] = "CREATE TABLE hdb_user_qualifikation (
										 user_id int(10) unsigned default '0',
										 quali_id int(10) unsigned default '0',
										 KEY user_quali_index (user_id,quali_id),
										 KEY quali_index (quali_id)
										) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Zuordnung zwischen user und qualifikationen'";
			}
		}

		$tbl_array = array();
		$sql = $cdb->select('SHOW TABLES');
		while ($tbl_result = $cdb->fetch_row($sql))
		{
			$tbl_array[] = $tbl_result[0];
		}

		//daten aus hdb_urlaub in hdb_absence_list übertragen
		if (in_array('hdb_urlaub', $tbl_array) and in_array('hdb_absence_list', $tbl_array))
		{
			$sql = $cdb->select('SELECT as_id FROM hdb_absence_list WHERE absence_type_id=2');
			$result = $cdb->fetch_array($sql);

			//bereits eintraege vorhanden
			//dies kann nur sein wenn das update skript bereits durchgelaufen ist und beim ersten mal die hdb_urlaub nicht gelöscht wurde
			if (isset($result['as_id']) and !empty($result['as_id']))
			{
				if ($cdb->query("DROP TABLE hdb_urlaub") === false)
				{
					$error_array['sql'][] = "DROP TABLE hdb_urlaub";
				}
			}
			else
			{
				$insert_error = false;
				$sql = $cdb->select('SELECT * FROM hdb_urlaub');
				while ($result = $cdb->fetch_array($sql))
				{
					if ($result['status'] == 'j')
					{
						$status = 'approved';
					}
					elseif ($result['status'] == 'n')
					{
						$status = 'rejected';
					}
					else
					{
						$status = 'open';
					}

					if (!$cdb->insert("INSERT INTO hdb_absence_list (absence_type_id, user_id, date_from, date_to, day_count, request_timestamp, status, comment) VALUES (2, ".$result['user_id'].", '".$result['datum_von']."', '".$result['datum_bis']."', '".$result['anzahl_tage']."', '".$result['timestamp_antrag']."', '$status', '".$result['comment']."')"))
					{
						$insert_error = true;
						$error_array['sql'][] = "INSERT INTO hdb_absence_list (absence_type_id, user_id, date_from, date_to, day_count, request_timestamp, status, comment) VALUES (2, ".$result['user_id'].", '".$result['datum_von']."', '".$result['datum_bis']."', '".$result['anzahl_tage']."', '".$result['timestamp_antrag']."', '$status', '".$result['comment']."')";
					}
				}

				if ($insert_error == false)
				{
					if ($cdb->query("DROP TABLE hdb_urlaub") === false)
					{
						$error_array['sql'][] = "DROP TABLE hdb_urlaub";
					}
				}
			}
		}

		//Daten aus hdb_gleitzeit in hdb_absence_list übertragen
		if (in_array('hdb_gleitzeit', $tbl_array) and in_array('hdb_absence_list', $tbl_array))
		{
			$sql = $cdb->select('SELECT as_id FROM hdb_absence_list WHERE absence_type_id=4');
			$result = $cdb->fetch_array($sql);

			//bereits eintraege vorhanden
			//dies kann nur sein wenn das update skript bereits durchgelaufen ist und beim ersten mal die hdb_gleitzeit nicht gelöscht wurde
			if (isset($result['as_id']) and !empty($result['as_id']))
			{
				if ($cdb->query("DROP TABLE hdb_gleitzeit") === false)
				{
					$error_array['sql'][] = "DROP TABLE hdb_gleitzeit";
				}
			}
			else
			{
				$insert_error = false;
				$sql = $cdb->select('SELECT * FROM hdb_gleitzeit');
				while ($result = $cdb->fetch_array($sql))
				{
					if (!empty($result['datum_am']) and $result['datum_am'] != '0000-00-00')
					{
						$date_from = $result['datum_am'];
						$date_to = $result['datum_am'];
					}
					else
					{
						$date_from = $result['datum_von'];
						$date_to = $result['datum_bis'];
					}

					if (!$cdb->insert("INSERT INTO hdb_absence_list (absence_type_id, user_id, date_from, date_to, day_count, request_timestamp, status, comment) VALUES (4, ".$result['user_id'].", '$date_from', '$date_to', '".$result['anzahl_tage']."', '".$result['timestamp_antrag']."', 'approved', '".$result['comment']."')"))
					{
						$insert_error = true;
						$error_array['sql'][] = "INSERT INTO hdb_absence_list (absence_type_id, user_id, date_from, date_to, day_count, request_timestamp, status, comment) VALUES (4, ".$result['user_id'].", '$date_from', '$date_to', '".$result['anzahl_tage']."', '".$result['timestamp_antrag']."', 'approved', '".$result['comment']."')";
					}
				}

				if ($insert_error == false)
				{
					if ($cdb->query("DROP TABLE hdb_gleitzeit") === false)
					{
						$error_array['sql'][] = "DROP TABLE hdb_gleitzeit";
					}
				}
			}
		}

		//Daten aus hdb_absence in hdb_absence_type übertragen
		if (in_array('hdb_absence', $tbl_array) and in_array('hdb_absence_type', $tbl_array))
		{
			$sql = $cdb->select('SELECT COUNT(absence_type_id) AS count_id FROM hdb_absence_type');
			$result = $cdb->fetch_array($sql);

			//bereits eintraege vorhanden
			//dies kann nur sein wenn das update skript bereits durchgelaufen ist und beim ersten mal die hdb_absence nicht gelöscht wurde
			if ($result['count_id'] > 0)
			{
				if ($cdb->query("DROP TABLE hdb_absence") === false)
				{
					$error_array['sql'][] = "DROP TABLE hdb_absence";
				}
			}
			else
			{
				$insert_error = false;
				$sql = $cdb->select('SELECT * FROM hdb_absence');
				while ($result = $cdb->fetch_array($sql))
				{
					$absence_type_id = $result['absence_id'];
					$absence_name = $result['name'];

					if ($result['zeit'] == 'j')
					{
						$working_time = 1;
					}
					else
					{
						$working_time = 0;
					}

					if ($result['bezahlt'] == 'j')
					{
						$paid = 1;
					}
					else
					{
						$paid = 0;
					}

					if ($result['gesamt_tag'] == 'j')
					{
						$total_day = 1;
					}
					else
					{
						$total_day = 0;
					}

					if ($absence_type_id == 2 or $absence_type_id == 4)
					{
						$application = 1;
					}
					else
					{
						$application = 0;
					}

					if ($absence_type_id == 2)
					{
						$approval = 1;
					}
					else
					{
						$approval = 0;
					}

					if ($absence_type_id == 1)
					{
						$color = 'C0C451';
					}
					elseif ($absence_type_id == 2)
					{
						$color = 'DA9797';
					}
					elseif ($absence_type_id == 3)
					{
						$color = '516C9B';
					}
					elseif ($absence_type_id == 4)
					{
						$color = '7994C3';
					}
					else
					{
						$color = 'CCCCCC';
					}

					if ($result['anzeigen'] == 'j')
					{
						$display = 1;
					}
					else
					{
						$display = 0;
					}

					if (!$cdb->insert("INSERT INTO hdb_absence_type (absence_type_id, absence_name, working_time, paid, total_day, application, approval, color, display) VALUES ($absence_type_id, '$absence_name', $working_time, $paid, $total_day, $application, $approval, '$color', $display)"))
					{
						$insert_error = true;
						$error_array['sql'][] = "INSERT INTO hdb_absence_type (absence_type_id, absence_name, working_time, paid, total_day, application, approval, color, display) VALUES ($absence_type_id, '$absence_name', $working_time, $paid, $total_day, $application, $approval, '$color', $display)";
					}
				}

				if ($insert_error == false)
				{
					if ($cdb->query("DROP TABLE hdb_absence") === false)
					{
						$error_array['sql'][] = "DROP TABLE hdb_absence";
					}
				}
			}
		}

		/**
		 * Neue Texte eintragen
		 */
		$sql_array = array();
		$sql_array[1009] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1009, NULL, 'content', NULL, 'Kalendertyp', 'Calendar Type')";
		$sql_array[1010] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1010, NULL, 'content', NULL, '&Uuml;bersicht nach Mitarbeiter', 'List by employee')";
		$sql_array[1011] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1011, NULL, 'content', NULL, '&Uuml;bersicht nach Qualifikation', 'List by qualification')";
		$sql_array[1012] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1012, NULL, 'content', NULL, 'keine Auswahl', 'No selection')";
		$sql_array[1013] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1013, NULL, 'content', NULL, 'Meine Qualifikationen', 'My qualifications')";
		$sql_array[1014] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1014, NULL, 'content', NULL, 'Alle meine Qualifikationen', 'All my qualifications')";
		$sql_array[1015] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1015, NULL, 'content', NULL, 'Andere Qualifikationen', 'Other qualifications')";
		$sql_array[1016] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1016, NULL, 'content', NULL, 'kein Kritischer Wert erreicht', 'no critical value is reached')";
		$sql_array[1017] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1017, NULL, 'content', NULL, 'min. Wert erreicht', 'min. value is reached')";
		$sql_array[1018] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1018, NULL, 'content', NULL, 'Kritischer Wert erreicht', 'Critical value reached')";
		$sql_array[1019] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1019, NULL, 'content', NULL, 'Mindest Mitarbeiterbestand', 'Minimum headcount')";
		$sql_array[1020] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1020, NULL, 'content', NULL, 'Kritischer Mitarbeiterbestand', 'Critical headcount')";
		$sql_array[1021] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1021, NULL, 'content', NULL, 'Mitarbeiter insgesamt', 'Employees total')";
		$sql_array[1022] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1022, NULL, 'content', NULL, 'Der Warnwert kann nicht kleiner sein als der min. Wert!', 'The warning value can not be less than the min. Value!')";
		$sql_array[1023] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1023, NULL, 'content', NULL, 'Nachfolgend k&ouml;nnen Sie den Mitarbeiterbestand einer Qualifikation festlegen.[br]Sollte der Mitarbeiterbestand unter die angegebenen Werte sinken wird dies auf der Urlaubsübersicht angezeigt.[br]Wenn Sie keine Limits setzen wollen geben Sie 0 an.', 'Below you can specify the number of employees of a qualification.[br]If the number of employees is falling under the stock value this is shown on the holiday list.[br]If you wish to place no limits, specify 0.')";
		$sql_array[1024] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1024, NULL, 'content', NULL, 'Warnen, wenn nachfolgender Mitarbeiterbestand unterschritten wird', 'Warn, if the number of employees falls below the following value')";
		$sql_array[1025] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1025, NULL, 'content', NULL, 'M&ouml;chten Sie wirklich die Zuordnung l&ouml;schen?', 'Do you really want to delete the mapping?')";
		$sql_array[1026] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1026, NULL, 'content', NULL, 'Der Qualifikation &quot;[quali_name]&quot; einen neuen Mitarbeiter zuordnen.', 'Assign a new employee to the qualification &quot;[quali_name]&quot;.')";
		$sql_array[1027] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1027, NULL, 'content', NULL, 'Resturlaub inkl. genehmigtem zuk&uuml;nftigem Urlaub und diesem Antrag', 'Remaining leave including next holidays and this request')";
		$sql_array[1028] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1028, NULL, 'fehlermeldung', NULL, 'Achtung, f&uuml;r den angegebenen Zeitraum existiert bereits ein Abwesenheitsantrag!', 'Attention, there already exists an absence request for the concerning period!')";
		$sql_array[1029] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1029, NULL, 'system', NULL, 'Abwesenheitsantrag', 'Absence request')";
		$sql_array[1030] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1030, NULL, 'system', NULL, 'Abwesenheitsgrund', 'Absenteeism reason')";
		$sql_array[1031] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1031, NULL, 'system', NULL, 'Dauer der Abwesenheit', 'Duration of the absence')";
		$sql_array[1032] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1032, NULL, 'system', NULL, '&Uuml;bersicht nach Projekt', 'List by project')";
		$sql_array[1033] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1033, NULL, 'system', NULL, 'Meine Projekte', 'My projects')";
		$sql_array[1034] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1034, NULL, 'system', NULL, 'Alle meine Projekte', 'All my projects')";
		$sql_array[1035] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1035, NULL, 'system', NULL, 'Andere Projekte', 'Other projects')";
		$sql_array[1036] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1036, NULL, 'system', NULL, 'Noch nicht beantragt', 'Not yet requested')";
		$sql_array[1037] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1037, NULL, 'system', NULL, 'Alle Qualifikationen des Mitarbeiters', 'All qualifications of the employee')";
		$sql_array[1038] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1038, NULL, 'system', NULL, 'Noch nicht genehmigt', 'Not yet approved')";
		$sql_array[1039] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1039, NULL, 'system', NULL, 'Noch nicht genehmigte Antr&auml;ge anzeigen', 'Show requests which are not yet approved')";
		$sql_array[1040] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1040, NULL, 'system', NULL, 'Es liegt ein neuer Abwesenheitsantrag vor.', 'There is a new absence request available.')";
		$sql_array[1041] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1041, NULL, 'system', NULL, 'Abwesenheits&uuml;bersicht (Personal)', 'Absence overview (Personnel)')";
		$sql_array[1042] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1042, NULL, 'system', NULL, 'Abwesenheits&uuml;bersicht', 'Absence overview')";
		$sql_array[1043] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1043, NULL, 'system', NULL, 'LDAP', 'LDAP')";
		$sql_array[1044] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1044, NULL, 'system', NULL, 'Bitte w&auml;hlen Sie min. ein Projekt aus!', 'Please select at least one project!')";
		$sql_array[1045] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1045, NULL, 'system', NULL, 'Noch nicht genehmigte Abwesenheitsantr&auml;ge', 'Absence requests which are not yet approved')";
		$sql_array[1046] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1046, NULL, 'system', NULL, 'Stundenzettel Kurz-Info', 'Timesheet quick-info')";
		$sql_array[1047] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1047, NULL, 'system', NULL, 'Stunden&uuml;bertrag (Vormonat)', 'Hours carried over (previous month)')";
		$sql_array[1048] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1048, NULL, NULL, NULL, 'Gesamtzeit +/- (aktueller Monat)', 'Total Time +/- (current month)')";
		$sql_array[1049] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1049, NULL, 'system', NULL, '... hat Feierabend', '... has finished work')";
		$sql_array[1050] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1050, NULL, 'system', NULL, 'Muss beantragt werden', 'Requires an absence request')";
		$sql_array[1051] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1051, NULL, 'system', NULL, 'Genehmigungspflichtig', 'Requires approval')";
		$sql_array[1052] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1052, NULL, 'system', NULL, 'Bitte geben Sie eine Mindestl&auml;nge f&uuml;r Benutzernamen an!', 'Please enter a value for the minimum length of usernames!')";
		$sql_array[1053] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1053, NULL, 'system', NULL, 'Mindestl&auml;nge f&uuml;r Benutzernamen', 'Minimum length of usernames')";
		$sql_array[1054] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1054, NULL, 'system', NULL, 'Bitte w&auml;hlen Sie ein Bild aus!', 'Please select an image!')";
		$sql_array[1055] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1055, NULL, 'system', NULL, 'Es k&ouml;nnen nur JPG Dateien als Logo verwendet werden!', 'Only JPG files can be used as logo!')";
		$sql_array[1056] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1056, NULL, 'system', NULL, 'Abwesenheitstage', 'Absence days')";
		$sql_array[1057] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1057, NULL, 'system', NULL, 'Hintergrundfarbe', 'Background color')";
		$sql_array[1058] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1058, NULL, 'system', NULL, 'F&uuml;r eine bessere Darstellung ist es empfohlen eine eindeutige Farbe f&uuml;r jeden Abwesenheitsgrund zu  definieren.', 'For a better presentation on the screen it is recommended to select a unique color for each absenteeism reason.')";
		$sql_array[1059] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1059, NULL, 'system', NULL, 'Gilt der Abwesenheitsgrund als Arbeitszeit oder nicht? (z.B. Urlaub = ja, Unbezahlt frei = nein)', 'Is the absenteeism reason counted as labour time or not? (e.g. holiday = yes, unpaid leave = no)')";
		$sql_array[1060] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1060, NULL, NULL, NULL, 'Gilt der Abwesenheitsgrund als bezahlte oder unbezahlte Abwesenheit? (z.B. Urlaub = ja, Unbezahlt frei = nein)', 'Is the absenteeism reason regarded as paid or unpaid absence? (e.g. holiday = yes, unpaid leave = no)')";
		$sql_array[1061] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1061, NULL, 'system', NULL, 'Muss dieser Abwesenheitsgrund beantragt werden wie z.B. Urlaub (Urlaubsantrag), oder nicht? Alle Abwesenheitsgr&uuml;nde die beantragt werden m&uuml;ssen, werden automatisch im Jahresurlaubsplan angezeigt.', 'Requires this absenteeism reason an absence request such as holidays (holiday request) or not? All absenteeism reasons which require a request will automatically be displayed in the annual holiday overview.')";
		$sql_array[1062] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1062, NULL, 'system', NULL, 'Erfordert der Abwesenheitsgrund eine Genehmigung? Dies spielt nur eine Rolle bei Abwesenheitsgr&uuml;nden, die beantragt werden m&uuml;ssen.', 'Defines whether or not the absenteeism reason reqires an approval. Affects only absenteeism reasons which have to be requested.')";
		$sql_array[1063] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1063, NULL, 'system', NULL, 'Projekte des Mitarbeiters', 'Projects of the employee')";
		$sql_array[1064] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1064, NULL, 'system', NULL, 'Alle Projekte des Mitarbeiters', 'All projects of the employee')";
		$sql_array[1065] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1065, NULL, 'system', NULL, 'Abwesenheitstyp', 'Absence type')";
		$sql_array[1066] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1066, NULL, 'system', NULL, 'Passwortvergabe und -pr&uumlfung erfolgen &uuml;ber den LDAP Server!', 'Password administration and verification are handled by the LDAP server!')";
		$sql_array[1067] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1067, NULL, 'system', NULL, 'Achtung, Ihre aktuelle PHP-Konfiguration unterst&uuml;tzt keinen LDAP-Support. Wenn Sie einen LDAP-Server für die Loginauthentifizierung nutzen m&ouml;chten, aktivieren Sie den LDAP Support (http://www.php.net/manual/en/book.ldap.php).', 'Attention, your current PHP configuration doesn&#039;t support LDAP functionality. If you want to use a LDAP server for login authentication you have to enable LDAP support (http://www.php.net/manual/en/book.ldap.php).')";
		$sql_array[1068] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1068, NULL, 'system', NULL, 'Bitte geben Sie Ihr Passwort f&uuml;r den LDAP Server ein!', 'Please enter your password for the LDAP server!')";
		$sql_array[1069] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1069, NULL, 'system', NULL, 'Bitte nehmen Sie die Einstellungen f&uuml;r den Loginnamen vor!', 'Please configure the login name settings!')";
		$sql_array[1070] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1070, NULL, 'system', NULL, 'Bitte geben Sie min. eine Domain zu Ihrem LDAP Server an!', 'Please enter at least one domain for your LDAP server!')";
		$sql_array[1071] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1071, NULL, 'system', NULL, 'Bitte geben Sie einen Trenner zwischen den TOM Userdaten an!', 'Please specify a seperator between the TOM userdata inputfields!')";
		$sql_array[1072] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1072, NULL, 'system', NULL, 'Die LDAP-Verwendung ist deaktiviert!', 'LDAP is disabled!')";
		$sql_array[1073] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1073, NULL, 'system', NULL, 'Sie haben die LDAP-Einstellungen nicht erfolgreich getestet! Wollen Sie die Einstellungen dennoch speichern?', 'The LDAP settings were not successfully tested! Do you want to save these settings anyway?')";
		$sql_array[1074] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1074, NULL, 'system', NULL, 'Bitte nehmen Sie die Einstellungen für den Loginnamen vor!', 'Please configure the login name settings!')";
		$sql_array[1075] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1075, NULL, 'system', NULL, 'LDAP', 'LDAP')";
		$sql_array[1076] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1076, NULL, 'system', NULL, 'Diese Seite dient zur Konfiguration eines LDAP Servers.[br]TOM verwendet den LDAP Server f&uuml;r den Abgleich der Logindaten.[br]Beachten Sie bitte, dass TOM nur die Logindaten des LDAP Servers verwendet. Andere Mitarbeiterdaten (z.B. E-Mailadresse) werden nicht abgeglichen.', 'On this page you may configure a LDAP server.[br]TOM will use the LDAP server for user authentication.[br]Please regard, that TOM uses only the login data of the server. Other user data (e.g. e-mail) will not be used.')";
		$sql_array[1077] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1077, NULL, 'system', NULL, 'LDAP Server verwenden', 'Use LDAP server')";
		$sql_array[1078] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1078, NULL, 'system', NULL, 'Wenn Sie die Option &quot;TOM als Zweit-Loginsystem verwenden&quot; aktivieren, speichert TOM nach einer erfolgreichen Authentifizierung durch den LDAP Server das LDAP Passwort in der Usertabelle (hdb_user).[br]Sollte der LDAP Server ausfallen bzw. nicht erreichbar sein, werden die Logindaten mit denen in der Usertabelle abgeglichen und der Zugang gegebenenfalls gew&auml;hrt.[br]Dies ist nur dann der Fall, wenn der LDAP Server nicht erreichbar ist. Sollte der LDAP Server die Authentifizierung ablehnen, erfolgt kein Abgleich der Logindaten![br]Beachten Sie bitte, dass Sie sich nicht im TOM anmelden k&ouml;nnen, wenn diese Option deaktiviert ist und der LDAP Server nicht erreichbar sein sollte.', 'If you enable the option &quot;Use TOM as secondary login system&quot;, TOM will save the LDAP password after successful authentication into the user table of the database (hdb_user).[br]In case of problems (for instance if the server is offline or cannot be connected) it is possible to compare login data with the user data stored in the user table, so that access can be granted without LDAP when required.[br]This affects only if the LDAP server is unavailable. If the LDAP server refuses the authentication there will be no comparison of login data![br]Please regard, that it is not possible to login into TOM, if this option is enabled and the LDAP server is unavailable.')";
		$sql_array[1079] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1079, NULL, 'system', NULL, 'TOM als Zweit-Loginsystem verwenden', 'Use TOM as secondary login system')";
		$sql_array[1080] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1080, NULL, 'system', NULL, 'Domain zum LDAP Server.', 'Domain of the LDAP server.')";
		$sql_array[1081] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1081, NULL, 'system', NULL, 'Domain', 'Domain')";
		$sql_array[1082] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1082, NULL, 'system', NULL, 'SSL verwenden', 'Use SSL')";
		$sql_array[1083] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1083, NULL, 'system', NULL, 'TLS verwenden', 'Use TLS')";
		$sql_array[1084] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1084, NULL, 'system', NULL, 'Achtung, da TOM den LDAP Server nur zur Loginpr&uuml;fung verwendet, ist es notwenig, die Struktur des LDAP Loginnamens f&uuml;r TOM anzugeben. Beachten Sie dabei, dass der Loginname im TOM eindeutig einem Benutzer zugeordnet werden muss. Verwenden Sie daher nach M&ouml;glichkeit den Benutzernamen aus TOM, dieser ist f&uuml;r jeden Mitarbeiter eindeutig.[br]Verwenden Sie z.B. nicht die E-Mailadresse wenn Sie eine E-Mailadresse mehr als einem Mitarbeiter zugeordnet haben!', 'Attention, TOM uses the LDAP server only for authentication. Therefore it is necessary to define the structure of the login names for TOM. Please regard, that the login name has to be assigned to a specific user in TOM. Use (if possible) the TOM user name which is unique.[br]Don&#039;t use an e-mail address which is assigned to more than one user! ')";
		$sql_array[1085] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1085, NULL, 'system', 'LDAP-Loginname', 'Loginname', 'Login name')";
		$sql_array[1086] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1086, NULL, 'system', NULL, 'Login-Pr&auml;fix', 'Login prefix')";
		$sql_array[1087] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1087, NULL, 'system', NULL, 'Login-Suffix', 'Login suffix')";
		$sql_array[1088] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1088, NULL, 'system', 'LDAP', 'TOM Userdaten', 'TOM Userdata')";
		$sql_array[1089] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1089, NULL, 'system', 'LDAP', 'Trenner', 'Separator')";
		$sql_array[1090] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1090, NULL, 'system', NULL, 'Bitte testen Sie Ihre LDAP-Einstellungen vor dem Speichern.[br]Bei falschen Einstellungen k&ouml;nnte sonst der Zugang zu TOM dauerhaft gesperrt sein!', 'Please test your LDAP settings before saving.[br]The access to TOM could be permanently blocked if you save wrong settings!')";
		$sql_array[1091] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1091, NULL, 'system', NULL, 'LDAP-Einstellungen testen', 'Test LDAP settings')";
		$sql_array[1092] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1092, NULL, 'system', NULL, 'Test starten', 'Start test')";
		$sql_array[1093] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1093, NULL, 'system', NULL, 'Server-Verbindung erfolgreich getestet', 'Server connection successfully tested')";
		$sql_array[1094] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1094, NULL, 'system', NULL, 'Zugangsdaten erfolgreich getestet', 'Login data successfully tested')";
		$sql_array[1095] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1095, NULL, 'system', NULL, 'Eindeutige Benutzerkennung in TOM', 'Unique login name in TOM')";
		$sql_array[1096] = "INSERT INTO hdb_texte (text_id, text_key, kategorie, bemerkungen, sprache_1, sprache_2) VALUES (1096, NULL, 'system', NULL, 'Beispiel', 'Example')";

		foreach ($sql_array as $txt_id => $sql_string)
		{
			/**
			 * SQL Befehle durchfuehren
			 */
			//Pruefen ob bereits vorhanden
			$sql = $cdb->select('SELECT text_id FROM hdb_texte WHERE text_id='.$txt_id);
			$result = $cdb->fetch_array($sql);

			//text noch nicht vorhanden
			if (!isset($result['text_id']) or empty($result['text_id']))
			{
				if (!$cdb->insert($sql_string))
				{
					$error_array['sql'][] = $sql_string;
				}
			}
		}

		/**
		 * Texte bearbeiten
		 */
		$cdb->query("UPDATE hdb_texte SET sprache_1='Bitte geben Sie eine Zahl an!', sprache_2='Please enter a number!' WHERE text_id=993 LIMIT 1");
		$cdb->query("UPDATE hdb_texte SET sprache_1='Der angegebene Benutzername ist zu kurz. Die Mindestl&auml;nge betr&auml;gt', sprache_2='The entered username is too short. The minimum length is' WHERE text_id=231 LIMIT 1");


		/**
		 * Qualifikationen bearbeiten
		 */
		$sql = $cdb->select("SHOW COLUMNS FROM hdb_qualifikation WHERE Field = 'min_headcount'");
		$result = $cdb->fetch_array($sql);
		if (!isset($result['Field']) or empty($result['Field']))
		{
			if ($cdb->query("ALTER TABLE hdb_qualifikation ADD min_headcount INT UNSIGNED NOT NULL DEFAULT '0', ADD critical_headcount INT UNSIGNED NOT NULL DEFAULT '0'") === false)
			{
				$error_array['sql'][] = "ALTER TABLE hdb_qualifikation ADD min_headcount INT UNSIGNED NOT NULL DEFAULT '0', ADD critical_headcount INT UNSIGNED NOT NULL DEFAULT '0'";
			}
		}

		//Index Anlegen
		$sql = $cdb->query("SHOW INDEX FROM hdb_qualifikation WHERE Column_name='qualifikation'");
		$result = $cdb->fetch_array($sql);
		if (!isset($result['Column_name']) or empty($result['Column_name']))
		{
			if ($cdb->query("ALTER TABLE hdb_qualifikation ADD INDEX order_index (qualifikation)") === false)
			{
				$error_array['sql'][] = "ALTER TABLE hdb_qualifikation ADD INDEX order_index (qualifikation)";
			}
		}

		if (in_array('hdb_user_qualifikation', $tbl_array))
		{
			$sql = $cdb->select("SHOW COLUMNS FROM hdb_user WHERE Field = 'quali_ids'");
			$result = $cdb->fetch_array($sql);
			if (isset($result['Field']) and !empty($result['Field']))
			{
				$sql = $cdb->select('SELECT user_id, quali_ids FROM hdb_user');
				while ($result = $cdb->fetch_array($sql))
				{
					if (!empty($result['quali_ids']))
					{
						$quali_array = @unserialize($result['quali_ids']);

						if (is_array($quali_array))
						{
							foreach ($quali_array as $quali_id)
							{
								$cdb->insert("INSERT INTO hdb_user_qualifikation (user_id, quali_id) VALUES (".$result['user_id'].", $quali_id)");
							}
						}
					}
				}

				if ($cdb->query("ALTER TABLE hdb_user DROP quali_ids") === false)
				{
					$error_array['sql'][] = "ALTER TABLE hdb_user DROP quali_ids";
				}
			}
		}

		//Webservice Files anpassen
		if (file_exists(TOM_ABS_PFAD.'web_services/access.wsdl') and file_exists(TOM_ABS_PFAD.'web_services/tom.wsdl'))
		{
			$is_writable = false;
			$change_chmod = false;
			if (!is_writable(TOM_ABS_PFAD.'web_services/access.wsdl'))
			{
				@chmod(TOM_ABS_PFAD.'web_services/access.wsdl', 0777);
				$change_chmod = true;
				if (is_writable(TOM_ABS_PFAD.'web_services/access.wsdl'))
				{
					$is_writable = true;
				}
			}
			else
			{
				$is_writable = true;
			}

			if (!is_writable(TOM_ABS_PFAD.'web_services/tom.wsdl'))
			{
				@chmod(TOM_ABS_PFAD.'web_services/tom.wsdl', 0777);
				$change_chmod = true;
				if (is_writable(TOM_ABS_PFAD.'web_services/tom.wsdl'))
				{
					$is_writable = true;
				}
			}
			else
			{
				$is_writable = true;
			}

			if ($is_writable === true)
			{
				$tom_wsdl = file_get_contents(TOM_ABS_PFAD.'web_services/tom.wsdl');
				$access_wsdl = file_get_contents(TOM_ABS_PFAD.'web_services/access.wsdl');

				$tom_replace = '<soap:address location="'.TOM_ABS_URL.'web_services/tom.php"/>';
				$access_replace = '<soap:address location="'.TOM_ABS_URL.'web_services/access.php"/>';

				$new_tom_wsdl = preg_replace('/<soap:address location="(.*)"\/>/', $tom_replace, $tom_wsdl);
				$new_access_wsdl = preg_replace('/<soap:address location="(.*)"\/>/', $access_replace, $access_wsdl);

				$write_wsdl = true;
				if ($tom_wsdl != $new_tom_wsdl)
				{
					if (file_put_contents(TOM_ABS_PFAD.'web_services/tom.wsdl', $new_tom_wsdl) === false)
					{
						$write_wsdl = false;
					}
				}
				if ($access_wsdl != $new_access_wsdl)
				{
					if (file_put_contents(TOM_ABS_PFAD.'web_services/access.wsdl', $new_access_wsdl) === false)
					{
						$write_wsdl = false;
					}
				}
			}
			else
			{
				$error_array['txt'][] = '<strong>DE:</strong> Die Dateien "web_services/access.wsdl" und "web_services/tom.wsdl" konnten nicht beschrieben werden.<br /><strong>EN:</strong> The files "web_services/access.wsdl" and "web_services/tom.wsdl" could not be written.';
			}

			if ($change_chmod === true)
			{
				@chmod(TOM_ABS_PFAD.'web_services/access.wsdl', 0644);
				@chmod(TOM_ABS_PFAD.'web_services/tom.wsdl', 0644);
			}

			if ($write_wsdl == false)
			{
				$error_array['txt'][] = '<strong>DE:</strong> Die Dateien "web_services/access.wsdl" und "web_services/tom.wsdl" konnten nicht beschrieben werden.<br /><strong>EN:</strong> The files "web_services/access.wsdl" and "web_services/tom.wsdl" could not be written.';
			}
		}
		else
		{
			$error_array['txt'][] = '<strong>DE:</strong> Die Dateien "web_services/access.wsdl" und "web_services/tom.wsdl" existieren nicht oder sind nicht beschreibbar.<br /><strong>EN:</strong> The files "web_services/access.wsdl" and "web_services/tom.wsdl" don´t exist or are not writeable.';
		}

		//neue Setupeinstellungen
		$new_setup = array();
		if (!isset($setup_array['holiday']))
		{
			$new_setup['holiday']['overview_project']		= true;
			$new_setup['holiday']['overview_qualification'] = true;
		}
		if (!isset($setup_array['ldap']))
		{
			$new_setup['ldap']['active']					= false;
			$new_setup['ldap']['tom_login']					= true;
			$new_setup['ldap']['domain']					= '';
			$new_setup['ldap']['ssl']						= true;
			$new_setup['ldap']['tls']						= true;
			$new_setup['ldap']['loginname']['praefix']		= '';
			$new_setup['ldap']['loginname']['user_data_1']	= '';
			$new_setup['ldap']['loginname']['separator_1']	= '';
			$new_setup['ldap']['loginname']['user_data_2']	= '';
			$new_setup['ldap']['loginname']['separator_2']	= '';
			$new_setup['ldap']['loginname']['user_data_3']	= '';
			$new_setup['ldap']['loginname']['suffix']		= '';
		}
		if (!isset($setup_array['min_username_len']))
		{
			$new_setup['min_username_len']					= 8;
		}
		if ($setup_array['database_version'] != $update_to)
		{
			$new_setup['database_version']					= $update_to;
		}
		if (!empty($new_setup))
		{
			$setup->update_setup($new_setup);
		}

		//del filelist
		$del_file_array = array('holiday/flextime_add.php',
								'holiday/flextime_del.php',
								'holiday/holiday_add.php',
								'holiday/holiday_edit.php',
								'main/new_flextime.php',
								'main/new_holiday.php',
								'main/new_holiday_all.php',
								'report/pdf_flextime.php',
								'report/pdf_holiday.php');

		foreach ($del_file_array as $del_file)
		{
			if (file_exists(TOM_ABS_PFAD.$del_file))
			{
				@unlink(TOM_ABS_PFAD.$del_file);
			}
		}

		//keine SQL Fehler aufgetretten
		if (!isset($error_array['sql']) or count($error_array['sql']) == 0)
		{
			$optimize_sql = 'OPTIMIZE TABLE '.implode(", ", $tbl_array);
			$cdb->query($optimize_sql);
			$result = $backup->create_dump('auto', "First Backup of $update_to ".date('YmdHis'));
		}
	}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>TOM update <?php echo $update_to; ?></title>
<link rel="stylesheet" media="screen" type="text/css" href="<?php echo 'template/default/screen.css?v='.$update_to; ?>" />
</head>
<body>
	<table cellpadding="0" cellspacing="0" border="0" width="100%">
		<tr valign="top">
			<td width="80%" class="header_bg"><img src="template/default/image/_header_bg_logo.png" height="151" width="340" border="0" alt="" /><?php
					if (file_exists('template/logo_default.jpg'))
					{
						$logo_size = getimagesize('template/logo_default.jpg');
				?><div class="header_logo_box">
					<div style="width: 340px; text-align: center;"><img src="<?php echo 'template/logo_default.jpg'; ?>" height="<?php echo $logo_size[1]; ?>" width="<?php echo $logo_size[0]; ?>" border="0" alt="" /></div>
				</div><?php
					}
				?></td>
			<td width="20%" class="header_bg">&nbsp;</td>
		</tr>
	</table>
	<div class="content_bg">
		<div class="content" style="min-height: 500px;">
<?php
	if (!isset($_GET['step']) or $_GET['step'] == 1)
	{
?>
		<table cellpadding="0" cellspacing="0" border="0" width="100%">
			<tr valign="middle">
				<td class="info_table_header" width="100%">DE:</td>
			</tr>
			<tr><td><img src="template/default/image/_spacer.gif" width="1" height="4" border="0" alt="" /></td></tr>
			<tr>
				<td class="info_table_content">
					<ul>
						<li>Sie k&ouml;nnen alle &Auml;nderungen in der Datei changelog.txt nachlesen. Diese Anleitung bezieht sich auf das Update von <?php echo $update_from; ?> auf <?php echo $update_to; ?>.</li>
						<li>Erstellen Sie eine Sicherungskopie ihrer aktuellen Installation. Achten Sie besonders darauf, dass die Dateien/Ordner config/config.php, config/cryptpw_salt.php und files/ gesichert sind.</li>
						<li>Laden Sie alle neuen TOM Dateien auf Ihren Server.</li>
						<li>Achtung es gibt eine neue TCPDF Version (5.5.*). Sie können die aktuellste Version unter <a href="http://sourceforge.net/projects/tcpdf/" target="_blank">http://sourceforge.net/projects/tcpdf/</a> beziehen. Kopieren Sie die Dateien in den Ordner inc/classes/tcpdf/.</li>
						<li>Achtung - &Uuml;berschreiben bzw. ersetzen Sie nicht nachfolgende Dateien/Ordner:
							<ul>
								<li>config/config.php</li>
								<li>config/cryptpw_salt.php</li>
								<li>files/*</li>
								<li>inc/classes/PHPMailer/*</li>
								<li>inc/classes/tcpdf/*</li>
								<li>inc/classes/zip/*</li>
							</ul>
						</li>
						<li>Wenn Sie alle oben beschriebenen Schritte durchgef&uuml;hrt haben, klicken Sie auf den Button "<a href="update.php?step=2"><u>Update durchf&uuml;hren</u></a>"</li>
					</ul>
				</td>
			</tr>
		</table>
		<br /><br />
		<table cellpadding="0" cellspacing="0" border="0" width="100%">
			<tr valign="middle">
				<td class="info_table_header" width="100%">EN:</td>
			</tr>
			<tr><td><img src="template/default/image/_spacer.gif" width="1" height="4" border="0" alt="" /></td></tr>
			<tr>
				<td class="info_table_content">
					<ul>
						<li>All changes can be found within the file changelog.txt. This manual applies to the update from version <?php echo $update_from; ?> to <?php echo $update_to; ?>.</li>
						<li>Please create a backup of your current installation. Please pay attention to backup primarily the following folders/files: config/config.php, config/cryptpw_salt.php and files/.</li>
						<li>Upload all files to your server.</li>
						<li>Attention there is a new TCPDF version (5.5.*). You may download it at <a href="http://sourceforge.net/projects/tcpdf/" target="_blank">http://sourceforge.net/projects/tcpdf/</a>  and copy it into the directory inc/classes/tcpdf/.</li>
						<li>Attention - do not overwrite the following files/folders:
							<ul>
								<li>config/config.php</li>
								<li>config/cryptpw_salt.php</li>
								<li>files/*</li>
								<li>inc/classes/PHPMailer/*</li>
								<li>inc/classes/tcpdf/*</li>
								<li>inc/classes/zip/*</li>
							</ul>
						</li>
						<li>If you have accomplished all steps described above you may click the button "<a href="update.php?step=2"><u>Start Update</u></a>"</li>
					</ul>
				</td>
			</tr>
		</table>
		<br /><br />
<?php
	}
	elseif (isset($_GET['step']) and $_GET['step'] == 2)
	{
		if (isset($error_array) and count($error_array) > 0)
		{
			echo 		'<table cellpadding="0" cellspacing="0" border="0" width="100%">
							<tr valign="middle">
								<td class="error_table_header" width="100%">Fehlermeldung / Error Message</td>
							</tr>
							<tr><td><img src="template/default/image/_spacer.gif" width="1" height="4" border="0" alt="" /></td></tr>
							<tr>
								<td class="error_table_content">
									<ul>';
			//allgemeine Fehler
			if (isset($error_array['txt']))
			{
				echo 					'<li><strong>DE:</strong> Nachfolgende Fehler sind aufgetreten. Wiederholen Sie gegebenenfalls den Updatevorgang.<br /><strong>EN:</strong> The following errors occurred. Please repeat the update procedure if necessary.';

				echo 						'<ul>';
				foreach ($error_array['txt'] as $txt)
				{
					echo 						"<li>$txt</li>";
				}
				echo 						'</ul>';
				echo					'</li>';
			}
			//SQL Fehler
			if (isset($error_array['sql']))
			{
				echo 					'<li><strong>DE:</strong> Nachfolgende SQL Fehler sind aufgetreten. Pr&uuml;fen Sie die SQL Syntax f&uuml;r Ihre MySql Version und f&uuml;hren Sie die SQL Befehle gegebenenfalls von Hand aus. Wiederholen sie gegebenenfalls den Updatevorgang.<br /><strong>EN:</strong> The following SQL errors occurred. Please check the SQL syntax for your MySql version and execute the SQL commands manually if necessary. Please repeat the update procedure if necessary.';

				echo						'<ul>';
				foreach ($error_array['sql'] as $txt)
				{
					echo 						'<li><textarea cols="80" rows="2" readonly="readonly">'.$txt.'</textarea></li>';
				}
				echo 						'</ul>';
				echo					'</li>';
				echo					'<li><a href="update.php"><u>Update neustarten. Re-start Update.</u></li>';
			}
				echo 				'</ul>
								</td>
							</tr>
						</table><br /><br />';
		}
		else
		{
?>
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
				<tr valign="middle">
					<td class="green_table_header" width="100%">Erfolgsmeldungen / Good news</td>
				</tr>
				<tr><td><img src="template/default/image/_spacer.gif" width="1" height="4" border="0" alt="" /></td></tr>
				<tr>
					<td class="green_table_content">
						<ul>
							<li><strong>DE:</strong> Das Update wurde erfolgreich durchgef&uuml;hrt. Sie k&ouml;nnen Die Datei "update.php" jetzt l&ouml;schen.</li>
							<li><strong>EN:</strong> The update was successfully performed. Finally you also may delete this file (update.php).</li>
							<li>
								<ul>
									<li><u><a href="login/index.php"><strong>DE:</strong> Zur Loginseite gelangen Sie &uuml;ber diesen Link.</a></u></li>
									<li><u><a href="login/index.php"><strong>EN:</strong> Use this link to get to the login page.</a></u></li>
								</ul>
							</li>
						</ul>
					</td>
				</tr>
			</table><br /><br />
<?php
		}
	}
?>
			</div>
		<div style="text-align:center; font-size:10px; margin-top:15px;">
			TOM update <?php echo $update_to; ?><br /><br />
			<a href="http://www.gnu.org/licenses/gpl.html" target="_blank"><img style="vertical-align:middle;" src="<?php echo 'template/default/image/_gplv3-88x31.png'; ?>" alt="GPLv3" height="31" width="88" border="0" /></a>
			<a href="http://validator.w3.org" target="_blank"><img style="vertical-align:middle;" src="<?php echo 'template/default/image/_valid-xhtml10-blue.png'; ?>" alt="Valid XHTML 1.0 Transitional" height="31" width="88" border="0" /></a>
			<a href="http://jigsaw.w3.org/css-validator/validator?uri=<?php echo 'template/default/screen.css'; ?>" target="_blank"><img style="border:0;width:88px;height:31px;vertical-align:middle;" src="<?php echo 'template/default/image/_vcss-blue.gif'; ?>" alt="CSS ist valide!" border="0" /></a>
		</div>
		<br /><br />
	</div>
</body>
</html>