<?php
	/**
	 * Webserviceaufruf für die Authentifizierung von Webservice anfragen
	 * @package time-o-meter
	 * @subpackage webservice
	 */
	//FIXME: ist nur fuer den Pfad zur WSDL
	require_once ('../../config/config.php');

	/*
	 * Gibt den WsKex zurück der allen anderen WebServices mit übergeben werden muß
	 */
	class WebServiceLogin
	{
		private $setup_array = array();

		/*
		 * Setzt die Grundeinstellungen
		 */
		public function __construct()
		{
			//ACHTUNG: TOM_ABS_URL kommt aus der config.php
			$this->setup_array['wsdl_pfad']		= TOM_ABS_URL.'web_services/access.wsdl';
			//FIXME: Daten sollten aus eine DB kommen
			//ACHTUNG: Der User muss die notwendigen Zugriffsrechte innerhalb von TOM haben!
			//z.B. User == Read, Project == read and Reports == read
			$this->setup_array['ws_loginname']	= 'username';
			$this->setup_array['ws_loginpw']	= 'pw';
		}

		/*
		 * Gibt den WebService Key zurück den Alle anderen WebService Abfragen benötigen
		 * @return mixed
		 */
		public function get_ws_key()
		{
			$ws_key = $this->read_ws_key_cache();
			//WsKey aus lokalem Speicher vorhanden
			if (!empty($ws_key))
			{
				try
				{
					// Soap-Client initialisieren
					$client = @new SoapClient($this->setup_array['wsdl_pfad']);
					$ws_check = $client->chk_ws_key($ws_key);

					if ($ws_check == 'true')
					{
						return $ws_key;
					}
				}
				catch(Exception $e)
				{
					//error Fehlerbericht
					var_dump($e);
					return false;
				}
			}
			else
			{
				//Kein WsKey vorhanden oder abgelaufen neuen Loginvorgang starten
				try
				{
					// Soap-Client initialisieren
					$client = @new SoapClient($this->setup_array['wsdl_pfad']);
					//Einloggen
					$ws_key = $client->ws_login($this->setup_array['ws_loginpw'], $this->setup_array['ws_loginname']);

					//keine Fehler
					if ($ws_key != 'false')
					{
						$this->insert_ws_key_cache($ws_key);
						return $ws_key;
					}
					else
					{
						return false;
					}
				}
				catch(Exception $e)
				{
					//error Fehlerbericht
					var_dump($e);
					return false;
				}
			}
		}

		/*
		 * Liest den WsKey aus einem Lokalen Speicher
		 * @return string
		 */
		private function read_ws_key_cache()
		{
			//Hier koennte der WsKey von einer Session oder DB kommen
			//Halt irgend etwas um nicht mit jedem Seitenaufruf sich neu Einloggen zu muessen
			return '';
		}

		/*
		 * Schreibt den WsKey in einen Lokalen Speicher (Session, DB, ...)
		 * @param string $ws_key
		 * @return boole
		 */
		private function insert_ws_key_cache($ws_key)
		{
			//hier kann der WsKey in die Session oder DB gespeichert werden
			return true;
		}
	}
?>